/*!
 * clipboard.js v2.0.8
 * https://clipboardjs.com/
 *
 * Licensed MIT © Zeno Rocha
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.ClipboardJS=t():e.ClipboardJS=t()}(this,function(){return i={134:function(e,t,i){"use strict";i.d(t,{default:function(){return g}});var t=i(279),r=i.n(t),t=i(370),o=i.n(t),t=i(817),n=i.n(t);function s(e){return(s="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function a(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}a(c.prototype,[{key:"resolveOptions",value:function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};this.action=e.action,this.container=e.container,this.emitter=e.emitter,this.target=e.target,this.text=e.text,this.trigger=e.trigger,this.selectedText=""}},{key:"initSelection",value:function(){this.text?this.selectFake():this.target&&this.selectTarget()}},{key:"createFakeElement",value:function(){var e="rtl"===document.documentElement.getAttribute("dir");return this.fakeElem=document.createElement("textarea"),this.fakeElem.style.fontSize="12pt",this.fakeElem.style.border="0",this.fakeElem.style.padding="0",this.fakeElem.style.margin="0",this.fakeElem.style.position="absolute",this.fakeElem.style[e?"right":"left"]="-9999px",e=window.pageYOffset||document.documentElement.scrollTop,this.fakeElem.style.top="".concat(e,"px"),this.fakeElem.setAttribute("readonly",""),this.fakeElem.value=this.text,this.fakeElem}},{key:"selectFake",value:function(){var e=this,t=this.createFakeElement();this.fakeHandlerCallback=function(){return e.removeFake()},this.fakeHandler=this.container.addEventListener("click",this.fakeHandlerCallback)||!0,this.container.appendChild(t),this.selectedText=n()(t),this.copyText(),this.removeFake()}},{key:"removeFake",value:function(){this.fakeHandler&&(this.container.removeEventListener("click",this.fakeHandlerCallback),this.fakeHandler=null,this.fakeHandlerCallback=null),this.fakeElem&&(this.container.removeChild(this.fakeElem),this.fakeElem=null)}},{key:"selectTarget",value:function(){this.selectedText=n()(this.target),this.copyText()}},{key:"copyText",value:function(){var t;try{t=document.execCommand(this.action)}catch(e){t=!1}this.handleResult(t)}},{key:"handleResult",value:function(e){this.emitter.emit(e?"success":"error",{action:this.action,text:this.selectedText,trigger:this.trigger,clearSelection:this.clearSelection.bind(this)})}},{key:"clearSelection",value:function(){this.trigger&&this.trigger.focus(),document.activeElement.blur(),window.getSelection().removeAllRanges()}},{key:"destroy",value:function(){this.removeFake()}},{key:"action",set:function(){if(this._action=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"copy","copy"!==this._action&&"cut"!==this._action)throw new Error('Invalid "action" value, use either "copy" or "cut"')},get:function(){return this._action}},{key:"target",set:function(e){if(void 0!==e){if(!e||"object"!==s(e)||1!==e.nodeType)throw new Error('Invalid "target" value, use a valid Element');if("copy"===this.action&&e.hasAttribute("disabled"))throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');if("cut"===this.action&&(e.hasAttribute("readonly")||e.hasAttribute("disabled")))throw new Error('Invalid "target" attribute. You can\'t cut text from elements with "readonly" or "disabled" attributes');this._target=e}},get:function(){return this._target}}]);var l=c;function c(e){if(!(this instanceof c))throw new TypeError("Cannot call a class as a function");this.resolveOptions(e),this.initSelection()}function d(e){return(d="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function u(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function p(e,t){return(p=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function h(e){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function m(e,t){if(e="data-clipboard-".concat(e),t.hasAttribute(e))return t.getAttribute(e)}var g=function(){var e=a,t=r();if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&p(e,t);i=a,n=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(e){return!1}}();var i,n,s=function(){var e=h(i),t=n?(t=h(this).constructor,Reflect.construct(e,arguments,t)):e.apply(this,arguments),e=this;if(!t||"object"!==d(t)&&"function"!=typeof t){if(void 0!==e)return e;throw new ReferenceError("this hasn't been initialised - super() hasn't been called")}return t};function a(e,t){var i;if(this instanceof a)return(i=s.call(this)).resolveOptions(t),i.listenClick(e),i;throw new TypeError("Cannot call a class as a function")}return e=[{key:"isSupported",value:function(){var e="string"==typeof(e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:["copy","cut"])?[e]:e,t=!!document.queryCommandSupported;return e.forEach(function(e){t=t&&!!document.queryCommandSupported(e)}),t}}],u((t=a).prototype,[{key:"resolveOptions",value:function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};this.action="function"==typeof e.action?e.action:this.defaultAction,this.target="function"==typeof e.target?e.target:this.defaultTarget,this.text="function"==typeof e.text?e.text:this.defaultText,this.container="object"===d(e.container)?e.container:document.body}},{key:"listenClick",value:function(e){var t=this;this.listener=o()(e,"click",function(e){return t.onClick(e)})}},{key:"onClick",value:function(e){e=e.delegateTarget||e.currentTarget,this.clipboardAction&&(this.clipboardAction=null),this.clipboardAction=new l({action:this.action(e),target:this.target(e),text:this.text(e),container:this.container,trigger:e,emitter:this})}},{key:"defaultAction",value:function(e){return m("action",e)}},{key:"defaultTarget",value:function(e){if(e=m("target",e))return document.querySelector(e)}},{key:"defaultText",value:function(e){return m("text",e)}},{key:"destroy",value:function(){this.listener.destroy(),this.clipboardAction&&(this.clipboardAction.destroy(),this.clipboardAction=null)}}]),u(t,e),a}()},828:function(e){var t;"undefined"==typeof Element||Element.prototype.matches||((t=Element.prototype).matches=t.matchesSelector||t.mozMatchesSelector||t.msMatchesSelector||t.oMatchesSelector||t.webkitMatchesSelector),e.exports=function(e,t){for(;e&&9!==e.nodeType;){if("function"==typeof e.matches&&e.matches(t))return e;e=e.parentNode}}},438:function(e,t,i){var r=i(828);function a(e,t,i,n,s){var a=function(t,i,e,n){return function(e){e.delegateTarget=r(e.target,i),e.delegateTarget&&n.call(t,e)}}.apply(this,arguments);return e.addEventListener(i,a,s),{destroy:function(){e.removeEventListener(i,a,s)}}}e.exports=function(e,t,i,n,s){return"function"==typeof e.addEventListener?a.apply(null,arguments):"function"==typeof i?a.bind(null,document).apply(null,arguments):("string"==typeof e&&(e=document.querySelectorAll(e)),Array.prototype.map.call(e,function(e){return a(e,t,i,n,s)}))}},879:function(e,i){i.node=function(e){return void 0!==e&&e instanceof HTMLElement&&1===e.nodeType},i.nodeList=function(e){var t=Object.prototype.toString.call(e);return void 0!==e&&("[object NodeList]"===t||"[object HTMLCollection]"===t)&&"length"in e&&(0===e.length||i.node(e[0]))},i.string=function(e){return"string"==typeof e||e instanceof String},i.fn=function(e){return"[object Function]"===Object.prototype.toString.call(e)}},370:function(e,t,i){var c=i(879),d=i(438);e.exports=function(e,t,i){if(!e&&!t&&!i)throw new Error("Missing required arguments");if(!c.string(t))throw new TypeError("Second argument must be a String");if(!c.fn(i))throw new TypeError("Third argument must be a Function");if(c.node(e))return(r=e).addEventListener(o=t,l=i),{destroy:function(){r.removeEventListener(o,l)}};if(c.nodeList(e))return n=e,s=t,a=i,Array.prototype.forEach.call(n,function(e){e.addEventListener(s,a)}),{destroy:function(){Array.prototype.forEach.call(n,function(e){e.removeEventListener(s,a)})}};if(c.string(e))return d(document.body,e,t,i);throw new TypeError("First argument must be a String, HTMLElement, HTMLCollection, or NodeList");var n,s,a,r,o,l}},817:function(e){e.exports=function(e){var t,i="SELECT"===e.nodeName?(e.focus(),e.value):"INPUT"===e.nodeName||"TEXTAREA"===e.nodeName?((t=e.hasAttribute("readonly"))||e.setAttribute("readonly",""),e.select(),e.setSelectionRange(0,e.value.length),t||e.removeAttribute("readonly"),e.value):(e.hasAttribute("contenteditable")&&e.focus(),i=window.getSelection(),(t=document.createRange()).selectNodeContents(e),i.removeAllRanges(),i.addRange(t),i.toString());return i}},279:function(e){function t(){}t.prototype={on:function(e,t,i){var n=this.e||(this.e={});return(n[e]||(n[e]=[])).push({fn:t,ctx:i}),this},once:function(e,t,i){var n=this;function s(){n.off(e,s),t.apply(i,arguments)}return s._=t,this.on(e,s,i)},emit:function(e){for(var t=[].slice.call(arguments,1),i=((this.e||(this.e={}))[e]||[]).slice(),n=0,s=i.length;n<s;n++)i[n].fn.apply(i[n].ctx,t);return this},off:function(e,t){var i=this.e||(this.e={}),n=i[e],s=[];if(n&&t)for(var a=0,r=n.length;a<r;a++)n[a].fn!==t&&n[a].fn._!==t&&s.push(n[a]);return s.length?i[e]=s:delete i[e],this}},e.exports=t,e.exports.TinyEmitter=t}},s={},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,{a:t}),t},n.d=function(e,t){for(var i in t)n.o(t,i)&&!n.o(e,i)&&Object.defineProperty(e,i,{enumerable:!0,get:t[i]})},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n(134).default;function n(e){var t;return(s[e]||(t=s[e]={exports:{}},i[e](t,t.exports,n),t)).exports}var i,s});var InstantClick=function(l,s){var r,t,n,a,c,o,d,u,e=navigator.userAgent,z=-1<e.indexOf(" CriOS/"),p="createTouch"in l,h={},m=!1,g=!1,f=!1,b=!1,v={},y=!1,w=!1,_=[],E={fetch:[],receive:[],wait:[],change:[]};function x(e){var t=e.indexOf("#");return t<0?e:e.substr(0,t)}function T(e){for(;e&&"A"!=e.nodeName;)e=e.parentNode;return e}function C(e){var t=s.protocol+"//"+s.host;return!(e.target||e.hasAttribute("download")||0!=e.href.indexOf(t+"/")||-1<e.href.indexOf("#")&&x(e.href)==r||(o?!function(e){do{if(!e.hasAttribute)break;if(e.hasAttribute("data-no-instant"))return;if(e.hasAttribute("data-instant"))return 1}while(e=e.parentNode)}(e):function(e){do{if(!e.hasAttribute)break;if(e.hasAttribute("data-instant"))return;if(e.hasAttribute("data-no-instant"))return 1}while(e=e.parentNode)}(e)))}function S(e,t,i,n){for(var s,a=!1,r=0;r<E[e].length;r++)"receive"==e?(s=E[e][r](t,i,n))&&("body"in s&&(i=s.body),"title"in s&&(n=s.title),a=s):E[e][r](t,i,n);return a}function k(e,t,i,n){if(l.documentElement.replaceChild(t,l.body),i){history.pushState(null,null,i);var t=i.indexOf("#"),s=-1<t&&l.getElementById(i.substr(t+1)),a=0;if(s)for(;s.offsetParent;)a+=s.offsetTop,s=s.offsetParent;scrollTo(0,a),r=x(i)}else scrollTo(0,n);z&&l.title==e?l.title=e+String.fromCharCode(160):l.title=e,G(),D.done(),S("change",!1);t=l.createEvent("HTMLEvents");t.initEvent("instantclick:newpage",!0,!0),dispatchEvent(t)}function R(){w=y=!1}function B(e){a>+new Date-500||(e=T(e.target))&&C(e)&&M(e.href)}function F(e){a>+new Date-500||(e=T(e.target))&&C(e)&&(e.addEventListener("mouseout",W),u?(t=e.href,n=setTimeout(M,u)):M(e.href))}function H(e){a=+new Date;e=T(e.target);e&&C(e)&&(d?e.removeEventListener("mousedown",B):e.removeEventListener("mouseover",F),M(e.href))}function q(e){var t=T(e.target);t&&C(t)&&(1<e.which||e.metaKey||e.ctrlKey||(e.preventDefault(),X(t.href)))}function W(){n?(clearTimeout(n),n=!1):y&&!w&&(c.abort(),R())}function U(){if(!(c.readyState<4)&&0!=c.status){if(v.ready=+new Date-v.start,c.getResponseHeader("Content-Type").match(/\/(x|ht|xht)ml/)){var e=l.implementation.createHTMLDocument(""),t=(e.documentElement.innerHTML=c.responseText.replace(/<noscript[\s\S]+<\/noscript>/gi,""),g=e.title,b=e.body,S("receive",m,b,g)),t=(t&&("body"in t&&(b=t.body),"title"in t)&&(g=t.title),x(m));h[t]={body:b,title:g,scrollY:t in h?h[t].scrollY:0};for(var i,n=e.head.children,s=0,a=n.length-1;0<=a;a--)if((i=n[a]).hasAttribute("data-instant-track"))for(var r=i.getAttribute("href")||i.getAttribute("src")||i.innerHTML,o=_.length-1;0<=o;o--)_[o]==r&&s++;s!=_.length&&(f=!0)}else f=!0;w&&(w=!1,X(m))}}function G(e){if(l.body.addEventListener("touchstart",H,!0),d?l.body.addEventListener("mousedown",B,!0):l.body.addEventListener("mouseover",F,!0),l.body.addEventListener("click",q,!0),!e){var t,n,s,a,r=l.body.getElementsByTagName("script");for(i=0,j=r.length;i<j;i++)(t=r[i]).hasAttribute("data-no-instant")||(n=l.createElement("script"),t.src&&(n.src=t.src),t.innerHTML&&(n.innerHTML=t.innerHTML),s=t.parentNode,a=t.nextSibling,s.removeChild(t),s.insertBefore(n,a))}}function M(e){!d&&"display"in v&&+new Date-(v.start+v.display)<100||(n&&(clearTimeout(n),n=!1),e=e||t,y&&(e==m||w))||(m=e,f=b=w=!(y=!0),v={start:+new Date},S("fetch"),c.open("GET",e),c.send())}function X(e){if("display"in v||(v.display=+new Date-v.start),n||!y)return n&&m&&m!=e?s.href=e:(M(e),D.start(0,!0),S("wait"),w=!0);if(w)s.href=e;else if(f)s.href=m;else{if(!b)return D.start(0,!0),S("wait"),w=!0;h[r].scrollY=pageYOffset,R(),k(g,b,m)}}var N,O,A,L,I,D={init:function(){(N=l.createElement("div")).id="instantclick",(O=l.createElement("div")).id="instantclick-bar",O.className="instantclick-bar",N.appendChild(O);var e=["Webkit","Moz","O"];if(!((A="transform")in O.style))for(var t=0;t<3;t++)e[t]+"Transform"in O.style&&(A=e[t]+"Transform");var i="transition";if(!(i in O.style))for(t=0;t<3;t++)e[t]+"Transition"in O.style&&(i="-"+e[t].toLowerCase()+"-"+i);var n=l.createElement("style");n.innerHTML="#instantclick{position:"+(p?"absolute":"fixed")+";top:0;left:0;width:100%;pointer-events:none;z-index:2147483647;"+i+":opacity .25s .1s}.instantclick-bar{background:#29d;width:100%;margin-left:-100%;height:2px;"+i+":all .25s}",l.head.appendChild(n),p&&(P(),addEventListener("resize",P),addEventListener("scroll",P))},start:K,done:function e(){l.getElementById(N.id)?(clearTimeout(I),L=100,$(),N.style.opacity="0"):(K(100==L?0:L),setTimeout(e,0))}},Y="pushState"in history&&(!e.match("Android")||e.match("Chrome/"))&&"file:"!=s.protocol;function K(e,t){L=e,l.getElementById(N.id)&&l.body.removeChild(N),N.style.opacity="1",l.getElementById(N.id)&&l.body.removeChild(N),$(),t&&setTimeout(V,0),clearTimeout(I),I=setTimeout(Z,500)}function V(){L=10,$()}function Z(){98<=(L+=1+2*Math.random())?L=98:I=setTimeout(Z,500),$()}function $(){O.style[A]="translate("+L+"%)",l.getElementById(N.id)||l.body.appendChild(N)}function P(){N.style.left=pageXOffset+"px",N.style.width=innerWidth+"px",N.style.top=pageYOffset+"px";var e="orientation"in window&&90==Math.abs(orientation),e=innerWidth/screen[e?"height":"width"]*2;N.style[A]="scaleY("+e+")"}return{supported:Y,init:function(){if(!r)if(Y){for(var e=arguments.length-1;0<=e;e--){var t=arguments[e];!0===t?o=!0:"mousedown"==t?d=!0:"number"==typeof t&&(u=t)}r=x(s.href),h[r]={body:l.body,title:l.title,scrollY:pageYOffset};for(var i,n=l.head.children,e=n.length-1;0<=e;e--)(i=n[e]).hasAttribute("data-instant-track")&&(i=i.getAttribute("href")||i.getAttribute("src")||i.innerHTML,_.push(i));(c=new XMLHttpRequest).addEventListener("readystatechange",U),G(!0),D.init(),S("change",!0),addEventListener("popstate",function(){var e=x(s.href);e!=r&&(e in h?(h[r].scrollY=pageYOffset,k(h[r=e].title,h[e].body,!1,h[e].scrollY)):s.href=s.href)})}else S("change",!0)},on:function(e,t){E[e].push(t)}}}(document,location),hljs=(!function(e){var t,i,n=!1;"function"==typeof define&&define.amd&&(define(e),n=!0),"object"==typeof exports&&(module.exports=e(),n=!0),n||(t=window.Cookies,(i=window.Cookies=e()).noConflict=function(){return window.Cookies=t,i})}(function(){function h(){for(var e=0,t={};e<arguments.length;e++){var i,n=arguments[e];for(i in n)t[i]=n[i]}return t}return function e(u){function p(e,t,i){var n,s;if("undefined"!=typeof document){if(1<arguments.length){"number"==typeof(i=h({path:"/"},p.defaults,i)).expires&&((s=new Date).setMilliseconds(s.getMilliseconds()+864e5*i.expires),i.expires=s);try{n=JSON.stringify(t),/^[\{\[]/.test(n)&&(t=n)}catch(e){}return t=u.write?u.write(t,e):encodeURIComponent(String(t)).replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g,decodeURIComponent),e=(e=(e=encodeURIComponent(String(e))).replace(/%(23|24|26|2B|5E|60|7C)/g,decodeURIComponent)).replace(/[\(\)]/g,escape),document.cookie=[e,"=",t,i.expires?"; expires="+i.expires.toUTCString():"",i.path?"; path="+i.path:"",i.domain?"; domain="+i.domain:"",i.secure?"; secure":""].join("")}e||(n={});for(var a=document.cookie?document.cookie.split("; "):[],r=/(%[0-9A-Z]{2})+/g,o=0;o<a.length;o++){var l=a[o].split("=");'"'===(d=l.slice(1).join("=")).charAt(0)&&(d=d.slice(1,-1));try{var c=l[0].replace(r,decodeURIComponent),d=u.read?u.read(d,c):u(d,c)||d.replace(r,decodeURIComponent);if(this.json)try{d=JSON.parse(d)}catch(e){}if(e===c){n=d;break}e||(n[c]=d)}catch(e){}}return n}}return(p.set=p).get=function(e){return p.call(p,e)},p.getJSON=function(){return p.apply({json:!0},[].slice.call(arguments))},p.defaults={},p.remove=function(e,t){p(e,"",h(t,{expires:-1}))},p.withConverter=e,p}(function(){})}),
//# sourceMappingURL=js.cookie.min.js.map
/*! lozad.js - v1.16.0 - 2020-09-06
* https://github.com/ApoorvSaxena/lozad.js
* Copyright (c) 2020 Apoorv Saxena; Licensed MIT */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.lozad=t()}(this,function(){"use strict";
/**
   * Detect IE browser
   * @const {boolean}
   * @private
   */var r="undefined"!=typeof document&&document.documentMode,h={rootMargin:"0px",threshold:0,load:function(e){if("picture"===e.nodeName.toLowerCase()&&(a=!1,null===(s=e.querySelector("img"))&&(s=document.createElement("img"),a=!0),r&&e.getAttribute("data-iesrc")&&(s.src=e.getAttribute("data-iesrc")),e.getAttribute("data-alt")&&(s.alt=e.getAttribute("data-alt")),a)&&e.append(s),"video"===e.nodeName.toLowerCase()&&!e.getAttribute("data-src")&&e.children){for(var t,i=e.children,n=0;n<=i.length-1;n++)(t=i[n].getAttribute("data-src"))&&(i[n].src=t);e.load()}e.getAttribute("data-poster")&&(e.poster=e.getAttribute("data-poster")),e.getAttribute("data-src")&&(e.src=e.getAttribute("data-src")),e.getAttribute("data-srcset")&&e.setAttribute("srcset",e.getAttribute("data-srcset"));var s,a=",";e.getAttribute("data-background-delimiter")&&(a=e.getAttribute("data-background-delimiter")),e.getAttribute("data-background-image")?e.style.backgroundImage="url('"+e.getAttribute("data-background-image").split(a).join("'),url('")+"')":e.getAttribute("data-background-image-set")&&(// Substring before ... 1x
a=-1===(a=(s=e.getAttribute("data-background-image-set").split(a))[0].substr(0,s[0].indexOf(" "))||s[0]).indexOf("url(")?"url("+a+")":a,1===s.length?e.style.backgroundImage=a:e.setAttribute("style",(e.getAttribute("style")||"")+"background-image: "+a+"; background-image: -webkit-image-set("+s+"); background-image: image-set("+s+")")),e.getAttribute("data-toggle-class")&&e.classList.toggle(e.getAttribute("data-toggle-class"))},loaded:function(){}};function m(e){e.setAttribute("data-loaded",!0)}function g(e){return"true"===e.getAttribute("data-loaded")}function f(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:document;return e instanceof Element?[e]:e instanceof NodeList?e:t.querySelectorAll(e)}return function(){var i,n,s=0<arguments.length&&void 0!==arguments[0]?arguments[0]:".lozad",e=Object.assign({},h,1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}),a=e.root,t=e.rootMargin,r=e.threshold,o=e.load,l=e.loaded,c=void 0;"undefined"!=typeof window&&window.IntersectionObserver&&(c=new IntersectionObserver((i=o,n=l,function(e,t){e.forEach(function(e){(0<e.intersectionRatio||e.isIntersecting)&&(t.unobserve(e.target),g(e.target)||(i(e.target),m(e.target),n(e.target)))})}),{root:a,rootMargin:t,threshold:r}));for(var d,u=f(s,a),p=0;p<u.length;p++)(d=u[p]).getAttribute("data-placeholder-background")&&(d.style.background=d.getAttribute("data-placeholder-background"));return{observe:function(){for(var e=f(s,a),t=0;t<e.length;t++)g(e[t])||(c?c.observe(e[t]):(o(e[t]),m(e[t]),l(e[t])))},triggerLoad:function(e){g(e)||(o(e),m(e),l(e))},observer:c}}}),
/*!
  * Bootstrap v5.2.3 (https://getbootstrap.com/)
  * Copyright 2011-2022 The Bootstrap Authors (https://github.com/twbs/bootstrap/graphs/contributors)
  * Licensed under MIT (https://github.com/twbs/bootstrap/blob/main/LICENSE)
  */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).bootstrap=t()}(this,function(){"use strict";const P="transitionend",z=t=>{let i=t.getAttribute("data-bs-target");if(!i||"#"===i){let e=t.getAttribute("href");if(!e||!e.includes("#")&&!e.startsWith("."))return null;e.includes("#")&&!e.startsWith("#")&&(e="#"+e.split("#")[1]),i=e&&"#"!==e?e.trim():null}return i},R=e=>{e=z(e);return e&&document.querySelector(e)?e:null},s=e=>{e=z(e);return e?document.querySelector(e):null},B=e=>{e.dispatchEvent(new Event(P))},a=e=>!(!e||"object"!=typeof e)&&void 0!==(e=void 0!==e.jquery?e[0]:e).nodeType,n=e=>a(e)?e.jquery?e[0]:e:"string"==typeof e&&0<e.length?document.querySelector(e):null,r=e=>{if(!a(e)||0===e.getClientRects().length)return!1;const t="visible"===getComputedStyle(e).getPropertyValue("visibility"),i=e.closest("details:not([open])");if(i&&i!==e){const t=e.closest("summary");if(t&&t.parentNode!==i)return!1;if(null===t)return!1}return t},o=e=>!e||e.nodeType!==Node.ELEMENT_NODE||!!e.classList.contains("disabled")||(void 0!==e.disabled?e.disabled:e.hasAttribute("disabled")&&"false"!==e.getAttribute("disabled")),j=e=>{var t;return document.documentElement.attachShadow?"function"==typeof e.getRootNode?(t=e.getRootNode())instanceof ShadowRoot?t:null:e instanceof ShadowRoot?e:e.parentNode?j(e.parentNode):null:null},F=()=>{},H=e=>{e.offsetHeight},q=()=>window.jQuery&&!document.body.hasAttribute("data-bs-no-jquery")?window.jQuery:null,W=[],l=()=>"rtl"===document.documentElement.dir,e=n=>{var e=()=>{const e=q();if(e){const t=n.NAME,i=e.fn[t];e.fn[t]=n.jQueryInterface,e.fn[t].Constructor=n,e.fn[t].noConflict=()=>(e.fn[t]=i,n.jQueryInterface)}};"loading"===document.readyState?(W.length||document.addEventListener("DOMContentLoaded",()=>{for(const e of W)e()}),W.push(e)):e()},c=e=>{"function"==typeof e&&e()},U=(i,s,e=!0)=>{if(e){e=(()=>{if(!s)return 0;let{transitionDuration:e,transitionDelay:t}=window.getComputedStyle(s);var i=Number.parseFloat(e),n=Number.parseFloat(t);return i||n?(e=e.split(",")[0],t=t.split(",")[0],1e3*(Number.parseFloat(e)+Number.parseFloat(t))):0})()+5;let t=!1;const n=({target:e})=>{e===s&&(t=!0,s.removeEventListener(P,n),c(i))};s.addEventListener(P,n),setTimeout(()=>{t||B(s)},e)}else c(i)},G=(e,t,i,n)=>{var s=e.length;let a=e.indexOf(t);return-1===a?!i&&n?e[s-1]:e[0]:(a+=i?1:-1,n&&(a=(a+s)%s),e[Math.max(0,Math.min(a,s-1))])},X=/[^.]*(?=\..*)\.|.*/,Y=/\..*/,K=/::\d+$/,V={};let Z=1;const Q={mouseenter:"mouseover",mouseleave:"mouseout"},J=new Set(["click","dblclick","mouseup","mousedown","contextmenu","mousewheel","DOMMouseScroll","mouseover","mouseout","mousemove","selectstart","selectend","keydown","keypress","keyup","orientationchange","touchstart","touchmove","touchend","touchcancel","pointerdown","pointermove","pointerup","pointerleave","pointercancel","gesturestart","gesturechange","gestureend","focus","blur","change","reset","select","submit","focusin","focusout","load","unload","beforeunload","resize","move","DOMContentLoaded","readystatechange","error","abort","scroll"]);function ee(e,t){return t&&t+"::"+Z++||e.uidEvent||Z++}function te(e){var t=ee(e);return e.uidEvent=t,V[t]=V[t]||{},V[t]}function ie(e,t,i=null){return Object.values(e).find(e=>e.callable===t&&e.delegationSelector===i)}function ne(e,t,i){var n="string"==typeof t,t=!n&&t||i;let s=re(e);return[n,t,s=J.has(s)?s:e]}function se(n,s,a,r,o){if("string"==typeof s&&n){let[e,t,i]=ne(s,a,r);if(s in Q){const n=t=>function(e){if(!e.relatedTarget||e.relatedTarget!==e.delegateTarget&&!e.delegateTarget.contains(e.relatedTarget))return t.call(this,e)};t=n(t)}var r=te(n),r=r[i]||(r[i]={}),l=ie(r,t,e?a:null);if(l)return l.oneOff=l.oneOff&&o;var c,d,u,p,h,l=ee(t,s.replace(X,"")),s=e?(u=n,p=a,h=t,function t(i){var n=u.querySelectorAll(p);for(let e=i["target"];e&&e!==this;e=e.parentNode)for(const s of n)if(s===e)return oe(i,{delegateTarget:e}),t.oneOff&&m.off(u,i.type,p,h),h.apply(e,[i])}):(c=n,d=t,function e(t){return oe(t,{delegateTarget:c}),e.oneOff&&m.off(c,t.type,d),d.apply(c,[t])});s.delegationSelector=e?a:null,s.callable=t,s.oneOff=o,r[s.uidEvent=l]=s,n.addEventListener(i,s,e)}}function ae(e,t,i,n,s){n=ie(t[i],n,s);n&&(e.removeEventListener(i,n,Boolean(s)),delete t[i][n.uidEvent])}function re(e){return e=e.replace(Y,""),Q[e]||e}const m={on(e,t,i,n){se(e,t,i,n,!1)},one(e,t,i,n){se(e,t,i,n,!0)},off(e,t,i,n){if("string"==typeof t&&e){var[n,s,a]=ne(t,i,n),r=a!==t,o=te(e),l=o[a]||{},c=t.startsWith(".");if(void 0===s){if(c)for(const i of Object.keys(o)){d=void 0;u=void 0;p=void 0;h=void 0;m=void 0;var d=e;var u=o;var p=i;var h=t.slice(1);var m=u[p]||{};for(const g of Object.keys(m))if(g.includes(h)){const h=m[g];ae(d,u,p,h.callable,h.delegationSelector)}}for(const i of Object.keys(l)){const n=i.replace(K,"");if(!r||t.includes(n)){const t=l[i];ae(e,o,a,t.callable,t.delegationSelector)}}}else Object.keys(l).length&&ae(e,o,a,s,n?i:null)}},trigger(e,t,i){if("string"!=typeof t||!e)return null;var n=q();let s=null,a=!0,r=!0,o=!1;t!==re(t)&&n&&(s=n.Event(t,i),n(e).trigger(s),a=!s.isPropagationStopped(),r=!s.isImmediatePropagationStopped(),o=s.isDefaultPrevented());n=oe(n=new Event(t,{bubbles:a,cancelable:!0}),i);return o&&n.preventDefault(),r&&e.dispatchEvent(n),n.defaultPrevented&&s&&s.preventDefault(),n}};function oe(e,t){for(const[i,n]of Object.entries(t||{}))try{e[i]=n}catch(t){Object.defineProperty(e,i,{configurable:!0,get:()=>n})}return e}const d=new Map,le={set(e,t,i){d.has(e)||d.set(e,new Map);e=d.get(e);e.has(t)||0===e.size?e.set(t,i):console.error(`Bootstrap doesn't allow more than one instance per element. Bound instance: ${Array.from(e.keys())[0]}.`)},get:(e,t)=>d.has(e)&&d.get(e).get(t)||null,remove(e,t){var i;d.has(e)&&((i=d.get(e)).delete(t),0===i.size)&&d.delete(e)}};function ce(t){if("true"===t)return!0;if("false"===t)return!1;if(t===Number(t).toString())return Number(t);if(""===t||"null"===t)return null;if("string"!=typeof t)return t;try{return JSON.parse(decodeURIComponent(t))}catch(e){return t}}function de(e){return e.replace(/[A-Z]/g,e=>"-"+e.toLowerCase())}const u={setDataAttribute(e,t,i){e.setAttribute("data-bs-"+de(t),i)},removeDataAttribute(e,t){e.removeAttribute("data-bs-"+de(t))},getDataAttributes(t){if(!t)return{};var i={};for(const n of Object.keys(t.dataset).filter(e=>e.startsWith("bs")&&!e.startsWith("bsConfig"))){let e=n.replace(/^bs/,"");i[e=e.charAt(0).toLowerCase()+e.slice(1,e.length)]=ce(t.dataset[n])}return i},getDataAttribute:(e,t)=>ce(e.getAttribute("data-bs-"+de(t)))};class ue{static get Default(){return{}}static get DefaultType(){return{}}static get NAME(){throw new Error('You have to implement the static method "NAME", for each component!')}_getConfig(e){return e=this._mergeConfigObj(e),e=this._configAfterMerge(e),this._typeCheckConfig(e),e}_configAfterMerge(e){return e}_mergeConfigObj(e,t){var i=a(t)?u.getDataAttribute(t,"config"):{};return{...this.constructor.Default,..."object"==typeof i?i:{},...a(t)?u.getDataAttributes(t):{},..."object"==typeof e?e:{}}}_typeCheckConfig(e,t=this.constructor.DefaultType){for(const s of Object.keys(t)){var i=t[s],n=e[s],n=a(n)?"element":null==n?""+n:Object.prototype.toString.call(n).match(/\s([a-z]+)/i)[1].toLowerCase();if(!new RegExp(i).test(n))throw new TypeError(`${this.constructor.NAME.toUpperCase()}: Option "${s}" provided type "${n}" but expected type "${i}".`)}}}class t extends ue{constructor(e,t){super(),(e=n(e))&&(this._element=e,this._config=this._getConfig(t),le.set(this._element,this.constructor.DATA_KEY,this))}dispose(){le.remove(this._element,this.constructor.DATA_KEY),m.off(this._element,this.constructor.EVENT_KEY);for(const e of Object.getOwnPropertyNames(this))this[e]=null}_queueCallback(e,t,i=!0){U(e,t,i)}_getConfig(e){return e=this._mergeConfigObj(e,this._element),e=this._configAfterMerge(e),this._typeCheckConfig(e),e}static getInstance(e){return le.get(n(e),this.DATA_KEY)}static getOrCreateInstance(e,t={}){return this.getInstance(e)||new this(e,"object"==typeof t?t:null)}static get VERSION(){return"5.2.3"}static get DATA_KEY(){return"bs."+this.NAME}static get EVENT_KEY(){return"."+this.DATA_KEY}static eventName(e){return""+e+this.EVENT_KEY}}var pe=(t,i="hide")=>{const e="click.dismiss"+t.EVENT_KEY,n=t.NAME;m.on(document,e,`[data-bs-dismiss="${n}"]`,function(e){["A","AREA"].includes(this.tagName)&&e.preventDefault(),o(this)||(e=s(this)||this.closest("."+n),t.getOrCreateInstance(e)[i]())})};class he extends t{static get NAME(){return"alert"}close(){var e;m.trigger(this._element,"close.bs.alert").defaultPrevented||(this._element.classList.remove("show"),e=this._element.classList.contains("fade"),this._queueCallback(()=>this._destroyElement(),this._element,e))}_destroyElement(){this._element.remove(),m.trigger(this._element,"closed.bs.alert"),this.dispose()}static jQueryInterface(t){return this.each(function(){var e=he.getOrCreateInstance(this);if("string"==typeof t){if(void 0===e[t]||t.startsWith("_")||"constructor"===t)throw new TypeError(`No method named "${t}"`);e[t](this)}})}}pe(he,"close"),e(he);const me='[data-bs-toggle="button"]';class ge extends t{static get NAME(){return"button"}toggle(){this._element.setAttribute("aria-pressed",this._element.classList.toggle("active"))}static jQueryInterface(t){return this.each(function(){var e=ge.getOrCreateInstance(this);"toggle"===t&&e[t]()})}}m.on(document,"click.bs.button.data-api",me,e=>{e.preventDefault();e=e.target.closest(me);ge.getOrCreateInstance(e).toggle()}),e(ge);const p={find:(e,t=document.documentElement)=>[].concat(...Element.prototype.querySelectorAll.call(t,e)),findOne:(e,t=document.documentElement)=>Element.prototype.querySelector.call(t,e),children:(e,t)=>[].concat(...e.children).filter(e=>e.matches(t)),parents(e,t){var i=[];let n=e.parentNode.closest(t);for(;n;)i.push(n),n=n.parentNode.closest(t);return i},prev(e,t){let i=e.previousElementSibling;for(;i;){if(i.matches(t))return[i];i=i.previousElementSibling}return[]},next(e,t){let i=e.nextElementSibling;for(;i;){if(i.matches(t))return[i];i=i.nextElementSibling}return[]},focusableChildren(e){var t=["a","button","input","textarea","select","details","[tabindex]",'[contenteditable="true"]'].map(e=>e+':not([tabindex^="-"])').join(",");return this.find(t,e).filter(e=>!o(e)&&r(e))}},fe={endCallback:null,leftCallback:null,rightCallback:null},be={endCallback:"(function|null)",leftCallback:"(function|null)",rightCallback:"(function|null)"};class ve extends ue{constructor(e,t){super(),(this._element=e)&&ve.isSupported()&&(this._config=this._getConfig(t),this._deltaX=0,this._supportPointerEvents=Boolean(window.PointerEvent),this._initEvents())}static get Default(){return fe}static get DefaultType(){return be}static get NAME(){return"swipe"}dispose(){m.off(this._element,".bs.swipe")}_start(e){this._supportPointerEvents?this._eventIsPointerPenTouch(e)&&(this._deltaX=e.clientX):this._deltaX=e.touches[0].clientX}_end(e){this._eventIsPointerPenTouch(e)&&(this._deltaX=e.clientX-this._deltaX),this._handleSwipe(),c(this._config.endCallback)}_move(e){this._deltaX=e.touches&&1<e.touches.length?0:e.touches[0].clientX-this._deltaX}_handleSwipe(){var e=Math.abs(this._deltaX);e<=40||(e=e/this._deltaX,this._deltaX=0,e&&c(0<e?this._config.rightCallback:this._config.leftCallback))}_initEvents(){this._supportPointerEvents?(m.on(this._element,"pointerdown.bs.swipe",e=>this._start(e)),m.on(this._element,"pointerup.bs.swipe",e=>this._end(e)),this._element.classList.add("pointer-event")):(m.on(this._element,"touchstart.bs.swipe",e=>this._start(e)),m.on(this._element,"touchmove.bs.swipe",e=>this._move(e)),m.on(this._element,"touchend.bs.swipe",e=>this._end(e)))}_eventIsPointerPenTouch(e){return this._supportPointerEvents&&("pen"===e.pointerType||"touch"===e.pointerType)}static isSupported(){return"ontouchstart"in document.documentElement||0<navigator.maxTouchPoints}}const ye="next",h="prev",i="left",we="right",_e="slid.bs.carousel",Ee="carousel",xe="active",Te={ArrowLeft:we,ArrowRight:i},Ce={interval:5e3,keyboard:!0,pause:"hover",ride:!1,touch:!0,wrap:!0},Se={interval:"(number|boolean)",keyboard:"boolean",pause:"(string|boolean)",ride:"(boolean|string)",touch:"boolean",wrap:"boolean"};class ke extends t{constructor(e,t){super(e,t),this._interval=null,this._activeElement=null,this._isSliding=!1,this.touchTimeout=null,this._swipeHelper=null,this._indicatorsElement=p.findOne(".carousel-indicators",this._element),this._addEventListeners(),this._config.ride===Ee&&this.cycle()}static get Default(){return Ce}static get DefaultType(){return Se}static get NAME(){return"carousel"}next(){this._slide(ye)}nextWhenVisible(){!document.hidden&&r(this._element)&&this.next()}prev(){this._slide(h)}pause(){this._isSliding&&B(this._element),this._clearInterval()}cycle(){this._clearInterval(),this._updateInterval(),this._interval=setInterval(()=>this.nextWhenVisible(),this._config.interval)}_maybeEnableCycle(){this._config.ride&&(this._isSliding?m.one(this._element,_e,()=>this.cycle()):this.cycle())}to(e){var t,i=this._getItems();e>i.length-1||e<0||(this._isSliding?m.one(this._element,_e,()=>this.to(e)):(t=this._getItemIndex(this._getActive()))!==e&&(t=t<e?ye:h,this._slide(t,i[e])))}dispose(){this._swipeHelper&&this._swipeHelper.dispose(),super.dispose()}_configAfterMerge(e){return e.defaultInterval=e.interval,e}_addEventListeners(){this._config.keyboard&&m.on(this._element,"keydown.bs.carousel",e=>this._keydown(e)),"hover"===this._config.pause&&(m.on(this._element,"mouseenter.bs.carousel",()=>this.pause()),m.on(this._element,"mouseleave.bs.carousel",()=>this._maybeEnableCycle())),this._config.touch&&ve.isSupported()&&this._addTouchEventListeners()}_addTouchEventListeners(){for(const e of p.find(".carousel-item img",this._element))m.on(e,"dragstart.bs.carousel",e=>e.preventDefault());const e={leftCallback:()=>this._slide(this._directionToOrder(i)),rightCallback:()=>this._slide(this._directionToOrder(we)),endCallback:()=>{"hover"===this._config.pause&&(this.pause(),this.touchTimeout&&clearTimeout(this.touchTimeout),this.touchTimeout=setTimeout(()=>this._maybeEnableCycle(),500+this._config.interval))}};this._swipeHelper=new ve(this._element,e)}_keydown(e){var t;/input|textarea/i.test(e.target.tagName)||(t=Te[e.key])&&(e.preventDefault(),this._slide(this._directionToOrder(t)))}_getItemIndex(e){return this._getItems().indexOf(e)}_setActiveIndicatorElement(e){var t;this._indicatorsElement&&((t=p.findOne(".active",this._indicatorsElement)).classList.remove(xe),t.removeAttribute("aria-current"),t=p.findOne(`[data-bs-slide-to="${e}"]`,this._indicatorsElement))&&(t.classList.add(xe),t.setAttribute("aria-current","true"))}_updateInterval(){var e=this._activeElement||this._getActive();e&&(e=Number.parseInt(e.getAttribute("data-bs-interval"),10),this._config.interval=e||this._config.defaultInterval)}_slide(t,e=null){if(!this._isSliding){const i=this._getActive(),n=t===ye,s=e||G(this._getItems(),i,n,this._config.wrap);if(s!==i){const a=this._getItemIndex(s),r=e=>m.trigger(this._element,e,{relatedTarget:s,direction:this._orderToDirection(t),from:this._getItemIndex(i),to:a});if(!r("slide.bs.carousel").defaultPrevented&&i&&s){e=Boolean(this._interval);this.pause(),this._isSliding=!0,this._setActiveIndicatorElement(a),this._activeElement=s;const o=n?"carousel-item-start":"carousel-item-end",l=n?"carousel-item-next":"carousel-item-prev";s.classList.add(l),H(s),i.classList.add(o),s.classList.add(o),this._queueCallback(()=>{s.classList.remove(o,l),s.classList.add(xe),i.classList.remove(xe,l,o),this._isSliding=!1,r(_e)},i,this._isAnimated()),e&&this.cycle()}}}}_isAnimated(){return this._element.classList.contains("slide")}_getActive(){return p.findOne(".active.carousel-item",this._element)}_getItems(){return p.find(".carousel-item",this._element)}_clearInterval(){this._interval&&(clearInterval(this._interval),this._interval=null)}_directionToOrder(e){return l()?e===i?h:ye:e===i?ye:h}_orderToDirection(e){return l()?e===h?i:we:e===h?we:i}static jQueryInterface(t){return this.each(function(){var e=ke.getOrCreateInstance(this,t);if("number"!=typeof t){if("string"==typeof t){if(void 0===e[t]||t.startsWith("_")||"constructor"===t)throw new TypeError(`No method named "${t}"`);e[t]()}}else e.to(t)})}}m.on(document,"click.bs.carousel.data-api","[data-bs-slide], [data-bs-slide-to]",function(e){var t=s(this);t&&t.classList.contains(Ee)&&(e.preventDefault(),e=ke.getOrCreateInstance(t),(t=this.getAttribute("data-bs-slide-to"))?e.to(t):"next"===u.getDataAttribute(this,"slide")?e.next():e.prev(),e._maybeEnableCycle())}),m.on(window,"load.bs.carousel.data-api",()=>{for(const e of p.find('[data-bs-ride="carousel"]'))ke.getOrCreateInstance(e)}),e(ke);const Me="show",Ne="collapse",Oe="collapsing",Ae='[data-bs-toggle="collapse"]',Le={parent:null,toggle:!0},Ie={parent:"(null|element)",toggle:"boolean"};class De extends t{constructor(e,t){super(e,t),this._isTransitioning=!1,this._triggerArray=[];const i=p.find(Ae);for(const e of i){const t=R(e),i=p.find(t).filter(e=>e===this._element);null!==t&&i.length&&this._triggerArray.push(e)}this._initializeChildren(),this._config.parent||this._addAriaAndCollapsedClass(this._triggerArray,this._isShown()),this._config.toggle&&this.toggle()}static get Default(){return Le}static get DefaultType(){return Ie}static get NAME(){return"collapse"}toggle(){this._isShown()?this.hide():this.show()}show(){if(!this._isTransitioning&&!this._isShown()){let e=[];if(!((e=this._config.parent?this._getFirstLevelChildren(".collapse.show, .collapse.collapsing").filter(e=>e!==this._element).map(e=>De.getOrCreateInstance(e,{toggle:!1})):e).length&&e[0]._isTransitioning||m.trigger(this._element,"show.bs.collapse").defaultPrevented)){for(const i of e)i.hide();const i=this._getDimension();this._element.classList.remove(Ne),this._element.classList.add(Oe),this._element.style[i]=0,this._addAriaAndCollapsedClass(this._triggerArray,!0),this._isTransitioning=!0;var t="scroll"+(i[0].toUpperCase()+i.slice(1));this._queueCallback(()=>{this._isTransitioning=!1,this._element.classList.remove(Oe),this._element.classList.add(Ne,Me),this._element.style[i]="",m.trigger(this._element,"shown.bs.collapse")},this._element,!0),this._element.style[i]=this._element[t]+"px"}}}hide(){if(!this._isTransitioning&&this._isShown()&&!m.trigger(this._element,"hide.bs.collapse").defaultPrevented){const t=this._getDimension();this._element.style[t]=this._element.getBoundingClientRect()[t]+"px",H(this._element),this._element.classList.add(Oe),this._element.classList.remove(Ne,Me);for(const t of this._triggerArray){var e=s(t);e&&!this._isShown(e)&&this._addAriaAndCollapsedClass([t],!1)}this._isTransitioning=!0,this._element.style[t]="",this._queueCallback(()=>{this._isTransitioning=!1,this._element.classList.remove(Oe),this._element.classList.add(Ne),m.trigger(this._element,"hidden.bs.collapse")},this._element,!0)}}_isShown(e=this._element){return e.classList.contains(Me)}_configAfterMerge(e){return e.toggle=Boolean(e.toggle),e.parent=n(e.parent),e}_getDimension(){return this._element.classList.contains("collapse-horizontal")?"width":"height"}_initializeChildren(){if(this._config.parent){const e=this._getFirstLevelChildren(Ae);for(const t of e){const e=s(t);e&&this._addAriaAndCollapsedClass([t],this._isShown(e))}}}_getFirstLevelChildren(e){const t=p.find(":scope .collapse .collapse",this._config.parent);return p.find(e,this._config.parent).filter(e=>!t.includes(e))}_addAriaAndCollapsedClass(e,t){if(e.length)for(const i of e)i.classList.toggle("collapsed",!t),i.setAttribute("aria-expanded",t)}static jQueryInterface(t){const i={};return"string"==typeof t&&/show|hide/.test(t)&&(i.toggle=!1),this.each(function(){var e=De.getOrCreateInstance(this,i);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t]()}})}}m.on(document,"click.bs.collapse.data-api",Ae,function(e){("A"===e.target.tagName||e.delegateTarget&&"A"===e.delegateTarget.tagName)&&e.preventDefault();var t=R(this);for(const e of p.find(t))De.getOrCreateInstance(e,{toggle:!1}).toggle()}),e(De);var k="top",M="bottom",N="right",O="left",$e="auto",A=[k,M,N,O],L="start",y="end",Pe="clippingParents",ze="viewport",f="popper",Re="reference",Be=A.reduce(function(e,t){return e.concat([t+"-"+L,t+"-"+y])},[]),je=[].concat(A,[$e]).reduce(function(e,t){return e.concat([t,t+"-"+L,t+"-"+y])},[]),Fe="beforeRead",He="afterRead",qe="beforeMain",We="afterMain",Ue="beforeWrite",Ge="afterWrite",Xe=[Fe,"read",He,qe,"main",We,Ue,"write",Ge];function b(e){return e?(e.nodeName||"").toLowerCase():null}function w(e){var t;return null==e?window:"[object Window]"!==e.toString()?(t=e.ownerDocument)&&t.defaultView||window:e}function v(e){return e instanceof w(e).Element||e instanceof Element}function _(e){return e instanceof w(e).HTMLElement||e instanceof HTMLElement}function Ye(e){return"undefined"!=typeof ShadowRoot&&(e instanceof w(e).ShadowRoot||e instanceof ShadowRoot)}var Ke={name:"applyStyles",enabled:!0,phase:"write",fn:function(e){var s=e.state;Object.keys(s.elements).forEach(function(e){var t=s.styles[e]||{},i=s.attributes[e]||{},n=s.elements[e];_(n)&&b(n)&&(Object.assign(n.style,t),Object.keys(i).forEach(function(e){var t=i[e];!1===t?n.removeAttribute(e):n.setAttribute(e,!0===t?"":t)}))})},effect:function(e){var n=e.state,s={popper:{position:n.options.strategy,left:"0",top:"0",margin:"0"},arrow:{position:"absolute"},reference:{}};return Object.assign(n.elements.popper.style,s.popper),n.styles=s,n.elements.arrow&&Object.assign(n.elements.arrow.style,s.arrow),function(){Object.keys(n.elements).forEach(function(e){var t=n.elements[e],i=n.attributes[e]||{},e=Object.keys((n.styles.hasOwnProperty(e)?n.styles:s)[e]).reduce(function(e,t){return e[t]="",e},{});_(t)&&b(t)&&(Object.assign(t.style,e),Object.keys(i).forEach(function(e){t.removeAttribute(e)}))})}},requires:["computeStyles"]};function I(e){return e.split("-")[0]}var S=Math.max,Ve=Math.min,E=Math.round;function Ze(){var e=navigator.userAgentData;return null!=e&&e.brands?e.brands.map(function(e){return e.brand+"/"+e.version}).join(" "):navigator.userAgent}function Qe(){return!/^((?!chrome|android).)*safari/i.test(Ze())}function x(e,t,i){void 0===t&&(t=!1),void 0===i&&(i=!1);var n=e.getBoundingClientRect(),s=1,a=1,t=(t&&_(e)&&(s=0<e.offsetWidth&&E(n.width)/e.offsetWidth||1,a=0<e.offsetHeight&&E(n.height)/e.offsetHeight||1),(v(e)?w(e):window).visualViewport),e=!Qe()&&i,i=(n.left+(e&&t?t.offsetLeft:0))/s,e=(n.top+(e&&t?t.offsetTop:0))/a,t=n.width/s,s=n.height/a;return{width:t,height:s,top:e,right:i+t,bottom:e+s,left:i,x:i,y:e}}function Je(e){var t=x(e),i=e.offsetWidth,n=e.offsetHeight;return Math.abs(t.width-i)<=1&&(i=t.width),Math.abs(t.height-n)<=1&&(n=t.height),{x:e.offsetLeft,y:e.offsetTop,width:i,height:n}}function et(e,t){var i=t.getRootNode&&t.getRootNode();if(e.contains(t))return!0;if(i&&Ye(i)){var n=t;do{if(n&&e.isSameNode(n))return!0}while(n=n.parentNode||n.host)}return!1}function T(e){return w(e).getComputedStyle(e)}function C(e){return((v(e)?e.ownerDocument:e.document)||window.document).documentElement}function tt(e){return"html"===b(e)?e:e.assignedSlot||e.parentNode||(Ye(e)?e.host:null)||C(e)}function it(e){return _(e)&&"fixed"!==T(e).position?e.offsetParent:null}function nt(e){for(var t,i=w(e),n=it(e);n&&(t=n,0<=["table","td","th"].indexOf(b(t)))&&"static"===T(n).position;)n=it(n);return(!n||"html"!==b(n)&&("body"!==b(n)||"static"!==T(n).position))&&(n||function(e){var t=/firefox/i.test(Ze());if(!/Trident/i.test(Ze())||!_(e)||"fixed"!==T(e).position){var i=tt(e);for(Ye(i)&&(i=i.host);_(i)&&["html","body"].indexOf(b(i))<0;){var n=T(i);if("none"!==n.transform||"none"!==n.perspective||"paint"===n.contain||-1!==["transform","perspective"].indexOf(n.willChange)||t&&"filter"===n.willChange||t&&n.filter&&"none"!==n.filter)return i;i=i.parentNode}}return null}(e))||i}function st(e){return 0<=["top","bottom"].indexOf(e)?"x":"y"}function at(e,t,i){return S(e,Ve(t,i))}function rt(e){return Object.assign({},{top:0,right:0,bottom:0,left:0},e)}function ot(i,e){return e.reduce(function(e,t){return e[t]=i,e},{})}var lt={name:"arrow",enabled:!0,phase:"main",fn:function(e){var t,i,n,s,a=e.state,r=e.name,e=e.options,o=a.elements.arrow,l=a.modifiersData.popperOffsets,c=I(a.placement),d=st(c),c=0<=[O,N].indexOf(c)?"height":"width";o&&l&&(e=rt("number"!=typeof(e="function"==typeof(e=e.padding)?e(Object.assign({},a.rects,{placement:a.placement})):e)?e:ot(e,A)),t=Je(o),s="y"===d?k:O,n="y"===d?M:N,i=a.rects.reference[c]+a.rects.reference[d]-l[d]-a.rects.popper[c],l=l[d]-a.rects.reference[d],o=(o=nt(o))?"y"===d?o.clientHeight||0:o.clientWidth||0:0,s=e[s],e=o-t[c]-e[n],s=at(s,n=o/2-t[c]/2+(i/2-l/2),e),a.modifiersData[r]=((o={})[d]=s,o.centerOffset=s-n,o))},effect:function(e){var t=e.state,e=e.options.element,e=void 0===e?"[data-popper-arrow]":e;null!=e&&("string"!=typeof e||(e=t.elements.popper.querySelector(e)))&&et(t.elements.popper,e)&&(t.elements.arrow=e)},requires:["popperOffsets"],requiresIfExists:["preventOverflow"]};function ct(e){return e.split("-")[1]}var dt={top:"auto",right:"auto",bottom:"auto",left:"auto"};function ut(e){var t,i=e.popper,n=e.popperRect,s=e.placement,a=e.variation,r=e.offsets,o=e.position,l=e.gpuAcceleration,c=e.adaptive,d=e.roundOffsets,e=e.isFixed,u=r.x,u=void 0===u?0:u,p=r.y,p=void 0===p?0:p,h="function"==typeof d?d({x:u,y:p}):{x:u,y:p},u=h.x,p=h.y,h=r.hasOwnProperty("x"),r=r.hasOwnProperty("y"),m=O,g=k,f=window;c&&(v="clientHeight",t="clientWidth",(b=nt(i))===w(i)&&"static"!==T(b=C(i)).position&&"absolute"===o&&(v="scrollHeight",t="scrollWidth"),s!==k&&(s!==O&&s!==N||a!==y)||(g=M,p=(p-((e&&b===f&&f.visualViewport?f.visualViewport.height:b[v])-n.height))*(l?1:-1)),s!==O&&(s!==k&&s!==M||a!==y)||(m=N,u=(u-((e&&b===f&&f.visualViewport?f.visualViewport.width:b[t])-n.width))*(l?1:-1)));var b,v,i=Object.assign({position:o},c&&dt),e=!0===d?(s=(v={x:u,y:p}).y,a=window.devicePixelRatio||1,{x:E(v.x*a)/a||0,y:E(s*a)/a||0}):{x:u,y:p};return u=e.x,p=e.y,l?Object.assign({},i,((b={})[g]=r?"0":"",b[m]=h?"0":"",b.transform=(f.devicePixelRatio||1)<=1?"translate("+u+"px, "+p+"px)":"translate3d("+u+"px, "+p+"px, 0)",b)):Object.assign({},i,((t={})[g]=r?p+"px":"",t[m]=h?u+"px":"",t.transform="",t))}var pt={name:"computeStyles",enabled:!0,phase:"beforeWrite",fn:function(e){var t=e.state,e=e.options,i=e.gpuAcceleration,i=void 0===i||i,n=e.adaptive,n=void 0===n||n,e=e.roundOffsets,e=void 0===e||e,i={placement:I(t.placement),variation:ct(t.placement),popper:t.elements.popper,popperRect:t.rects.popper,gpuAcceleration:i,isFixed:"fixed"===t.options.strategy};null!=t.modifiersData.popperOffsets&&(t.styles.popper=Object.assign({},t.styles.popper,ut(Object.assign({},i,{offsets:t.modifiersData.popperOffsets,position:t.options.strategy,adaptive:n,roundOffsets:e})))),null!=t.modifiersData.arrow&&(t.styles.arrow=Object.assign({},t.styles.arrow,ut(Object.assign({},i,{offsets:t.modifiersData.arrow,position:"absolute",adaptive:!1,roundOffsets:e})))),t.attributes.popper=Object.assign({},t.attributes.popper,{"data-popper-placement":t.placement})},data:{}},ht={passive:!0},mt={name:"eventListeners",enabled:!0,phase:"write",fn:function(){},effect:function(e){var t=e.state,i=e.instance,e=e.options,n=e.scroll,s=void 0===n||n,n=e.resize,a=void 0===n||n,r=w(t.elements.popper),o=[].concat(t.scrollParents.reference,t.scrollParents.popper);return s&&o.forEach(function(e){e.addEventListener("scroll",i.update,ht)}),a&&r.addEventListener("resize",i.update,ht),function(){s&&o.forEach(function(e){e.removeEventListener("scroll",i.update,ht)}),a&&r.removeEventListener("resize",i.update,ht)}},data:{}},gt={left:"right",right:"left",bottom:"top",top:"bottom"};function ft(e){return e.replace(/left|right|bottom|top/g,function(e){return gt[e]})}var bt={start:"end",end:"start"};function vt(e){return e.replace(/start|end/g,function(e){return bt[e]})}function yt(e){e=w(e);return{scrollLeft:e.pageXOffset,scrollTop:e.pageYOffset}}function wt(e){return x(C(e)).left+yt(e).scrollLeft}function _t(e){var e=T(e),t=e.overflow,i=e.overflowX,e=e.overflowY;return/auto|scroll|overlay|hidden/.test(t+e+i)}function Et(e,t){void 0===t&&(t=[]);var i=function e(t){return 0<=["html","body","#document"].indexOf(b(t))?t.ownerDocument.body:_(t)&&_t(t)?t:e(tt(t))}(e),e=i===(null==(e=e.ownerDocument)?void 0:e.body),n=w(i),n=e?[n].concat(n.visualViewport||[],_t(i)?i:[]):i,i=t.concat(n);return e?i:i.concat(Et(tt(n)))}function xt(e){return Object.assign({},e,{left:e.x,top:e.y,right:e.x+e.width,bottom:e.y+e.height})}function Tt(e,t,i){return t===ze?xt((s=i,r=w(n=e),o=C(n),r=r.visualViewport,l=o.clientWidth,o=o.clientHeight,d=c=0,r&&(l=r.width,o=r.height,(a=Qe())||!a&&"fixed"===s)&&(c=r.offsetLeft,d=r.offsetTop),{width:l,height:o,x:c+wt(n),y:d})):v(t)?((s=x(a=t,!1,"fixed"===i)).top=s.top+a.clientTop,s.left=s.left+a.clientLeft,s.bottom=s.top+a.clientHeight,s.right=s.left+a.clientWidth,s.width=a.clientWidth,s.height=a.clientHeight,s.x=s.left,s.y=s.top,s):xt((r=C(e),l=C(r),o=yt(r),c=null==(c=r.ownerDocument)?void 0:c.body,n=S(l.scrollWidth,l.clientWidth,c?c.scrollWidth:0,c?c.clientWidth:0),d=S(l.scrollHeight,l.clientHeight,c?c.scrollHeight:0,c?c.clientHeight:0),r=-o.scrollLeft+wt(r),o=-o.scrollTop,"rtl"===T(c||l).direction&&(r+=S(l.clientWidth,c?c.clientWidth:0)-n),{width:n,height:d,x:r,y:o}));var n,s,a,r,o,l,c,d}function Ct(e){var t,i=e.reference,n=e.element,e=e.placement,s=e?I(e):null,e=e?ct(e):null,a=i.x+i.width/2-n.width/2,r=i.y+i.height/2-n.height/2;switch(s){case k:t={x:a,y:i.y-n.height};break;case M:t={x:a,y:i.y+i.height};break;case N:t={x:i.x+i.width,y:r};break;case O:t={x:i.x-n.width,y:r};break;default:t={x:i.x,y:i.y}}var o=s?st(s):null;if(null!=o){var l="y"===o?"height":"width";switch(e){case L:t[o]=t[o]-(i[l]/2-n[l]/2);break;case y:t[o]=t[o]+(i[l]/2-n[l]/2)}}return t}function St(e,t){var i,n,s,a,r,o,t=t=void 0===t?{}:t,l=t.placement,l=void 0===l?e.placement:l,c=t.strategy,c=void 0===c?e.strategy:c,d=t.boundary,d=void 0===d?Pe:d,u=t.rootBoundary,u=void 0===u?ze:u,p=t.elementContext,p=void 0===p?f:p,h=t.altBoundary,h=void 0!==h&&h,t=t.padding,t=void 0===t?0:t,t=rt("number"!=typeof t?t:ot(t,A)),m=e.rects.popper,h=e.elements[h?p===f?Re:f:p],c=(i=v(h)?h:h.contextElement||C(e.elements.popper),h=u,n=c,a="clippingParents"===(u=d)?(r=Et(tt(a=i)),v(s=0<=["absolute","fixed"].indexOf(T(a).position)&&_(a)?nt(a):a)?r.filter(function(e){return v(e)&&et(e,s)&&"body"!==b(e)}):[]):[].concat(u),r=[].concat(a,[h]),u=r[0],(h=r.reduce(function(e,t){t=Tt(i,t,n);return e.top=S(t.top,e.top),e.right=Ve(t.right,e.right),e.bottom=Ve(t.bottom,e.bottom),e.left=S(t.left,e.left),e},Tt(i,u,n))).width=h.right-h.left,h.height=h.bottom-h.top,h.x=h.left,h.y=h.top,h),d=x(e.elements.reference),u=Ct({reference:d,element:m,strategy:"absolute",placement:l}),h=xt(Object.assign({},m,u)),m=p===f?h:d,g={top:c.top-m.top+t.top,bottom:m.bottom-c.bottom+t.bottom,left:c.left-m.left+t.left,right:m.right-c.right+t.right},u=e.modifiersData.offset;return p===f&&u&&(o=u[l],Object.keys(g).forEach(function(e){var t=0<=[N,M].indexOf(e)?1:-1,i=0<=[k,M].indexOf(e)?"y":"x";g[e]+=o[i]*t})),g}var kt={name:"flip",enabled:!0,phase:"main",fn:function(e){var u=e.state,t=e.options,e=e.name;if(!u.modifiersData[e]._skip){for(var i=t.mainAxis,n=void 0===i||i,i=t.altAxis,s=void 0===i||i,i=t.fallbackPlacements,p=t.padding,h=t.boundary,m=t.rootBoundary,a=t.altBoundary,r=t.flipVariations,g=void 0===r||r,f=t.allowedAutoPlacements,r=u.options.placement,t=I(r),i=i||(t!==r&&g?I(i=r)===$e?[]:(t=ft(i),[vt(i),t,vt(t)]):[ft(r)]),o=[r].concat(i).reduce(function(e,t){return e.concat(I(t)===$e?(i=u,n=(e=e=void 0===(e={placement:t,boundary:h,rootBoundary:m,padding:p,flipVariations:g,allowedAutoPlacements:f})?{}:e).placement,s=e.boundary,a=e.rootBoundary,r=e.padding,o=e.flipVariations,l=void 0===(e=e.allowedAutoPlacements)?je:e,c=ct(n),e=c?o?Be:Be.filter(function(e){return ct(e)===c}):A,d=(n=0===(n=e.filter(function(e){return 0<=l.indexOf(e)})).length?e:n).reduce(function(e,t){return e[t]=St(i,{placement:t,boundary:s,rootBoundary:a,padding:r})[I(t)],e},{}),Object.keys(d).sort(function(e,t){return d[e]-d[t]})):t);var i,n,s,a,r,o,l,c,d},[]),l=u.rects.reference,c=u.rects.popper,d=new Map,b=!0,v=o[0],y=0;y<o.length;y++){var w=o[y],_=I(w),E=ct(w)===L,x=0<=[k,M].indexOf(_),T=x?"width":"height",C=St(u,{placement:w,boundary:h,rootBoundary:m,altBoundary:a,padding:p}),x=x?E?N:O:E?M:k,E=(l[T]>c[T]&&(x=ft(x)),ft(x)),T=[];if(n&&T.push(C[_]<=0),s&&T.push(C[x]<=0,C[E]<=0),T.every(function(e){return e})){v=w,b=!1;break}d.set(w,T)}if(b)for(var S=g?3:1;0<S&&"break"!==function(t){var e=o.find(function(e){e=d.get(e);if(e)return e.slice(0,t).every(function(e){return e})});if(e)return v=e,"break"}(S);S--);u.placement!==v&&(u.modifiersData[e]._skip=!0,u.placement=v,u.reset=!0)}},requiresIfExists:["offset"],data:{_skip:!1}};function Mt(e,t,i){return{top:e.top-t.height-(i=void 0===i?{x:0,y:0}:i).y,right:e.right-t.width+i.x,bottom:e.bottom-t.height+i.y,left:e.left-t.width-i.x}}function Nt(t){return[k,N,M,O].some(function(e){return 0<=t[e]})}var Ot={name:"hide",enabled:!0,phase:"main",requiresIfExists:["preventOverflow"],fn:function(e){var t=e.state,e=e.name,i=t.rects.reference,n=t.rects.popper,s=t.modifiersData.preventOverflow,a=St(t,{elementContext:"reference"}),r=St(t,{altBoundary:!0}),a=Mt(a,i),i=Mt(r,n,s),r=Nt(a),n=Nt(i);t.modifiersData[e]={referenceClippingOffsets:a,popperEscapeOffsets:i,isReferenceHidden:r,hasPopperEscaped:n},t.attributes.popper=Object.assign({},t.attributes.popper,{"data-popper-reference-hidden":r,"data-popper-escaped":n})}},At={name:"offset",enabled:!0,phase:"main",requires:["popperOffsets"],fn:function(e){var r=e.state,t=e.options,e=e.name,t=t.offset,o=void 0===t?[0,0]:t,t=je.reduce(function(e,t){return e[t]=(t=t,i=r.rects,n=o,s=I(t),a=0<=[O,k].indexOf(s)?-1:1,i="function"==typeof n?n(Object.assign({},i,{placement:t})):n,t=i[0]||0,n=(i[1]||0)*a,0<=[O,N].indexOf(s)?{x:n,y:t}:{x:t,y:n}),e;var i,n,s,a},{}),i=t[r.placement],n=i.x,i=i.y;null!=r.modifiersData.popperOffsets&&(r.modifiersData.popperOffsets.x+=n,r.modifiersData.popperOffsets.y+=i),r.modifiersData[e]=t}},Lt={name:"popperOffsets",enabled:!0,phase:"read",fn:function(e){var t=e.state,e=e.name;t.modifiersData[e]=Ct({reference:t.rects.reference,element:t.rects.popper,strategy:"absolute",placement:t.placement})},data:{}},It={name:"preventOverflow",enabled:!0,phase:"main",fn:function(e){var t,i,n,s,a,r,o,l,c,d=e.state,u=e.options,e=e.name,p=u.mainAxis,p=void 0===p||p,h=u.altAxis,h=void 0!==h&&h,m=u.boundary,g=u.rootBoundary,f=u.altBoundary,b=u.padding,v=u.tether,v=void 0===v||v,u=u.tetherOffset,u=void 0===u?0:u,m=St(d,{boundary:m,rootBoundary:g,padding:b,altBoundary:f}),g=I(d.placement),b=ct(d.placement),f=!b,y=st(g),w="x"===y?"y":"x",_=d.modifiersData.popperOffsets,E=d.rects.reference,x=d.rects.popper,u="function"==typeof u?u(Object.assign({},d.rects,{placement:d.placement})):u,u="number"==typeof u?{mainAxis:u,altAxis:u}:Object.assign({mainAxis:0,altAxis:0},u),T=d.modifiersData.offset?d.modifiersData.offset[d.placement]:null,C={x:0,y:0};_&&(p&&(p="y"===y?"height":"width",r=(o=_[y])+m[i="y"===y?k:O],l=o-m[c="y"===y?M:N],t=v?-x[p]/2:0,s=(b===L?E:x)[p],b=b===L?-x[p]:-E[p],a=d.elements.arrow,a=v&&a?Je(a):{width:0,height:0},i=(n=d.modifiersData["arrow#persistent"]?d.modifiersData["arrow#persistent"].padding:{top:0,right:0,bottom:0,left:0})[i],n=n[c],c=at(0,E[p],a[p]),a=f?E[p]/2-t-c-i-u.mainAxis:s-c-i-u.mainAxis,s=f?-E[p]/2+t+c+n+u.mainAxis:b+c+n+u.mainAxis,f=(i=d.elements.arrow&&nt(d.elements.arrow))?"y"===y?i.clientTop||0:i.clientLeft||0:0,b=o+s-(t=null!=(p=null==T?void 0:T[y])?p:0),c=at(v?Ve(r,o+a-t-f):r,o,v?S(l,b):l),_[y]=c,C[y]=c-o),h&&(n="y"==w?"height":"width",s=(i=_[w])+m["x"===y?k:O],p=i-m["x"===y?M:N],a=-1!==[k,O].indexOf(g),f=null!=(t=null==T?void 0:T[w])?t:0,r=a?s:i-E[n]-x[n]-f+u.altAxis,b=a?i+E[n]+x[n]-f-u.altAxis:p,o=v&&a?(c=at(r,i,l=b),l<c?l:c):at(v?r:s,i,v?b:p),_[w]=o,C[w]=o-i),d.modifiersData[e]=C)},requiresIfExists:["offset"]};function Dt(e){var i=new Map,n=new Set,s=[];return e.forEach(function(e){i.set(e.name,e)}),e.forEach(function(e){n.has(e.name)||function t(e){n.add(e.name),[].concat(e.requires||[],e.requiresIfExists||[]).forEach(function(e){n.has(e)||(e=i.get(e))&&t(e)}),s.push(e)}(e)}),s}var $t={placement:"bottom",modifiers:[],strategy:"absolute"};function Pt(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];return!t.some(function(e){return!(e&&"function"==typeof e.getBoundingClientRect)})}function zt(e){var e=e=void 0===e?{}:e,t=e.defaultModifiers,l=void 0===t?[]:t,t=e.defaultOptions,c=void 0===t?$t:t;return function(n,s,t){void 0===t&&(t=c);var i,a,h={placement:"bottom",orderedModifiers:[],options:Object.assign({},$t,c),modifiersData:{},elements:{reference:n,popper:s},attributes:{},styles:{}},r=[],m=!1,g={state:h,setOptions:function(e){e="function"==typeof e?e(h.options):e;o(),h.options=Object.assign({},c,h.options,e),h.scrollParents={reference:v(n)?Et(n):n.contextElement?Et(n.contextElement):[],popper:Et(s)};e=[].concat(l,h.options.modifiers),t=e.reduce(function(e,t){var i=e[t.name];return e[t.name]=i?Object.assign({},i,t,{options:Object.assign({},i.options,t.options),data:Object.assign({},i.data,t.data)}):t,e},{}),i=Dt(Object.keys(t).map(function(e){return t[e]}));var t,i,e=Xe.reduce(function(e,t){return e.concat(i.filter(function(e){return e.phase===t}))},[]);return h.orderedModifiers=e.filter(function(e){return e.enabled}),h.orderedModifiers.forEach(function(e){var t=e.name,i=e.options,e=e.effect;"function"==typeof e&&(e=e({state:h,name:t,instance:g,options:void 0===i?{}:i}),r.push(e||function(){}))}),g.update()},forceUpdate:function(){if(!m){var e=h.elements,t=e.reference,e=e.popper;if(Pt(t,e)){h.rects={reference:(t=t,r=nt(e),void 0===(o="fixed"===h.options.strategy)&&(o=!1),l=_(r),c=_(r)&&(u=(c=r).getBoundingClientRect(),d=E(u.width)/c.offsetWidth||1,u=E(u.height)/c.offsetHeight||1,1!==d||1!==u),d=C(r),u=x(t,c,o),t={scrollLeft:0,scrollTop:0},p={x:0,y:0},!l&&o||("body"===b(r)&&!_t(d)||(t=(l=r)!==w(l)&&_(l)?{scrollLeft:l.scrollLeft,scrollTop:l.scrollTop}:yt(l)),_(r)?((p=x(r,!0)).x+=r.clientLeft,p.y+=r.clientTop):d&&(p.x=wt(d))),{x:u.left+t.scrollLeft-p.x,y:u.top+t.scrollTop-p.y,width:u.width,height:u.height}),popper:Je(e)},h.reset=!1,h.placement=h.options.placement,h.orderedModifiers.forEach(function(e){return h.modifiersData[e.name]=Object.assign({},e.data)});for(var i,n,s,a=0;a<h.orderedModifiers.length;a++)!0!==h.reset?(i=(s=h.orderedModifiers[a]).fn,n=s.options,s=s.name,"function"==typeof i&&(h=i({state:h,options:void 0===n?{}:n,name:s,instance:g})||h)):(h.reset=!1,a=-1)}}var r,o,l,c,d,u,p},update:(i=function(){return new Promise(function(e){g.forceUpdate(),e(h)})},function(){return a=a||new Promise(function(e){Promise.resolve().then(function(){a=void 0,e(i())})})}),destroy:function(){o(),m=!0}};return Pt(n,s)&&g.setOptions(t).then(function(e){!m&&t.onFirstUpdate&&t.onFirstUpdate(e)}),g;function o(){r.forEach(function(e){return e()}),r=[]}}}var Rt=zt(),Bt=zt({defaultModifiers:[mt,Lt,pt,Ke]}),jt=zt({defaultModifiers:[mt,Lt,pt,Ke,At,kt,It,lt,Ot]});const Ft=Object.freeze(Object.defineProperty({__proto__:null,popperGenerator:zt,detectOverflow:St,createPopperBase:Rt,createPopper:jt,createPopperLite:Bt,top:k,bottom:M,right:N,left:O,auto:$e,basePlacements:A,start:L,end:y,clippingParents:Pe,viewport:ze,popper:f,reference:Re,variationPlacements:Be,placements:je,beforeRead:Fe,read:"read",afterRead:He,beforeMain:qe,main:"main",afterMain:We,beforeWrite:Ue,write:"write",afterWrite:Ge,modifierPhases:Xe,applyStyles:Ke,arrow:lt,computeStyles:pt,eventListeners:mt,flip:kt,hide:Ot,offset:At,popperOffsets:Lt,preventOverflow:It},Symbol.toStringTag,{value:"Module"})),Ht="dropdown",qt="ArrowDown",Wt="click.bs.dropdown.data-api",Ut="keydown.bs.dropdown.data-api",Gt="show",g='[data-bs-toggle="dropdown"]:not(.disabled):not(:disabled)',Xt=(g,".dropdown-menu"),Yt=l()?"top-end":"top-start",Kt=l()?"top-start":"top-end",Vt=l()?"bottom-end":"bottom-start",Zt=l()?"bottom-start":"bottom-end",Qt=l()?"left-start":"right-start",Jt=l()?"right-start":"left-start",ei={autoClose:!0,boundary:"clippingParents",display:"dynamic",offset:[0,2],popperConfig:null,reference:"toggle"},ti={autoClose:"(boolean|string)",boundary:"(string|element)",display:"string",offset:"(array|string|function)",popperConfig:"(null|object|function)",reference:"(string|element|object)"};class D extends t{constructor(e,t){super(e,t),this._popper=null,this._parent=this._element.parentNode,this._menu=p.next(this._element,Xt)[0]||p.prev(this._element,Xt)[0]||p.findOne(Xt,this._parent),this._inNavbar=this._detectNavbar()}static get Default(){return ei}static get DefaultType(){return ti}static get NAME(){return Ht}toggle(){return this._isShown()?this.hide():this.show()}show(){if(!o(this._element)&&!this._isShown()){const e={relatedTarget:this._element};if(!m.trigger(this._element,"show.bs.dropdown",e).defaultPrevented){if(this._createPopper(),"ontouchstart"in document.documentElement&&!this._parent.closest(".navbar-nav"))for(const e of[].concat(...document.body.children))m.on(e,"mouseover",F);this._element.focus(),this._element.setAttribute("aria-expanded",!0),this._menu.classList.add(Gt),this._element.classList.add(Gt),m.trigger(this._element,"shown.bs.dropdown",e)}}}hide(){var e;!o(this._element)&&this._isShown()&&(e={relatedTarget:this._element},this._completeHide(e))}dispose(){this._popper&&this._popper.destroy(),super.dispose()}update(){this._inNavbar=this._detectNavbar(),this._popper&&this._popper.update()}_completeHide(e){if(!m.trigger(this._element,"hide.bs.dropdown",e).defaultPrevented){if("ontouchstart"in document.documentElement)for(const e of[].concat(...document.body.children))m.off(e,"mouseover",F);this._popper&&this._popper.destroy(),this._menu.classList.remove(Gt),this._element.classList.remove(Gt),this._element.setAttribute("aria-expanded","false"),u.removeDataAttribute(this._menu,"popper"),m.trigger(this._element,"hidden.bs.dropdown",e)}}_getConfig(e){if("object"!=typeof(e=super._getConfig(e)).reference||a(e.reference)||"function"==typeof e.reference.getBoundingClientRect)return e;throw new TypeError(Ht.toUpperCase()+': Option "reference" provided type "object" without a required "getBoundingClientRect" method.')}_createPopper(){if(void 0===Ft)throw new TypeError("Bootstrap's dropdowns require Popper (https://popper.js.org)");let e=this._element;"parent"===this._config.reference?e=this._parent:a(this._config.reference)?e=n(this._config.reference):"object"==typeof this._config.reference&&(e=this._config.reference);var t=this._getPopperConfig();this._popper=jt(e,this._menu,t)}_isShown(){return this._menu.classList.contains(Gt)}_getPlacement(){var e,t=this._parent;return t.classList.contains("dropend")?Qt:t.classList.contains("dropstart")?Jt:t.classList.contains("dropup-center")?"top":t.classList.contains("dropdown-center")?"bottom":(e="end"===getComputedStyle(this._menu).getPropertyValue("--bs-position").trim(),t.classList.contains("dropup")?e?Kt:Yt:e?Zt:Vt)}_detectNavbar(){return null!==this._element.closest(".navbar")}_getOffset(){const t=this._config["offset"];return"string"==typeof t?t.split(",").map(e=>Number.parseInt(e,10)):"function"==typeof t?e=>t(e,this._element):t}_getPopperConfig(){var e={placement:this._getPlacement(),modifiers:[{name:"preventOverflow",options:{boundary:this._config.boundary}},{name:"offset",options:{offset:this._getOffset()}}]};return!this._inNavbar&&"static"!==this._config.display||(u.setDataAttribute(this._menu,"popper","static"),e.modifiers=[{name:"applyStyles",enabled:!1}]),{...e,..."function"==typeof this._config.popperConfig?this._config.popperConfig(e):this._config.popperConfig}}_selectMenuItem({key:e,target:t}){var i=p.find(".dropdown-menu .dropdown-item:not(.disabled):not(:disabled)",this._menu).filter(e=>r(e));i.length&&G(i,t,e===qt,!i.includes(t)).focus()}static jQueryInterface(t){return this.each(function(){var e=D.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t]()}})}static clearMenus(e){if(2!==e.button&&("keyup"!==e.type||"Tab"===e.key)){const n=p.find('[data-bs-toggle="dropdown"]:not(.disabled):not(:disabled).show');for(const s of n){const n=D.getInstance(s);var t,i;n&&!1!==n._config.autoClose&&(t=(i=e.composedPath()).includes(n._menu),i.includes(n._element)||"inside"===n._config.autoClose&&!t||"outside"===n._config.autoClose&&t||n._menu.contains(e.target)&&("keyup"===e.type&&"Tab"===e.key||/input|select|option|textarea|form/i.test(e.target.tagName))||(i={relatedTarget:n._element},"click"===e.type&&(i.clickEvent=e),n._completeHide(i)))}}}static dataApiKeydownHandler(e){var t=/input|textarea/i.test(e.target.tagName),i="Escape"===e.key,n=["ArrowUp",qt].includes(e.key);!n&&!i||t&&!i||(e.preventDefault(),t=this.matches(g)?this:p.prev(this,g)[0]||p.next(this,g)[0]||p.findOne(g,e.delegateTarget.parentNode),i=D.getOrCreateInstance(t),n?(e.stopPropagation(),i.show(),i._selectMenuItem(e)):i._isShown()&&(e.stopPropagation(),i.hide(),t.focus()))}}m.on(document,Ut,g,D.dataApiKeydownHandler),m.on(document,Ut,Xt,D.dataApiKeydownHandler),m.on(document,Wt,D.clearMenus),m.on(document,"keyup.bs.dropdown.data-api",D.clearMenus),m.on(document,Wt,g,function(e){e.preventDefault(),D.getOrCreateInstance(this).toggle()}),e(D);const ii=".fixed-top, .fixed-bottom, .is-fixed, .sticky-top",ni=".sticky-top",si="padding-right",ai="margin-right";class ri{constructor(){this._element=document.body}getWidth(){var e=document.documentElement.clientWidth;return Math.abs(window.innerWidth-e)}hide(){const t=this.getWidth();this._disableOverFlow(),this._setElementAttributes(this._element,si,e=>e+t),this._setElementAttributes(ii,si,e=>e+t),this._setElementAttributes(ni,ai,e=>e-t)}reset(){this._resetElementAttributes(this._element,"overflow"),this._resetElementAttributes(this._element,si),this._resetElementAttributes(ii,si),this._resetElementAttributes(ni,ai)}isOverflowing(){return 0<this.getWidth()}_disableOverFlow(){this._saveInitialAttribute(this._element,"overflow"),this._element.style.overflow="hidden"}_setElementAttributes(e,i,n){const s=this.getWidth();this._applyManipulationCallback(e,e=>{var t;e!==this._element&&window.innerWidth>e.clientWidth+s||(this._saveInitialAttribute(e,i),t=window.getComputedStyle(e).getPropertyValue(i),e.style.setProperty(i,n(Number.parseFloat(t))+"px"))})}_saveInitialAttribute(e,t){var i=e.style.getPropertyValue(t);i&&u.setDataAttribute(e,t,i)}_resetElementAttributes(e,i){this._applyManipulationCallback(e,e=>{var t=u.getDataAttribute(e,i);null!==t?(u.removeDataAttribute(e,i),e.style.setProperty(i,t)):e.style.removeProperty(i)})}_applyManipulationCallback(e,t){if(a(e))t(e);else for(const i of p.find(e,this._element))t(i)}}const oi="mousedown.bs.backdrop",li={className:"modal-backdrop",clickCallback:null,isAnimated:!1,isVisible:!0,rootElement:"body"},ci={className:"string",clickCallback:"(function|null)",isAnimated:"boolean",isVisible:"boolean",rootElement:"(element|string)"};class di extends ue{constructor(e){super(),this._config=this._getConfig(e),this._isAppended=!1,this._element=null}static get Default(){return li}static get DefaultType(){return ci}static get NAME(){return"backdrop"}show(e){var t;this._config.isVisible?(this._append(),t=this._getElement(),this._config.isAnimated&&H(t),t.classList.add("show"),this._emulateAnimation(()=>{c(e)})):c(e)}hide(e){this._config.isVisible?(this._getElement().classList.remove("show"),this._emulateAnimation(()=>{this.dispose(),c(e)})):c(e)}dispose(){this._isAppended&&(m.off(this._element,oi),this._element.remove(),this._isAppended=!1)}_getElement(){var e;return this._element||((e=document.createElement("div")).className=this._config.className,this._config.isAnimated&&e.classList.add("fade"),this._element=e),this._element}_configAfterMerge(e){return e.rootElement=n(e.rootElement),e}_append(){var e;this._isAppended||(e=this._getElement(),this._config.rootElement.append(e),m.on(e,oi,()=>{c(this._config.clickCallback)}),this._isAppended=!0)}_emulateAnimation(e){U(e,this._getElement(),this._config.isAnimated)}}const ui=".bs.focustrap",pi="backward",hi={autofocus:!0,trapElement:null},mi={autofocus:"boolean",trapElement:"element"};class gi extends ue{constructor(e){super(),this._config=this._getConfig(e),this._isActive=!1,this._lastTabNavDirection=null}static get Default(){return hi}static get DefaultType(){return mi}static get NAME(){return"focustrap"}activate(){this._isActive||(this._config.autofocus&&this._config.trapElement.focus(),m.off(document,ui),m.on(document,"focusin.bs.focustrap",e=>this._handleFocusin(e)),m.on(document,"keydown.tab.bs.focustrap",e=>this._handleKeydown(e)),this._isActive=!0)}deactivate(){this._isActive&&(this._isActive=!1,m.off(document,ui))}_handleFocusin(e){var t=this._config["trapElement"];e.target===document||e.target===t||t.contains(e.target)||(0===(e=p.focusableChildren(t)).length?t:this._lastTabNavDirection===pi?e[e.length-1]:e[0]).focus()}_handleKeydown(e){"Tab"===e.key&&(this._lastTabNavDirection=e.shiftKey?pi:"forward")}}const fi="hidden.bs.modal",bi="show.bs.modal",vi="modal-open",yi="modal-static",wi={backdrop:!0,focus:!0,keyboard:!0},_i={backdrop:"(boolean|string)",focus:"boolean",keyboard:"boolean"};class Ei extends t{constructor(e,t){super(e,t),this._dialog=p.findOne(".modal-dialog",this._element),this._backdrop=this._initializeBackDrop(),this._focustrap=this._initializeFocusTrap(),this._isShown=!1,this._isTransitioning=!1,this._scrollBar=new ri,this._addEventListeners()}static get Default(){return wi}static get DefaultType(){return _i}static get NAME(){return"modal"}toggle(e){return this._isShown?this.hide():this.show(e)}show(e){this._isShown||this._isTransitioning||m.trigger(this._element,bi,{relatedTarget:e}).defaultPrevented||(this._isShown=!0,this._isTransitioning=!0,this._scrollBar.hide(),document.body.classList.add(vi),this._adjustDialog(),this._backdrop.show(()=>this._showElement(e)))}hide(){!this._isShown||this._isTransitioning||m.trigger(this._element,"hide.bs.modal").defaultPrevented||(this._isShown=!1,this._isTransitioning=!0,this._focustrap.deactivate(),this._element.classList.remove("show"),this._queueCallback(()=>this._hideModal(),this._element,this._isAnimated()))}dispose(){for(const e of[window,this._dialog])m.off(e,".bs.modal");this._backdrop.dispose(),this._focustrap.deactivate(),super.dispose()}handleUpdate(){this._adjustDialog()}_initializeBackDrop(){return new di({isVisible:Boolean(this._config.backdrop),isAnimated:this._isAnimated()})}_initializeFocusTrap(){return new gi({trapElement:this._element})}_showElement(e){document.body.contains(this._element)||document.body.append(this._element),this._element.style.display="block",this._element.removeAttribute("aria-hidden"),this._element.setAttribute("aria-modal",!0),this._element.setAttribute("role","dialog"),this._element.scrollTop=0;var t=p.findOne(".modal-body",this._dialog);t&&(t.scrollTop=0),H(this._element),this._element.classList.add("show"),this._queueCallback(()=>{this._config.focus&&this._focustrap.activate(),this._isTransitioning=!1,m.trigger(this._element,"shown.bs.modal",{relatedTarget:e})},this._dialog,this._isAnimated())}_addEventListeners(){m.on(this._element,"keydown.dismiss.bs.modal",e=>{if("Escape"===e.key)return this._config.keyboard?(e.preventDefault(),void this.hide()):void this._triggerBackdropTransition()}),m.on(window,"resize.bs.modal",()=>{this._isShown&&!this._isTransitioning&&this._adjustDialog()}),m.on(this._element,"mousedown.dismiss.bs.modal",t=>{m.one(this._element,"click.dismiss.bs.modal",e=>{this._element===t.target&&this._element===e.target&&("static"!==this._config.backdrop?this._config.backdrop&&this.hide():this._triggerBackdropTransition())})})}_hideModal(){this._element.style.display="none",this._element.setAttribute("aria-hidden",!0),this._element.removeAttribute("aria-modal"),this._element.removeAttribute("role"),this._isTransitioning=!1,this._backdrop.hide(()=>{document.body.classList.remove(vi),this._resetAdjustments(),this._scrollBar.reset(),m.trigger(this._element,fi)})}_isAnimated(){return this._element.classList.contains("fade")}_triggerBackdropTransition(){if(!m.trigger(this._element,"hidePrevented.bs.modal").defaultPrevented){const e=this._element.scrollHeight>document.documentElement.clientHeight,t=this._element.style.overflowY;"hidden"===t||this._element.classList.contains(yi)||(e||(this._element.style.overflowY="hidden"),this._element.classList.add(yi),this._queueCallback(()=>{this._element.classList.remove(yi),this._queueCallback(()=>{this._element.style.overflowY=t},this._dialog)},this._dialog),this._element.focus())}}_adjustDialog(){const e=this._element.scrollHeight>document.documentElement.clientHeight,t=this._scrollBar.getWidth(),i=0<t;if(i&&!e){const e=l()?"paddingLeft":"paddingRight";this._element.style[e]=t+"px"}if(!i&&e){const e=l()?"paddingRight":"paddingLeft";this._element.style[e]=t+"px"}}_resetAdjustments(){this._element.style.paddingLeft="",this._element.style.paddingRight=""}static jQueryInterface(t,i){return this.each(function(){var e=Ei.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t](i)}})}}m.on(document,"click.bs.modal.data-api",'[data-bs-toggle="modal"]',function(e){const t=s(this);["A","AREA"].includes(this.tagName)&&e.preventDefault(),m.one(t,bi,e=>{e.defaultPrevented||m.one(t,fi,()=>{r(this)&&this.focus()})});e=p.findOne(".modal.show");e&&Ei.getInstance(e).hide(),Ei.getOrCreateInstance(t).toggle(this)}),pe(Ei),e(Ei);const xi="showing",Ti=".offcanvas.show",Ci="hidePrevented.bs.offcanvas",Si="hidden.bs.offcanvas",ki={backdrop:!0,keyboard:!0,scroll:!1},Mi={backdrop:"(boolean|string)",keyboard:"boolean",scroll:"boolean"};class $ extends t{constructor(e,t){super(e,t),this._isShown=!1,this._backdrop=this._initializeBackDrop(),this._focustrap=this._initializeFocusTrap(),this._addEventListeners()}static get Default(){return ki}static get DefaultType(){return Mi}static get NAME(){return"offcanvas"}toggle(e){return this._isShown?this.hide():this.show(e)}show(e){this._isShown||m.trigger(this._element,"show.bs.offcanvas",{relatedTarget:e}).defaultPrevented||(this._isShown=!0,this._backdrop.show(),this._config.scroll||(new ri).hide(),this._element.setAttribute("aria-modal",!0),this._element.setAttribute("role","dialog"),this._element.classList.add(xi),this._queueCallback(()=>{this._config.scroll&&!this._config.backdrop||this._focustrap.activate(),this._element.classList.add("show"),this._element.classList.remove(xi),m.trigger(this._element,"shown.bs.offcanvas",{relatedTarget:e})},this._element,!0))}hide(){!this._isShown||m.trigger(this._element,"hide.bs.offcanvas").defaultPrevented||(this._focustrap.deactivate(),this._element.blur(),this._isShown=!1,this._element.classList.add("hiding"),this._backdrop.hide(),this._queueCallback(()=>{this._element.classList.remove("show","hiding"),this._element.removeAttribute("aria-modal"),this._element.removeAttribute("role"),this._config.scroll||(new ri).reset(),m.trigger(this._element,Si)},this._element,!0))}dispose(){this._backdrop.dispose(),this._focustrap.deactivate(),super.dispose()}_initializeBackDrop(){var e=Boolean(this._config.backdrop);return new di({className:"offcanvas-backdrop",isVisible:e,isAnimated:!0,rootElement:this._element.parentNode,clickCallback:e?()=>{"static"!==this._config.backdrop?this.hide():m.trigger(this._element,Ci)}:null})}_initializeFocusTrap(){return new gi({trapElement:this._element})}_addEventListeners(){m.on(this._element,"keydown.dismiss.bs.offcanvas",e=>{"Escape"===e.key&&(this._config.keyboard?this.hide():m.trigger(this._element,Ci))})}static jQueryInterface(t){return this.each(function(){var e=$.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t]||t.startsWith("_")||"constructor"===t)throw new TypeError(`No method named "${t}"`);e[t](this)}})}}m.on(document,"click.bs.offcanvas.data-api",'[data-bs-toggle="offcanvas"]',function(e){var t=s(this);["A","AREA"].includes(this.tagName)&&e.preventDefault(),o(this)||(m.one(t,Si,()=>{r(this)&&this.focus()}),(e=p.findOne(Ti))&&e!==t&&$.getInstance(e).hide(),$.getOrCreateInstance(t).toggle(this))}),m.on(window,"load.bs.offcanvas.data-api",()=>{for(const e of p.find(Ti))$.getOrCreateInstance(e).show()}),m.on(window,"resize.bs.offcanvas",()=>{for(const e of p.find("[aria-modal][class*=show][class*=offcanvas-]"))"fixed"!==getComputedStyle(e).position&&$.getOrCreateInstance(e).hide()}),pe($),e($);const Ni=new Set(["background","cite","href","itemtype","longdesc","poster","src","xlink:href"]),Oi=/^(?:(?:https?|mailto|ftp|tel|file|sms):|[^#&/:?]*(?:[#/?]|$))/i,Ai=/^data:(?:image\/(?:bmp|gif|jpeg|jpg|png|tiff|webp)|video\/(?:mpeg|mp4|ogg|webm)|audio\/(?:mp3|oga|ogg|opus));base64,[\d+/a-z]+=*$/i,Li={"*":["class","dir","id","lang","role",/^aria-[\w-]*$/i],a:["target","href","title","rel"],area:[],b:[],br:[],col:[],code:[],div:[],em:[],hr:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],i:[],img:["src","srcset","alt","title","width","height"],li:[],ol:[],p:[],pre:[],s:[],small:[],span:[],sub:[],sup:[],strong:[],u:[],ul:[]},Ii={allowList:Li,content:{},extraClass:"",html:!1,sanitize:!0,sanitizeFn:null,template:"<div></div>"},Di={allowList:"object",content:"object",extraClass:"(string|function)",html:"boolean",sanitize:"boolean",sanitizeFn:"(null|function)",template:"string"},$i={entry:"(string|element|function|null)",selector:"(string|element)"};class Pi extends ue{constructor(e){super(),this._config=this._getConfig(e)}static get Default(){return Ii}static get DefaultType(){return Di}static get NAME(){return"TemplateFactory"}getContent(){return Object.values(this._config.content).map(e=>this._resolvePossibleFunction(e)).filter(Boolean)}hasContent(){return 0<this.getContent().length}changeContent(e){return this._checkContent(e),this._config.content={...this._config.content,...e},this}toHtml(){var e=document.createElement("div");e.innerHTML=this._maybeSanitize(this._config.template);for(const[t,i]of Object.entries(this._config.content))this._setContent(e,i,t);const t=e.children[0],i=this._resolvePossibleFunction(this._config.extraClass);return i&&t.classList.add(...i.split(" ")),t}_typeCheckConfig(e){super._typeCheckConfig(e),this._checkContent(e.content)}_checkContent(e){for(var[t,i]of Object.entries(e))super._typeCheckConfig({selector:t,entry:i},$i)}_setContent(e,t,i){i=p.findOne(i,e);i&&((t=this._resolvePossibleFunction(t))?a(t)?this._putElementInTemplate(n(t),i):this._config.html?i.innerHTML=this._maybeSanitize(t):i.textContent=t:i.remove())}_maybeSanitize(e){if(this._config.sanitize){var t=e,i=this._config.allowList,n=this._config.sanitizeFn;if(!t.length)return t;if(n&&"function"==typeof n)return n(t);const s=(new window.DOMParser).parseFromString(t,"text/html"),a=[].concat(...s.body.querySelectorAll("*"));for(const t of a){const n=t.nodeName.toLowerCase();if(Object.keys(i).includes(n)){const s=[].concat(...t.attributes),a=[].concat(i["*"]||[],i[n]||[]);for(const i of s)((e,t)=>{const i=e.nodeName.toLowerCase();return t.includes(i)?!Ni.has(i)||Boolean(Oi.test(e.nodeValue)||Ai.test(e.nodeValue)):t.filter(e=>e instanceof RegExp).some(e=>e.test(i))})(i,a)||t.removeAttribute(i.nodeName)}else t.remove()}return s.body.innerHTML}return e}_resolvePossibleFunction(e){return"function"==typeof e?e(this):e}_putElementInTemplate(e,t){this._config.html?(t.innerHTML="",t.append(e)):t.textContent=e.textContent}}const zi=new Set(["sanitize","allowList","sanitizeFn"]),Ri="fade",Bi="show",ji="hide.bs.modal",Fi="hover",Hi={AUTO:"auto",TOP:"top",RIGHT:l()?"left":"right",BOTTOM:"bottom",LEFT:l()?"right":"left"},qi={allowList:Li,animation:!0,boundary:"clippingParents",container:!1,customClass:"",delay:0,fallbackPlacements:["top","right","bottom","left"],html:!1,offset:[0,0],placement:"top",popperConfig:null,sanitize:!0,sanitizeFn:null,selector:!1,template:'<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',title:"",trigger:"hover focus"},Wi={allowList:"object",animation:"boolean",boundary:"(string|element)",container:"(string|element|boolean)",customClass:"(string|function)",delay:"(number|object)",fallbackPlacements:"array",html:"boolean",offset:"(array|string|function)",placement:"(string|function)",popperConfig:"(null|object|function)",sanitize:"boolean",sanitizeFn:"(null|function)",selector:"(string|boolean)",template:"string",title:"(string|element|function)",trigger:"string"};class Ui extends t{constructor(e,t){if(void 0===Ft)throw new TypeError("Bootstrap's tooltips require Popper (https://popper.js.org)");super(e,t),this._isEnabled=!0,this._timeout=0,this._isHovered=null,this._activeTrigger={},this._popper=null,this._templateFactory=null,this._newContent=null,this.tip=null,this._setListeners(),this._config.selector||this._fixTitle()}static get Default(){return qi}static get DefaultType(){return Wi}static get NAME(){return"tooltip"}enable(){this._isEnabled=!0}disable(){this._isEnabled=!1}toggleEnabled(){this._isEnabled=!this._isEnabled}toggle(){this._isEnabled&&(this._activeTrigger.click=!this._activeTrigger.click,this._isShown()?this._leave():this._enter())}dispose(){clearTimeout(this._timeout),m.off(this._element.closest(".modal"),ji,this._hideModalHandler),this._element.getAttribute("data-bs-original-title")&&this._element.setAttribute("title",this._element.getAttribute("data-bs-original-title")),this._disposePopper(),super.dispose()}show(){if("none"===this._element.style.display)throw new Error("Please use show on visible elements");if(this._isWithContent()&&this._isEnabled){const i=m.trigger(this._element,this.constructor.eventName("show")),n=(j(this._element)||this._element.ownerDocument.documentElement).contains(this._element);if(!i.defaultPrevented&&n){this._disposePopper();var e=this._getTipElement(),t=(this._element.setAttribute("aria-describedby",e.getAttribute("id")),this._config)["container"];if(this._element.ownerDocument.documentElement.contains(this.tip)||(t.append(e),m.trigger(this._element,this.constructor.eventName("inserted"))),this._popper=this._createPopper(e),e.classList.add(Bi),"ontouchstart"in document.documentElement)for(const i of[].concat(...document.body.children))m.on(i,"mouseover",F);this._queueCallback(()=>{m.trigger(this._element,this.constructor.eventName("shown")),!1===this._isHovered&&this._leave(),this._isHovered=!1},this.tip,this._isAnimated())}}}hide(){if(this._isShown()&&!m.trigger(this._element,this.constructor.eventName("hide")).defaultPrevented){if(this._getTipElement().classList.remove(Bi),"ontouchstart"in document.documentElement)for(const e of[].concat(...document.body.children))m.off(e,"mouseover",F);this._activeTrigger.click=!1,this._activeTrigger.focus=!1,this._activeTrigger.hover=!1,this._isHovered=null,this._queueCallback(()=>{this._isWithActiveTrigger()||(this._isHovered||this._disposePopper(),this._element.removeAttribute("aria-describedby"),m.trigger(this._element,this.constructor.eventName("hidden")))},this.tip,this._isAnimated())}}update(){this._popper&&this._popper.update()}_isWithContent(){return Boolean(this._getTitle())}_getTipElement(){return this.tip||(this.tip=this._createTipElement(this._newContent||this._getContentForTemplate())),this.tip}_createTipElement(e){e=this._getTemplateFactory(e).toHtml();if(!e)return null;e.classList.remove(Ri,Bi),e.classList.add(`bs-${this.constructor.NAME}-auto`);var t=(e=>{for(;e+=Math.floor(1e6*Math.random()),document.getElementById(e););return e})(this.constructor.NAME).toString();return e.setAttribute("id",t),this._isAnimated()&&e.classList.add(Ri),e}setContent(e){this._newContent=e,this._isShown()&&(this._disposePopper(),this.show())}_getTemplateFactory(e){return this._templateFactory?this._templateFactory.changeContent(e):this._templateFactory=new Pi({...this._config,content:e,extraClass:this._resolvePossibleFunction(this._config.customClass)}),this._templateFactory}_getContentForTemplate(){return{".tooltip-inner":this._getTitle()}}_getTitle(){return this._resolvePossibleFunction(this._config.title)||this._element.getAttribute("data-bs-original-title")}_initializeOnDelegatedTarget(e){return this.constructor.getOrCreateInstance(e.delegateTarget,this._getDelegateConfig())}_isAnimated(){return this._config.animation||this.tip&&this.tip.classList.contains(Ri)}_isShown(){return this.tip&&this.tip.classList.contains(Bi)}_createPopper(e){var t="function"==typeof this._config.placement?this._config.placement.call(this,e,this._element):this._config.placement,t=Hi[t.toUpperCase()];return jt(this._element,e,this._getPopperConfig(t))}_getOffset(){const t=this._config["offset"];return"string"==typeof t?t.split(",").map(e=>Number.parseInt(e,10)):"function"==typeof t?e=>t(e,this._element):t}_resolvePossibleFunction(e){return"function"==typeof e?e.call(this._element):e}_getPopperConfig(e){e={placement:e,modifiers:[{name:"flip",options:{fallbackPlacements:this._config.fallbackPlacements}},{name:"offset",options:{offset:this._getOffset()}},{name:"preventOverflow",options:{boundary:this._config.boundary}},{name:"arrow",options:{element:`.${this.constructor.NAME}-arrow`}},{name:"preSetPlacement",enabled:!0,phase:"beforeMain",fn:e=>{this._getTipElement().setAttribute("data-popper-placement",e.state.placement)}}]};return{...e,..."function"==typeof this._config.popperConfig?this._config.popperConfig(e):this._config.popperConfig}}_setListeners(){const e=this._config.trigger.split(" ");for(const t of e)if("click"===t)m.on(this._element,this.constructor.eventName("click"),this._config.selector,e=>{this._initializeOnDelegatedTarget(e).toggle()});else if("manual"!==t){const e=t===Fi?this.constructor.eventName("mouseenter"):this.constructor.eventName("focusin"),i=t===Fi?this.constructor.eventName("mouseleave"):this.constructor.eventName("focusout");m.on(this._element,e,this._config.selector,e=>{var t=this._initializeOnDelegatedTarget(e);t._activeTrigger["focusin"===e.type?"focus":Fi]=!0,t._enter()}),m.on(this._element,i,this._config.selector,e=>{var t=this._initializeOnDelegatedTarget(e);t._activeTrigger["focusout"===e.type?"focus":Fi]=t._element.contains(e.relatedTarget),t._leave()})}this._hideModalHandler=()=>{this._element&&this.hide()},m.on(this._element.closest(".modal"),ji,this._hideModalHandler)}_fixTitle(){var e=this._element.getAttribute("title");e&&(this._element.getAttribute("aria-label")||this._element.textContent.trim()||this._element.setAttribute("aria-label",e),this._element.setAttribute("data-bs-original-title",e),this._element.removeAttribute("title"))}_enter(){this._isShown()||this._isHovered?this._isHovered=!0:(this._isHovered=!0,this._setTimeout(()=>{this._isHovered&&this.show()},this._config.delay.show))}_leave(){this._isWithActiveTrigger()||(this._isHovered=!1,this._setTimeout(()=>{this._isHovered||this.hide()},this._config.delay.hide))}_setTimeout(e,t){clearTimeout(this._timeout),this._timeout=setTimeout(e,t)}_isWithActiveTrigger(){return Object.values(this._activeTrigger).includes(!0)}_getConfig(e){var t=u.getDataAttributes(this._element);for(const e of Object.keys(t))zi.has(e)&&delete t[e];return e={...t,..."object"==typeof e&&e?e:{}},e=this._mergeConfigObj(e),e=this._configAfterMerge(e),this._typeCheckConfig(e),e}_configAfterMerge(e){return e.container=!1===e.container?document.body:n(e.container),"number"==typeof e.delay&&(e.delay={show:e.delay,hide:e.delay}),"number"==typeof e.title&&(e.title=e.title.toString()),"number"==typeof e.content&&(e.content=e.content.toString()),e}_getDelegateConfig(){var e={};for(const t in this._config)this.constructor.Default[t]!==this._config[t]&&(e[t]=this._config[t]);return e.selector=!1,e.trigger="manual",e}_disposePopper(){this._popper&&(this._popper.destroy(),this._popper=null),this.tip&&(this.tip.remove(),this.tip=null)}static jQueryInterface(t){return this.each(function(){var e=Ui.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t]()}})}}e(Ui);const Gi={...Ui.Default,content:"",offset:[0,8],placement:"right",template:'<div class="popover" role="tooltip"><div class="popover-arrow"></div><h3 class="popover-header"></h3><div class="popover-body"></div></div>',trigger:"click"},Xi={...Ui.DefaultType,content:"(null|string|element|function)"};class Yi extends Ui{static get Default(){return Gi}static get DefaultType(){return Xi}static get NAME(){return"popover"}_isWithContent(){return this._getTitle()||this._getContent()}_getContentForTemplate(){return{".popover-header":this._getTitle(),".popover-body":this._getContent()}}_getContent(){return this._resolvePossibleFunction(this._config.content)}static jQueryInterface(t){return this.each(function(){var e=Yi.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t]()}})}}e(Yi);const Ki="click.bs.scrollspy",Vi="active",Zi={offset:null,rootMargin:"0px 0px -25%",smoothScroll:!1,target:null,threshold:[.1,.5,1]},Qi={offset:"(number|null)",rootMargin:"string",smoothScroll:"boolean",target:"element",threshold:"array"};class Ji extends t{constructor(e,t){super(e,t),this._targetLinks=new Map,this._observableSections=new Map,this._rootElement="visible"===getComputedStyle(this._element).overflowY?null:this._element,this._activeTarget=null,this._observer=null,this._previousScrollData={visibleEntryTop:0,parentScrollTop:0},this.refresh()}static get Default(){return Zi}static get DefaultType(){return Qi}static get NAME(){return"scrollspy"}refresh(){this._initializeTargetsAndObservables(),this._maybeEnableSmoothScroll(),this._observer?this._observer.disconnect():this._observer=this._getNewObserver();for(const e of this._observableSections.values())this._observer.observe(e)}dispose(){this._observer.disconnect(),super.dispose()}_configAfterMerge(e){return e.target=n(e.target)||document.body,e.rootMargin=e.offset?e.offset+"px 0px -30%":e.rootMargin,"string"==typeof e.threshold&&(e.threshold=e.threshold.split(",").map(e=>Number.parseFloat(e))),e}_maybeEnableSmoothScroll(){this._config.smoothScroll&&(m.off(this._config.target,Ki),m.on(this._config.target,Ki,"[href]",e=>{var t=this._observableSections.get(e.target.hash);t&&(e.preventDefault(),e=this._rootElement||window,t=t.offsetTop-this._element.offsetTop,e.scrollTo?e.scrollTo({top:t,behavior:"smooth"}):e.scrollTop=t)}))}_getNewObserver(){var e={root:this._rootElement,threshold:this._config.threshold,rootMargin:this._config.rootMargin};return new IntersectionObserver(e=>this._observerCallback(e),e)}_observerCallback(e){const t=e=>this._targetLinks.get("#"+e.target.id),i=e=>{this._previousScrollData.visibleEntryTop=e.target.offsetTop,this._process(t(e))},n=(this._rootElement||document.documentElement).scrollTop,s=n>=this._previousScrollData.parentScrollTop;this._previousScrollData.parentScrollTop=n;for(const a of e)if(a.isIntersecting){const e=a.target.offsetTop>=this._previousScrollData.visibleEntryTop;if(s&&e){if(i(a),!n)return}else s||e||i(a)}else this._activeTarget=null,this._clearActiveClass(t(a))}_initializeTargetsAndObservables(){this._targetLinks=new Map,this._observableSections=new Map;const e=p.find("[href]",this._config.target);for(const t of e)if(t.hash&&!o(t)){const e=p.findOne(t.hash,this._element);r(e)&&(this._targetLinks.set(t.hash,t),this._observableSections.set(t.hash,e))}}_process(e){this._activeTarget!==e&&(this._clearActiveClass(this._config.target),(this._activeTarget=e).classList.add(Vi),this._activateParents(e),m.trigger(this._element,"activate.bs.scrollspy",{relatedTarget:e}))}_activateParents(e){if(e.classList.contains("dropdown-item"))p.findOne(".dropdown-toggle",e.closest(".dropdown")).classList.add(Vi);else for(const t of p.parents(e,".nav, .list-group"))for(const e of p.prev(t,".nav-link, .nav-item > .nav-link, .list-group-item"))e.classList.add(Vi)}_clearActiveClass(e){e.classList.remove(Vi);var t=p.find("[href].active",e);for(const e of t)e.classList.remove(Vi)}static jQueryInterface(t){return this.each(function(){var e=Ji.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t]||t.startsWith("_")||"constructor"===t)throw new TypeError(`No method named "${t}"`);e[t]()}})}}m.on(window,"load.bs.scrollspy.data-api",()=>{for(const e of p.find('[data-bs-spy="scroll"]'))Ji.getOrCreateInstance(e)}),e(Ji);const en="ArrowRight",tn="ArrowDown",nn="active",sn="show",an='[data-bs-toggle="tab"], [data-bs-toggle="pill"], [data-bs-toggle="list"]',rn='.nav-link:not(.dropdown-toggle), .list-group-item:not(.dropdown-toggle), [role="tab"]:not(.dropdown-toggle), '+an;class on extends t{constructor(e){super(e),this._parent=this._element.closest('.list-group, .nav, [role="tablist"]'),this._parent&&(this._setInitialAttributes(this._parent,this._getChildren()),m.on(this._element,"keydown.bs.tab",e=>this._keydown(e)))}static get NAME(){return"tab"}show(){var e,t,i=this._element;this._elemIsActive(i)||(t=(e=this._getActiveElem())?m.trigger(e,"hide.bs.tab",{relatedTarget:i}):null,m.trigger(i,"show.bs.tab",{relatedTarget:e}).defaultPrevented)||t&&t.defaultPrevented||(this._deactivate(e,i),this._activate(i,e))}_activate(e,t){e&&(e.classList.add(nn),this._activate(s(e)),this._queueCallback(()=>{"tab"===e.getAttribute("role")?(e.removeAttribute("tabindex"),e.setAttribute("aria-selected",!0),this._toggleDropDown(e,!0),m.trigger(e,"shown.bs.tab",{relatedTarget:t})):e.classList.add(sn)},e,e.classList.contains("fade")))}_deactivate(e,t){e&&(e.classList.remove(nn),e.blur(),this._deactivate(s(e)),this._queueCallback(()=>{"tab"===e.getAttribute("role")?(e.setAttribute("aria-selected",!1),e.setAttribute("tabindex","-1"),this._toggleDropDown(e,!1),m.trigger(e,"hidden.bs.tab",{relatedTarget:t})):e.classList.remove(sn)},e,e.classList.contains("fade")))}_keydown(e){var t;["ArrowLeft",en,"ArrowUp",tn].includes(e.key)&&(e.stopPropagation(),e.preventDefault(),t=[en,tn].includes(e.key),e=G(this._getChildren().filter(e=>!o(e)),e.target,t,!0))&&(e.focus({preventScroll:!0}),on.getOrCreateInstance(e).show())}_getChildren(){return p.find(rn,this._parent)}_getActiveElem(){return this._getChildren().find(e=>this._elemIsActive(e))||null}_setInitialAttributes(e,t){this._setAttributeIfNotExists(e,"role","tablist");for(const e of t)this._setInitialAttributesOnChild(e)}_setInitialAttributesOnChild(e){e=this._getInnerElement(e);var t=this._elemIsActive(e),i=this._getOuterElement(e);e.setAttribute("aria-selected",t),i!==e&&this._setAttributeIfNotExists(i,"role","presentation"),t||e.setAttribute("tabindex","-1"),this._setAttributeIfNotExists(e,"role","tab"),this._setInitialAttributesOnTargetPanel(e)}_setInitialAttributesOnTargetPanel(e){var t=s(e);t&&(this._setAttributeIfNotExists(t,"role","tabpanel"),e.id)&&this._setAttributeIfNotExists(t,"aria-labelledby","#"+e.id)}_toggleDropDown(e,i){const n=this._getOuterElement(e);n.classList.contains("dropdown")&&((e=(e,t)=>{e=p.findOne(e,n);e&&e.classList.toggle(t,i)})(".dropdown-toggle",nn),e(".dropdown-menu",sn),n.setAttribute("aria-expanded",i))}_setAttributeIfNotExists(e,t,i){e.hasAttribute(t)||e.setAttribute(t,i)}_elemIsActive(e){return e.classList.contains(nn)}_getInnerElement(e){return e.matches(rn)?e:p.findOne(rn,e)}_getOuterElement(e){return e.closest(".nav-item, .list-group-item")||e}static jQueryInterface(t){return this.each(function(){var e=on.getOrCreateInstance(this);if("string"==typeof t){if(void 0===e[t]||t.startsWith("_")||"constructor"===t)throw new TypeError(`No method named "${t}"`);e[t]()}})}}m.on(document,"click.bs.tab",an,function(e){["A","AREA"].includes(this.tagName)&&e.preventDefault(),o(this)||on.getOrCreateInstance(this).show()}),m.on(window,"load.bs.tab",()=>{for(const e of p.find('.active[data-bs-toggle="tab"], .active[data-bs-toggle="pill"], .active[data-bs-toggle="list"]'))on.getOrCreateInstance(e)}),e(on);const ln="show",cn="showing",dn={animation:"boolean",autohide:"boolean",delay:"number"},un={animation:!0,autohide:!0,delay:5e3};class pn extends t{constructor(e,t){super(e,t),this._timeout=null,this._hasMouseInteraction=!1,this._hasKeyboardInteraction=!1,this._setListeners()}static get Default(){return un}static get DefaultType(){return dn}static get NAME(){return"toast"}show(){m.trigger(this._element,"show.bs.toast").defaultPrevented||(this._clearTimeout(),this._config.animation&&this._element.classList.add("fade"),this._element.classList.remove("hide"),H(this._element),this._element.classList.add(ln,cn),this._queueCallback(()=>{this._element.classList.remove(cn),m.trigger(this._element,"shown.bs.toast"),this._maybeScheduleHide()},this._element,this._config.animation))}hide(){!this.isShown()||m.trigger(this._element,"hide.bs.toast").defaultPrevented||(this._element.classList.add(cn),this._queueCallback(()=>{this._element.classList.add("hide"),this._element.classList.remove(cn,ln),m.trigger(this._element,"hidden.bs.toast")},this._element,this._config.animation))}dispose(){this._clearTimeout(),this.isShown()&&this._element.classList.remove(ln),super.dispose()}isShown(){return this._element.classList.contains(ln)}_maybeScheduleHide(){!this._config.autohide||this._hasMouseInteraction||this._hasKeyboardInteraction||(this._timeout=setTimeout(()=>{this.hide()},this._config.delay))}_onInteraction(e,t){switch(e.type){case"mouseover":case"mouseout":this._hasMouseInteraction=t;break;case"focusin":case"focusout":this._hasKeyboardInteraction=t}t?this._clearTimeout():(e=e.relatedTarget,this._element===e||this._element.contains(e)||this._maybeScheduleHide())}_setListeners(){m.on(this._element,"mouseover.bs.toast",e=>this._onInteraction(e,!0)),m.on(this._element,"mouseout.bs.toast",e=>this._onInteraction(e,!1)),m.on(this._element,"focusin.bs.toast",e=>this._onInteraction(e,!0)),m.on(this._element,"focusout.bs.toast",e=>this._onInteraction(e,!1))}_clearTimeout(){clearTimeout(this._timeout),this._timeout=null}static jQueryInterface(t){return this.each(function(){var e=pn.getOrCreateInstance(this,t);if("string"==typeof t){if(void 0===e[t])throw new TypeError(`No method named "${t}"`);e[t](this)}})}}return pe(pn),e(pn),{Alert:he,Button:ge,Carousel:ke,Collapse:De,Dropdown:D,Modal:Ei,Offcanvas:$,Popover:Yi,ScrollSpy:Ji,Tab:on,Toast:pn,Tooltip:Ui}}),function(){"use strict";var e={exports:{}};function i(t){return t instanceof Map?t.clear=t.delete=t.set=()=>{throw Error("map is read-only")}:t instanceof Set&&(t.add=t.clear=t.delete=()=>{throw Error("set is read-only")}),Object.freeze(t),Object.getOwnPropertyNames(t).forEach(e=>{e=t[e];"object"!=typeof e||Object.isFrozen(e)||i(e)}),t}e.exports=i,e.exports.default=i;var x=e.exports;class A{constructor(e){void 0===e.data&&(e.data={}),this.data=e.data,this.isMatchIgnored=!1}ignoreMatch(){this.isMatchIgnored=!0}}function t(e){return e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;")}function l(e,...t){const i=Object.create(null);for(const t in e)i[t]=e[t];return t.forEach(e=>{for(const t in e)i[t]=e[t]}),i}const s=e=>!!e.kind;class T{constructor(e,t){this.buffer="",this.classPrefix=t.classPrefix,e.walk(this)}addText(e){this.buffer+=t(e)}openNode(e){var t,i,n;s(e)&&(n=e.kind,n=e.sublanguage?"language-"+n:([e,t]=[n,{prefix:this.classPrefix}["prefix"]],e.includes(".")?[""+t+(i=e.split(".")).shift(),...i.map((e,t)=>""+e+"_".repeat(t+1))].join(" "):""+t+e),this.span(n))}closeNode(e){s(e)&&(this.buffer+="</span>")}value(){return this.buffer}span(e){this.buffer+=`<span class="${e}">`}}class S{constructor(){this.rootNode={children:[]},this.stack=[this.rootNode]}get top(){return this.stack[this.stack.length-1]}get root(){return this.rootNode}add(e){this.top.children.push(e)}openNode(e){e={kind:e,children:[]};this.add(e),this.stack.push(e)}closeNode(){if(1<this.stack.length)return this.stack.pop()}closeAllNodes(){for(;this.closeNode(););}toJSON(){return JSON.stringify(this.rootNode,null,4)}walk(e){return this.constructor._walk(e,this.rootNode)}static _walk(t,e){return"string"==typeof e?t.addText(e):e.children&&(t.openNode(e),e.children.forEach(e=>this._walk(t,e)),t.closeNode(e)),t}static _collapse(e){"string"!=typeof e&&e.children&&(e.children.every(e=>"string"==typeof e)?e.children=[e.children.join("")]:e.children.forEach(e=>{S._collapse(e)}))}}class H extends S{constructor(e){super(),this.options=e}addKeyword(e,t){""!==e&&(this.openNode(t),this.addText(e),this.closeNode())}addText(e){""!==e&&this.add(e)}addSublanguage(e,t){e=e.root;e.kind=t,e.sublanguage=!0,this.add(e)}toHTML(){return new T(this,this.options).value()}finalize(){return!0}}function c(e){return e?"string"==typeof e?e:e.source:null}function O(e){return L("(?=",e,")")}function h(e){return L("(?:",e,")?")}function L(...e){return e.map(e=>c(e)).join("")}function I(...e){return"("+(("object"==typeof(i=(t=e)[t.length-1])&&i.constructor===Object?(t.splice(t.length-1,1),i):{}).capture?"":"?:")+e.map(e=>c(e)).join("|")+")";var t,i}function k(e){return RegExp(e.toString()+"|").exec("").length-1}const M=/\[(?:[^\\\]]|\\.)*\]|\(\??|\\([1-9][0-9]*)|\\./;function d(e,{joinWith:t}){let s=0;return e.map(e=>{var t=s+=1;let i=c(e),n="";for(;0<i.length;){const e=M.exec(i);if(!e){n+=i;break}n+=i.substring(0,e.index),i=i.substring(e.index+e[0].length),"\\"===e[0][0]&&e[1]?n+="\\"+(Number(e[1])+t):(n+=e[0],"("===e[0]&&s++)}return n}).map(e=>`(${e})`).join(t)}const N="[a-zA-Z]\\w*",u="[a-zA-Z_]\\w*",q="\\b\\d+(\\.\\d+)?",W="(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",U="\\b(0b[01]+)",n={begin:"\\\\[\\s\\S]",relevance:0},G={scope:"string",begin:"'",end:"'",illegal:"\\n",contains:[n]},X={scope:"string",begin:'"',end:'"',illegal:"\\n",contains:[n]},a=(e,t,i={})=>{e=l({scope:"comment",begin:e,end:t,contains:[]},i),e.contains.push({scope:"doctag",begin:"[ ]*(?=(TODO|FIXME|NOTE|BUG|OPTIMIZE|HACK|XXX):)",end:/(TODO|FIXME|NOTE|BUG|OPTIMIZE|HACK|XXX):/,excludeBegin:!0,relevance:0}),t=I("I","a","is","so","us","to","at","if","in","it","on",/[A-Za-z]+['](d|ve|re|ll|t|s|n)/,/[A-Za-z]+[-][a-z]+/,/[A-Za-z][a-z]{2,}/);return e.contains.push({begin:L(/[ ]+/,"(",t,/[.]?[:]?([.][ ]|[ ])/,"){3}")}),e},Y=a("//","$"),K=a("/\\*","\\*/"),V=a("#","$");var p=Object.freeze({__proto__:null,MATCH_NOTHING_RE:/\b\B/,IDENT_RE:N,UNDERSCORE_IDENT_RE:u,NUMBER_RE:q,C_NUMBER_RE:W,BINARY_NUMBER_RE:U,RE_STARTERS_RE:"!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",SHEBANG:(e={})=>{var t=/^#![ ]*\//;return e.binary&&(e.begin=L(t,/.*\b/,e.binary,/\b.*/)),l({scope:"meta",begin:t,end:/$/,relevance:0,"on:begin":(e,t)=>{0!==e.index&&t.ignoreMatch()}},e)},BACKSLASH_ESCAPE:n,APOS_STRING_MODE:G,QUOTE_STRING_MODE:X,PHRASAL_WORDS_MODE:{begin:/\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|they|like|more)\b/},COMMENT:a,C_LINE_COMMENT_MODE:Y,C_BLOCK_COMMENT_MODE:K,HASH_COMMENT_MODE:V,NUMBER_MODE:{scope:"number",begin:q,relevance:0},C_NUMBER_MODE:{scope:"number",begin:W,relevance:0},BINARY_NUMBER_MODE:{scope:"number",begin:U,relevance:0},REGEXP_MODE:{begin:/(?=\/[^/\n]*\/)/,contains:[{scope:"regexp",begin:/\//,end:/\/[gimuy]*/,illegal:/\n/,contains:[n,{begin:/\[/,end:/\]/,relevance:0,contains:[n]}]}]},TITLE_MODE:{scope:"title",begin:N,relevance:0},UNDERSCORE_TITLE_MODE:{scope:"title",begin:u,relevance:0},METHOD_GUARD:{begin:"\\.\\s*[a-zA-Z_]\\w*",relevance:0},END_SAME_AS_BEGIN:e=>Object.assign(e,{"on:begin":(e,t)=>{t.data._beginMatch=e[1]},"on:end":(e,t)=>{t.data._beginMatch!==e[1]&&t.ignoreMatch()}})});function Z(e,t){"."===e.input[e.index-1]&&t.ignoreMatch()}const Q=(t,e)=>{if(t.beforeMatch){if(t.starts)throw Error("beforeMatch cannot be used with starts");var i=Object.assign({},t);Object.keys(t).forEach(e=>{delete t[e]}),t.keywords=i.keywords,t.begin=L(i.beforeMatch,O(i.begin)),t.starts={relevance:0,contains:[Object.assign(i,{endsParent:!0})]},t.relevance=0,delete i.beforeMatch}},J=["of","and","for","in","not","or","if","then","parent","list","value"];function ee(t,n,e="keyword"){const s=Object.create(null);return"string"==typeof t?i(e,t.split(" ")):Array.isArray(t)?i(e,t):Object.keys(t).forEach(e=>{Object.assign(s,ee(t[e],n,e))}),s;function i(i,e){(e=n?e.map(e=>e.toLowerCase()):e).forEach(e=>{var t,e=e.split("|");s[e[0]]=[i,(t=e[0],(e=e[1])?Number(e):(e=>J.includes(e.toLowerCase()))(t)?0:1)]})}}const te={},D=e=>{console.error(e)},ie=(e,...t)=>{console.log("WARN: "+e,...t)},m=(e,t)=>{te[e+"/"+t]||(console.log(`Deprecated as of ${e}. `+t),te[e+"/"+t]=!0)},g=Error();function ne(e,t,{key:i}){let n=0;var s=e[i],a={},r={};for(let e=1;e<=t.length;e++)r[e+n]=s[e],a[e+n]=!0,n+=k(t[e-1]);e[i]=r,e[i]._emit=a,e[i]._multi=!0}function se(a){function r(e,t){return RegExp(c(e),"m"+(a.case_insensitive?"i":"")+(t?"g":""))}class t{constructor(){this.matchIndexes={},this.regexes=[],this.matchAt=1,this.position=0}addRule(e,t){t.position=this.position++,this.matchIndexes[this.matchAt]=t,this.regexes.push([t,e]),this.matchAt+=k(e)+1}compile(){0===this.regexes.length&&(this.exec=()=>null);var e=this.regexes.map(e=>e[1]);this.matcherRe=r(d(e,{joinWith:"|"}),!0),this.lastIndex=0}exec(e){this.matcherRe.lastIndex=this.lastIndex;var t,i,e=this.matcherRe.exec(e);return e?(t=e.findIndex((e,t)=>0<t&&void 0!==e),i=this.matchIndexes[t],e.splice(0,t),Object.assign(e,i)):null}}class o{constructor(){this.rules=[],this.multiRegexes=[],this.count=0,this.lastIndex=0,this.regexIndex=0}getMatcher(e){if(this.multiRegexes[e])return this.multiRegexes[e];const i=new t;return this.rules.slice(e).forEach(([e,t])=>i.addRule(e,t)),i.compile(),this.multiRegexes[e]=i}resumingScanAtSamePosition(){return 0!==this.regexIndex}considerAll(){this.regexIndex=0}addRule(e,t){this.rules.push([e,t]),"begin"===t.type&&this.count++}exec(e){const t=this.getMatcher(this.regexIndex);t.lastIndex=this.lastIndex;let i=t.exec(e);if(this.resumingScanAtSamePosition()&&(!i||i.index!==this.lastIndex)){const t=this.getMatcher(0);t.lastIndex=this.lastIndex+1,i=t.exec(e)}return i&&(this.regexIndex+=i.position+1,this.regexIndex===this.count)&&this.considerAll(),i}}if(a.compilerExtensions||(a.compilerExtensions=[]),a.contains&&a.contains.includes("self"))throw Error("ERR: contains `self` is not supported at the top-level of a language.  See documentation.");return a.classNameAliases=l(a.classNameAliases||{}),function t(i,n){const s=i;if(!i.isCompiled){[function(e,t){void 0!==e.className&&(e.scope=e.className,delete e.className)},function(e,t){if(e.match){if(e.begin||e.end)throw Error("begin & end are not supported with match");e.begin=e.match,delete e.match}},function(e){if((t=e).scope&&"object"==typeof t.scope&&null!==t.scope&&(t.beginScope=t.scope,delete t.scope),"string"==typeof e.beginScope&&(e.beginScope={_wrap:e.beginScope}),"string"==typeof e.endScope&&(e.endScope={_wrap:e.endScope}),t=e,Array.isArray(t.begin)){if(t.skip||t.excludeBegin||t.returnBegin)throw D("skip, excludeBegin, returnBegin not compatible with beginScope: {}"),g;if("object"!=typeof t.beginScope||null===t.beginScope)throw D("beginScope must be object"),g;ne(t,t.begin,{key:"beginScope"}),t.begin=d(t.begin,{joinWith:""})}var t=e;if(Array.isArray(t.end)){if(t.skip||t.excludeEnd||t.returnEnd)throw D("skip, excludeEnd, returnEnd not compatible with endScope: {}"),g;if("object"!=typeof t.endScope||null===t.endScope)throw D("endScope must be object"),g;ne(t,t.end,{key:"endScope"}),t.end=d(t.end,{joinWith:""})}},Q].forEach(e=>e(i,n)),a.compilerExtensions.forEach(e=>e(i,n)),i.__beforeBegin=null,[function(e,t){t&&e.beginKeywords&&(e.begin="\\b("+e.beginKeywords.split(" ").join("|")+")(?!\\.)(?=\\b|\\s)",e.__beforeBegin=Z,e.keywords=e.keywords||e.beginKeywords,delete e.beginKeywords,void 0===e.relevance)&&(e.relevance=0)},function(e,t){Array.isArray(e.illegal)&&(e.illegal=I(...e.illegal))},function(e,t){void 0===e.relevance&&(e.relevance=1)}].forEach(e=>e(i,n)),i.isCompiled=!0;let e=null;"object"==typeof i.keywords&&i.keywords.$pattern&&(i.keywords=Object.assign({},i.keywords),e=i.keywords.$pattern,delete i.keywords.$pattern),e=e||/\w+/,i.keywords&&(i.keywords=ee(i.keywords,a.case_insensitive)),s.keywordPatternRe=r(e,!0),n&&(i.begin||(i.begin=/\B|\b/),s.beginRe=r(i.begin),i.end||i.endsWithParent||(i.end=/\B|\b/),i.end&&(s.endRe=r(i.end)),s.terminatorEnd=c(i.end)||"",i.endsWithParent)&&n.terminatorEnd&&(s.terminatorEnd+=(i.end?"|":"")+n.terminatorEnd),i.illegal&&(s.illegalRe=r(i.illegal)),i.contains||(i.contains=[]),i.contains=[].concat(...i.contains.map(e=>{return(t="self"===e?i:e).variants&&!t.cachedVariants&&(t.cachedVariants=t.variants.map(e=>l(t,{variants:null},e))),t.cachedVariants||(function e(t){return!!t&&(t.endsWithParent||e(t.starts))}(t)?l(t,{starts:t.starts?l(t.starts):null}):Object.isFrozen(t)?l(t):t);var t})),i.contains.forEach(e=>{t(e,s)}),i.starts&&t(i.starts,n),s.matcher=(e=>{const t=new o;return e.contains.forEach(e=>t.addRule(e.begin,{rule:e,type:"begin"})),e.terminatorEnd&&t.addRule(e.terminatorEnd,{type:"end"}),e.illegal&&t.addRule(e.illegal,{type:"illegal"}),t})(s)}return s}(a)}const $=t,ae=l,re=Symbol("nomatch");e=(n=>{const T=Object.create(null),r=Object.create(null),s=[];let C=!0;const S="Could not find the language '{}', did you forget to load/include a language module?",a={disableAutodetect:!0,name:"Plain text",contains:[]};let k={ignoreUnescapedHTML:!1,noHighlightRe:/^(no-?highlight)$/i,languageDetectRe:/\blang(?:uage)?-([\w-]+)\b/i,classPrefix:"hljs-",cssSelector:"pre code",languages:null,__emitter:H};function o(e){return k.noHighlightRe.test(e)}function l(e,t,i){let n="",s="";"object"==typeof t?(n=e,i=t.ignoreIllegals,s=t.language):(m("10.7.0","highlight(lang, code, ...args) has been deprecated."),m("10.7.0","Please use highlight(code, options) instead.\nhttps://github.com/highlightjs/highlight.js/issues/2277"),s=e,n=t),void 0===i&&(i=!0);e={code:n,language:s},u("before:highlight",e),t=e.result||M(e.language,e.code,i);return t.code=e.code,u("after:highlight",t),t}function M(c,d,u,e){const r=Object.create(null);function a(){if(!f.keywords)return b.addText(y);let e=0,t=(f.keywordPatternRe.lastIndex=0,f.keywordPatternRe.exec(y)),i="";for(;t;){i+=y.substring(e,t.index);var n=o.case_insensitive?t[0].toLowerCase():t[0],s=(a=n,f.keywords[a]);if(s){const[e,a]=s;if(b.addText(i),i="",r[n]=(r[n]||0)+1,r[n]<=7&&(w+=a),e.startsWith("_"))i+=t[0];else{const i=o.classNameAliases[e]||e;b.addKeyword(t[0],i)}}else i+=t[0];e=f.keywordPatternRe.lastIndex,t=f.keywordPatternRe.exec(y)}var a;i+=y.substr(e),b.addText(i)}function p(){(null!=f.subLanguage?()=>{if(""!==y){let e=null;if("string"==typeof f.subLanguage){if(!T[f.subLanguage])return void b.addText(y);e=M(f.subLanguage,y,!0,l[f.subLanguage]),l[f.subLanguage]=e._top}else e=N(y,f.subLanguage.length?f.subLanguage:null);0<f.relevance&&(w+=e.relevance),b.addSublanguage(e._emitter,e.language)}}:a)(),y=""}function s(e,t){let i=1;for(;void 0!==t[i];){var n,s;e._emit[i]?(n=o.classNameAliases[e[i]]||e[i],s=t[i],n?b.addKeyword(s,n):(y=s,a(),y=""),i++):i++}}function h(e,t){e.scope&&"string"==typeof e.scope&&b.openNode(o.classNameAliases[e.scope]||e.scope),e.beginScope&&(e.beginScope._wrap?(b.addKeyword(y,o.classNameAliases[e.beginScope._wrap]||e.beginScope._wrap),y=""):e.beginScope._multi&&(s(e.beginScope,t),y="")),f=Object.create(e,{parent:{value:f}})}function m(e){var t=e[0],i=d.substr(e.index),n=function e(t,i,n){let s=(e=>(e=e&&e.exec(n))&&0===e.index)(t.endRe);if(s){if(t["on:end"]){const n=new A(t);t["on:end"](i,n),n.isMatchIgnored&&(s=!1)}if(s){for(;t.endsParent&&t.parent;)t=t.parent;return t}}if(t.endsWithParent)return e(t.parent,i,n)}(f,e,i);if(!n)return re;i=f;for(f.endScope&&f.endScope._wrap?(p(),b.addKeyword(t,f.endScope._wrap)):f.endScope&&f.endScope._multi?(p(),s(f.endScope,e)):i.skip?y+=t:(i.returnEnd||i.excludeEnd||(y+=t),p(),i.excludeEnd&&(y=t));f.scope&&b.closeNode(),f.skip||f.subLanguage||(w+=f.relevance),(f=f.parent)!==n.parent;);return n.starts&&h(n.starts,e),i.returnEnd?0:t.length}let g={};function t(e,t){var i,n=t&&t[0];if(y+=e,null==n)return p(),0;if("begin"===g.type&&"end"===t.type&&g.index===t.index&&""===n){if(y+=d.slice(t.index,t.index+1),C)return 1;{const e=Error(`0 width match regex (${c})`);throw e.languageName=c,e.badRule=g.rule,e}}if("begin"===(g=t).type){var s=t;const a=s[0],r=s.rule,o=new A(r),l=[r.__beforeBegin,r["on:begin"]];for(const r of l)if(r&&(r(s,o),o.isMatchIgnored))return i=a,0===f.matcher.regexIndex?(y+=i[0],1):(x=!0,0);return r.skip?y+=a:(r.excludeBegin&&(y+=a),p(),r.returnBegin||r.excludeBegin||(y=a)),h(r,s),r.returnBegin?0:a.length}if("illegal"===t.type&&!u){const c=Error('Illegal lexeme "'+n+'" for mode "'+(f.scope||"<unnamed>")+'"');throw c.mode=f,c}if("end"===t.type){const c=m(t);if(c!==re)return c}if("illegal"===t.type&&""===n)return 1;if(1e5<E&&E>3*t.index)throw Error("potential infinite loop, way more iterations than matches");return y+=n,n.length}const o=O(c);if(!o)throw D(S.replace("{}",c)),Error('Unknown language: "'+c+'"');var i=se(o);let n="",f=e||i;const l={},b=new k.__emitter(k);var v=[];for(let e=f;e!==o;e=e.parent)e.scope&&v.unshift(e.scope);v.forEach(e=>b.openNode(e));let y="",w=0,_=0,E=0,x=!1;try{for(f.matcher.considerAll();;){E++,x?x=!1:f.matcher.considerAll(),f.matcher.lastIndex=_;const c=f.matcher.exec(d);if(!c)break;const T=t(d.substring(_,c.index),c);_=c.index+T}return t(d.substr(_)),b.closeAllNodes(),b.finalize(),n=b.toHTML(),{language:c,value:n,relevance:w,illegal:!1,_emitter:b,_top:f}}catch(e){if(e.message&&e.message.includes("Illegal"))return{language:c,value:$(d),illegal:!0,relevance:0,_illegalBy:{message:e.message,index:_,context:d.slice(_-100,_+100),mode:e.mode,resultSoFar:n},_emitter:b};if(C)return{language:c,value:$(d),illegal:!1,relevance:0,errorRaised:e,_emitter:b,_top:f};throw e}}function N(t,e){e=e||k.languages||Object.keys(T);i=t,(n={value:$(i),illegal:!1,relevance:0,_top:a,_emitter:new k.__emitter(k)})._emitter.addText(i);var i=n,n=e.filter(O).filter(d).map(e=>M(e,t,!1)),e=(n.unshift(i),n.sort((e,t)=>{if(e.relevance!==t.relevance)return t.relevance-e.relevance;if(e.language&&t.language){if(O(e.language).supersetOf===t.language)return 1;if(O(t.language).supersetOf===e.language)return-1}return 0})),[i,n]=e,e=i;return e.secondBest=n,e}function t(e){var t,i,n,s,a=(e=>{let t=e.className+" ";t+=e.parentNode?e.parentNode.className:"";var i=k.languageDetectRe.exec(t);if(i){const t=O(i[1]);return t||(ie(S.replace("{}",i[1])),ie("Falling back to no-highlight mode for this block.",e)),t?i[1]:"no-highlight"}return t.split(/\s+/).find(e=>o(e)||O(e))})(e);o(a)||(u("before:highlightElement",{el:e,language:a}),!k.ignoreUnescapedHTML&&0<e.children.length&&(console.warn("One of your code blocks includes unescaped HTML. This is a potentially serious security risk."),console.warn("https://github.com/highlightjs/highlight.js/issues/2886"),console.warn(e)),t=e.textContent,i=a?l(t,{language:a,ignoreIllegals:!0}):N(t),e.innerHTML=i.value,n=e,a=a,s=i.language,a=a&&r[a]||s,n.classList.add("hljs"),n.classList.add("language-"+a),e.result={language:i.language,re:i.relevance,relevance:i.relevance},i.secondBest&&(e.secondBest={language:i.secondBest.language,relevance:i.secondBest.relevance}),u("after:highlightElement",{el:e,result:i,text:t}))}let e=!1;function i(){"loading"!==document.readyState?document.querySelectorAll(k.cssSelector).forEach(t):e=!0}function O(e){return e=(e||"").toLowerCase(),T[e]||T[r[e]]}function c(e,{languageName:t}){(e="string"==typeof e?[e]:e).forEach(e=>{r[e.toLowerCase()]=t})}function d(e){e=O(e);return e&&!e.disableAutodetect}function u(e,t){const i=e;s.forEach(e=>{e[i]&&e[i](t)})}"undefined"!=typeof window&&window.addEventListener&&window.addEventListener("DOMContentLoaded",()=>{e&&i()},!1),Object.assign(n,{highlight:l,highlightAuto:N,highlightAll:i,highlightElement:t,highlightBlock:e=>(m("10.7.0","highlightBlock will be removed entirely in v12.0"),m("10.7.0","Please use highlightElement now."),t(e)),configure:e=>{k=ae(k,e)},initHighlighting:()=>{i(),m("10.6.0","initHighlighting() deprecated.  Use highlightAll() now.")},initHighlightingOnLoad:()=>{i(),m("10.6.0","initHighlightingOnLoad() deprecated.  Use highlightAll() now.")},registerLanguage:(t,e)=>{let i=null;try{i=e(n)}catch(e){if(D("Language definition for '{}' could not be registered.".replace("{}",t)),!C)throw e;D(e),i=a}i.name||(i.name=t),(T[t]=i).rawDefinition=e.bind(null,n),i.aliases&&c(i.aliases,{languageName:t})},unregisterLanguage:e=>{delete T[e];for(const T of Object.keys(r))r[T]===e&&delete r[T]},listLanguages:()=>Object.keys(T),getLanguage:O,registerAliases:c,autoDetection:d,inherit:ae,addPlugin:e=>{var t;(t=e)["before:highlightBlock"]&&!t["before:highlightElement"]&&(t["before:highlightElement"]=e=>{t["before:highlightBlock"](Object.assign({block:e.el},e))}),t["after:highlightBlock"]&&!t["after:highlightElement"]&&(t["after:highlightElement"]=e=>{t["after:highlightBlock"](Object.assign({block:e.el},e))}),s.push(e)}}),n.debugMode=()=>{C=!1},n.safeMode=()=>{C=!0},n.versionString="11.2.0";for(const n in p)"object"==typeof p[n]&&x(p[n]);return Object.assign(n,p),n})({});const f=e=>({IMPORTANT:{scope:"meta",begin:"!important"},HEXCOLOR:{scope:"number",begin:"#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})"},ATTRIBUTE_SELECTOR_MODE:{scope:"selector-attr",begin:/\[/,end:/\]/,illegal:"$",contains:[e.APOS_STRING_MODE,e.QUOTE_STRING_MODE]},CSS_NUMBER_MODE:{scope:"number",begin:e.NUMBER_RE+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",relevance:0},CSS_VARIABLE:{className:"attr",begin:/--[A-Za-z][A-Za-z0-9_-]*/}}),b=["a","abbr","address","article","aside","audio","b","blockquote","body","button","canvas","caption","cite","code","dd","del","details","dfn","div","dl","dt","em","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hgroup","html","i","iframe","img","input","ins","kbd","label","legend","li","main","mark","menu","nav","object","ol","p","q","quote","samp","section","span","strong","summary","sup","table","tbody","td","textarea","tfoot","th","thead","time","tr","ul","var","video"],v=["any-hover","any-pointer","aspect-ratio","color","color-gamut","color-index","device-aspect-ratio","device-height","device-width","display-mode","forced-colors","grid","height","hover","inverted-colors","monochrome","orientation","overflow-block","overflow-inline","pointer","prefers-color-scheme","prefers-contrast","prefers-reduced-motion","prefers-reduced-transparency","resolution","scan","scripting","update","width","min-width","max-width","min-height","max-height"],y=["active","any-link","blank","checked","current","default","defined","dir","disabled","drop","empty","enabled","first","first-child","first-of-type","fullscreen","future","focus","focus-visible","focus-within","has","host","host-context","hover","indeterminate","in-range","invalid","is","lang","last-child","last-of-type","left","link","local-link","not","nth-child","nth-col","nth-last-child","nth-last-col","nth-last-of-type","nth-of-type","only-child","only-of-type","optional","out-of-range","past","placeholder-shown","read-only","read-write","required","right","root","scope","target","target-within","user-invalid","valid","visited","where"],w=["after","backdrop","before","cue","cue-region","first-letter","first-line","grammar-error","marker","part","placeholder","selection","slotted","spelling-error"],_=["align-content","align-items","align-self","animation","animation-delay","animation-direction","animation-duration","animation-fill-mode","animation-iteration-count","animation-name","animation-play-state","animation-timing-function","auto","backface-visibility","background","background-attachment","background-clip","background-color","background-image","background-origin","background-position","background-repeat","background-size","border","border-bottom","border-bottom-color","border-bottom-left-radius","border-bottom-right-radius","border-bottom-style","border-bottom-width","border-collapse","border-color","border-image","border-image-outset","border-image-repeat","border-image-slice","border-image-source","border-image-width","border-left","border-left-color","border-left-style","border-left-width","border-radius","border-right","border-right-color","border-right-style","border-right-width","border-spacing","border-style","border-top","border-top-color","border-top-left-radius","border-top-right-radius","border-top-style","border-top-width","border-width","bottom","box-decoration-break","box-shadow","box-sizing","break-after","break-before","break-inside","caption-side","clear","clip","clip-path","color","column-count","column-fill","column-gap","column-rule","column-rule-color","column-rule-style","column-rule-width","column-span","column-width","columns","content","counter-increment","counter-reset","cursor","direction","display","empty-cells","filter","flex","flex-basis","flex-direction","flex-flow","flex-grow","flex-shrink","flex-wrap","float","font","font-display","font-family","font-feature-settings","font-kerning","font-language-override","font-size","font-size-adjust","font-smoothing","font-stretch","font-style","font-variant","font-variant-ligatures","font-variation-settings","font-weight","height","hyphens","icon","image-orientation","image-rendering","image-resolution","ime-mode","inherit","initial","justify-content","left","letter-spacing","line-height","list-style","list-style-image","list-style-position","list-style-type","margin","margin-bottom","margin-left","margin-right","margin-top","marks","mask","max-height","max-width","min-height","min-width","nav-down","nav-index","nav-left","nav-right","nav-up","none","normal","object-fit","object-position","opacity","order","orphans","outline","outline-color","outline-offset","outline-style","outline-width","overflow","overflow-wrap","overflow-x","overflow-y","padding","padding-bottom","padding-left","padding-right","padding-top","page-break-after","page-break-before","page-break-inside","perspective","perspective-origin","pointer-events","position","quotes","resize","right","src","tab-size","table-layout","text-align","text-align-last","text-decoration","text-decoration-color","text-decoration-line","text-decoration-style","text-indent","text-overflow","text-rendering","text-shadow","text-transform","text-underline-position","top","transform","transform-origin","transform-style","transition","transition-delay","transition-duration","transition-property","transition-timing-function","unicode-bidi","vertical-align","visibility","white-space","widows","width","word-break","word-spacing","word-wrap","z-index"].reverse(),oe=y.concat(w);var r="\\.([0-9](_*[0-9])*)",o="[0-9a-fA-F](_*[0-9a-fA-F])*",E={className:"number",variants:[{begin:`(\\b([0-9](_*[0-9])*)((${r})|\\.)?|(${r}))[eE][+-]?([0-9](_*[0-9])*)[fFdD]?\\b`},{begin:`\\b([0-9](_*[0-9])*)((${r})[fFdD]?\\b|\\.([fFdD]\\b)?)`},{begin:`(${r})[fFdD]?\\b`},{begin:"\\b([0-9](_*[0-9])*)[fFdD]\\b"},{begin:`\\b0[xX]((${o})\\.?|(${o})?\\.(${o}))[pP][+-]?([0-9](_*[0-9])*)[fFdD]?\\b`},{begin:"\\b(0|[1-9](_*[0-9])*)[lL]?\\b"},{begin:`\\b0[xX](${o})[lL]?\\b`},{begin:"\\b0(_*[0-7])*[lL]?\\b"},{begin:"\\b0[bB][01](_*[01])*[lL]?\\b"}],relevance:0};const C="[A-Za-z$_][0-9A-Za-z$_]*",le=["as","in","of","if","for","while","finally","var","new","function","do","return","void","else","break","catch","instanceof","with","throw","case","default","try","switch","continue","typeof","delete","let","yield","const","class","debugger","async","await","static","import","from","export","extends"],ce=["true","false","null","undefined","NaN","Infinity"],de=["Intl","DataView","Number","Math","Date","String","RegExp","Object","Function","Boolean","Error","Symbol","Set","Map","WeakSet","WeakMap","Proxy","Reflect","JSON","Promise","Float64Array","Int16Array","Int32Array","Int8Array","Uint16Array","Uint32Array","Float32Array","Array","Uint8Array","Uint8ClampedArray","ArrayBuffer","BigInt64Array","BigUint64Array","BigInt"],ue=["EvalError","InternalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError"],pe=["setInterval","setTimeout","clearInterval","clearTimeout","require","exports","eval","isFinite","isNaN","parseFloat","parseInt","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","unescape"],he=["arguments","this","super","console","window","document","localStorage","module","global"],me=[].concat(pe,de,ue);function ge(e){const t=C,i=/<[A-Za-z0-9\\._:-]+/,n=/\/[A-Za-z0-9\\._:-]+>|\/>/,s=(e,t)=>{var i=e[0].length+e.index,n=e.input[i];("<"===n||">"===n&&([n,e]=[e,{after:i}["after"]],i="</"+n[0].slice(1),-1===n.input.indexOf(i,e)))&&t.ignoreMatch()},a={$pattern:C,keyword:le,literal:ce,built_in:me,"variable.language":he},r="\\.([0-9](_?[0-9])*)",o="0|[1-9](_?[0-9])*|0[0-7]*[89][0-9]*",l={className:"number",variants:[{begin:`(\\b(${o})((${r})|\\.)?|(${r}))[eE][+-]?([0-9](_?[0-9])*)\\b`},{begin:`\\b(${o})\\b((${r})\\b|\\.)?|(${r})\\b`},{begin:"\\b(0|[1-9](_?[0-9])*)n\\b"},{begin:"\\b0[xX][0-9a-fA-F](_?[0-9a-fA-F])*n?\\b"},{begin:"\\b0[bB][0-1](_?[0-1])*n?\\b"},{begin:"\\b0[oO][0-7](_?[0-7])*n?\\b"},{begin:"\\b0[0-7]+n?\\b"}],relevance:0},c={className:"subst",begin:"\\$\\{",end:"\\}",keywords:a,contains:[]},d={begin:"html`",end:"",starts:{end:"`",returnEnd:!1,contains:[e.BACKSLASH_ESCAPE,c],subLanguage:"xml"}},u={begin:"css`",end:"",starts:{end:"`",returnEnd:!1,contains:[e.BACKSLASH_ESCAPE,c],subLanguage:"css"}},p={className:"string",begin:"`",end:"`",contains:[e.BACKSLASH_ESCAPE,c]},h={className:"comment",variants:[e.COMMENT(/\/\*\*(?!\/)/,"\\*/",{relevance:0,contains:[{begin:"(?=@[A-Za-z]+)",relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"},{className:"type",begin:"\\{",end:"\\}",excludeEnd:!0,excludeBegin:!0,relevance:0},{className:"variable",begin:t+"(?=\\s*(-)|$)",endsParent:!0,relevance:0},{begin:/(?=[^\n])\s/,relevance:0}]}]}),e.C_BLOCK_COMMENT_MODE,e.C_LINE_COMMENT_MODE]},m=[e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,d,u,p,l,e.REGEXP_MODE];c.contains=m.concat({begin:/\{/,end:/\}/,keywords:a,contains:["self"].concat(m)});var g=[].concat(h,c.contains),g=g.concat([{begin:/\(/,end:/\)/,keywords:a,contains:["self"].concat(g)}]),f={className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:a,contains:g},b={variants:[{match:[/class/,/\s+/,t],scope:{1:"keyword",3:"title.class"}},{match:[/extends/,/\s+/,L(t,"(",L(/\./,t),")*")],scope:{1:"keyword",3:"title.class.inherited"}}]},v={relevance:0,match:/\b[A-Z][a-z]+([A-Z][a-z]+)*/,className:"title.class",keywords:{_:[...de,...ue]}},y={variants:[{match:[/function/,/\s+/,t,/(?=\s*\()/]},{match:[/function/,/\s*(?=\()/]}],className:{1:"keyword",3:"title.function"},label:"func.def",contains:[f],illegal:/%/},w={match:L(/\b/,L("(?!",[...pe,"super"].join("|"),")"),t,O(/\(/)),className:"title.function",relevance:0},_={begin:L(/\./,O(L(t,/(?![0-9A-Za-z$_(])/))),end:t,excludeBegin:!0,keywords:"prototype",className:"property",relevance:0},E={match:[/get|set/,/\s+/,t,/(?=\()/],className:{1:"keyword",3:"title.function"},contains:[{begin:/\(\)/},f]},x="(\\([^()]*(\\([^()]*(\\([^()]*\\)[^()]*)*\\)[^()]*)*\\)|"+e.UNDERSCORE_IDENT_RE+")\\s*=>",T={match:[/const|var|let/,/\s+/,t,/\s*/,/=\s*/,O(x)],className:{1:"keyword",3:"title.function"},contains:[f]};return{name:"Javascript",aliases:["js","jsx","mjs","cjs"],keywords:a,exports:{PARAMS_CONTAINS:g},illegal:/#(?![$_A-z])/,contains:[e.SHEBANG({label:"shebang",binary:"node",relevance:5}),{label:"use_strict",className:"meta",relevance:10,begin:/^\s*['"]use (strict|asm)['"]/},e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,d,u,p,h,l,v,{className:"attr",begin:t+O(":"),relevance:0},T,{begin:"("+e.RE_STARTERS_RE+"|\\b(case|return|throw)\\b)\\s*",keywords:"return throw case",relevance:0,contains:[h,e.REGEXP_MODE,{className:"function",begin:x,returnBegin:!0,end:"\\s*=>",contains:[{className:"params",variants:[{begin:e.UNDERSCORE_IDENT_RE,relevance:0},{className:null,begin:/\(\s*\)/,skip:!0},{begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:a,contains:g}]}]},{begin:/,/,relevance:0},{match:/\s+/,relevance:0},{variants:[{begin:"<>",end:"</>"},{begin:i,"on:begin":s,end:n}],subLanguage:"xml",contains:[{begin:i,end:n,skip:!0,contains:["self"]}]}]},y,{beginKeywords:"while if switch catch for"},{begin:"\\b(?!function)"+e.UNDERSCORE_IDENT_RE+"\\([^()]*(\\([^()]*(\\([^()]*\\)[^()]*)*\\)[^()]*)*\\)\\s*\\{",returnBegin:!0,label:"func.def",contains:[f,e.inherit(e.TITLE_MODE,{begin:t,className:"title.function"})]},{match:/\.\.\./,relevance:0},_,{match:"\\$"+t,relevance:0},{match:[/\bconstructor(?=\s*\()/],className:{1:"title.function"},contains:[f]},w,{relevance:0,match:/\b[A-Z][A-Z_0-9]+\b/,className:"variable.constant"},b,E,{match:/\$[(.]/}]}}const P=e=>L(/\b/,e,/\w$/.test(e)?/\b/:/\B/),fe=["Protocol","Type"].map(P),be=["init","self"].map(P),ve=["Any","Self"],z=["actor","associatedtype","async","await",/as\?/,/as!/,"as","break","case","catch","class","continue","convenience","default","defer","deinit","didSet","do","dynamic","else","enum","extension","fallthrough",/fileprivate\(set\)/,"fileprivate","final","for","func","get","guard","if","import","indirect","infix",/init\?/,/init!/,"inout",/internal\(set\)/,"internal","in","is","isolated","nonisolated","lazy","let","mutating","nonmutating",/open\(set\)/,"open","operator","optional","override","postfix","precedencegroup","prefix",/private\(set\)/,"private","protocol",/public\(set\)/,"public","repeat","required","rethrows","return","set","some","static","struct","subscript","super","switch","throws","throw",/try\?/,/try!/,"try","typealias",/unowned\(safe\)/,/unowned\(unsafe\)/,"unowned","var","weak","where","while","willSet"],ye=["false","nil","true"],we=["assignment","associativity","higherThan","left","lowerThan","none","right"],_e=["#colorLiteral","#column","#dsohandle","#else","#elseif","#endif","#error","#file","#fileID","#fileLiteral","#filePath","#function","#if","#imageLiteral","#keyPath","#line","#selector","#sourceLocation","#warn_unqualified_access","#warning"],Ee=["abs","all","any","assert","assertionFailure","debugPrint","dump","fatalError","getVaList","isKnownUniquelyReferenced","max","min","numericCast","pointwiseMax","pointwiseMin","precondition","preconditionFailure","print","readLine","repeatElement","sequence","stride","swap","swift_unboxFromSwiftValueWithType","transcode","type","unsafeBitCast","unsafeDowncast","withExtendedLifetime","withUnsafeMutablePointer","withUnsafePointer","withVaList","withoutActuallyEscaping","zip"],xe=I(/[/=\-+!*%<>&|^~?]/,/[\u00A1-\u00A7]/,/[\u00A9\u00AB]/,/[\u00AC\u00AE]/,/[\u00B0\u00B1]/,/[\u00B6\u00BB\u00BF\u00D7\u00F7]/,/[\u2016-\u2017]/,/[\u2020-\u2027]/,/[\u2030-\u203E]/,/[\u2041-\u2053]/,/[\u2055-\u205E]/,/[\u2190-\u23FF]/,/[\u2500-\u2775]/,/[\u2794-\u2BFF]/,/[\u2E00-\u2E7F]/,/[\u3001-\u3003]/,/[\u3008-\u3020]/,/[\u3030]/),Te=I(xe,/[\u0300-\u036F]/,/[\u1DC0-\u1DFF]/,/[\u20D0-\u20FF]/,/[\uFE00-\uFE0F]/,/[\uFE20-\uFE2F]/),R=L(xe,Te,"*"),Ce=I(/[a-zA-Z_]/,/[\u00A8\u00AA\u00AD\u00AF\u00B2-\u00B5\u00B7-\u00BA]/,/[\u00BC-\u00BE\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u00FF]/,/[\u0100-\u02FF\u0370-\u167F\u1681-\u180D\u180F-\u1DBF]/,/[\u1E00-\u1FFF]/,/[\u200B-\u200D\u202A-\u202E\u203F-\u2040\u2054\u2060-\u206F]/,/[\u2070-\u20CF\u2100-\u218F\u2460-\u24FF\u2776-\u2793]/,/[\u2C00-\u2DFF\u2E80-\u2FFF]/,/[\u3004-\u3007\u3021-\u302F\u3031-\u303F\u3040-\uD7FF]/,/[\uF900-\uFD3D\uFD40-\uFDCF\uFDF0-\uFE1F\uFE30-\uFE44]/,/[\uFE47-\uFEFE\uFF00-\uFFFD]/),B=I(Ce,/\d/,/[\u0300-\u036F\u1DC0-\u1DFF\u20D0-\u20FF\uFE20-\uFE2F]/),j=L(Ce,B,"*"),F=L(/[A-Z]/,B,"*"),Se=["autoclosure",L(/convention\(/,I("swift","block","c"),/\)/),"discardableResult","dynamicCallable","dynamicMemberLookup","escaping","frozen","GKInspectable","IBAction","IBDesignable","IBInspectable","IBOutlet","IBSegueAction","inlinable","main","nonobjc","NSApplicationMain","NSCopying","NSManaged",L(/objc\(/,j,/\)/),"objc","objcMembers","propertyWrapper","requires_stored_property_inits","resultBuilder","testable","UIApplicationMain","unknown","usableFromInline"],ke=["iOS","iOSApplicationExtension","macOS","macOSApplicationExtension","macCatalyst","macCatalystApplicationExtension","watchOS","watchOSApplicationExtension","tvOS","tvOSApplicationExtension","swift"];var Me=Object.freeze({__proto__:null,grmr_bash:e=>{var t={},i={begin:/\$\{/,end:/\}/,contains:["self",{begin:/:-/,contains:[t]}]},i=(Object.assign(t,{className:"variable",variants:[{begin:L(/\$[\w\d#@][\w\d_]*/,"(?![\\w\\d])(?![$])")},i]}),{className:"subst",begin:/\$\(/,end:/\)/,contains:[e.BACKSLASH_ESCAPE]}),n={begin:/<<-?\s*(?=\w+)/,starts:{contains:[e.END_SAME_AS_BEGIN({begin:/(\w+)/,end:/(\w+)/,className:"string"})]}},s={className:"string",begin:/"/,end:/"/,contains:[e.BACKSLASH_ESCAPE,t,i]},i=(i.contains.push(s),{begin:/\$\(\(/,end:/\)\)/,contains:[{begin:/\d+#[0-9a-f]+/,className:"number"},e.NUMBER_MODE,t]}),a=e.SHEBANG({binary:"(fish|bash|zsh|sh|csh|ksh|tcsh|dash|scsh)",relevance:10}),r={className:"function",begin:/\w[\w\d_]*\s*\(\s*\)\s*\{/,returnBegin:!0,contains:[e.inherit(e.TITLE_MODE,{begin:/\w[\w\d_]*/})],relevance:0};return{name:"Bash",aliases:["sh"],keywords:{$pattern:/\b[a-z._-]+\b/,keyword:["if","then","else","elif","fi","for","while","in","do","done","case","esac","function"],literal:["true","false"],built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp"},contains:[a,e.SHEBANG(),r,i,e.HASH_COMMENT_MODE,n,s,{className:"",begin:/\\"/},{className:"string",begin:/'/,end:/'/},t]}},grmr_c:e=>{var t=e.COMMENT("//","$",{contains:[{begin:/\\\n/}]}),i="[a-zA-Z_]\\w*::",n="(decltype\\(auto\\)|"+h(i)+"[a-zA-Z_]\\w*"+h("<[^<>]+>")+")",s={className:"type",variants:[{begin:"\\b[a-z\\d_]*_t\\b"},{match:/\batomic_[a-z]{3,6}\b/}]},a={className:"string",variants:[{begin:'(u8?|U|L)?"',end:'"',illegal:"\\n",contains:[e.BACKSLASH_ESCAPE]},{begin:"(u8?|U|L)?'(\\\\(x[0-9A-Fa-f]{2}|u[0-9A-Fa-f]{4,8}|[0-7]{3}|\\S)|.)",end:"'",illegal:"."},e.END_SAME_AS_BEGIN({begin:/(?:u8?|U|L)?R"([^()\\ ]{0,16})\(/,end:/\)([^()\\ ]{0,16})"/})]},r={className:"number",variants:[{begin:"\\b(0b[01']+)"},{begin:"(-?)\\b([\\d']+(\\.[\\d']*)?|\\.[\\d']+)((ll|LL|l|L)(u|U)?|(u|U)(ll|LL|l|L)?|f|F|b|B)"},{begin:"(-?)(\\b0[xX][a-fA-F0-9']+|(\\b[\\d']+(\\.[\\d']*)?|\\.[\\d']+)([eE][-+]?[\\d']+)?)"}],relevance:0},o={className:"meta",begin:/#\s*[a-z]+\b/,end:/$/,keywords:{keyword:"if else elif endif define undef warning error line pragma _Pragma ifdef ifndef include"},contains:[{begin:/\\\n/,relevance:0},e.inherit(a,{className:"string"}),{className:"string",begin:/<.*?>/},t,e.C_BLOCK_COMMENT_MODE]},l={className:"title",begin:h(i)+e.IDENT_RE,relevance:0},i=h(i)+e.IDENT_RE+"\\s*\\(",c={keyword:["asm","auto","break","case","const","continue","default","do","else","enum","extern","for","fortran","goto","if","inline","register","restrict","return","sizeof","static","struct","switch","typedef","union","volatile","while","_Alignas","_Alignof","_Atomic","_Generic","_Noreturn","_Static_assert","_Thread_local","alignas","alignof","noreturn","static_assert","thread_local","_Pragma"],type:["float","double","signed","unsigned","int","short","long","char","void","_Bool","_Complex","_Imaginary","_Decimal32","_Decimal64","_Decimal128","complex","bool","imaginary"],literal:"true false NULL",built_in:"std string wstring cin cout cerr clog stdin stdout stderr stringstream istringstream ostringstream auto_ptr deque list queue stack vector map set pair bitset multiset multimap unordered_set unordered_map unordered_multiset unordered_multimap priority_queue make_pair array shared_ptr abort terminate abs acos asin atan2 atan calloc ceil cosh cos exit exp fabs floor fmod fprintf fputs free frexp fscanf future isalnum isalpha iscntrl isdigit isgraph islower isprint ispunct isspace isupper isxdigit tolower toupper labs ldexp log10 log malloc realloc memchr memcmp memcpy memset modf pow printf putchar puts scanf sinh sin snprintf sprintf sqrt sscanf strcat strchr strcmp strcpy strcspn strlen strncat strncmp strncpy strpbrk strrchr strspn strstr tanh tan vfprintf vprintf vsprintf endl initializer_list unique_ptr"},d=[o,s,t,e.C_BLOCK_COMMENT_MODE,r,a],u={variants:[{begin:/=/,end:/;/},{begin:/\(/,end:/\)/},{beginKeywords:"new throw return else",end:/;/}],keywords:c,contains:d.concat([{begin:/\(/,end:/\)/,keywords:c,contains:d.concat(["self"]),relevance:0}]),relevance:0},n={begin:"("+n+"[\\*&\\s]+)+"+i,returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:c,illegal:/[^\w\s\*&:<>.]/,contains:[{begin:"decltype\\(auto\\)",keywords:c,relevance:0},{begin:i,returnBegin:!0,contains:[e.inherit(l,{className:"title.function"})],relevance:0},{relevance:0,match:/,/},{className:"params",begin:/\(/,end:/\)/,keywords:c,relevance:0,contains:[t,e.C_BLOCK_COMMENT_MODE,a,r,s,{begin:/\(/,end:/\)/,keywords:c,relevance:0,contains:["self",t,e.C_BLOCK_COMMENT_MODE,a,r,s]}]},s,t,e.C_BLOCK_COMMENT_MODE,o]};return{name:"C",aliases:["h"],keywords:c,disableAutodetect:!0,illegal:"</",contains:[].concat(u,n,d,[o,{begin:e.IDENT_RE+"::",keywords:c},{className:"class",beginKeywords:"enum class struct union",end:/[{;:<>=]/,contains:[{beginKeywords:"final class struct"},e.TITLE_MODE]}]),exports:{preprocessor:o,strings:a,keywords:c}}},grmr_cpp:e=>{var t=e.COMMENT("//","$",{contains:[{begin:/\\\n/}]}),i="[a-zA-Z_]\\w*::",n="(?!struct)(decltype\\(auto\\)|"+h(i)+"[a-zA-Z_]\\w*"+h("<[^<>]+>")+")",s={className:"type",begin:"\\b[a-z\\d_]*_t\\b"},a={className:"string",variants:[{begin:'(u8?|U|L)?"',end:'"',illegal:"\\n",contains:[e.BACKSLASH_ESCAPE]},{begin:"(u8?|U|L)?'(\\\\(x[0-9A-Fa-f]{2}|u[0-9A-Fa-f]{4,8}|[0-7]{3}|\\S)|.)",end:"'",illegal:"."},e.END_SAME_AS_BEGIN({begin:/(?:u8?|U|L)?R"([^()\\ ]{0,16})\(/,end:/\)([^()\\ ]{0,16})"/})]},r={className:"number",variants:[{begin:"\\b(0b[01']+)"},{begin:"(-?)\\b([\\d']+(\\.[\\d']*)?|\\.[\\d']+)((ll|LL|l|L)(u|U)?|(u|U)(ll|LL|l|L)?|f|F|b|B)"},{begin:"(-?)(\\b0[xX][a-fA-F0-9']+|(\\b[\\d']+(\\.[\\d']*)?|\\.[\\d']+)([eE][-+]?[\\d']+)?)"}],relevance:0},o={className:"meta",begin:/#\s*[a-z]+\b/,end:/$/,keywords:{keyword:"if else elif endif define undef warning error line pragma _Pragma ifdef ifndef include"},contains:[{begin:/\\\n/,relevance:0},e.inherit(a,{className:"string"}),{className:"string",begin:/<.*?>/},t,e.C_BLOCK_COMMENT_MODE]},l={className:"title",begin:h(i)+e.IDENT_RE,relevance:0},i=h(i)+e.IDENT_RE+"\\s*\\(",c={type:["bool","char","char16_t","char32_t","char8_t","double","float","int","long","short","void","wchar_t"],keyword:["alignas","alignof","and","and_eq","asm","atomic_cancel","atomic_commit","atomic_noexcept","auto","bitand","bitor","break","case","catch","class","co_await","co_return","co_yield","compl","concept","const","const_cast|10","consteval","constexpr","constinit","continue","decltype","default","delete","do","dynamic_cast|10","else","enum","explicit","export","extern","false","final","for","friend","goto","if","import","inline","module","mutable","namespace","new","noexcept","not","not_eq","nullptr","operator","or","or_eq","override","private","protected","public","reflexpr","register","reinterpret_cast|10","requires","return","signed","sizeof","static","static_assert","static_cast|10","struct","switch","synchronized","template","this","thread_local","throw","transaction_safe","transaction_safe_dynamic","true","try","typedef","typeid","typename","union","unsigned","using","virtual","volatile","while","xor","xor_eq,"],literal:["NULL","false","nullopt","nullptr","true"],built_in:["_Pragma"],_type_hints:["any","auto_ptr","barrier","binary_semaphore","bitset","complex","condition_variable","condition_variable_any","counting_semaphore","deque","false_type","future","imaginary","initializer_list","istringstream","jthread","latch","lock_guard","multimap","multiset","mutex","optional","ostringstream","packaged_task","pair","promise","priority_queue","queue","recursive_mutex","recursive_timed_mutex","scoped_lock","set","shared_future","shared_lock","shared_mutex","shared_timed_mutex","shared_ptr","stack","string_view","stringstream","timed_mutex","thread","true_type","tuple","unique_lock","unique_ptr","unordered_map","unordered_multimap","unordered_multiset","unordered_set","variant","vector","weak_ptr","wstring","wstring_view"]},d={className:"function.dispatch",relevance:0,keywords:{_hint:["abort","abs","acos","apply","as_const","asin","atan","atan2","calloc","ceil","cerr","cin","clog","cos","cosh","cout","declval","endl","exchange","exit","exp","fabs","floor","fmod","forward","fprintf","fputs","free","frexp","fscanf","future","invoke","isalnum","isalpha","iscntrl","isdigit","isgraph","islower","isprint","ispunct","isspace","isupper","isxdigit","labs","launder","ldexp","log","log10","make_pair","make_shared","make_shared_for_overwrite","make_tuple","make_unique","malloc","memchr","memcmp","memcpy","memset","modf","move","pow","printf","putchar","puts","realloc","scanf","sin","sinh","snprintf","sprintf","sqrt","sscanf","std","stderr","stdin","stdout","strcat","strchr","strcmp","strcpy","strcspn","strlen","strncat","strncmp","strncpy","strpbrk","strrchr","strspn","strstr","swap","tan","tanh","terminate","to_underlying","tolower","toupper","vfprintf","visit","vprintf","vsprintf"]},begin:L(/\b/,/(?!decltype)/,/(?!if)/,/(?!for)/,/(?!while)/,e.IDENT_RE,O(/(<[^<>]+>|)\s*\(/))},u=[d,o,s,t,e.C_BLOCK_COMMENT_MODE,r,a],p={variants:[{begin:/=/,end:/;/},{begin:/\(/,end:/\)/},{beginKeywords:"new throw return else",end:/;/}],keywords:c,contains:u.concat([{begin:/\(/,end:/\)/,keywords:c,contains:u.concat(["self"]),relevance:0}]),relevance:0},n={className:"function",begin:"("+n+"[\\*&\\s]+)+"+i,returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:c,illegal:/[^\w\s\*&:<>.]/,contains:[{begin:"decltype\\(auto\\)",keywords:c,relevance:0},{begin:i,returnBegin:!0,contains:[l],relevance:0},{begin:/::/,relevance:0},{begin:/:/,endsWithParent:!0,contains:[a,r]},{relevance:0,match:/,/},{className:"params",begin:/\(/,end:/\)/,keywords:c,relevance:0,contains:[t,e.C_BLOCK_COMMENT_MODE,a,r,s,{begin:/\(/,end:/\)/,keywords:c,relevance:0,contains:["self",t,e.C_BLOCK_COMMENT_MODE,a,r,s]}]},s,t,e.C_BLOCK_COMMENT_MODE,o]};return{name:"C++",aliases:["cc","c++","h++","hpp","hh","hxx","cxx"],keywords:c,illegal:"</",classNameAliases:{"function.dispatch":"built_in"},contains:[].concat(p,n,d,u,[o,{begin:"\\b(deque|list|queue|priority_queue|pair|stack|vector|map|set|bitset|multiset|multimap|unordered_map|unordered_set|unordered_multiset|unordered_multimap|array|tuple|optional|variant|function)\\s*<",end:">",keywords:c,contains:["self",s]},{begin:e.IDENT_RE+"::",keywords:c},{match:[/\b(?:enum(?:\s+(?:class|struct))?|class|struct|union)/,/\s+/,/\w+/],className:{1:"keyword",3:"title.class"}}])}},grmr_csharp:e=>{var t={keyword:["abstract","as","base","break","case","catch","class","const","continue","do","else","event","explicit","extern","finally","fixed","for","foreach","goto","if","implicit","in","interface","internal","is","lock","namespace","new","operator","out","override","params","private","protected","public","readonly","record","ref","return","sealed","sizeof","stackalloc","static","struct","switch","this","throw","try","typeof","unchecked","unsafe","using","virtual","void","volatile","while"].concat(["add","alias","and","ascending","async","await","by","descending","equals","from","get","global","group","init","into","join","let","nameof","not","notnull","on","or","orderby","partial","remove","select","set","unmanaged","value|0","var","when","where","with","yield"]),built_in:["bool","byte","char","decimal","delegate","double","dynamic","enum","float","int","long","nint","nuint","object","sbyte","short","string","ulong","uint","ushort"],literal:["default","false","null","true"]},i=e.inherit(e.TITLE_MODE,{begin:"[a-zA-Z](\\.?\\w)*"}),n={className:"number",variants:[{begin:"\\b(0b[01']+)"},{begin:"(-?)\\b([\\d']+(\\.[\\d']*)?|\\.[\\d']+)(u|U|l|L|ul|UL|f|F|b|B)"},{begin:"(-?)(\\b0[xX][a-fA-F0-9']+|(\\b[\\d']+(\\.[\\d']*)?|\\.[\\d']+)([eE][-+]?[\\d']+)?)"}],relevance:0},s={className:"string",begin:'@"',end:'"',contains:[{begin:'""'}]},a=e.inherit(s,{illegal:/\n/}),r={className:"subst",begin:/\{/,end:/\}/,keywords:t},o=e.inherit(r,{illegal:/\n/}),l={className:"string",begin:/\$"/,end:'"',illegal:/\n/,contains:[{begin:/\{\{/},{begin:/\}\}/},e.BACKSLASH_ESCAPE,o]},c={className:"string",begin:/\$@"/,end:'"',contains:[{begin:/\{\{/},{begin:/\}\}/},{begin:'""'},r]},d=e.inherit(c,{illegal:/\n/,contains:[{begin:/\{\{/},{begin:/\}\}/},{begin:'""'},o]}),r=(r.contains=[c,l,s,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,n,e.C_BLOCK_COMMENT_MODE],o.contains=[d,l,a,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,n,e.inherit(e.C_BLOCK_COMMENT_MODE,{illegal:/\n/})],{variants:[c,l,s,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE]}),o={begin:"<",end:">",contains:[{beginKeywords:"in out"},i]},d=e.IDENT_RE+"(<"+e.IDENT_RE+"(\\s*,\\s*"+e.IDENT_RE+")*>)?(\\[\\])?",a={begin:"@"+e.IDENT_RE,relevance:0};return{name:"C#",aliases:["cs","c#"],keywords:t,illegal:/::/,contains:[e.COMMENT("///","$",{returnBegin:!0,contains:[{className:"doctag",variants:[{begin:"///",relevance:0},{begin:"\x3c!--|--\x3e"},{begin:"</?",end:">"}]}]}),e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,{className:"meta",begin:"#",end:"$",keywords:{keyword:"if else elif endif define undef warning error line region endregion pragma checksum"}},r,n,{beginKeywords:"class interface",relevance:0,end:/[{;=]/,illegal:/[^\s:,]/,contains:[{beginKeywords:"where class"},i,o,e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},{beginKeywords:"namespace",relevance:0,end:/[{;=]/,illegal:/[^\s:]/,contains:[i,e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},{beginKeywords:"record",relevance:0,end:/[{;=]/,illegal:/[^\s:]/,contains:[i,o,e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},{className:"meta",begin:"^\\s*\\[(?=[\\w])",excludeBegin:!0,end:"\\]",excludeEnd:!0,contains:[{className:"string",begin:/"/,end:/"/}]},{beginKeywords:"new return throw await else",relevance:0},{className:"function",begin:"("+d+"\\s+)+"+e.IDENT_RE+"\\s*(<.+>\\s*)?\\(",returnBegin:!0,end:/\s*[{;=]/,excludeEnd:!0,keywords:t,contains:[{beginKeywords:"public private protected static internal protected abstract async extern override unsafe virtual new sealed partial",relevance:0},{begin:e.IDENT_RE+"\\s*(<.+>\\s*)?\\(",returnBegin:!0,contains:[e.TITLE_MODE,o],relevance:0},{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:t,relevance:0,contains:[r,n,e.C_BLOCK_COMMENT_MODE]},e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},a]}},grmr_css:e=>{var t=f(e),i=[e.APOS_STRING_MODE,e.QUOTE_STRING_MODE];return{name:"CSS",case_insensitive:!0,illegal:/[=|'\$]/,keywords:{keyframePosition:"from to"},classNameAliases:{keyframePosition:"selector-tag"},contains:[e.C_BLOCK_COMMENT_MODE,{begin:/-(webkit|moz|ms|o)-(?=[a-z])/},t.CSS_NUMBER_MODE,{className:"selector-id",begin:/#[A-Za-z0-9_-]+/,relevance:0},{className:"selector-class",begin:"\\.[a-zA-Z-][a-zA-Z0-9_-]*",relevance:0},t.ATTRIBUTE_SELECTOR_MODE,{className:"selector-pseudo",variants:[{begin:":("+y.join("|")+")"},{begin:"::("+w.join("|")+")"}]},t.CSS_VARIABLE,{className:"attribute",begin:"\\b("+_.join("|")+")\\b"},{begin:":",end:"[;}]",contains:[t.HEXCOLOR,t.IMPORTANT,t.CSS_NUMBER_MODE,...i,{begin:/(url|data-uri)\(/,end:/\)/,relevance:0,keywords:{built_in:"url data-uri"},contains:[{className:"string",begin:/[^)]/,endsWithParent:!0,excludeEnd:!0}]},{className:"built_in",begin:/[\w-]+(?=\()/}]},{begin:O(/@/),end:"[{;]",relevance:0,illegal:/:/,contains:[{className:"keyword",begin:/@-?\w[\w]*(-\w+)*/},{begin:/\s/,endsWithParent:!0,excludeEnd:!0,relevance:0,keywords:{$pattern:/[a-z-]+/,keyword:"and or not only",attribute:v.join(" ")},contains:[{begin:/[a-z-]+(?=:)/,className:"attribute"},...i,t.CSS_NUMBER_MODE]}]},{className:"selector-tag",begin:"\\b("+b.join("|")+")\\b"}]}},grmr_diff:e=>({name:"Diff",aliases:["patch"],contains:[{className:"meta",relevance:10,match:I(/^@@ +-\d+,\d+ +\+\d+,\d+ +@@/,/^\*\*\* +\d+,\d+ +\*\*\*\*$/,/^--- +\d+,\d+ +----$/)},{className:"comment",variants:[{begin:I(/Index: /,/^index/,/={3,}/,/^-{3}/,/^\*{3} /,/^\+{3}/,/^diff --git/),end:/$/},{match:/^\*{15}$/}]},{className:"addition",begin:/^\+/,end:/$/},{className:"deletion",begin:/^-/,end:/$/},{className:"addition",begin:/^!/,end:/$/}]}),grmr_go:e=>{var t={keyword:["break","default","func","interface","select","case","map","struct","chan","else","goto","package","switch","const","fallthrough","if","range","type","continue","for","import","return","var","go","defer","bool","byte","complex64","complex128","float32","float64","int8","int16","int32","int64","string","uint8","uint16","uint32","uint64","int","uint","uintptr","rune"],literal:["true","false","iota","nil"],built_in:["append","cap","close","complex","copy","imag","len","make","new","panic","print","println","real","recover","delete"]};return{name:"Go",aliases:["golang"],keywords:t,illegal:"</",contains:[e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,{className:"string",variants:[e.QUOTE_STRING_MODE,e.APOS_STRING_MODE,{begin:"`",end:"`"}]},{className:"number",variants:[{begin:e.C_NUMBER_RE+"[i]",relevance:1},e.C_NUMBER_MODE]},{begin:/:=/},{className:"function",beginKeywords:"func",end:"\\s*(\\{|$)",excludeEnd:!0,contains:[e.TITLE_MODE,{className:"params",begin:/\(/,end:/\)/,keywords:t,illegal:/["']/}]}]}},grmr_ini:e=>{var t={className:"number",relevance:0,variants:[{begin:/([+-]+)?[\d]+_[\d_]+/},{begin:e.NUMBER_RE}]},i=e.COMMENT(),n=(i.variants=[{begin:/;/,end:/$/},{begin:/#/,end:/$/}],{className:"variable",variants:[{begin:/\$[\w\d"][\w\d_]*/},{begin:/\$\{(.*?)\}/}]}),s={className:"literal",begin:/\bon|off|true|false|yes|no\b/},e={className:"string",contains:[e.BACKSLASH_ESCAPE],variants:[{begin:"'''",end:"'''",relevance:10},{begin:'"""',end:'"""',relevance:10},{begin:'"',end:'"'},{begin:"'",end:"'"}]},a={begin:/\[/,end:/\]/,contains:[i,s,n,e,t,"self"],relevance:0},r=I(/[A-Za-z0-9_-]+/,/"(\\"|[^"])*"/,/'[^']*'/);return{name:"TOML, also INI",aliases:["toml"],case_insensitive:!0,illegal:/\S/,contains:[i,{className:"section",begin:/\[+/,end:/\]+/},{begin:L(r,"(\\s*\\.\\s*",r,")*",O(/\s*=\s*[^#\s]/)),className:"attr",starts:{end:/$/,contains:[i,a,s,n,e,t]}}]}},grmr_java:e=>{var t="[À-ʸa-zA-Z_$][À-ʸa-zA-Z_$0-9]*",i=t+function t(i,n,s){return-1===s?"":i.replace(n,e=>t(i,n,s-1))}("(?:<"+t+"~~~(?:\\s*,\\s*"+t+"~~~)*>)?",/~~~/g,2),n={keyword:["synchronized","abstract","private","var","static","if","const ","for","while","strictfp","finally","protected","import","native","final","void","enum","else","break","transient","catch","instanceof","volatile","case","assert","package","default","public","try","switch","continue","throws","protected","public","private","module","requires","exports","do"],literal:["false","true","null"],type:["char","boolean","long","float","int","byte","short","double"],built_in:["super","this"]},s={className:"meta",begin:"@"+t,contains:[{begin:/\(/,end:/\)/,contains:["self"]}]},a={className:"params",begin:/\(/,end:/\)/,keywords:n,relevance:0,contains:[e.C_BLOCK_COMMENT_MODE],endsParent:!0};return{name:"Java",aliases:["jsp"],keywords:n,illegal:/<\/|#/,contains:[e.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{begin:/\w+@/,relevance:0},{className:"doctag",begin:"@[A-Za-z]+"}]}),{begin:/import java\.[a-z]+\./,keywords:"import",relevance:2},e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,{match:[/\b(?:class|interface|enum|extends|implements|new)/,/\s+/,t],className:{1:"keyword",3:"title.class"}},{begin:[t,/\s+/,t,/\s+/,/=/],className:{1:"type",3:"variable",5:"operator"}},{begin:[/record/,/\s+/,t],className:{1:"keyword",3:"title.class"},contains:[a,e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},{beginKeywords:"new throw return else",relevance:0},{begin:["(?:"+i+"\\s+)",e.UNDERSCORE_IDENT_RE,/\s*(?=\()/],className:{2:"title.function"},keywords:n,contains:[{className:"params",begin:/\(/,end:/\)/,keywords:n,relevance:0,contains:[s,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,E,e.C_BLOCK_COMMENT_MODE]},e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},E,s]}},grmr_javascript:ge,grmr_json:e=>({name:"JSON",contains:[{className:"attr",begin:/"(\\.|[^\\"\r\n])*"(?=\s*:)/,relevance:1.01},{match:/[{}[\],:]/,className:"punctuation",relevance:0},e.QUOTE_STRING_MODE,{beginKeywords:"true false null"},e.C_NUMBER_MODE,e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE],illegal:"\\S"}),grmr_kotlin:e=>{var t={keyword:"abstract as val var vararg get set class object open private protected public noinline crossinline dynamic final enum if else do while for when throw try catch finally import package is in fun override companion reified inline lateinit init interface annotation data sealed internal infix operator out by constructor super tailrec where const inner suspend typealias external expect actual",built_in:"Byte Short Char Int Long Boolean Float Double Void Unit Nothing",literal:"true false null"},i={className:"symbol",begin:e.UNDERSCORE_IDENT_RE+"@"},n={className:"subst",begin:/\$\{/,end:/\}/,contains:[e.C_NUMBER_MODE]},s={className:"variable",begin:"\\$"+e.UNDERSCORE_IDENT_RE},s={className:"string",variants:[{begin:'"""',end:'"""(?=[^"])',contains:[s,n]},{begin:"'",end:"'",illegal:/\n/,contains:[e.BACKSLASH_ESCAPE]},{begin:'"',end:'"',illegal:/\n/,contains:[e.BACKSLASH_ESCAPE,s,n]}]},n=(n.contains.push(s),{className:"meta",begin:"@(?:file|property|field|get|set|receiver|param|setparam|delegate)\\s*:(?:\\s*"+e.UNDERSCORE_IDENT_RE+")?"}),a={className:"meta",begin:"@"+e.UNDERSCORE_IDENT_RE,contains:[{begin:/\(/,end:/\)/,contains:[e.inherit(s,{className:"string"})]}]},r=E,o=e.COMMENT("/\\*","\\*/",{contains:[e.C_BLOCK_COMMENT_MODE]}),l={variants:[{className:"type",begin:e.UNDERSCORE_IDENT_RE},{begin:/\(/,end:/\)/,contains:[]}]},c=l;return c.variants[1].contains=[l],l.variants[1].contains=[c],{name:"Kotlin",aliases:["kt","kts"],keywords:t,contains:[e.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),e.C_LINE_COMMENT_MODE,o,{className:"keyword",begin:/\b(break|continue|return|this)\b/,starts:{contains:[{className:"symbol",begin:/@\w+/}]}},i,n,a,{className:"function",beginKeywords:"fun",end:"[(]|$",returnBegin:!0,excludeEnd:!0,keywords:t,relevance:5,contains:[{begin:e.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[e.UNDERSCORE_TITLE_MODE]},{className:"type",begin:/</,end:/>/,keywords:"reified",relevance:0},{className:"params",begin:/\(/,end:/\)/,endsParent:!0,keywords:t,relevance:0,contains:[{begin:/:/,end:/[=,\/]/,endsWithParent:!0,contains:[l,e.C_LINE_COMMENT_MODE,o],relevance:0},e.C_LINE_COMMENT_MODE,o,n,a,s,e.C_NUMBER_MODE]},o]},{className:"class",beginKeywords:"class interface trait",end:/[:\{(]|$/,excludeEnd:!0,illegal:"extends implements",contains:[{beginKeywords:"public protected internal private constructor"},e.UNDERSCORE_TITLE_MODE,{className:"type",begin:/</,end:/>/,excludeBegin:!0,excludeEnd:!0,relevance:0},{className:"type",begin:/[,:]\s*/,end:/[<\(,]|$/,excludeBegin:!0,returnEnd:!0},n,a]},s,{className:"meta",begin:"^#!/usr/bin/env",end:"$",illegal:"\n"},r]}},grmr_less:e=>{var t=f(e),i=oe,n="([\\w-]+|@\\{[\\w-]+\\})",s=[],a=[],r=e=>({className:"string",begin:"~?"+e+".*?"+e}),o=(e,t,i)=>({className:e,begin:t,relevance:i}),l={$pattern:/[a-z-]+/,keyword:"and or not only",attribute:v.join(" ")},r=(a.push(e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,r("'"),r('"'),t.CSS_NUMBER_MODE,{begin:"(url|data-uri)\\(",starts:{className:"string",end:"[\\)\\n]",excludeEnd:!0}},t.HEXCOLOR,{begin:"\\(",end:"\\)",contains:a,keywords:l,relevance:0},o("variable","@@?[\\w-]+",10),o("variable","@\\{[\\w-]+\\}"),o("built_in","~?`[^`]*?`"),{className:"attribute",begin:"[\\w-]+\\s*:",end:":",returnBegin:!0,excludeEnd:!0},t.IMPORTANT),a.concat({begin:/\{/,end:/\}/,contains:s})),c={beginKeywords:"when",endsWithParent:!0,contains:[{beginKeywords:"and not"}].concat(a)},d={begin:n+"\\s*:",returnBegin:!0,end:/[;}]/,relevance:0,contains:[{begin:/-(webkit|moz|ms|o)-/},t.CSS_VARIABLE,{className:"attribute",begin:"\\b("+_.join("|")+")\\b",end:/(?=:)/,starts:{endsWithParent:!0,illegal:"[<=$]",relevance:0,contains:a}}]},l={className:"keyword",begin:"@(import|media|charset|font-face|(-[a-z]+-)?keyframes|supports|document|namespace|page|viewport|host)\\b",starts:{end:"[;{}]",keywords:l,returnEnd:!0,contains:a,relevance:0}},a={className:"variable",variants:[{begin:"@[\\w-]+\\s*:",relevance:15},{begin:"@[\\w-]+"}],starts:{end:"[;}]",returnEnd:!0,contains:r}},c={variants:[{begin:"[\\.#:&\\[>]",end:"[;{}]"},{begin:n,end:/\{/}],returnBegin:!0,returnEnd:!0,illegal:"[<='$\"]",relevance:0,contains:[e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,c,o("keyword","all\\b"),o("variable","@\\{[\\w-]+\\}"),{begin:"\\b("+b.join("|")+")\\b",className:"selector-tag"},o("selector-tag",n+"%?",0),o("selector-id","#"+n),o("selector-class","\\."+n,0),o("selector-tag","&",0),t.ATTRIBUTE_SELECTOR_MODE,{className:"selector-pseudo",begin:":("+y.join("|")+")"},{className:"selector-pseudo",begin:"::("+w.join("|")+")"},{begin:/\(/,end:/\)/,relevance:0,contains:r},{begin:"!important"}]},n={begin:`[\\w-]+:(:)?(${i.join("|")})`,returnBegin:!0,contains:[c]};return s.push(e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,l,a,n,d,c),{name:"Less",case_insensitive:!0,illegal:"[=>'/<($\"]",contains:s}},grmr_lua:e=>{var t="\\[=*\\[",i="\\]=*\\]",n={begin:t,end:i,contains:["self"]},s=[e.COMMENT("--(?!\\[=*\\[)","$"),e.COMMENT("--\\[=*\\[",i,{contains:[n],relevance:10})];return{name:"Lua",keywords:{$pattern:e.UNDERSCORE_IDENT_RE,literal:"true false nil",keyword:"and break do else elseif end for goto if in local not or repeat return then until while",built_in:"_G _ENV _VERSION __index __newindex __mode __call __metatable __tostring __len __gc __add __sub __mul __div __mod __pow __concat __unm __eq __lt __le assert collectgarbage dofile error getfenv getmetatable ipairs load loadfile loadstring module next pairs pcall print rawequal rawget rawset require select setfenv setmetatable tonumber tostring type unpack xpcall arg self coroutine resume yield status wrap create running debug getupvalue debug sethook getmetatable gethook setmetatable setlocal traceback setfenv getinfo setupvalue getlocal getregistry getfenv io lines write close flush open output type read stderr stdin input stdout popen tmpfile math log max acos huge ldexp pi cos tanh pow deg tan cosh sinh random randomseed frexp ceil floor rad abs sqrt modf asin min mod fmod log10 atan2 exp sin atan os exit setlocale date getenv difftime remove time clock tmpname rename execute package preload loadlib loaded loaders cpath config path seeall string sub upper len gfind rep find match char dump gmatch reverse byte format gsub lower table setn insert getn foreachi maxn foreach concat sort remove"},contains:s.concat([{className:"function",beginKeywords:"function",end:"\\)",contains:[e.inherit(e.TITLE_MODE,{begin:"([_a-zA-Z]\\w*\\.)*([_a-zA-Z]\\w*:)?[_a-zA-Z]\\w*"}),{className:"params",begin:"\\(",endsWithParent:!0,contains:s}].concat(s)},e.C_NUMBER_MODE,e.APOS_STRING_MODE,e.QUOTE_STRING_MODE,{className:"string",begin:t,end:i,contains:[n],relevance:5}])}},grmr_makefile:e=>{var t={className:"variable",variants:[{begin:"\\$\\("+e.UNDERSCORE_IDENT_RE+"\\)",contains:[e.BACKSLASH_ESCAPE]},{begin:/\$[@%<?\^\+\*]/}]},i={className:"string",begin:/"/,end:/"/,contains:[e.BACKSLASH_ESCAPE,t]},n={begin:"^"+e.UNDERSCORE_IDENT_RE+"\\s*(?=[:+?]?=)"};return{name:"Makefile",aliases:["mk","mak","make"],keywords:{$pattern:/[\w-]+/,keyword:"define endef undefine ifdef ifndef ifeq ifneq else endif include -include sinclude override export unexport private vpath"},contains:[e.HASH_COMMENT_MODE,t,i,{className:"variable",begin:/\$\([\w-]+\s/,end:/\)/,keywords:{built_in:"subst patsubst strip findstring filter filter-out sort word wordlist firstword lastword dir notdir suffix basename addsuffix addprefix join wildcard realpath abspath error warning shell origin flavor foreach if or and call eval file value"},contains:[t]},n,{className:"meta",begin:/^\.PHONY:/,end:/$/,keywords:{$pattern:/[\.\w]+/,keyword:".PHONY"}},{className:"section",begin:/^[^\s]+:/,end:/$/,contains:[t]}]}},grmr_xml:e=>{var t=L(/[A-Z_]/,h(/[A-Z0-9_.-]*:/),/[A-Z0-9_.-]*/),i={className:"symbol",begin:/&[a-z]+;|&#[0-9]+;|&#x[a-f0-9]+;/},n={begin:/\s/,contains:[{className:"keyword",begin:/#?[a-z_][a-z1-9_-]+/,illegal:/\n/}]},s=e.inherit(n,{begin:/\(/,end:/\)/}),a=e.inherit(e.APOS_STRING_MODE,{className:"string"}),r=e.inherit(e.QUOTE_STRING_MODE,{className:"string"}),o={endsWithParent:!0,illegal:/</,relevance:0,contains:[{className:"attr",begin:/[A-Za-z0-9._:-]+/,relevance:0},{begin:/=\s*/,relevance:0,contains:[{className:"string",endsParent:!0,variants:[{begin:/"/,end:/"/,contains:[i]},{begin:/'/,end:/'/,contains:[i]},{begin:/[^\s"'=<>`]+/}]}]}]};return{name:"HTML, XML",aliases:["html","xhtml","rss","atom","xjb","xsd","xsl","plist","wsf","svg"],case_insensitive:!0,contains:[{className:"meta",begin:/<![a-z]/,end:/>/,relevance:10,contains:[n,r,a,s,{begin:/\[/,end:/\]/,contains:[{className:"meta",begin:/<![a-z]/,end:/>/,contains:[n,s,r,a]}]}]},e.COMMENT(/<!--/,/-->/,{relevance:10}),{begin:/<!\[CDATA\[/,end:/\]\]>/,relevance:10},i,{className:"meta",begin:/<\?xml/,end:/\?>/,relevance:10},{className:"tag",begin:/<style(?=\s|>)/,end:/>/,keywords:{name:"style"},contains:[o],starts:{end:/<\/style>/,returnEnd:!0,subLanguage:["css","xml"]}},{className:"tag",begin:/<script(?=\s|>)/,end:/>/,keywords:{name:"script"},contains:[o],starts:{end:/<\/script>/,returnEnd:!0,subLanguage:["javascript","handlebars","xml"]}},{className:"tag",begin:/<>|<\/>/},{className:"tag",begin:L(/</,O(L(t,I(/\/>/,/>/,/\s/)))),end:/\/?>/,contains:[{className:"name",begin:t,relevance:0,starts:o}]},{className:"tag",begin:L(/<\//,O(L(t,/>/))),contains:[{className:"name",begin:t,relevance:0},{begin:/>/,relevance:0,endsParent:!0}]}]}},grmr_markdown:e=>{var t={begin:/<\/?[A-Za-z_]/,end:">",subLanguage:"xml",relevance:0},i={variants:[{begin:/\[.+?\]\[.*?\]/,relevance:0},{begin:/\[.+?\]\(((data|javascript|mailto):|(?:http|ftp)s?:\/\/).*?\)/,relevance:2},{begin:L(/\[.+?\]\(/,/[A-Za-z][A-Za-z0-9+.-]*/,/:\/\/.*?\)/),relevance:2},{begin:/\[.+?\]\([./?&#].*?\)/,relevance:1},{begin:/\[.*?\]\(.*?\)/,relevance:0}],returnBegin:!0,contains:[{match:/\[(?=\])/},{className:"string",relevance:0,begin:"\\[",end:"\\]",excludeBegin:!0,returnEnd:!0},{className:"link",relevance:0,begin:"\\]\\(",end:"\\)",excludeBegin:!0,excludeEnd:!0},{className:"symbol",relevance:0,begin:"\\]\\[",end:"\\]",excludeBegin:!0,excludeEnd:!0}]},n={className:"strong",contains:[],variants:[{begin:/_{2}/,end:/_{2}/},{begin:/\*{2}/,end:/\*{2}/}]},s={className:"emphasis",contains:[],variants:[{begin:/\*(?!\*)/,end:/\*/},{begin:/_(?!_)/,end:/_/,relevance:0}]};n.contains.push(s),s.contains.push(n);let a=[t,i];return n.contains=n.contains.concat(a),s.contains=s.contains.concat(a),{name:"Markdown",aliases:["md","mkdown","mkd"],contains:[{className:"section",variants:[{begin:"^#{1,6}",end:"$",contains:a=a.concat(n,s)},{begin:"(?=^.+?\\n[=-]{2,}$)",contains:[{begin:"^[=-]*$"},{begin:"^",end:"\\n",contains:a}]}]},t,{className:"bullet",begin:"^[ \t]*([*+-]|(\\d+\\.))(?=\\s+)",end:"\\s+",excludeEnd:!0},n,s,{className:"quote",begin:"^>\\s+",contains:a,end:"$"},{className:"code",variants:[{begin:"(`{3,})[^`](.|\\n)*?\\1`*[ ]*"},{begin:"(~{3,})[^~](.|\\n)*?\\1~*[ ]*"},{begin:"```",end:"```+[ ]*$"},{begin:"~~~",end:"~~~+[ ]*$"},{begin:"`.+?`"},{begin:"(?=^( {4}|\\t))",contains:[{begin:"^( {4}|\\t)",end:"(\\n)$"}],relevance:0}]},{begin:"^[-\\*]{3,}",end:"$"},i,{begin:/^\[[^\n]+\]:/,returnBegin:!0,contains:[{className:"symbol",begin:/\[/,end:/\]/,excludeBegin:!0,excludeEnd:!0},{className:"link",begin:/:\s*/,end:/$/,excludeBegin:!0}]}]}},grmr_objectivec:e=>{var t=/[a-zA-Z@][a-zA-Z0-9_]*/,i={$pattern:t,keyword:["@interface","@class","@protocol","@implementation"]};return{name:"Objective-C",aliases:["mm","objc","obj-c","obj-c++","objective-c++"],keywords:{$pattern:t,keyword:["int","float","while","char","export","sizeof","typedef","const","struct","for","union","unsigned","long","volatile","static","bool","mutable","if","do","return","goto","void","enum","else","break","extern","asm","case","short","default","double","register","explicit","signed","typename","this","switch","continue","wchar_t","inline","readonly","assign","readwrite","self","@synchronized","id","typeof","nonatomic","super","unichar","IBOutlet","IBAction","strong","weak","copy","in","out","inout","bycopy","byref","oneway","__strong","__weak","__block","__autoreleasing","@private","@protected","@public","@try","@property","@end","@throw","@catch","@finally","@autoreleasepool","@synthesize","@dynamic","@selector","@optional","@required","@encode","@package","@import","@defs","@compatibility_alias","__bridge","__bridge_transfer","__bridge_retained","__bridge_retain","__covariant","__contravariant","__kindof","_Nonnull","_Nullable","_Null_unspecified","__FUNCTION__","__PRETTY_FUNCTION__","__attribute__","getter","setter","retain","unsafe_unretained","nonnull","nullable","null_unspecified","null_resettable","class","instancetype","NS_DESIGNATED_INITIALIZER","NS_UNAVAILABLE","NS_REQUIRES_SUPER","NS_RETURNS_INNER_POINTER","NS_INLINE","NS_AVAILABLE","NS_DEPRECATED","NS_ENUM","NS_OPTIONS","NS_SWIFT_UNAVAILABLE","NS_ASSUME_NONNULL_BEGIN","NS_ASSUME_NONNULL_END","NS_REFINED_FOR_SWIFT","NS_SWIFT_NAME","NS_SWIFT_NOTHROW","NS_DURING","NS_HANDLER","NS_ENDHANDLER","NS_VALUERETURN","NS_VOIDRETURN"],literal:["false","true","FALSE","TRUE","nil","YES","NO","NULL"],built_in:["BOOL","dispatch_once_t","dispatch_queue_t","dispatch_sync","dispatch_async","dispatch_once"]},illegal:"</",contains:[{className:"built_in",begin:"\\b(AV|CA|CF|CG|CI|CL|CM|CN|CT|MK|MP|MTK|MTL|NS|SCN|SK|UI|WK|XC)\\w+"},e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,e.C_NUMBER_MODE,e.QUOTE_STRING_MODE,e.APOS_STRING_MODE,{className:"string",variants:[{begin:'@"',end:'"',illegal:"\\n",contains:[e.BACKSLASH_ESCAPE]}]},{className:"meta",begin:/#\s*[a-z]+\b/,end:/$/,keywords:{keyword:"if else elif endif define undef warning error line pragma ifdef ifndef include"},contains:[{begin:/\\\n/,relevance:0},e.inherit(e.QUOTE_STRING_MODE,{className:"string"}),{className:"string",begin:/<.*?>/,end:/$/,illegal:"\\n"},e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE]},{className:"class",begin:"("+i.keyword.join("|")+")\\b",end:/(\{|$)/,excludeEnd:!0,keywords:i,contains:[e.UNDERSCORE_TITLE_MODE]},{begin:"\\."+e.UNDERSCORE_IDENT_RE,relevance:0}]}},grmr_perl:e=>{const s=/[dualxmsipngr]{0,12}/,t={$pattern:/[\w.]+/,keyword:"abs accept alarm and atan2 bind binmode bless break caller chdir chmod chomp chop chown chr chroot close closedir connect continue cos crypt dbmclose dbmopen defined delete die do dump each else elsif endgrent endhostent endnetent endprotoent endpwent endservent eof eval exec exists exit exp fcntl fileno flock for foreach fork format formline getc getgrent getgrgid getgrnam gethostbyaddr gethostbyname gethostent getlogin getnetbyaddr getnetbyname getnetent getpeername getpgrp getpriority getprotobyname getprotobynumber getprotoent getpwent getpwnam getpwuid getservbyname getservbyport getservent getsockname getsockopt given glob gmtime goto grep gt hex if index int ioctl join keys kill last lc lcfirst length link listen local localtime log lstat lt ma map mkdir msgctl msgget msgrcv msgsnd my ne next no not oct open opendir or ord our pack package pipe pop pos print printf prototype push q|0 qq quotemeta qw qx rand read readdir readline readlink readpipe recv redo ref rename require reset return reverse rewinddir rindex rmdir say scalar seek seekdir select semctl semget semop send setgrent sethostent setnetent setpgrp setpriority setprotoent setpwent setservent setsockopt shift shmctl shmget shmread shmwrite shutdown sin sleep socket socketpair sort splice split sprintf sqrt srand stat state study sub substr symlink syscall sysopen sysread sysseek system syswrite tell telldir tie tied time times tr truncate uc ucfirst umask undef unless unlink unpack unshift untie until use utime values vec wait waitpid wantarray warn when while write x|0 xor y|0"},i={className:"subst",begin:"[$@]\\{",end:"\\}",keywords:t},n={begin:/->\{/,end:/\}/},a={variants:[{begin:/\$\d/},{begin:L(/[$%@](\^\w\b|#\w+(::\w+)*|\{\w+\}|\w+(::\w*)*)/,"(?![A-Za-z])(?![@$%])")},{begin:/[$%@][^\s\w{]/,relevance:0}]},r=[e.BACKSLASH_ESCAPE,i,a],o=[/!/,/\//,/\|/,/\?/,/'/,/"/,/#/],l=(e,t,i="\\1")=>{var n="\\1"===i?i:L(i,t);return L(L("(?:",e,")"),t,/(?:\\.|[^\\\/])*?/,n,/(?:\\.|[^\\\/])*?/,i,s)},c=(e,t,i)=>L(L("(?:",e,")"),t,/(?:\\.|[^\\\/])*?/,i,s),d=[a,e.HASH_COMMENT_MODE,e.COMMENT(/^=\w/,/=cut/,{endsWithParent:!0}),n,{className:"string",contains:r,variants:[{begin:"q[qwxr]?\\s*\\(",end:"\\)",relevance:5},{begin:"q[qwxr]?\\s*\\[",end:"\\]",relevance:5},{begin:"q[qwxr]?\\s*\\{",end:"\\}",relevance:5},{begin:"q[qwxr]?\\s*\\|",end:"\\|",relevance:5},{begin:"q[qwxr]?\\s*<",end:">",relevance:5},{begin:"qw\\s+q",end:"q",relevance:5},{begin:"'",end:"'",contains:[e.BACKSLASH_ESCAPE]},{begin:'"',end:'"'},{begin:"`",end:"`",contains:[e.BACKSLASH_ESCAPE]},{begin:/\{\w+\}/,relevance:0},{begin:"-?\\w+\\s*=>",relevance:0}]},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{begin:"(\\/\\/|"+e.RE_STARTERS_RE+"|\\b(split|return|print|reverse|grep)\\b)\\s*",keywords:"split return print reverse grep",relevance:0,contains:[e.HASH_COMMENT_MODE,{className:"regexp",variants:[{begin:l("s|tr|y",I(...o,{capture:!0}))},{begin:l("s|tr|y","\\(","\\)")},{begin:l("s|tr|y","\\[","\\]")},{begin:l("s|tr|y","\\{","\\}")}],relevance:2},{className:"regexp",variants:[{begin:/(m|qr)\/\//,relevance:0},{begin:c("(?:m|qr)?",/\//,/\//)},{begin:c("m|qr",I(...o,{capture:!0}),/\1/)},{begin:c("m|qr",/\(/,/\)/)},{begin:c("m|qr",/\[/,/\]/)},{begin:c("m|qr",/\{/,/\}/)}]}]},{className:"function",beginKeywords:"sub",end:"(\\s*\\(.*?\\))?[;{]",excludeEnd:!0,relevance:5,contains:[e.TITLE_MODE]},{begin:"-\\w\\b",relevance:0},{begin:"^__DATA__$",end:"^__END__$",subLanguage:"mojolicious",contains:[{begin:"^@@.*",end:"$",className:"comment"}]}];return i.contains=d,{name:"Perl",aliases:["pl","pm"],keywords:t,contains:n.contains=d}},grmr_php:e=>{var t={className:"variable",begin:"\\$+[a-zA-Z_-ÿ][a-zA-Z0-9_-ÿ]*(?![A-Za-z0-9])(?![$])"},i={className:"meta",variants:[{begin:/<\?php/,relevance:10},{begin:/<\?[=]?/},{begin:/\?>/}]},n={className:"subst",variants:[{begin:/\$\w+/},{begin:/\{\$/,end:/\}/}]},s=e.inherit(e.APOS_STRING_MODE,{illegal:null}),a=e.inherit(e.QUOTE_STRING_MODE,{illegal:null,contains:e.QUOTE_STRING_MODE.contains.concat(n)}),n=e.END_SAME_AS_BEGIN({begin:/<<<[ \t]*(\w+)\n/,end:/[ \t]*(\w+)\b/,contains:e.QUOTE_STRING_MODE.contains.concat(n)}),a={className:"string",contains:[e.BACKSLASH_ESCAPE,i],variants:[e.inherit(s,{begin:"b'",end:"'"}),e.inherit(a,{begin:'b"',end:'"'}),a,s,n]},s={className:"number",variants:[{begin:"\\b0b[01]+(?:_[01]+)*\\b"},{begin:"\\b0o[0-7]+(?:_[0-7]+)*\\b"},{begin:"\\b0x[\\da-f]+(?:_[\\da-f]+)*\\b"},{begin:"(?:\\b\\d+(?:_\\d+)*(\\.(?:\\d+(?:_\\d+)*))?|\\B\\.\\d+)(?:e[+-]?\\d+)?"}],relevance:0},n={keyword:"__CLASS__ __DIR__ __FILE__ __FUNCTION__ __LINE__ __METHOD__ __NAMESPACE__ __TRAIT__ die echo exit include include_once print require require_once array abstract and as binary bool boolean break callable case catch class clone const continue declare default do double else elseif empty enddeclare endfor endforeach endif endswitch endwhile enum eval extends final finally float for foreach from global goto if implements instanceof insteadof int integer interface isset iterable list match|0 mixed new object or private protected public real return string switch throw trait try unset use var void while xor yield",literal:"false null true",built_in:"Error|0 AppendIterator ArgumentCountError ArithmeticError ArrayIterator ArrayObject AssertionError BadFunctionCallException BadMethodCallException CachingIterator CallbackFilterIterator CompileError Countable DirectoryIterator DivisionByZeroError DomainException EmptyIterator ErrorException Exception FilesystemIterator FilterIterator GlobIterator InfiniteIterator InvalidArgumentException IteratorIterator LengthException LimitIterator LogicException MultipleIterator NoRewindIterator OutOfBoundsException OutOfRangeException OuterIterator OverflowException ParentIterator ParseError RangeException RecursiveArrayIterator RecursiveCachingIterator RecursiveCallbackFilterIterator RecursiveDirectoryIterator RecursiveFilterIterator RecursiveIterator RecursiveIteratorIterator RecursiveRegexIterator RecursiveTreeIterator RegexIterator RuntimeException SeekableIterator SplDoublyLinkedList SplFileInfo SplFileObject SplFixedArray SplHeap SplMaxHeap SplMinHeap SplObjectStorage SplObserver SplObserver SplPriorityQueue SplQueue SplStack SplSubject SplSubject SplTempFileObject TypeError UnderflowException UnexpectedValueException UnhandledMatchError ArrayAccess Closure Generator Iterator IteratorAggregate Serializable Stringable Throwable Traversable WeakReference WeakMap Directory __PHP_Incomplete_Class parent php_user_filter self static stdClass"};return{case_insensitive:!0,keywords:n,contains:[e.HASH_COMMENT_MODE,e.COMMENT("//","$",{contains:[i]}),e.COMMENT("/\\*","\\*/",{contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),e.COMMENT("__halt_compiler.+?;",!1,{endsWithParent:!0,keywords:"__halt_compiler"}),i,{className:"keyword",begin:/\$this\b/},t,{begin:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{className:"function",relevance:0,beginKeywords:"fn function",end:/[;{]/,excludeEnd:!0,illegal:"[$%\\[]",contains:[{beginKeywords:"use"},e.UNDERSCORE_TITLE_MODE,{begin:"=>",endsParent:!0},{className:"params",begin:"\\(",end:"\\)",excludeBegin:!0,excludeEnd:!0,keywords:n,contains:["self",t,e.C_BLOCK_COMMENT_MODE,a,s]}]},{className:"class",variants:[{beginKeywords:"enum",illegal:/[($"]/},{beginKeywords:"class interface trait",illegal:/[:($"]/}],relevance:0,end:/\{/,excludeEnd:!0,contains:[{beginKeywords:"extends implements"},e.UNDERSCORE_TITLE_MODE]},{beginKeywords:"namespace",relevance:0,end:";",illegal:/[.']/,contains:[e.UNDERSCORE_TITLE_MODE]},{beginKeywords:"use",relevance:0,end:";",contains:[e.UNDERSCORE_TITLE_MODE]},a,s]}},grmr_php_template:e=>({name:"PHP template",subLanguage:"xml",contains:[{begin:/<\?(php|=)?/,end:/\?>/,subLanguage:"php",contains:[{begin:"/\\*",end:"\\*/",skip:!0},{begin:'b"',end:'"',skip:!0},{begin:"b'",end:"'",skip:!0},e.inherit(e.APOS_STRING_MODE,{illegal:null,className:null,contains:null,skip:!0}),e.inherit(e.QUOTE_STRING_MODE,{illegal:null,className:null,contains:null,skip:!0})]}]}),grmr_plaintext:e=>({name:"Plain text",aliases:["text","txt"],disableAutodetect:!0}),grmr_python:e=>{var t={$pattern:/[A-Za-z]\w+|__\w+__/,keyword:["and","as","assert","async","await","break","class","continue","def","del","elif","else","except","finally","for","from","global","if","import","in","is","lambda","nonlocal|10","not","or","pass","raise","return","try","while","with","yield"],built_in:["__import__","abs","all","any","ascii","bin","bool","breakpoint","bytearray","bytes","callable","chr","classmethod","compile","complex","delattr","dict","dir","divmod","enumerate","eval","exec","filter","float","format","frozenset","getattr","globals","hasattr","hash","help","hex","id","input","int","isinstance","issubclass","iter","len","list","locals","map","max","memoryview","min","next","object","oct","open","ord","pow","print","property","range","repr","reversed","round","set","setattr","slice","sorted","staticmethod","str","sum","super","tuple","type","vars","zip"],literal:["__debug__","Ellipsis","False","None","NotImplemented","True"],type:["Any","Callable","Coroutine","Dict","List","Literal","Generic","Optional","Sequence","Set","Tuple","Type","Union"]},i={className:"meta",begin:/^(>>>|\.\.\.) /},n={className:"subst",begin:/\{/,end:/\}/,keywords:t,illegal:/#/},s={begin:/\{\{/,relevance:0},s={className:"string",contains:[e.BACKSLASH_ESCAPE],variants:[{begin:/([uU]|[bB]|[rR]|[bB][rR]|[rR][bB])?'''/,end:/'''/,contains:[e.BACKSLASH_ESCAPE,i],relevance:10},{begin:/([uU]|[bB]|[rR]|[bB][rR]|[rR][bB])?"""/,end:/"""/,contains:[e.BACKSLASH_ESCAPE,i],relevance:10},{begin:/([fF][rR]|[rR][fF]|[fF])'''/,end:/'''/,contains:[e.BACKSLASH_ESCAPE,i,s,n]},{begin:/([fF][rR]|[rR][fF]|[fF])"""/,end:/"""/,contains:[e.BACKSLASH_ESCAPE,i,s,n]},{begin:/([uU]|[rR])'/,end:/'/,relevance:10},{begin:/([uU]|[rR])"/,end:/"/,relevance:10},{begin:/([bB]|[bB][rR]|[rR][bB])'/,end:/'/},{begin:/([bB]|[bB][rR]|[rR][bB])"/,end:/"/},{begin:/([fF][rR]|[rR][fF]|[fF])'/,end:/'/,contains:[e.BACKSLASH_ESCAPE,s,n]},{begin:/([fF][rR]|[rR][fF]|[fF])"/,end:/"/,contains:[e.BACKSLASH_ESCAPE,s,n]},e.APOS_STRING_MODE,e.QUOTE_STRING_MODE]},a="[0-9](_?[0-9])*",r=`(\\b(${a}))?\\.(${a})|\\b(${a})\\.`,r={className:"number",relevance:0,variants:[{begin:`(\\b(${a})|(${r}))[eE][+-]?(${a})[jJ]?\\b`},{begin:`(${r})[jJ]?`},{begin:"\\b([1-9](_?[0-9])*|0+(_?0)*)[lLjJ]?\\b"},{begin:"\\b0[bB](_?[01])+[lL]?\\b"},{begin:"\\b0[oO](_?[0-7])+[lL]?\\b"},{begin:"\\b0[xX](_?[0-9a-fA-F])+[lL]?\\b"},{begin:`\\b(${a})[jJ]\\b`}]},a={className:"comment",begin:O(/# type:/),end:/$/,keywords:t,contains:[{begin:/# type:/},{begin:/#/,end:/\b\B/,endsWithParent:!0}]},o={className:"params",variants:[{className:"",begin:/\(\s*\)/,skip:!0},{begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:t,contains:["self",i,r,s,e.HASH_COMMENT_MODE]}]};return n.contains=[s,r,i],{name:"Python",aliases:["py","gyp","ipython"],keywords:t,illegal:/(<\/|->|\?)|=>/,contains:[i,r,{begin:/\bself\b/},{beginKeywords:"if",relevance:0},s,a,e.HASH_COMMENT_MODE,{match:[/def/,/\s+/,u],scope:{1:"keyword",3:"title.function"},contains:[o]},{variants:[{match:[/class/,/\s+/,u,/\s*/,/\(\s*/,u,/\s*\)/]},{match:[/class/,/\s+/,u]}],scope:{1:"keyword",3:"title.class",6:"title.class.inherited"}},{className:"meta",begin:/^[\t ]*@/,end:/(?=#)|$/,contains:[r,o,s]}]}},grmr_python_repl:e=>({aliases:["pycon"],contains:[{className:"meta",starts:{end:/ |$/,starts:{end:"$",subLanguage:"python"}},variants:[{begin:/^>>>(?=[ ]|$)/},{begin:/^\.\.\.(?=[ ]|$)/}]}]}),grmr_r:e=>{var t=/(?:(?:[a-zA-Z]|\.[._a-zA-Z])[._a-zA-Z0-9]*)|\.(?!\d)/,i=I(/0[xX][0-9a-fA-F]+\.[0-9a-fA-F]*[pP][+-]?\d+i?/,/0[xX][0-9a-fA-F]+(?:[pP][+-]?\d+)?[Li]?/,/(?:\d+(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+)?[Li]?/),n=/[=!<>:]=|\|\||&&|:::?|<-|<<-|->>|->|\|>|[-+*\/?!$&|:<=>@^~]|\*\*/,s=I(/[()]/,/[{}]/,/\[\[/,/[[\]]/,/\\/,/,/);return{name:"R",keywords:{$pattern:t,keyword:"function if in break next repeat else for while",literal:"NULL NA TRUE FALSE Inf NaN NA_integer_|10 NA_real_|10 NA_character_|10 NA_complex_|10",built_in:"LETTERS letters month.abb month.name pi T F abs acos acosh all any anyNA Arg as.call as.character as.complex as.double as.environment as.integer as.logical as.null.default as.numeric as.raw asin asinh atan atanh attr attributes baseenv browser c call ceiling class Conj cos cosh cospi cummax cummin cumprod cumsum digamma dim dimnames emptyenv exp expression floor forceAndCall gamma gc.time globalenv Im interactive invisible is.array is.atomic is.call is.character is.complex is.double is.environment is.expression is.finite is.function is.infinite is.integer is.language is.list is.logical is.matrix is.na is.name is.nan is.null is.numeric is.object is.pairlist is.raw is.recursive is.single is.symbol lazyLoadDBfetch length lgamma list log max min missing Mod names nargs nzchar oldClass on.exit pos.to.env proc.time prod quote range Re rep retracemem return round seq_along seq_len seq.int sign signif sin sinh sinpi sqrt standardGeneric substitute sum switch tan tanh tanpi tracemem trigamma trunc unclass untracemem UseMethod xtfrm"},contains:[e.COMMENT(/#'/,/$/,{contains:[{scope:"doctag",match:/@examples/,starts:{end:O(I(/\n^#'\s*(?=@[a-zA-Z]+)/,/\n^(?!#')/)),endsParent:!0}},{scope:"doctag",begin:"@param",end:/$/,contains:[{scope:"variable",variants:[{match:t},{match:/`(?:\\.|[^`\\])+`/}],endsParent:!0}]},{scope:"doctag",match:/@[a-zA-Z]+/},{scope:"keyword",match:/\\[a-zA-Z]+/}]}),e.HASH_COMMENT_MODE,{scope:"string",contains:[e.BACKSLASH_ESCAPE],variants:[e.END_SAME_AS_BEGIN({begin:/[rR]"(-*)\(/,end:/\)(-*)"/}),e.END_SAME_AS_BEGIN({begin:/[rR]"(-*)\{/,end:/\}(-*)"/}),e.END_SAME_AS_BEGIN({begin:/[rR]"(-*)\[/,end:/\](-*)"/}),e.END_SAME_AS_BEGIN({begin:/[rR]'(-*)\(/,end:/\)(-*)'/}),e.END_SAME_AS_BEGIN({begin:/[rR]'(-*)\{/,end:/\}(-*)'/}),e.END_SAME_AS_BEGIN({begin:/[rR]'(-*)\[/,end:/\](-*)'/}),{begin:'"',end:'"',relevance:0},{begin:"'",end:"'",relevance:0}]},{relevance:0,variants:[{scope:{1:"operator",2:"number"},match:[n,i]},{scope:{1:"operator",2:"number"},match:[/%[^%]*%/,i]},{scope:{1:"punctuation",2:"number"},match:[s,i]},{scope:{2:"number"},match:[/[^a-zA-Z0-9._]|^/,i]}]},{scope:{3:"operator"},match:[t,/\s+/,/<-/,/\s+/]},{scope:"operator",relevance:0,variants:[{match:n},{match:/%[^%]*%/}]},{scope:"punctuation",relevance:0,match:s},{begin:"`",end:"`",contains:[{begin:/\\./}]}]}},grmr_ruby:e=>{var t="([a-zA-Z_]\\w*[!?=]?|[-+~]@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?)",i={keyword:"and then defined module in return redo if BEGIN retry end for self when next until do begin unless END rescue else break undef not super class case require yield alias while ensure elsif or include attr_reader attr_writer attr_accessor __FILE__",built_in:"proc lambda",literal:"true false nil"},n={className:"doctag",begin:"@[A-Za-z]+"},s={begin:"#<",end:">"},n=[e.COMMENT("#","$",{contains:[n]}),e.COMMENT("^=begin","^=end",{contains:[n],relevance:10}),e.COMMENT("^__END__","\\n$")],a={className:"subst",begin:/#\{/,end:/\}/,keywords:i},r={className:"string",contains:[e.BACKSLASH_ESCAPE,a],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/`/,end:/`/},{begin:/%[qQwWx]?\(/,end:/\)/},{begin:/%[qQwWx]?\[/,end:/\]/},{begin:/%[qQwWx]?\{/,end:/\}/},{begin:/%[qQwWx]?</,end:/>/},{begin:/%[qQwWx]?\//,end:/\//},{begin:/%[qQwWx]?%/,end:/%/},{begin:/%[qQwWx]?-/,end:/-/},{begin:/%[qQwWx]?\|/,end:/\|/},{begin:/\B\?(\\\d{1,3})/},{begin:/\B\?(\\x[A-Fa-f0-9]{1,2})/},{begin:/\B\?(\\u\{?[A-Fa-f0-9]{1,6}\}?)/},{begin:/\B\?(\\M-\\C-|\\M-\\c|\\c\\M-|\\M-|\\C-\\M-)[\x20-\x7e]/},{begin:/\B\?\\(c|C-)[\x20-\x7e]/},{begin:/\B\?\\?\S/},{begin:L(/<<[-~]?'?/,O(/(\w+)(?=\W)[^\n]*\n(?:[^\n]*\n)*?\s*\1\b/)),contains:[e.END_SAME_AS_BEGIN({begin:/(\w+)/,end:/(\w+)/,contains:[e.BACKSLASH_ESCAPE,a]})]}]},o="[0-9](_?[0-9])*",o={className:"number",relevance:0,variants:[{begin:`\\b([1-9](_?[0-9])*|0)(\\.(${o}))?([eE][+-]?(${o})|r)?i?\\b`},{begin:"\\b0[dD][0-9](_?[0-9])*r?i?\\b"},{begin:"\\b0[bB][0-1](_?[0-1])*r?i?\\b"},{begin:"\\b0[oO][0-7](_?[0-7])*r?i?\\b"},{begin:"\\b0[xX][0-9a-fA-F](_?[0-9a-fA-F])*r?i?\\b"},{begin:"\\b0(_?[0-7])+r?i?\\b"}]},l={className:"params",begin:"\\(",end:"\\)",endsParent:!0,keywords:i},r=[r,{className:"class",beginKeywords:"class module",end:"$|;",illegal:/=/,contains:[e.inherit(e.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|!)?"}),{begin:"<\\s*",contains:[{begin:"("+e.IDENT_RE+"::)?"+e.IDENT_RE,relevance:0}]}].concat(n)},{className:"function",begin:L(/def\s+/,O(t+"\\s*(\\(|;|$)")),relevance:0,keywords:"def",end:"$|;",contains:[e.inherit(e.TITLE_MODE,{begin:t}),l].concat(n)},{begin:e.IDENT_RE+"::"},{className:"symbol",begin:e.UNDERSCORE_IDENT_RE+"(!|\\?)?:",relevance:0},{className:"symbol",begin:":(?!\\s)",contains:[r,{begin:t}],relevance:0},o,{className:"variable",begin:"(\\$\\W)|((\\$|@@?)(\\w+))(?=[^@$?])(?![A-Za-z])(?![@$?'])"},{className:"params",begin:/\|/,end:/\|/,relevance:0,keywords:i},{begin:"("+e.RE_STARTERS_RE+"|unless)\\s*",keywords:"unless",contains:[{className:"regexp",contains:[e.BACKSLASH_ESCAPE,a],illegal:/\n/,variants:[{begin:"/",end:"/[a-z]*"},{begin:/%r\{/,end:/\}[a-z]*/},{begin:"%r\\(",end:"\\)[a-z]*"},{begin:"%r!",end:"![a-z]*"},{begin:"%r\\[",end:"\\][a-z]*"}]}].concat(s,n),relevance:0}].concat(s,n),t=(a.contains=r,[{begin:/^\s*=>/,starts:{end:"$",contains:l.contains=r}},{className:"meta",begin:"^([>?]>|[\\w#]+\\(\\w+\\):\\d+:\\d+>|(\\w+-)?\\d+\\.\\d+\\.\\d+(p\\d+)?[^\\d][^>]+>)(?=[ ])",starts:{end:"$",contains:r}}]);return n.unshift(s),{name:"Ruby",aliases:["rb","gemspec","podspec","thor","irb"],keywords:i,illegal:/\/\*/,contains:[e.SHEBANG({binary:"ruby"})].concat(t).concat(n).concat(r)}},grmr_rust:e=>{var t={className:"title.function.invoke",relevance:0,begin:L(/\b/,/(?!let\b)/,e.IDENT_RE,O(/\s*\(/))},i="([ui](8|16|32|64|128|size)|f(32|64))?",n=["drop ","Copy","Send","Sized","Sync","Drop","Fn","FnMut","FnOnce","ToOwned","Clone","Debug","PartialEq","PartialOrd","Eq","Ord","AsRef","AsMut","Into","From","Default","Iterator","Extend","IntoIterator","DoubleEndedIterator","ExactSizeIterator","SliceConcatExt","ToString","assert!","assert_eq!","bitflags!","bytes!","cfg!","col!","concat!","concat_idents!","debug_assert!","debug_assert_eq!","env!","panic!","file!","format!","format_args!","include_bin!","include_str!","line!","local_data_key!","module_path!","option_env!","print!","println!","select!","stringify!","try!","unimplemented!","unreachable!","vec!","write!","writeln!","macro_rules!","assert_ne!","debug_assert_ne!"];return{name:"Rust",aliases:["rs"],keywords:{$pattern:e.IDENT_RE+"!?",type:["i8","i16","i32","i64","i128","isize","u8","u16","u32","u64","u128","usize","f32","f64","str","char","bool","Box","Option","Result","String","Vec"],keyword:["abstract","as","async","await","become","box","break","const","continue","crate","do","dyn","else","enum","extern","false","final","fn","for","if","impl","in","let","loop","macro","match","mod","move","mut","override","priv","pub","ref","return","self","Self","static","struct","super","trait","true","try","type","typeof","unsafe","unsized","use","virtual","where","while","yield"],literal:["true","false","Some","None","Ok","Err"],built_in:n},illegal:"</",contains:[e.C_LINE_COMMENT_MODE,e.COMMENT("/\\*","\\*/",{contains:["self"]}),e.inherit(e.QUOTE_STRING_MODE,{begin:/b?"/,illegal:null}),{className:"string",variants:[{begin:/b?r(#*)"(.|\n)*?"\1(?!#)/},{begin:/b?'\\?(x\w{2}|u\w{4}|U\w{8}|.)'/}]},{className:"symbol",begin:/'[a-zA-Z_][a-zA-Z0-9_]*/},{className:"number",variants:[{begin:"\\b0b([01_]+)"+i},{begin:"\\b0o([0-7_]+)"+i},{begin:"\\b0x([A-Fa-f0-9_]+)"+i},{begin:"\\b(\\d[\\d_]*(\\.[0-9_]+)?([eE][+-]?[0-9_]+)?)"+i}],relevance:0},{begin:[/fn/,/\s+/,e.UNDERSCORE_IDENT_RE],className:{1:"keyword",3:"title.function"}},{className:"meta",begin:"#!?\\[",end:"\\]",contains:[{className:"string",begin:/"/,end:/"/}]},{begin:[/let/,/\s+/,/(?:mut\s+)?/,e.UNDERSCORE_IDENT_RE],className:{1:"keyword",3:"keyword",4:"variable"}},{begin:[/for/,/\s+/,e.UNDERSCORE_IDENT_RE,/\s+/,/in/],className:{1:"keyword",3:"variable",5:"keyword"}},{begin:[/type/,/\s+/,e.UNDERSCORE_IDENT_RE],className:{1:"keyword",3:"title.class"}},{begin:[/(?:trait|enum|struct|union|impl|for)/,/\s+/,e.UNDERSCORE_IDENT_RE],className:{1:"keyword",3:"title.class"}},{begin:e.IDENT_RE+"::",keywords:{keyword:"Self",built_in:n}},{className:"punctuation",begin:"->"},t]}},grmr_scss:e=>{var t=f(e),i=w,n=y,s="@[a-z-]+",a={className:"variable",begin:"(\\$[a-zA-Z-][a-zA-Z0-9_-]*)\\b"};return{name:"SCSS",case_insensitive:!0,illegal:"[=/|']",contains:[e.C_LINE_COMMENT_MODE,e.C_BLOCK_COMMENT_MODE,{className:"selector-id",begin:"#[A-Za-z0-9_-]+",relevance:0},{className:"selector-class",begin:"\\.[A-Za-z0-9_-]+",relevance:0},t.ATTRIBUTE_SELECTOR_MODE,{className:"selector-tag",begin:"\\b("+b.join("|")+")\\b",relevance:0},{className:"selector-pseudo",begin:":("+n.join("|")+")"},{className:"selector-pseudo",begin:"::("+i.join("|")+")"},a,{begin:/\(/,end:/\)/,contains:[t.CSS_NUMBER_MODE]},t.CSS_VARIABLE,{className:"attribute",begin:"\\b("+_.join("|")+")\\b"},{begin:"\\b(whitespace|wait|w-resize|visible|vertical-text|vertical-ideographic|uppercase|upper-roman|upper-alpha|underline|transparent|top|thin|thick|text|text-top|text-bottom|tb-rl|table-header-group|table-footer-group|sw-resize|super|strict|static|square|solid|small-caps|separate|se-resize|scroll|s-resize|rtl|row-resize|ridge|right|repeat|repeat-y|repeat-x|relative|progress|pointer|overline|outside|outset|oblique|nowrap|not-allowed|normal|none|nw-resize|no-repeat|no-drop|newspaper|ne-resize|n-resize|move|middle|medium|ltr|lr-tb|lowercase|lower-roman|lower-alpha|loose|list-item|line|line-through|line-edge|lighter|left|keep-all|justify|italic|inter-word|inter-ideograph|inside|inset|inline|inline-block|inherit|inactive|ideograph-space|ideograph-parenthesis|ideograph-numeric|ideograph-alpha|horizontal|hidden|help|hand|groove|fixed|ellipsis|e-resize|double|dotted|distribute|distribute-space|distribute-letter|distribute-all-lines|disc|disabled|default|decimal|dashed|crosshair|collapse|col-resize|circle|char|center|capitalize|break-word|break-all|bottom|both|bolder|bold|block|bidi-override|below|baseline|auto|always|all-scroll|absolute|table|table-cell)\\b"},{begin:":",end:";",contains:[a,t.HEXCOLOR,t.CSS_NUMBER_MODE,e.QUOTE_STRING_MODE,e.APOS_STRING_MODE,t.IMPORTANT]},{begin:"@(page|font-face)",keywords:{$pattern:s,keyword:"@page @font-face"}},{begin:"@",end:"[{;]",returnBegin:!0,keywords:{$pattern:/[a-z-]+/,keyword:"and or not only",attribute:v.join(" ")},contains:[{begin:s,className:"keyword"},{begin:/[a-z-]+(?=:)/,className:"attribute"},a,e.QUOTE_STRING_MODE,e.APOS_STRING_MODE,t.HEXCOLOR,t.CSS_NUMBER_MODE]}]}},grmr_shell:e=>({name:"Shell Session",aliases:["console","shellsession"],contains:[{className:"meta",begin:/^\s{0,3}[/~\w\d[\]()@-]*[>%$#][ ]?/,starts:{end:/[^\\](?=\s*$)/,subLanguage:"bash"}}]}),grmr_sql:e=>{const t=e.COMMENT("--","$"),i=["true","false","unknown"],n=["bigint","binary","blob","boolean","char","character","clob","date","dec","decfloat","decimal","float","int","integer","interval","nchar","nclob","national","numeric","real","row","smallint","time","timestamp","varchar","varying","varbinary"],s=["abs","acos","array_agg","asin","atan","avg","cast","ceil","ceiling","coalesce","corr","cos","cosh","count","covar_pop","covar_samp","cume_dist","dense_rank","deref","element","exp","extract","first_value","floor","json_array","json_arrayagg","json_exists","json_object","json_objectagg","json_query","json_table","json_table_primitive","json_value","lag","last_value","lead","listagg","ln","log","log10","lower","max","min","mod","nth_value","ntile","nullif","percent_rank","percentile_cont","percentile_disc","position","position_regex","power","rank","regr_avgx","regr_avgy","regr_count","regr_intercept","regr_r2","regr_slope","regr_sxx","regr_sxy","regr_syy","row_number","sin","sinh","sqrt","stddev_pop","stddev_samp","substring","substring_regex","sum","tan","tanh","translate","translate_regex","treat","trim","trim_array","unnest","upper","value_of","var_pop","var_samp","width_bucket"],a=["create table","insert into","primary key","foreign key","not null","alter table","add constraint","grouping sets","on overflow","character set","respect nulls","ignore nulls","nulls first","nulls last","depth first","breadth first"],r=s,o=["abs","acos","all","allocate","alter","and","any","are","array","array_agg","array_max_cardinality","as","asensitive","asin","asymmetric","at","atan","atomic","authorization","avg","begin","begin_frame","begin_partition","between","bigint","binary","blob","boolean","both","by","call","called","cardinality","cascaded","case","cast","ceil","ceiling","char","char_length","character","character_length","check","classifier","clob","close","coalesce","collate","collect","column","commit","condition","connect","constraint","contains","convert","copy","corr","corresponding","cos","cosh","count","covar_pop","covar_samp","create","cross","cube","cume_dist","current","current_catalog","current_date","current_default_transform_group","current_path","current_role","current_row","current_schema","current_time","current_timestamp","current_path","current_role","current_transform_group_for_type","current_user","cursor","cycle","date","day","deallocate","dec","decimal","decfloat","declare","default","define","delete","dense_rank","deref","describe","deterministic","disconnect","distinct","double","drop","dynamic","each","element","else","empty","end","end_frame","end_partition","end-exec","equals","escape","every","except","exec","execute","exists","exp","external","extract","false","fetch","filter","first_value","float","floor","for","foreign","frame_row","free","from","full","function","fusion","get","global","grant","group","grouping","groups","having","hold","hour","identity","in","indicator","initial","inner","inout","insensitive","insert","int","integer","intersect","intersection","interval","into","is","join","json_array","json_arrayagg","json_exists","json_object","json_objectagg","json_query","json_table","json_table_primitive","json_value","lag","language","large","last_value","lateral","lead","leading","left","like","like_regex","listagg","ln","local","localtime","localtimestamp","log","log10","lower","match","match_number","match_recognize","matches","max","member","merge","method","min","minute","mod","modifies","module","month","multiset","national","natural","nchar","nclob","new","no","none","normalize","not","nth_value","ntile","null","nullif","numeric","octet_length","occurrences_regex","of","offset","old","omit","on","one","only","open","or","order","out","outer","over","overlaps","overlay","parameter","partition","pattern","per","percent","percent_rank","percentile_cont","percentile_disc","period","portion","position","position_regex","power","precedes","precision","prepare","primary","procedure","ptf","range","rank","reads","real","recursive","ref","references","referencing","regr_avgx","regr_avgy","regr_count","regr_intercept","regr_r2","regr_slope","regr_sxx","regr_sxy","regr_syy","release","result","return","returns","revoke","right","rollback","rollup","row","row_number","rows","running","savepoint","scope","scroll","search","second","seek","select","sensitive","session_user","set","show","similar","sin","sinh","skip","smallint","some","specific","specifictype","sql","sqlexception","sqlstate","sqlwarning","sqrt","start","static","stddev_pop","stddev_samp","submultiset","subset","substring","substring_regex","succeeds","sum","symmetric","system","system_time","system_user","table","tablesample","tan","tanh","then","time","timestamp","timezone_hour","timezone_minute","to","trailing","translate","translate_regex","translation","treat","trigger","trim","trim_array","true","truncate","uescape","union","unique","unknown","unnest","update","upper","user","using","value","values","value_of","var_pop","var_samp","varbinary","varchar","varying","versioning","when","whenever","where","width_bucket","window","with","within","without","year","add","asc","collation","desc","final","first","last","view"].filter(e=>!s.includes(e)),l={begin:L(/\b/,I(...r),/\s*\(/),relevance:0,keywords:{built_in:r}};return{name:"SQL",case_insensitive:!0,illegal:/[{}]|<\//,keywords:{$pattern:/\b[\w\.]+/,keyword:(({exceptions:t,when:e})=>{const i=e;return t=t||[],o.map(e=>!e.match(/\|\d+$/)&&!t.includes(e)&&i(e)?e+"|0":e)})({when:e=>e.length<3}),literal:i,type:n,built_in:["current_catalog","current_date","current_default_transform_group","current_path","current_role","current_schema","current_transform_group_for_type","current_user","session_user","system_time","system_user","current_time","localtime","current_timestamp","localtimestamp"]},contains:[{begin:I(...a),relevance:0,keywords:{$pattern:/[\w\.]+/,keyword:o.concat(a),literal:i,type:n}},{className:"type",begin:I("double precision","large object","with timezone","without timezone")},l,{className:"variable",begin:/@[a-z0-9]+/},{className:"string",variants:[{begin:/'/,end:/'/,contains:[{begin:/''/}]}]},{begin:/"/,end:/"/,contains:[{begin:/""/}]},e.C_NUMBER_MODE,e.C_BLOCK_COMMENT_MODE,t,{className:"operator",begin:/[-+*/=%^~]|&&?|\|\|?|!=?|<(?:=>?|<|>)?|>[>=]?/,relevance:0}]}},grmr_swift:e=>{const t={match:/\s+/,relevance:0},i=e.COMMENT("/\\*","\\*/",{contains:["self"]}),n=[e.C_LINE_COMMENT_MODE,i],s={match:[/\./,I(...fe,...be)],className:{2:"keyword"}},a={match:L(/\./,I(...z)),relevance:0},r=z.filter(e=>"string"==typeof e).concat(["_|0"]),o={variants:[{className:"keyword",match:I(...z.filter(e=>"string"!=typeof e).concat(ve).map(P),...be)}]},l={$pattern:I(/\b\w+/,/#\w+/),keyword:r.concat(_e),literal:ye},c=[s,a,o],d=[{match:L(/\./,I(...Ee)),relevance:0},{className:"built_in",match:L(/\b/,I(...Ee),/(?=\()/)}],u={match:/->/,relevance:0},p=[u,{className:"operator",relevance:0,variants:[{match:R},{match:`\\.(\\.|${Te})+`}]}],h="([0-9a-fA-F]_*)+",m={className:"number",relevance:0,variants:[{match:"\\b(([0-9]_*)+)(\\.(([0-9]_*)+))?([eE][+-]?(([0-9]_*)+))?\\b"},{match:`\\b0x(${h})(\\.(${h}))?([pP][+-]?(([0-9]_*)+))?\\b`},{match:/\b0o([0-7]_*)+\b/},{match:/\b0b([01]_*)+\b/}]},g=(e="")=>({className:"subst",variants:[{match:L(/\\/,e,/[0\\tnr"']/)},{match:L(/\\/,e,/u\{[0-9a-fA-F]{1,8}\}/)}]}),f=(e="")=>({className:"subst",label:"interpol",begin:L(/\\/,e,/\(/),end:/\)/}),b=(e="")=>{return{begin:L(e,/"""/),end:L(/"""/,e),contains:[g(e),([t=""]=[e],{className:"subst",match:L(/\\/,t,/[\t ]*(?:[\r\n]|\r\n)/)}),f(e)]};var t},v=(e="")=>({begin:L(e,/"/),end:L(/"/,e),contains:[g(e),f(e)]}),y={className:"string",variants:[b(),b("#"),b("##"),b("###"),v(),v("#"),v("##"),v("###")]},w={match:L(/`/,j,/`/)},_=[w,{className:"variable",match:/\$\d+/},{className:"variable",match:`\\$${B}+`}],E=[{match:/(@|#)available/,className:"keyword",starts:{contains:[{begin:/\(/,end:/\)/,keywords:ke,contains:[...p,m,y]}]}},{className:"keyword",match:L(/@/,I(...Se))},{className:"meta",match:L(/@/,j)}],x={match:O(/\b[A-Z]/),relevance:0,contains:[{className:"type",match:L(/(AV|CA|CF|CG|CI|CL|CM|CN|CT|MK|MP|MTK|MTL|NS|SCN|SK|UI|WK|XC)/,B,"+")},{className:"type",match:F,relevance:0},{match:/[?!]+/,relevance:0},{match:/\.\.\./,relevance:0},{match:L(/\s+&\s+/,O(F)),relevance:0}]},T={begin:/</,end:/>/,keywords:l,contains:[...n,...c,...E,u,x]};x.contains.push(T);var C={begin:/\(/,end:/\)/,relevance:0,keywords:l,contains:["self",{match:L(j,/\s*:/),keywords:"_|0",relevance:0},...n,...c,...d,...p,m,y,..._,...E,x]},S={begin:/</,end:/>/,contains:[...n,x]},k={begin:/\(/,end:/\)/,keywords:l,contains:[{begin:I(O(L(j,/\s*:/)),O(L(j,/\s+/,j,/\s*:/))),end:/:/,relevance:0,contains:[{className:"keyword",match:/\b_\b/},{className:"params",match:j}]},...n,...c,...p,m,y,...E,x,C],endsParent:!0,illegal:/["']/},M={match:[/func/,/\s+/,I(w.match,j,R)],className:{1:"keyword",3:"title.function"},contains:[S,k,t],illegal:[/\[/,/%/]},S={match:[/\b(?:subscript|init[?!]?)/,/\s*(?=[<(])/],className:{1:"keyword"},contains:[S,k,t],illegal:/\[|%/},k={match:[/operator/,/\s+/,R],className:{1:"keyword",3:"title"}},N={begin:[/precedencegroup/,/\s+/,F],className:{1:"keyword",3:"title"},contains:[x],keywords:[...we,...ye],end:/}/};for(const e of y.variants){const t=e.contains.find(e=>"interpol"===e.label),i=(t.keywords=l,[...c,...d,...p,m,y,..._]);t.contains=[...i,{begin:/\(/,end:/\)/,contains:["self",...i]}]}return{name:"Swift",keywords:l,contains:[...n,M,S,{beginKeywords:"struct protocol class extension enum actor",end:"\\{",excludeEnd:!0,keywords:l,contains:[e.inherit(e.TITLE_MODE,{className:"title.class",begin:/[A-Za-z$_][\u00C0-\u02B80-9A-Za-z$_]*/}),...c]},k,N,{beginKeywords:"import",end:/$/,contains:[...n],relevance:0},...c,...d,...p,m,y,..._,...E,x,C]}},grmr_typescript:e=>{var t={$pattern:C,keyword:le.concat(["type","namespace","typedef","interface","public","private","protected","implements","declare","abstract","readonly"]),literal:ce,built_in:me.concat(["any","void","number","boolean","string","object","never","enum"]),"variable.language":he},i={className:"meta",begin:"@[A-Za-z$_][0-9A-Za-z$_]*"},n=(e,t,i)=>{var n=e.contains.findIndex(e=>e.label===t);if(-1===n)throw Error("can not find mode to replace");e.contains.splice(n,1,i)},s=ge(e);return Object.assign(s.keywords,t),s.exports.PARAMS_CONTAINS.push(i),s.contains=s.contains.concat([i,{beginKeywords:"namespace",end:/\{/,excludeEnd:!0},{beginKeywords:"interface",end:/\{/,excludeEnd:!0,keywords:"interface extends"}]),n(s,"shebang",e.SHEBANG()),n(s,"use_strict",{className:"meta",relevance:10,begin:/^\s*['"]use strict['"]/}),s.contains.find(e=>"func.def"===e.label).relevance=0,Object.assign(s,{name:"TypeScript",aliases:["ts","tsx"]}),s},grmr_vbnet:e=>{var t=/\d{1,2}\/\d{1,2}\/\d{4}/,i=/\d{4}-\d{1,2}-\d{1,2}/,n=/(\d|1[012])(:\d+){0,2} *(AM|PM)/,s=/\d{1,2}(:\d{1,2}){1,2}/,i={className:"literal",variants:[{begin:L(/# */,I(i,t),/ *#/)},{begin:L(/# */,s,/ *#/)},{begin:L(/# */,n,/ *#/)},{begin:L(/# */,I(i,t),/ +/,I(n,s),/ *#/)}]},t=e.COMMENT(/'''/,/$/,{contains:[{className:"doctag",begin:/<\/?/,end:/>/}]}),n=e.COMMENT(null,/$/,{variants:[{begin:/'/},{begin:/([\t ]|^)REM(?=\s)/}]});return{name:"Visual Basic .NET",aliases:["vb"],case_insensitive:!0,classNameAliases:{label:"symbol"},keywords:{keyword:"addhandler alias aggregate ansi as async assembly auto binary by byref byval call case catch class compare const continue custom declare default delegate dim distinct do each equals else elseif end enum erase error event exit explicit finally for friend from function get global goto group handles if implements imports in inherits interface into iterator join key let lib loop me mid module mustinherit mustoverride mybase myclass namespace narrowing new next notinheritable notoverridable of off on operator option optional order overloads overridable overrides paramarray partial preserve private property protected public raiseevent readonly redim removehandler resume return select set shadows shared skip static step stop structure strict sub synclock take text then throw to try unicode until using when where while widening with withevents writeonly yield",built_in:"addressof and andalso await directcast gettype getxmlnamespace is isfalse isnot istrue like mod nameof new not or orelse trycast typeof xor cbool cbyte cchar cdate cdbl cdec cint clng cobj csbyte cshort csng cstr cuint culng cushort",type:"boolean byte char date decimal double integer long object sbyte short single string uinteger ulong ushort",literal:"true false nothing"},illegal:"//|\\{|\\}|endif|gosub|variant|wend|^\\$ ",contains:[{className:"string",begin:/"(""|[^/n])"C\b/},{className:"string",begin:/"/,end:/"/,illegal:/\n/,contains:[{begin:/""/}]},i,{className:"number",relevance:0,variants:[{begin:/\b\d[\d_]*((\.[\d_]+(E[+-]?[\d_]+)?)|(E[+-]?[\d_]+))[RFD@!#]?/},{begin:/\b\d[\d_]*((U?[SIL])|[%&])?/},{begin:/&H[\dA-F_]+((U?[SIL])|[%&])?/},{begin:/&O[0-7_]+((U?[SIL])|[%&])?/},{begin:/&B[01_]+((U?[SIL])|[%&])?/}]},{className:"label",begin:/^\w+:/},t,n,{className:"meta",begin:/[\t ]*#(const|disable|else|elseif|enable|end|externalsource|if|region)\b/,end:/$/,keywords:{keyword:"const disable else elseif enable end externalsource if region then"},contains:[n]}]}},grmr_yaml:e=>{var t="true false yes no null",i="[\\w#;/?:@&=+$,.~*'()[\\]]+",n={className:"string",relevance:0,variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/\S+/}],contains:[e.BACKSLASH_ESCAPE,{className:"template-variable",variants:[{begin:/\{\{/,end:/\}\}/},{begin:/%\{/,end:/\}/}]}]},s=e.inherit(n,{variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/[^\s,{}[\]]+/}]}),a={end:",",endsWithParent:!0,excludeEnd:!0,keywords:t,relevance:0},i=[{className:"attr",variants:[{begin:"\\w[\\w :\\/.-]*:(?=[ \t]|$)"},{begin:'"\\w[\\w :\\/.-]*":(?=[ \t]|$)'},{begin:"'\\w[\\w :\\/.-]*':(?=[ \t]|$)"}]},{className:"meta",begin:"^---\\s*$",relevance:10},{className:"string",begin:"[\\|>]([1-9]?[+-])?[ ]*\\n( +)[^ ][^\\n]*\\n(\\2[^\\n]+\\n?)*"},{begin:"<%[%=-]?",end:"[%-]?%>",subLanguage:"ruby",excludeBegin:!0,excludeEnd:!0,relevance:0},{className:"type",begin:"!\\w+!"+i},{className:"type",begin:"!<"+i+">"},{className:"type",begin:"!"+i},{className:"type",begin:"!!"+i},{className:"meta",begin:"&"+e.UNDERSCORE_IDENT_RE+"$"},{className:"meta",begin:"\\*"+e.UNDERSCORE_IDENT_RE+"$"},{className:"bullet",begin:"-(?=[ ]|$)",relevance:0},e.HASH_COMMENT_MODE,{beginKeywords:t,keywords:{literal:t}},{className:"number",begin:"\\b[0-9]{4}(-[0-9][0-9]){0,2}([Tt \\t][0-9][0-9]?(:[0-9][0-9]){2})?(\\.[0-9]*)?([ \\t])*(Z|[-+][0-9][0-9]?(:[0-9][0-9])?)?\\b"},{className:"number",begin:e.C_NUMBER_RE+"\\b",relevance:0},{begin:/\{/,end:/\}/,contains:[a],illegal:"\\n",relevance:0},{begin:"\\[",end:"\\]",contains:[a],illegal:"\\n",relevance:0},n],t=[...i];return t.pop(),t.push(s),a.contains=t,{name:"YAML",case_insensitive:!0,aliases:["yml"],contains:i}}}),Ne=e;for(const e of Object.keys(Me)){const i=e.replace("grmr_","").replace("_","-");Ne.registerLanguage(i,Me[e])}return Ne}());"object"==typeof exports&&"undefined"!=typeof module&&(module.exports=hljs),function(n,s){"use strict";var e,c="hljs-ln",d="hljs-ln-line",p="hljs-ln-code",u="hljs-ln-numbers",h="hljs-ln-n",m="data-line-number",g=/\r\n|\r|\n/g;function t(e){try{var t,i=s.querySelectorAll("code.hljs,code.nohighlight");for(t in i)!i.hasOwnProperty(t)||i[t].classList.contains("nohljsln")||a(i[t],e)}catch(e){n.console.error("LineNumbers error: ",e)}}function a(e,t){"object"==typeof e&&n.setTimeout(function(){e.innerHTML=r(e,t)},0)}function r(e,t){var i,n={singleLine:!!(t=t||{}).singleLine&&t.singleLine,startFrom:(n=e,t=t,i=1,isFinite(t.startFrom)&&(i=t.startFrom),t="data-ln-start-from",n=(n=n).hasAttribute(t)?n.getAttribute(t):null,i=null!==n?n&&(t=Number(n),isFinite(t))?t:1:i)},t=(function e(t){var i,n,s=t.childNodes;for(i in s)if(s.hasOwnProperty(i)&&0<((n=s[i]).textContent.trim().match(g)||[]).length)if(0<n.childNodes.length)e(n);else{a=void 0;r=void 0;o=void 0;l=void 0;c=void 0;var a=n.parentNode;var r=a.className;if(/hljs-/.test(r)){for(var o=f(a.innerHTML),l=0,c="";l<o.length;l++)c+=b('<span class="{0}">{1}</span>\n',[r,0<o[l].length?o[l]:" "]);a.innerHTML=c.trim()}}}(e),e.innerHTML),s=n,a=f(t);if(""===a[a.length-1].trim()&&a.pop(),1<a.length||s.singleLine){for(var r="",o=0,l=a.length;o<l;o++)r+=b('<tr><td class="{0} {1}" {3}="{5}"><div class="{2}" {3}="{5}"></div></td><td class="{0} {4}" {3}="{5}">{6}</td></tr>',[d,u,h,m,p,o+s.startFrom,0<a[o].length?a[o]:" "]);return b('<table class="{0}">{1}</table>',[c,r])}return t}function f(e){return 0===e.length?[]:e.split(g)}function b(e,i){return e.replace(/\{(\d+)\}/g,function(e,t){return void 0!==i[t]?i[t]:e})}n.hljs?(n.hljs.initLineNumbersOnLoad=function(e){"interactive"===s.readyState||"complete"===s.readyState?t(e):n.addEventListener("DOMContentLoaded",function(){t(e)})},n.hljs.lineNumbersBlock=a,n.hljs.lineNumbersValue=function(e,t){var i;if("string"==typeof e)return(i=document.createElement("code")).innerHTML=e,r(i,t)},(e=s.createElement("style")).type="text/css",e.innerHTML=b(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[c,h,m]),s.getElementsByTagName("head")[0].appendChild(e)):n.console.error("highlight.js not detected!"),document.addEventListener("copy",function(e){var t,i=window.getSelection();!function(){for(var e=i.anchorNode;e;){if(e.className&&-1!==e.className.indexOf("hljs-ln-code"))return 1;e=e.parentNode}}()||(t=-1!==window.navigator.userAgent.indexOf("Edge")?function(e){for(var t=e.toString(),i=e.anchorNode;"TD"!==i.nodeName;)i=i.parentNode;for(var n=e.focusNode;"TD"!==n.nodeName;)n=n.parentNode;var e=parseInt(i.dataset.lineNumber),s=parseInt(n.dataset.lineNumber);if(e==s)return t;var a,r=i.textContent,o=n.textContent;for(s<e&&(a=e,e=s,s=a,a=r,r=o,o=a);0!==t.indexOf(r);)r=r.slice(1);for(;-1===t.lastIndexOf(o);)o=o.slice(0,-1);for(var l=r,c=function(){for(var e=i;"TABLE"!==e.nodeName;)e=e.parentNode;return e}(),d=e+1;d<s;++d){var u=b('.{0}[{1}="{2}"]',[p,m,d]);l+="\n"+c.querySelector(u).textContent}return l+"\n"+o}(i):i.toString(),e.clipboardData.setData("text/plain",t),e.preventDefault())})}(window,document),function(o,i,l){o.ripple=function(e,t){var a=this,r=a.log=function(){a.defaults.debug&&console&&console.log&&console.log.apply(console,arguments)};a.selector=e,a.defaults={debug:!1,on:"mousedown",opacity:.4,color:"auto",multi:!1,duration:.7,rate:function(e){return e},easing:"linear"},a.defaults=o.extend({},a.defaults,t);o(i).on(a.defaults.on,a.selector,function(e){var t,i,n=o(this),s=(n.addClass("has-ripple"),((t=o.extend({},a.defaults,n.data())).multi||!t.multi&&0===n.find(".ripple").length)&&((i=o("<span></span>").addClass("ripple")).appendTo(n),r("Create: Ripple"),i.height()||i.width()||(s=l.max(n.outerWidth(),n.outerHeight()),i.css({height:s,width:s}),r("Set: Ripple size")),t.rate&&"function"==typeof t.rate&&(s=l.round(i.width()/t.duration),s=t.rate(s),s=i.width()/s,t.duration.toFixed(2)!==s.toFixed(2))&&(r("Update: Ripple Duration",{from:t.duration,to:s}),t.duration=s),s="auto"==t.color?n.css("color"):t.color,s={animationDuration:t.duration.toString()+"s",animationTimingFunction:t.easing,background:s,opacity:t.opacity},r("Set: Ripple CSS",s),i.css(s)),t.multi||(r("Set: Ripple Element"),i=n.find(".ripple")),r("Destroy: Ripple Animation"),i.removeClass("ripple-animate"),e.pageX-n.offset().left-i.width()/2),e=e.pageY-n.offset().top-i.height()/2;t.multi&&(r("Set: Ripple animationend event"),i.one("animationend webkitAnimationEnd oanimationend MSAnimationEnd",function(){r("Note: Ripple animation ended"),r("Destroy: Ripple"),o(this).remove()})),r("Set: Ripple location"),r("Set: Ripple animation"),i.css({top:e+"px",left:s+"px"}).addClass("ripple-animate")})}}(jQuery,document,Math),function(){function o(i,e){function u(){var e,t;this.q=[],this.add=function(e){this.q.push(e)},this.call=function(){for(e=0,t=this.q.length;e<t;e++)this.q[e].call()}}function t(e,t){if(e.resizedAttached){if(e.resizedAttached)return e.resizedAttached.add(t)}else e.resizedAttached=new u,e.resizedAttached.add(t);e.resizeSensor=document.createElement("div"),e.resizeSensor.className="resize-sensor";var t="position: absolute; left: 0; top: 0; right: 0; bottom: 0; overflow: hidden; z-index: -1; visibility: hidden;",i="position: absolute; left: 0; top: 0; transition: 0s;";e.resizeSensor.style.cssText=t,e.resizeSensor.innerHTML='<div class="resize-sensor-expand" style="'+t+'"><div style="'+i+'"></div></div><div class="resize-sensor-shrink" style="'+t+'"><div style="'+i+' width: 200%; height: 200%"></div></div>',e.appendChild(e.resizeSensor),{fixed:1,absolute:1}[t="position",(i=e).currentStyle?i.currentStyle[t]:window.getComputedStyle?window.getComputedStyle(i,null).getPropertyValue(t):i.style[t]]||(e.style.position="relative");function n(){c.style.width=l.offsetWidth+10+"px",c.style.height=l.offsetHeight+10+"px",l.scrollLeft=l.scrollWidth,l.scrollTop=l.scrollHeight,d.scrollLeft=d.scrollWidth,d.scrollTop=d.scrollHeight,r=e.offsetWidth,o=e.offsetHeight}function s(e,t,i){e.attachEvent?e.attachEvent("on"+t,i):e.addEventListener(t,i)}function a(){e.offsetWidth==r&&e.offsetHeight==o||e.resizedAttached&&e.resizedAttached.call(),n()}var r,o,l=e.resizeSensor.childNodes[0],c=l.childNodes[0],d=e.resizeSensor.childNodes[1];d.childNodes[0],n();s(l,"scroll",a),s(d,"scroll",a)}var n=Object.prototype.toString.call(i),s="[object Array]"===n||"[object NodeList]"===n||"[object HTMLCollection]"===n||"undefined"!=typeof jQuery&&i instanceof jQuery||"undefined"!=typeof Elements&&i instanceof Elements;if(s)for(var a=0,r=i.length;a<r;a++)t(i[a],e);else t(i,e);this.detach=function(){if(s)for(var e=0,t=i.length;e<t;e++)o.detach(i[e]);else o.detach(i)}}o.detach=function(e){e.resizeSensor&&(e.removeChild(e.resizeSensor),delete e.resizeSensor,delete e.resizedAttached)},"undefined"!=typeof module&&void 0!==module.exports?module.exports=o:window.ResizeSensor=o}(),function(h){h.fn.theiaStickySidebar=function(e){function t(e,t){return!0===e.initialized||!(h("body").width()<e.minWidth)&&(t=t,(u=e).initialized=!0,0===h("#theia-sticky-sidebar-stylesheet-"+u.namespace).length&&h("head").append(h('<style id="theia-sticky-sidebar-stylesheet-'+u.namespace+'">.theiaStickySidebar:after {content: ""; display: table; clear: both;}</style>')),t.each(function(){function d(){s.fixedScrollTop=0,s.sidebar.css({"min-height":"1px"}),s.stickySidebar.css({position:"static",width:"",transform:"none"})}var i,e,t,n,s={},a=(s.sidebar=h(this),s.options=u||{},s.container=h(s.options.containerSelector),0==s.container.length&&(s.container=s.sidebar.parent()),s.sidebar.parents().css("-webkit-transform","none"),s.sidebar.css({position:s.options.defaultPosition,overflow:"visible","-webkit-box-sizing":"border-box","-moz-box-sizing":"border-box","box-sizing":"border-box"}),s.stickySidebar=s.sidebar.find(".theiaStickySidebar"),0==s.stickySidebar.length&&(i=/(?:text|application)\/(?:x-)?(?:javascript|ecmascript)/i,s.sidebar.find("script").filter(function(e,t){return 0===t.type.length||t.type.match(i)}).remove(),s.stickySidebar=h("<div>").addClass("theiaStickySidebar").append(s.sidebar.children()),s.sidebar.append(s.stickySidebar)),s.marginBottom=parseInt(s.sidebar.css("margin-bottom")),s.paddingTop=parseInt(s.sidebar.css("padding-top")),s.paddingBottom=parseInt(s.sidebar.css("padding-bottom")),s.stickySidebar.offset().top),r=s.stickySidebar.outerHeight();s.stickySidebar.css("padding-top",1),s.stickySidebar.css("padding-bottom",1),a-=s.stickySidebar.offset().top,r=s.stickySidebar.outerHeight()-r-a,0==a?(s.stickySidebar.css("padding-top",0),s.stickySidebarPaddingTop=0):s.stickySidebarPaddingTop=1,0==r?(s.stickySidebar.css("padding-bottom",0),s.stickySidebarPaddingBottom=0):s.stickySidebarPaddingBottom=1,s.previousScrollTop=null,s.fixedScrollTop=0,d(),s.onScroll=function(e){if(e.stickySidebar.is(":visible"))if(h("body").width()<e.options.minWidth)d();else{if(e.options.disableOnResponsiveLayouts)if(e.sidebar.outerWidth("none"==e.sidebar.css("float"))+50>e.container.width())return void d();var t,i,n,s,a,r=h(document).scrollTop(),o="static";r>=e.sidebar.offset().top+(e.paddingTop-e.options.additionalMarginTop)&&(i=e.paddingTop+u.additionalMarginTop,s=e.paddingBottom+e.marginBottom+u.additionalMarginBottom,a=e.sidebar.offset().top,l=e.sidebar.offset().top+(l=e.container,c=l.height(),l.children().each(function(){c=Math.max(c,h(this).height())}),c),t=0+u.additionalMarginTop,i=e.stickySidebar.outerHeight()+i+s<h(window).height()?t+e.stickySidebar.outerHeight():h(window).height()-e.marginBottom-e.paddingBottom-u.additionalMarginBottom,s=a-r+e.paddingTop,a=l-r-e.paddingBottom-e.marginBottom,l=e.stickySidebar.offset().top-r,n=e.previousScrollTop-r,"fixed"==e.stickySidebar.css("position")&&"modern"==e.options.sidebarBehavior&&(l+=n),"stick-to-top"==e.options.sidebarBehavior&&(l=u.additionalMarginTop),"stick-to-bottom"==e.options.sidebarBehavior&&(l=i-e.stickySidebar.outerHeight()),l=0<n?Math.min(l,t):Math.max(l,i-e.stickySidebar.outerHeight()),l=Math.max(l,s),l=Math.min(l,a-e.stickySidebar.outerHeight()),o=!(n=e.container.height()==e.stickySidebar.outerHeight())&&l==t||!n&&l==i-e.stickySidebar.outerHeight()?"fixed":r+l-e.sidebar.offset().top-e.paddingTop<=u.additionalMarginTop?"static":"absolute"),"fixed"==o?(s=h(document).scrollLeft(),e.stickySidebar.css({position:"fixed",width:p(e.stickySidebar)+"px",transform:"translateY("+l+"px)",left:e.sidebar.offset().left+parseInt(e.sidebar.css("padding-left"))-s+"px",top:"0px"})):"absolute"==o?(a={},"absolute"!=e.stickySidebar.css("position")&&(a.position="absolute",a.transform="translateY("+(r+l-e.sidebar.offset().top-e.stickySidebarPaddingTop-e.stickySidebarPaddingBottom)+"px)",a.top="0px"),a.width=p(e.stickySidebar)+"px",a.left="",e.stickySidebar.css(a)):"static"==o&&d(),"static"!=o&&1==e.options.updateSidebarHeight&&e.sidebar.css({"min-height":e.stickySidebar.outerHeight()+e.stickySidebar.offset().top-e.sidebar.offset().top+e.paddingBottom}),e.previousScrollTop=r}var l,c},s.onScroll(s),h(document).on("scroll."+s.options.namespace,(n=s,function(){n.onScroll(n)})),h(window).on("resize."+s.options.namespace,(t=s,function(){t.stickySidebar.css({position:"static"}),t.onScroll(t)})),"undefined"!=typeof ResizeSensor&&new ResizeSensor(s.stickySidebar[0],(e=s,function(){e.onScroll(e)}))}),!0);var u}function p(e){var t;try{t=e[0].getBoundingClientRect().width}catch(e){}return t=void 0===t?e.width():t}var i,n,s,a,r;return(e=h.extend({containerSelector:"",additionalMarginTop:0,additionalMarginBottom:0,updateSidebarHeight:!0,minWidth:0,disableOnResponsiveLayouts:!0,sidebarBehavior:"modern",defaultPosition:"relative",namespace:"TSS"},e)).additionalMarginTop=parseInt(e.additionalMarginTop)||0,e.additionalMarginBottom=parseInt(e.additionalMarginBottom)||0,t(e=e,i=this)||(console.log("TSS: Body width smaller than options.minWidth. Init is delayed."),h(document).on("scroll."+e.namespace,(a=e,r=i,function(e){t(a,r)&&h(this).unbind(e)})),h(window).on("resize."+e.namespace,(n=e,s=i,function(e){t(n,s)&&h(this).unbind(e)}))),this}}(jQuery),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).Swiper=t()}(this,function(){"use strict";function n(e){return null!==e&&"object"==typeof e&&"constructor"in e&&e.constructor===Object}function s(t,i){void 0===t&&(t={}),void 0===i&&(i={}),Object.keys(i).forEach(e=>{void 0===t[e]?t[e]=i[e]:n(i[e])&&n(t[e])&&0<Object.keys(i[e]).length&&s(t[e],i[e])})}const t={body:{},addEventListener(){},removeEventListener(){},activeElement:{blur(){},nodeName:""},querySelector:()=>null,querySelectorAll:()=>[],getElementById:()=>null,createEvent:()=>({initEvent(){}}),createElement:()=>({children:[],childNodes:[],style:{},setAttribute(){},getElementsByTagName:()=>[]}),createElementNS:()=>({}),importNode:()=>null,location:{hash:"",host:"",hostname:"",href:"",origin:"",pathname:"",protocol:"",search:""}};function T(){var e="undefined"!=typeof document?document:{};return s(e,t),e}const P={document:t,navigator:{userAgent:""},location:{hash:"",host:"",hostname:"",href:"",origin:"",pathname:"",protocol:"",search:""},history:{replaceState(){},pushState(){},go(){},back(){}},CustomEvent:function(){return this},addEventListener(){},removeEventListener(){},getComputedStyle:()=>({getPropertyValue:()=>""}),Image(){},Date(){},screen:{},setTimeout(){},clearTimeout(){},matchMedia:()=>({}),requestAnimationFrame:e=>"undefined"==typeof setTimeout?(e(),null):setTimeout(e,0),cancelAnimationFrame(e){"undefined"!=typeof setTimeout&&clearTimeout(e)}};function A(){var e="undefined"!=typeof window?window:{};return s(e,P),e}class r extends Array{constructor(e){if("number"==typeof e)super(e);else{super(...e||[]);{e=this;const t=e.__proto__;Object.defineProperty(e,"__proto__",{get:()=>t,set(e){t.__proto__=e}})}}}}function a(e){const t=[];return(e=void 0===e?[]:e).forEach(e=>{Array.isArray(e)?t.push(...a(e)):t.push(e)}),t}function o(e,t){return Array.prototype.filter.call(e,t)}function L(e,n){const t=A(),s=T();let i=[];if(!n&&e instanceof r)return e;if(!e)return new r(i);if("string"==typeof e){const t=e.trim();if(0<=t.indexOf("<")&&0<=t.indexOf(">")){let e="div";0===t.indexOf("<li")&&(e="ul"),0===t.indexOf("<tr")&&(e="tbody"),0!==t.indexOf("<td")&&0!==t.indexOf("<th")||(e="tr"),0===t.indexOf("<tbody")&&(e="table"),0===t.indexOf("<option")&&(e="select");const n=s.createElement(e);n.innerHTML=t;for(let e=0;e<n.childNodes.length;e+=1)i.push(n.childNodes[e])}else i=function(e){if("string"!=typeof e)return[e];var t=[],i=(n||s).querySelectorAll(e);for(let e=0;e<i.length;e+=1)t.push(i[e]);return t}(e.trim())}else if(e.nodeType||e===t||e===s)i.push(e);else if(Array.isArray(e)){if(e instanceof r)return e;i=e}return new r(function(t){var i=[];for(let e=0;e<t.length;e+=1)-1===i.indexOf(t[e])&&i.push(t[e]);return i}(i))}L.fn=r.prototype;const i={addClass:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];const n=a(t.map(e=>e.split(" ")));return this.forEach(e=>{e.classList.add(...n)}),this},removeClass:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];const n=a(t.map(e=>e.split(" ")));return this.forEach(e=>{e.classList.remove(...n)}),this},hasClass:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];const n=a(t.map(e=>e.split(" ")));return 0<o(this,t=>0<n.filter(e=>t.classList.contains(e)).length).length},toggleClass:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];const n=a(t.map(e=>e.split(" ")));this.forEach(t=>{n.forEach(e=>{t.classList.toggle(e)})})},attr:function(t,i){if(1===arguments.length&&"string"==typeof t)return this[0]?this[0].getAttribute(t):void 0;for(let e=0;e<this.length;e+=1)if(2===arguments.length)this[e].setAttribute(t,i);else for(const i in t)this[e][i]=t[i],this[e].setAttribute(i,t[i]);return this},removeAttr:function(t){for(let e=0;e<this.length;e+=1)this[e].removeAttribute(t);return this},transform:function(t){for(let e=0;e<this.length;e+=1)this[e].style.transform=t;return this},transition:function(t){for(let e=0;e<this.length;e+=1)this[e].style.transitionDuration="string"!=typeof t?t+"ms":t;return this},on:function(){for(var t=arguments.length,i=new Array(t),e=0;e<t;e++)i[e]=arguments[e];let[n,s,a,r]=i;function o(t){var e=t.target;if(e){var i=t.target.dom7EventData||[];if(i.indexOf(t)<0&&i.unshift(t),L(e).is(s))a.apply(e,i);else{const t=L(e).parents();for(let e=0;e<t.length;e+=1)L(t[e]).is(s)&&a.apply(t[e],i)}}}function l(e){var t=e&&e.target&&e.target.dom7EventData||[];t.indexOf(e)<0&&t.unshift(e),a.apply(this,t)}"function"==typeof i[1]&&([n,a,r]=i,s=void 0),r=r||!1;var c=n.split(" ");let d;for(let e=0;e<this.length;e+=1){const i=this[e];if(s)for(d=0;d<c.length;d+=1){const t=c[d];i.dom7LiveListeners||(i.dom7LiveListeners={}),i.dom7LiveListeners[t]||(i.dom7LiveListeners[t]=[]),i.dom7LiveListeners[t].push({listener:a,proxyListener:o}),i.addEventListener(t,o,r)}else for(d=0;d<c.length;d+=1){const t=c[d];i.dom7Listeners||(i.dom7Listeners={}),i.dom7Listeners[t]||(i.dom7Listeners[t]=[]),i.dom7Listeners[t].push({listener:a,proxyListener:l}),i.addEventListener(t,l,r)}}return this},off:function(){for(var e=arguments.length,i=new Array(e),n=0;n<e;n++)i[n]=arguments[n];let[t,s,a,r]=i;"function"==typeof i[1]&&([t,a,r]=i,s=void 0),r=r||!1;var o=t.split(" ");for(let e=0;e<o.length;e+=1){const i=o[e];for(let e=0;e<this.length;e+=1){const n=this[e];let t;if(!s&&n.dom7Listeners?t=n.dom7Listeners[i]:s&&n.dom7LiveListeners&&(t=n.dom7LiveListeners[i]),t&&t.length)for(let e=t.length-1;0<=e;--e){const s=t[e];(a&&s.listener===a||a&&s.listener&&s.listener.dom7proxy&&s.listener.dom7proxy===a||!a)&&(n.removeEventListener(i,s.proxyListener,r),t.splice(e,1))}}}return this},trigger:function(){for(var t=A(),i=arguments.length,n=new Array(i),s=0;s<i;s++)n[s]=arguments[s];const a=n[0].split(" "),r=n[1];for(let e=0;e<a.length;e+=1){const s=a[e];for(let e=0;e<this.length;e+=1){const a=this[e];if(t.CustomEvent){const i=new t.CustomEvent(s,{detail:r,bubbles:!0,cancelable:!0});a.dom7EventData=n.filter((e,t)=>0<t),a.dispatchEvent(i),a.dom7EventData=[],delete a.dom7EventData}}}return this},transitionEnd:function(i){const n=this;return i&&n.on("transitionend",function e(t){t.target===this&&(i.call(this,t),n.off("transitionend",e))}),this},outerWidth:function(e){if(0<this.length){if(e){const e=this.styles();return this[0].offsetWidth+parseFloat(e.getPropertyValue("margin-right"))+parseFloat(e.getPropertyValue("margin-left"))}return this[0].offsetWidth}return null},outerHeight:function(e){if(0<this.length){if(e){const e=this.styles();return this[0].offsetHeight+parseFloat(e.getPropertyValue("margin-top"))+parseFloat(e.getPropertyValue("margin-bottom"))}return this[0].offsetHeight}return null},styles:function(){var e=A();return this[0]?e.getComputedStyle(this[0],null):{}},offset:function(){var e,t,i,n,s,a;return 0<this.length?(a=A(),n=T(),t=(e=this[0]).getBoundingClientRect(),n=n.body,i=e.clientTop||n.clientTop||0,n=e.clientLeft||n.clientLeft||0,s=e===a?a.scrollY:e.scrollTop,a=e===a?a.scrollX:e.scrollLeft,{top:t.top+s-i,left:t.left+a-n}):null},css:function(e,t){var i=A();let n;if(1===arguments.length){if("string"!=typeof e){for(n=0;n<this.length;n+=1)for(const t in e)this[n].style[t]=e[t];return this}if(this[0])return i.getComputedStyle(this[0],null).getPropertyValue(e)}if(2===arguments.length&&"string"==typeof e)for(n=0;n<this.length;n+=1)this[n].style[e]=t;return this},each:function(i){return i&&this.forEach((e,t)=>{i.apply(e,[e,t])}),this},html:function(t){if(void 0===t)return this[0]?this[0].innerHTML:null;for(let e=0;e<this.length;e+=1)this[e].innerHTML=t;return this},text:function(t){if(void 0===t)return this[0]?this[0].textContent.trim():null;for(let e=0;e<this.length;e+=1)this[e].textContent=t;return this},is:function(e){var t=A(),i=T(),n=this[0];let s,a;if(n&&void 0!==e)if("string"==typeof e){if(n.matches)return n.matches(e);if(n.webkitMatchesSelector)return n.webkitMatchesSelector(e);if(n.msMatchesSelector)return n.msMatchesSelector(e);for(s=L(e),a=0;a<s.length;a+=1)if(s[a]===n)return!0}else{if(e===i)return n===i;if(e===t)return n===t;if(e.nodeType||e instanceof r)for(s=e.nodeType?[e]:e,a=0;a<s.length;a+=1)if(s[a]===n)return!0}return!1},index:function(){let e,t=this[0];if(t){for(e=0;null!==(t=t.previousSibling);)1===t.nodeType&&(e+=1);return e}},eq:function(e){var t;return void 0===e?this:L((t=this.length)-1<e?[]:e<0?(t=t+e)<0?[]:[this[t]]:[this[e]])},append:function(){var i,n=T();for(let e=0;e<arguments.length;e+=1){i=e<0||arguments.length<=e?void 0:arguments[e];for(let t=0;t<this.length;t+=1)if("string"==typeof i){const T=n.createElement("div");for(T.innerHTML=i;T.firstChild;)this[t].appendChild(T.firstChild)}else if(i instanceof r)for(let e=0;e<i.length;e+=1)this[t].appendChild(i[e]);else this[t].appendChild(i)}return this},prepend:function(e){var t=T();let i,n;for(i=0;i<this.length;i+=1)if("string"==typeof e){const T=t.createElement("div");for(T.innerHTML=e,n=T.childNodes.length-1;0<=n;--n)this[i].insertBefore(T.childNodes[n],this[i].childNodes[0])}else if(e instanceof r)for(n=0;n<e.length;n+=1)this[i].insertBefore(e[n],this[i].childNodes[0]);else this[i].insertBefore(e,this[i].childNodes[0]);return this},next:function(e){return 0<this.length?e?this[0].nextElementSibling&&L(this[0].nextElementSibling).is(e)?L([this[0].nextElementSibling]):L([]):this[0].nextElementSibling?L([this[0].nextElementSibling]):L([]):L([])},nextAll:function(e){var t=[];let i=this[0];if(!i)return L([]);for(;i.nextElementSibling;){var n=i.nextElementSibling;e&&!L(n).is(e)||t.push(n),i=n}return L(t)},prev:function(e){var t;return 0<this.length?(t=this[0],e?t.previousElementSibling&&L(t.previousElementSibling).is(e)?L([t.previousElementSibling]):L([]):t.previousElementSibling?L([t.previousElementSibling]):L([])):L([])},prevAll:function(e){var t=[];let i=this[0];if(!i)return L([]);for(;i.previousElementSibling;){var n=i.previousElementSibling;e&&!L(n).is(e)||t.push(n),i=n}return L(t)},parent:function(t){var i=[];for(let e=0;e<this.length;e+=1)null===this[e].parentNode||t&&!L(this[e].parentNode).is(t)||i.push(this[e].parentNode);return L(i)},parents:function(i){var n=[];for(let t=0;t<this.length;t+=1){let e=this[t].parentNode;for(;e;)i&&!L(e).is(i)||n.push(e),e=e.parentNode}return L(n)},closest:function(e){let t=this;return void 0===e?L([]):t=t.is(e)?t:t.parents(e).eq(0)},find:function(t){var i=[];for(let e=0;e<this.length;e+=1){var n=this[e].querySelectorAll(t);for(let e=0;e<n.length;e+=1)i.push(n[e])}return L(i)},children:function(t){var i=[];for(let e=0;e<this.length;e+=1){var n=this[e].children;for(let e=0;e<n.length;e+=1)t&&!L(n[e]).is(t)||i.push(n[e])}return L(i)},filter:function(e){return L(o(this,e))},remove:function(){for(let e=0;e<this.length;e+=1)this[e].parentNode&&this[e].parentNode.removeChild(this[e]);return this}};function C(e,t){return void 0===t&&(t=0),setTimeout(e,t)}function b(){return Date.now()}function I(e,t){void 0===t&&(t="x");var i=A();let n,s,a;e=function(e){var t=A();let i;return i=(i=!(i=t.getComputedStyle?t.getComputedStyle(e,null):i)&&e.currentStyle?e.currentStyle:i)||e.style}(e);return i.WebKitCSSMatrix?(6<(s=e.transform||e.webkitTransform).split(",").length&&(s=s.split(", ").map(e=>e.replace(",",".")).join(", ")),a=new i.WebKitCSSMatrix("none"===s?"":s)):(a=e.MozTransform||e.OTransform||e.MsTransform||e.msTransform||e.transform||e.getPropertyValue("transform").replace("translate(","matrix(1, 0, 0, 1,"),n=a.toString().split(",")),"x"===t&&(s=i.WebKitCSSMatrix?a.m41:16===n.length?parseFloat(n[12]):parseFloat(n[4])),(s="y"===t?i.WebKitCSSMatrix?a.m42:16===n.length?parseFloat(n[13]):parseFloat(n[5]):s)||0}function c(e){return"object"==typeof e&&null!==e&&e.constructor&&"Object"===Object.prototype.toString.call(e).slice(8,-1)}function m(e){const i=Object(arguments.length<=0?void 0:e),t=["__proto__","constructor","prototype"];for(let e=1;e<arguments.length;e+=1){var n=e<0||arguments.length<=e?void 0:arguments[e];if(null!=n&&(o=n,!("undefined"!=typeof window&&void 0!==window.HTMLElement?o instanceof HTMLElement:o&&(1===o.nodeType||11===o.nodeType)))){var s=Object.keys(Object(n)).filter(e=>t.indexOf(e)<0);for(let e=0,t=s.length;e<t;e+=1){var a=s[e],r=Object.getOwnPropertyDescriptor(n,a);void 0!==r&&r.enumerable&&(c(i[a])&&c(n[a])?n[a].__swiper__?i[a]=n[a]:m(i[a],n[a]):c(i[a])||!c(n[a])||(i[a]={},n[a].__swiper__)?i[a]=n[a]:m(i[a],n[a]))}}}var o;return i}function S(e,t,i){e.style.setProperty(t,i)}function v(e){let{swiper:i,targetPosition:n,side:s}=e;const a=A(),r=-i.translate;let o,l=null;const c=i.params.speed,d=(i.wrapperEl.style.scrollSnapType="none",a.cancelAnimationFrame(i.cssModeFrameID),n>r?"next":"prev"),u=(e,t)=>"next"===d&&t<=e||"prev"===d&&e<=t,p=()=>{o=(new Date).getTime(),null===l&&(l=o);var e=Math.max(Math.min((o-l)/c,1),0),e=.5-Math.cos(e*Math.PI)/2;let t=r+e*(n-r);u(t,n)&&(t=n),i.wrapperEl.scrollTo({[s]:t}),u(t,n)?(i.wrapperEl.style.overflow="hidden",i.wrapperEl.style.scrollSnapType="",setTimeout(()=>{i.wrapperEl.style.overflow="",i.wrapperEl.scrollTo({[s]:t})}),a.cancelAnimationFrame(i.cssModeFrameID)):i.cssModeFrameID=a.requestAnimationFrame(p)};p()}let e,d,l;function p(){return e=e||function(){const i=A(),e=T();return{smoothScroll:e.documentElement&&"scrollBehavior"in e.documentElement.style,touch:!!("ontouchstart"in i||i.DocumentTouch&&e instanceof i.DocumentTouch),passiveListener:function(){let e=!1;try{var t=Object.defineProperty({},"passive",{get(){e=!0}});i.addEventListener("testPassiveListener",null,t)}catch(e){}return e}(),gestures:"ongesturestart"in i}}()}function z(){return l=l||function(){const e=A();return{isSafari:0<=(t=e.navigator.userAgent.toLowerCase()).indexOf("safari")&&t.indexOf("chrome")<0&&t.indexOf("android")<0,isWebView:/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(e.navigator.userAgent)};var t}()}function u(e){var{swiper:e,runCallbacks:t,direction:i,step:n}=e,{activeIndex:s,previousIndex:a}=e;let r=i;if(r=r||(a<s?"next":s<a?"prev":"reset"),e.emit("transition"+n),t&&s!==a){if("reset"===r)return e.emit("slideResetTransition"+n);e.emit("slideChangeTransition"+n),"next"===r?e.emit("slideNextTransition"+n):e.emit("slidePrevTransition"+n)}}function h(){var e,t,i=this,{params:n,el:s}=i;s&&0===s.offsetWidth||(n.breakpoints&&i.setBreakpoint(),{allowSlideNext:s,allowSlidePrev:e,snapGrid:t}=i,i.allowSlideNext=!0,i.allowSlidePrev=!0,i.updateSize(),i.updateSlides(),i.updateSlidesClasses(),("auto"===n.slidesPerView||1<n.slidesPerView)&&i.isEnd&&!i.isBeginning&&!i.params.centeredSlides?i.slideTo(i.slides.length-1,0,!1,!0):i.slideTo(i.activeIndex,0,!1,!0),i.autoplay&&i.autoplay.running&&i.autoplay.paused&&i.autoplay.run(),i.allowSlidePrev=e,i.allowSlideNext=s,i.params.watchOverflow&&t!==i.snapGrid&&i.checkOverflow())}Object.keys(i).forEach(e=>{Object.defineProperty(L.fn,e,{value:i[e],writable:!0})});let g=!1;function R(){}const f=(e,t)=>{var i=T(),{params:n,touchEvents:s,el:a,wrapperEl:r,device:o,support:l}=e,c=!!n.nested,d="on"===t?"addEventListener":"removeEventListener";if(l.touch){const t=!("touchstart"!==s.start||!l.passiveListener||!n.passiveListeners)&&{passive:!0,capture:!1};a[d](s.start,e.onTouchStart,t),a[d](s.move,e.onTouchMove,l.passiveListener?{passive:!1,capture:c}:c),a[d](s.end,e.onTouchEnd,t),s.cancel&&a[d](s.cancel,e.onTouchEnd,t)}else a[d](s.start,e.onTouchStart,!1),i[d](s.move,e.onTouchMove,c),i[d](s.end,e.onTouchEnd,!1);(n.preventClicks||n.preventClicksPropagation)&&a[d]("click",e.onClick,!0),n.cssMode&&r[d]("scroll",e.onScroll),n.updateOnWindowResize?e[t](o.ios||o.android?"resize orientationchange observerUpdate":"resize observerUpdate",h,!0):e[t]("observerUpdate",h,!0)},y=(e,t)=>e.grid&&t.grid&&1<t.grid.rows;var w={init:!0,direction:"horizontal",touchEventsTarget:"wrapper",initialSlide:0,speed:300,cssMode:!1,updateOnWindowResize:!0,resizeObserver:!0,nested:!1,createElements:!1,enabled:!0,focusableElements:"input, select, option, textarea, button, video, label",width:null,height:null,preventInteractionOnTransition:!1,userAgent:null,url:null,edgeSwipeDetection:!1,edgeSwipeThreshold:20,autoHeight:!1,setWrapperSize:!1,virtualTranslate:!1,effect:"slide",breakpoints:void 0,breakpointsBase:"window",spaceBetween:0,slidesPerView:1,slidesPerGroup:1,slidesPerGroupSkip:0,slidesPerGroupAuto:!1,centeredSlides:!1,centeredSlidesBounds:!1,slidesOffsetBefore:0,slidesOffsetAfter:0,normalizeSlideIndex:!0,centerInsufficientSlides:!1,watchOverflow:!0,roundLengths:!1,touchRatio:1,touchAngle:45,simulateTouch:!0,shortSwipes:!0,longSwipes:!0,longSwipesRatio:.5,longSwipesMs:300,followFinger:!0,allowTouchMove:!0,threshold:0,touchMoveStopPropagation:!1,touchStartPreventDefault:!0,touchStartForcePreventDefault:!1,touchReleaseOnEdges:!1,uniqueNavElements:!0,resistance:!0,resistanceRatio:.85,watchSlidesProgress:!1,grabCursor:!1,preventClicks:!0,preventClicksPropagation:!0,slideToClickedSlide:!1,preloadImages:!0,updateOnImagesReady:!0,loop:!1,loopAdditionalSlides:0,loopedSlides:null,loopedSlidesLimit:!0,loopFillGroupWithBlank:!1,loopPreventsSlide:!0,rewind:!1,allowSlidePrev:!0,allowSlideNext:!0,swipeHandler:null,noSwiping:!0,noSwipingClass:"swiper-no-swiping",noSwipingSelector:null,passiveListeners:!0,maxBackfaceHiddenSlides:10,containerModifierClass:"swiper-",slideClass:"swiper-slide",slideBlankClass:"swiper-slide-invisible-blank",slideActiveClass:"swiper-slide-active",slideDuplicateActiveClass:"swiper-slide-duplicate-active",slideVisibleClass:"swiper-slide-visible",slideDuplicateClass:"swiper-slide-duplicate",slideNextClass:"swiper-slide-next",slideDuplicateNextClass:"swiper-slide-duplicate-next",slidePrevClass:"swiper-slide-prev",slideDuplicatePrevClass:"swiper-slide-duplicate-prev",wrapperClass:"swiper-wrapper",runCallbacksOnInit:!0,_emitClasses:!1};const _={eventsEmitter:{on(e,t,i){const n=this;if(n.eventsListeners&&!n.destroyed&&"function"==typeof t){const s=i?"unshift":"push";e.split(" ").forEach(e=>{n.eventsListeners[e]||(n.eventsListeners[e]=[]),n.eventsListeners[e][s](t)})}return n},once(n,s,e){const a=this;return!a.eventsListeners||a.destroyed||"function"!=typeof s?a:(r.__emitterProxy=s,a.on(n,r,e));function r(){a.off(n,r),r.__emitterProxy&&delete r.__emitterProxy;for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];s.apply(a,t)}},onAny(e,t){var i=this;return i.eventsListeners&&!i.destroyed&&"function"==typeof e&&(t=t?"unshift":"push",i.eventsAnyListeners.indexOf(e)<0)&&i.eventsAnyListeners[t](e),i},offAny(e){var t=this;return t.eventsListeners&&!t.destroyed&&t.eventsAnyListeners&&0<=(e=t.eventsAnyListeners.indexOf(e))&&t.eventsAnyListeners.splice(e,1),t},off(e,n){const s=this;return!s.eventsListeners||s.destroyed||s.eventsListeners&&e.split(" ").forEach(i=>{void 0===n?s.eventsListeners[i]=[]:s.eventsListeners[i]&&s.eventsListeners[i].forEach((e,t)=>{(e===n||e.__emitterProxy&&e.__emitterProxy===n)&&s.eventsListeners[i].splice(t,1)})}),s},emit(){const s=this;if(s.eventsListeners&&!s.destroyed&&s.eventsListeners){let e,i,n;for(var t=arguments.length,a=new Array(t),r=0;r<t;r++)a[r]=arguments[r];n="string"==typeof a[0]||Array.isArray(a[0])?(e=a[0],i=a.slice(1,a.length),s):(e=a[0].events,i=a[0].data,a[0].context||s),i.unshift(n),(Array.isArray(e)?e:e.split(" ")).forEach(t=>{s.eventsAnyListeners&&s.eventsAnyListeners.length&&s.eventsAnyListeners.forEach(e=>{e.apply(n,[t,...i])}),s.eventsListeners&&s.eventsListeners[t]&&s.eventsListeners[t].forEach(e=>{e.apply(n,i)})})}return s}},update:{updateSize:function(){var e=this;let t,i;var n=e.$el;t=void 0!==e.params.width&&null!==e.params.width?e.params.width:n[0].clientWidth,i=void 0!==e.params.height&&null!==e.params.height?e.params.height:n[0].clientHeight,0===t&&e.isHorizontal()||0===i&&e.isVertical()||(t=t-parseInt(n.css("padding-left")||0,10)-parseInt(n.css("padding-right")||0,10),i=i-parseInt(n.css("padding-top")||0,10)-parseInt(n.css("padding-bottom")||0,10),Number.isNaN(t)&&(t=0),Number.isNaN(i)&&(i=0),Object.assign(e,{width:t,height:i,size:e.isHorizontal()?t:i}))},updateSlides:function(){const i=this;function n(e){return i.isHorizontal()?e:{width:"height","margin-top":"margin-left","margin-bottom ":"margin-right","margin-left":"margin-top","margin-right":"margin-bottom","padding-left":"padding-top","padding-right":"padding-bottom",marginRight:"marginBottom"}[e]}function s(e,t){return parseFloat(e.getPropertyValue(n(t))||0)}const a=i.params,{$wrapperEl:r,size:o,rtlTranslate:l,wrongRTL:c}=i,d=i.virtual&&a.virtual.enabled,e=(d?i.virtual:i).slides.length,u=r.children("."+i.params.slideClass),p=(d?i.virtual.slides:u).length;let h=[];const m=[],g=[];let f=a.slidesOffsetBefore,b=("function"==typeof f&&(f=a.slidesOffsetBefore.call(i)),a.slidesOffsetAfter);"function"==typeof b&&(b=a.slidesOffsetAfter.call(i));var v=i.snapGrid.length,y=i.slidesGrid.length;let w=a.spaceBetween,_=-f,E=0,x=0;if(void 0!==o){"string"==typeof w&&0<=w.indexOf("%")&&(w=parseFloat(w.replace("%",""))/100*o),i.virtualSize=-w,l?u.css({marginLeft:"",marginBottom:"",marginTop:""}):u.css({marginRight:"",marginBottom:"",marginTop:""}),a.centeredSlides&&a.cssMode&&(S(i.wrapperEl,"--swiper-centered-offset-before",""),S(i.wrapperEl,"--swiper-centered-offset-after",""));var T=a.grid&&1<a.grid.rows&&i.grid;let t;T&&i.grid.initSlides(p);var C="auto"===a.slidesPerView&&a.breakpoints&&0<Object.keys(a.breakpoints).filter(e=>void 0!==a.breakpoints[e].slidesPerView).length;for(let e=0;e<p;e+=1){t=0;const l=u.eq(e);if(T&&i.grid.updateSlide(e,l,p,n),"none"!==l.css("display")){if("auto"===a.slidesPerView){C&&(u[e].style[n("width")]="");const o=getComputedStyle(l[0]),c=l[0].style.transform,d=l[0].style.webkitTransform;if(c&&(l[0].style.transform="none"),d&&(l[0].style.webkitTransform="none"),a.roundLengths)t=i.isHorizontal()?l.outerWidth(!0):l.outerHeight(!0);else{const i=s(o,"width"),n=s(o,"padding-left"),a=s(o,"padding-right"),r=s(o,"margin-left"),c=s(o,"margin-right"),d=o.getPropertyValue("box-sizing");if(d&&"border-box"===d)t=i+r+c;else{const{clientWidth:s,offsetWidth:o}=l[0];t=i+n+a+r+c+(o-s)}}c&&(l[0].style.transform=c),d&&(l[0].style.webkitTransform=d),a.roundLengths&&(t=Math.floor(t))}else t=(o-(a.slidesPerView-1)*w)/a.slidesPerView,a.roundLengths&&(t=Math.floor(t)),u[e]&&(u[e].style[n("width")]=t+"px");u[e]&&(u[e].swiperSlideSize=t),g.push(t),a.centeredSlides?(_=_+t/2+E/2+w,0===E&&0!==e&&(_=_-o/2-w),0===e&&(_=_-o/2-w),Math.abs(_)<.001&&(_=0),a.roundLengths&&(_=Math.floor(_)),x%a.slidesPerGroup==0&&h.push(_),m.push(_)):(a.roundLengths&&(_=Math.floor(_)),(x-Math.min(i.params.slidesPerGroupSkip,x))%i.params.slidesPerGroup==0&&h.push(_),m.push(_),_=_+t+w),i.virtualSize+=t+w,E=t,x+=1}}if(i.virtualSize=Math.max(i.virtualSize,o)+b,l&&c&&("slide"===a.effect||"coverflow"===a.effect)&&r.css({width:i.virtualSize+a.spaceBetween+"px"}),a.setWrapperSize&&r.css({[n("width")]:i.virtualSize+a.spaceBetween+"px"}),T&&i.grid.updateWrapperSize(t,h,n),!a.centeredSlides){const n=[];for(let t=0;t<h.length;t+=1){let e=h[t];a.roundLengths&&(e=Math.floor(e)),h[t]<=i.virtualSize-o&&n.push(e)}h=n,1<Math.floor(i.virtualSize-o)-Math.floor(h[h.length-1])&&h.push(i.virtualSize-o)}if(0===h.length&&(h=[0]),0!==a.spaceBetween){const s=i.isHorizontal()&&l?"marginLeft":n("marginRight");u.filter((e,t)=>!a.cssMode||t!==u.length-1).css({[s]:w+"px"})}if(a.centeredSlides&&a.centeredSlidesBounds){let t=0;g.forEach(e=>{t+=e+(a.spaceBetween||0)});const n=(t-=a.spaceBetween)-o;h=h.map(e=>e<0?-f:e>n?n+b:e)}if(a.centerInsufficientSlides){let t=0;if(g.forEach(e=>{t+=e+(a.spaceBetween||0)}),(t-=a.spaceBetween)<o){const n=(o-t)/2;h.forEach((e,t)=>{h[t]=e-n}),m.forEach((e,t)=>{m[t]=e+n})}}if(Object.assign(i,{slides:u,snapGrid:h,slidesGrid:m,slidesSizesGrid:g}),a.centeredSlides&&a.cssMode&&!a.centeredSlidesBounds){S(i.wrapperEl,"--swiper-centered-offset-before",-h[0]+"px"),S(i.wrapperEl,"--swiper-centered-offset-after",i.size/2-g[g.length-1]/2+"px");const n=-i.snapGrid[0],s=-i.slidesGrid[0];i.snapGrid=i.snapGrid.map(e=>e+n),i.slidesGrid=i.slidesGrid.map(e=>e+s)}if(p!==e&&i.emit("slidesLengthChange"),h.length!==v&&(i.params.watchOverflow&&i.checkOverflow(),i.emit("snapGridLengthChange")),m.length!==y&&i.emit("slidesGridLengthChange"),a.watchSlidesProgress&&i.updateSlidesOffset(),!(d||a.cssMode||"slide"!==a.effect&&"fade"!==a.effect)){const n=a.containerModifierClass+"backface-hidden",s=i.$el.hasClass(n);p<=a.maxBackfaceHiddenSlides?s||i.$el.addClass(n):s&&i.$el.removeClass(n)}}},updateAutoHeight:function(e){const i=this,t=[],n=i.virtual&&i.params.virtual.enabled;let s,a=0;"number"==typeof e?i.setTransition(e):!0===e&&i.setTransition(i.params.speed);var r=t=>(n?i.slides.filter(e=>parseInt(e.getAttribute("data-swiper-slide-index"),10)===t):i.slides.eq(t))[0];if("auto"!==i.params.slidesPerView&&1<i.params.slidesPerView)if(i.params.centeredSlides)(i.visibleSlides||L([])).each(e=>{t.push(e)});else for(s=0;s<Math.ceil(i.params.slidesPerView);s+=1){const e=i.activeIndex+s;if(e>i.slides.length&&!n)break;t.push(r(e))}else t.push(r(i.activeIndex));for(s=0;s<t.length;s+=1)if(void 0!==t[s]){const e=t[s].offsetHeight;a=e>a?e:a}!a&&0!==a||i.$wrapperEl.css("height",a+"px")},updateSlidesOffset:function(){var t=this.slides;for(let e=0;e<t.length;e+=1)t[e].swiperSlideOffset=this.isHorizontal()?t[e].offsetLeft:t[e].offsetTop},updateSlidesProgress:function(e){void 0===e&&(e=this&&this.translate||0);var n=this,s=n.params,{slides:a,rtlTranslate:r,snapGrid:o}=n;if(0!==a.length){void 0===a[0].swiperSlideOffset&&n.updateSlidesOffset();let i=r?e:-e;a.removeClass(s.slideVisibleClass),n.visibleSlidesIndexes=[],n.visibleSlides=[];for(let t=0;t<a.length;t+=1){var l=a[t];let e=l.swiperSlideOffset;s.cssMode&&s.centeredSlides&&(e-=a[0].swiperSlideOffset);const L=(i+(s.centeredSlides?n.minTranslate():0)-e)/(l.swiperSlideSize+s.spaceBetween),c=(i-o[0]+(s.centeredSlides?n.minTranslate():0)-e)/(l.swiperSlideSize+s.spaceBetween),d=-(i-e),u=d+n.slidesSizesGrid[t];(0<=d&&d<n.size-1||1<u&&u<=n.size||d<=0&&u>=n.size)&&(n.visibleSlides.push(l),n.visibleSlidesIndexes.push(t),a.eq(t).addClass(s.slideVisibleClass)),l.progress=r?-L:L,l.originalProgress=r?-c:c}n.visibleSlides=L(n.visibleSlides)}},updateProgress:function(e){var t=this;if(void 0===e){const i=t.rtlTranslate?-1:1;e=t&&t.translate&&t.translate*i||0}const i=t.params,n=t.maxTranslate()-t.minTranslate();let{progress:s,isBeginning:a,isEnd:r}=t;var o=a,l=r;r=0==n?(s=0,a=!0):(s=(e-t.minTranslate())/n,a=s<=0,1<=s),Object.assign(t,{progress:s,isBeginning:a,isEnd:r}),(i.watchSlidesProgress||i.centeredSlides&&i.autoHeight)&&t.updateSlidesProgress(e),a&&!o&&t.emit("reachBeginning toEdge"),r&&!l&&t.emit("reachEnd toEdge"),(o&&!a||l&&!r)&&t.emit("fromEdge"),t.emit("progress",s)},updateSlidesClasses:function(){var{slides:e,params:t,$wrapperEl:i,activeIndex:n,realIndex:s}=this,a=this.virtual&&t.virtual.enabled;e.removeClass(`${t.slideActiveClass} ${t.slideNextClass} ${t.slidePrevClass} ${t.slideDuplicateActiveClass} ${t.slideDuplicateNextClass} `+t.slideDuplicatePrevClass),(a=a?this.$wrapperEl.find(`.${t.slideClass}[data-swiper-slide-index="${n}"]`):e.eq(n)).addClass(t.slideActiveClass),t.loop&&(a.hasClass(t.slideDuplicateClass)?i.children(`.${t.slideClass}:not(.${t.slideDuplicateClass})[data-swiper-slide-index="${s}"]`):i.children(`.${t.slideClass}.${t.slideDuplicateClass}[data-swiper-slide-index="${s}"]`)).addClass(t.slideDuplicateActiveClass);let r=a.nextAll("."+t.slideClass).eq(0).addClass(t.slideNextClass),o=(t.loop&&0===r.length&&(r=e.eq(0)).addClass(t.slideNextClass),a.prevAll("."+t.slideClass).eq(0).addClass(t.slidePrevClass));t.loop&&0===o.length&&(o=e.eq(-1)).addClass(t.slidePrevClass),t.loop&&((r.hasClass(t.slideDuplicateClass)?i.children(`.${t.slideClass}:not(.${t.slideDuplicateClass})[data-swiper-slide-index="${r.attr("data-swiper-slide-index")}"]`):i.children(`.${t.slideClass}.${t.slideDuplicateClass}[data-swiper-slide-index="${r.attr("data-swiper-slide-index")}"]`)).addClass(t.slideDuplicateNextClass),(o.hasClass(t.slideDuplicateClass)?i.children(`.${t.slideClass}:not(.${t.slideDuplicateClass})[data-swiper-slide-index="${o.attr("data-swiper-slide-index")}"]`):i.children(`.${t.slideClass}.${t.slideDuplicateClass}[data-swiper-slide-index="${o.attr("data-swiper-slide-index")}"]`)).addClass(t.slideDuplicatePrevClass)),this.emitSlidesClasses()},updateActiveIndex:function(e){var t=this,i=t.rtlTranslate?t.translate:-t.translate,{slidesGrid:n,snapGrid:s,params:a,activeIndex:r,realIndex:o,snapIndex:l}=t;let c,d=e;if(void 0===d){for(let e=0;e<n.length;e+=1)void 0!==n[e+1]?i>=n[e]&&i<n[e+1]-(n[e+1]-n[e])/2?d=e:i>=n[e]&&i<n[e+1]&&(d=e+1):i>=n[e]&&(d=e);a.normalizeSlideIndex&&(d<0||void 0===d)&&(d=0)}if(0<=s.indexOf(i))c=s.indexOf(i);else{const e=Math.min(a.slidesPerGroupSkip,d);c=e+Math.floor((d-e)/a.slidesPerGroup)}c>=s.length&&(c=s.length-1),d===r?c!==l&&(t.snapIndex=c,t.emit("snapIndexChange")):(e=parseInt(t.slides.eq(d).attr("data-swiper-slide-index")||d,10),Object.assign(t,{snapIndex:c,realIndex:e,previousIndex:r,activeIndex:d}),t.emit("activeIndexChange"),t.emit("snapIndexChange"),o!==e&&t.emit("realIndexChange"),(t.initialized||t.params.runCallbacksOnInit)&&t.emit("slideChange"))},updateClickedSlide:function(e){var t=this,i=t.params,n=L(e).closest("."+i.slideClass)[0];let s,a=!1;if(n)for(let e=0;e<t.slides.length;e+=1)if(t.slides[e]===n){a=!0,s=e;break}n&&a?(t.clickedSlide=n,t.virtual&&t.params.virtual.enabled?t.clickedIndex=parseInt(L(n).attr("data-swiper-slide-index"),10):t.clickedIndex=s,i.slideToClickedSlide&&void 0!==t.clickedIndex&&t.clickedIndex!==t.activeIndex&&t.slideToClickedSlide()):(t.clickedSlide=void 0,t.clickedIndex=void 0)}},translate:{getTranslate:function(e){void 0===e&&(e=this.isHorizontal()?"x":"y");var{params:t,rtlTranslate:i,translate:n,$wrapperEl:s}=this;if(t.virtualTranslate)return i?-n:n;if(t.cssMode)return n;let a=I(s[0],e);return(a=i?-a:a)||0},setTranslate:function(e,t){var i=this,{rtlTranslate:n,params:s,$wrapperEl:a,wrapperEl:r,progress:o}=i;let l=0,c=0;i.isHorizontal()?l=n?-e:e:c=e,s.roundLengths&&(l=Math.floor(l),c=Math.floor(c)),s.cssMode?r[i.isHorizontal()?"scrollLeft":"scrollTop"]=i.isHorizontal()?-l:-c:s.virtualTranslate||a.transform(`translate3d(${l}px, ${c}px, 0px)`),i.previousTranslate=i.translate,i.translate=i.isHorizontal()?l:c;n=i.maxTranslate()-i.minTranslate();(0==n?0:(e-i.minTranslate())/n)!==o&&i.updateProgress(e),i.emit("setTranslate",i.translate,t)},minTranslate:function(){return-this.snapGrid[0]},maxTranslate:function(){return-this.snapGrid[this.snapGrid.length-1]},translateTo:function(e,t,i,n,s){void 0===e&&(e=0),void 0===t&&(t=this.params.speed),void 0===i&&(i=!0),void 0===n&&(n=!0);const a=this,{params:r,wrapperEl:o}=a;if(a.animating&&r.preventInteractionOnTransition)return!1;var l=a.minTranslate(),c=a.maxTranslate(),l=n&&l<e?l:n&&e<c?c:e;if(a.updateProgress(l),r.cssMode){const e=a.isHorizontal();if(0===t)o[e?"scrollLeft":"scrollTop"]=-l;else{if(!a.support.smoothScroll)return v({swiper:a,targetPosition:-l,side:e?"left":"top"}),!0;o.scrollTo({[e?"left":"top"]:-l,behavior:"smooth"})}}else 0===t?(a.setTransition(0),a.setTranslate(l),i&&(a.emit("beforeTransitionStart",t,s),a.emit("transitionEnd"))):(a.setTransition(t),a.setTranslate(l),i&&(a.emit("beforeTransitionStart",t,s),a.emit("transitionStart")),a.animating||(a.animating=!0,a.onTranslateToWrapperTransitionEnd||(a.onTranslateToWrapperTransitionEnd=function(e){a&&!a.destroyed&&e.target===this&&(a.$wrapperEl[0].removeEventListener("transitionend",a.onTranslateToWrapperTransitionEnd),a.$wrapperEl[0].removeEventListener("webkitTransitionEnd",a.onTranslateToWrapperTransitionEnd),a.onTranslateToWrapperTransitionEnd=null,delete a.onTranslateToWrapperTransitionEnd,i)&&a.emit("transitionEnd")}),a.$wrapperEl[0].addEventListener("transitionend",a.onTranslateToWrapperTransitionEnd),a.$wrapperEl[0].addEventListener("webkitTransitionEnd",a.onTranslateToWrapperTransitionEnd)));return!0}},transition:{setTransition:function(e,t){this.params.cssMode||this.$wrapperEl.transition(e),this.emit("setTransition",e,t)},transitionStart:function(e,t){void 0===e&&(e=!0);var i=this["params"];i.cssMode||(i.autoHeight&&this.updateAutoHeight(),u({swiper:this,runCallbacks:e,direction:t,step:"Start"}))},transitionEnd:function(e,t){void 0===e&&(e=!0);var i=this["params"];this.animating=!1,i.cssMode||(this.setTransition(0),u({swiper:this,runCallbacks:e,direction:t,step:"End"}))}},slide:{slideTo:function(e,t,i,n,s){if(void 0===t&&(t=this.params.speed),void 0===i&&(i=!0),"number"!=typeof(e=void 0===e?0:e)&&"string"!=typeof e)throw new Error(`The 'index' argument cannot have type other than 'number' or 'string'. [${typeof e}] given.`);if("string"==typeof e){const t=parseInt(e,10);if(!isFinite(t))throw new Error(`The passed-in 'index' (string) couldn't be converted to 'number'. [${e}] given.`);e=t}const a=this;let r=e;r<0&&(r=0);var{params:e,snapGrid:o,slidesGrid:l,previousIndex:c,activeIndex:d,rtlTranslate:u,wrapperEl:p,enabled:h}=a;if(a.animating&&e.preventInteractionOnTransition||!h&&!n&&!s)return!1;h=Math.min(a.params.slidesPerGroupSkip,r);let m=h+Math.floor((r-h)/a.params.slidesPerGroup);var g=-o[m=m>=o.length?o.length-1:m];if(e.normalizeSlideIndex)for(let e=0;e<l.length;e+=1){const t=-Math.floor(100*g),i=Math.floor(100*l[e]),n=Math.floor(100*l[e+1]);void 0!==l[e+1]?t>=i&&t<n-(n-i)/2?r=e:t>=i&&t<n&&(r=e+1):t>=i&&(r=e)}if(a.initialized&&r!==d){if(!a.allowSlideNext&&g<a.translate&&g<a.minTranslate())return!1;if(!a.allowSlidePrev&&g>a.translate&&g>a.maxTranslate()&&(d||0)!==r)return!1}let f;if(r!==(c||0)&&i&&a.emit("beforeSlideChangeStart"),a.updateProgress(g),f=r>d?"next":r<d?"prev":"reset",u&&-g===a.translate||!u&&g===a.translate)return a.updateActiveIndex(r),e.autoHeight&&a.updateAutoHeight(),a.updateSlidesClasses(),"slide"!==e.effect&&a.setTranslate(g),"reset"!=f&&(a.transitionStart(i,f),a.transitionEnd(i,f)),!1;if(e.cssMode){const e=a.isHorizontal(),i=u?g:-g;if(0===t){const t=a.virtual&&a.params.virtual.enabled;t&&(a.wrapperEl.style.scrollSnapType="none",a._immediateVirtual=!0),p[e?"scrollLeft":"scrollTop"]=i,t&&requestAnimationFrame(()=>{a.wrapperEl.style.scrollSnapType="",a._swiperImmediateVirtual=!1})}else{if(!a.support.smoothScroll)return v({swiper:a,targetPosition:i,side:e?"left":"top"}),!0;p.scrollTo({[e?"left":"top"]:i,behavior:"smooth"})}}else a.setTransition(t),a.setTranslate(g),a.updateActiveIndex(r),a.updateSlidesClasses(),a.emit("beforeTransitionStart",t,n),a.transitionStart(i,f),0===t?a.transitionEnd(i,f):a.animating||(a.animating=!0,a.onSlideToWrapperTransitionEnd||(a.onSlideToWrapperTransitionEnd=function(e){a&&!a.destroyed&&e.target===this&&(a.$wrapperEl[0].removeEventListener("transitionend",a.onSlideToWrapperTransitionEnd),a.$wrapperEl[0].removeEventListener("webkitTransitionEnd",a.onSlideToWrapperTransitionEnd),a.onSlideToWrapperTransitionEnd=null,delete a.onSlideToWrapperTransitionEnd,a.transitionEnd(i,f))}),a.$wrapperEl[0].addEventListener("transitionend",a.onSlideToWrapperTransitionEnd),a.$wrapperEl[0].addEventListener("webkitTransitionEnd",a.onSlideToWrapperTransitionEnd));return!0},slideToLoop:function(e,t,i,n){if(void 0===t&&(t=this.params.speed),void 0===i&&(i=!0),"string"==typeof(e=void 0===e?0:e)){const t=parseInt(e,10);if(!isFinite(t))throw new Error(`The passed-in 'index' (string) couldn't be converted to 'number'. [${e}] given.`);e=t}let s=e;return this.params.loop&&(s+=this.loopedSlides),this.slideTo(s,t,i,n)},slideNext:function(e,t,i){void 0===e&&(e=this.params.speed),void 0===t&&(t=!0);var n=this,{animating:s,enabled:a,params:r}=n;if(!a)return n;let o=r.slidesPerGroup;"auto"===r.slidesPerView&&1===r.slidesPerGroup&&r.slidesPerGroupAuto&&(o=Math.max(n.slidesPerViewDynamic("current",!0),1));a=n.activeIndex<r.slidesPerGroupSkip?1:o;if(r.loop){if(s&&r.loopPreventsSlide)return!1;n.loopFix(),n._clientLeft=n.$wrapperEl[0].clientLeft}return r.rewind&&n.isEnd?n.slideTo(0,e,t,i):n.slideTo(n.activeIndex+a,e,t,i)},slidePrev:function(e,t,i){void 0===e&&(e=this.params.speed),void 0===t&&(t=!0);const n=this,{params:s,animating:a,snapGrid:r,slidesGrid:o,rtlTranslate:l,enabled:c}=n;if(!c)return n;if(s.loop){if(a&&s.loopPreventsSlide)return!1;n.loopFix(),n._clientLeft=n.$wrapperEl[0].clientLeft}function d(e){return e<0?-Math.floor(Math.abs(e)):Math.floor(e)}const u=d(l?n.translate:-n.translate),p=r.map(e=>d(e));let h=r[p.indexOf(u)-1];if(void 0===h&&s.cssMode){let i;r.forEach((e,t)=>{u>=e&&(i=t)}),void 0!==i&&(h=r[0<i?i-1:i])}let m=0;if(void 0!==h&&((m=o.indexOf(h))<0&&(m=n.activeIndex-1),"auto"===s.slidesPerView)&&1===s.slidesPerGroup&&s.slidesPerGroupAuto&&(m=m-n.slidesPerViewDynamic("previous",!0)+1,m=Math.max(m,0)),s.rewind&&n.isBeginning){const s=n.params.virtual&&n.params.virtual.enabled&&n.virtual?n.virtual.slides.length-1:n.slides.length-1;return n.slideTo(s,e,t,i)}return n.slideTo(m,e,t,i)},slideReset:function(e,t,i){return void 0===e&&(e=this.params.speed),this.slideTo(this.activeIndex,e,t=void 0===t?!0:t,i)},slideToClosest:function(e,t,i,n){void 0===e&&(e=this.params.speed),void 0===t&&(t=!0),void 0===n&&(n=.5);var s=this;let a=s.activeIndex;var r=Math.min(s.params.slidesPerGroupSkip,a),r=r+Math.floor((a-r)/s.params.slidesPerGroup),o=s.rtlTranslate?s.translate:-s.translate;if(o>=s.snapGrid[r]){const e=s.snapGrid[r];o-e>(s.snapGrid[r+1]-e)*n&&(a+=s.params.slidesPerGroup)}else{const e=s.snapGrid[r-1];o-e<=(s.snapGrid[r]-e)*n&&(a-=s.params.slidesPerGroup)}return a=Math.max(a,0),a=Math.min(a,s.slidesGrid.length-1),s.slideTo(a,e,t,i)},slideToClickedSlide:function(){const e=this,{params:t,$wrapperEl:i}=e,n="auto"===t.slidesPerView?e.slidesPerViewDynamic():t.slidesPerView;let s,a=e.clickedIndex;t.loop?e.animating||(s=parseInt(L(e.clickedSlide).attr("data-swiper-slide-index"),10),t.centeredSlides?a<e.loopedSlides-n/2||a>e.slides.length-e.loopedSlides+n/2?(e.loopFix(),a=i.children(`.${t.slideClass}[data-swiper-slide-index="${s}"]:not(.${t.slideDuplicateClass})`).eq(0).index(),C(()=>{e.slideTo(a)})):e.slideTo(a):a>e.slides.length-n?(e.loopFix(),a=i.children(`.${t.slideClass}[data-swiper-slide-index="${s}"]:not(.${t.slideDuplicateClass})`).eq(0).index(),C(()=>{e.slideTo(a)})):e.slideTo(a)):e.slideTo(a)}},loop:{loopCreate:function(){const t=this,i=T(),{params:n,$wrapperEl:e}=t,s=0<e.children().length?L(e.children()[0].parentNode):e;s.children(`.${n.slideClass}.`+n.slideDuplicateClass).remove();let a=s.children("."+n.slideClass);if(n.loopFillGroupWithBlank){const t=n.slidesPerGroup-a.length%n.slidesPerGroup;if(t!==n.slidesPerGroup){for(let e=0;e<t;e+=1){const t=L(i.createElement("div")).addClass(n.slideClass+" "+n.slideBlankClass);s.append(t)}a=s.children("."+n.slideClass)}}"auto"!==n.slidesPerView||n.loopedSlides||(n.loopedSlides=a.length),t.loopedSlides=Math.ceil(parseFloat(n.loopedSlides||n.slidesPerView,10)),t.loopedSlides+=n.loopAdditionalSlides,t.loopedSlides>a.length&&t.params.loopedSlidesLimit&&(t.loopedSlides=a.length);var r=[],o=[];a.each((e,t)=>{L(e).attr("data-swiper-slide-index",t)});for(let e=0;e<t.loopedSlides;e+=1){const t=e-Math.floor(e/a.length)*a.length;o.push(a.eq(t)[0]),r.unshift(a.eq(a.length-t-1)[0])}for(let e=0;e<o.length;e+=1)s.append(L(o[e].cloneNode(!0)).addClass(n.slideDuplicateClass));for(let e=r.length-1;0<=e;--e)s.prepend(L(r[e].cloneNode(!0)).addClass(n.slideDuplicateClass))},loopFix:function(){var e=this,{activeIndex:t,slides:i,loopedSlides:n,allowSlidePrev:s,allowSlideNext:a,snapGrid:r,rtlTranslate:o}=(e.emit("beforeLoopFix"),e);let l;e.allowSlidePrev=!0,e.allowSlideNext=!0;r=-r[t]-e.getTranslate();t<n?(l=i.length-3*n+t,l+=n,e.slideTo(l,0,!1,!0)&&0!=r&&e.setTranslate((o?-e.translate:e.translate)-r)):t>=i.length-n&&(l=-i.length+t+n,l+=n,e.slideTo(l,0,!1,!0))&&0!=r&&e.setTranslate((o?-e.translate:e.translate)-r),e.allowSlidePrev=s,e.allowSlideNext=a,e.emit("loopFix")},loopDestroy:function(){var{$wrapperEl:e,params:t,slides:i}=this;e.children(`.${t.slideClass}.${t.slideDuplicateClass},.${t.slideClass}.`+t.slideBlankClass).remove(),i.removeAttr("data-swiper-slide-index")}},grabCursor:{setGrabCursor:function(e){var t=this;t.support.touch||!t.params.simulateTouch||t.params.watchOverflow&&t.isLocked||t.params.cssMode||((t="container"===t.params.touchEventsTarget?t.el:t.wrapperEl).style.cursor="move",t.style.cursor=e?"grabbing":"grab")},unsetGrabCursor:function(){var e=this;e.support.touch||e.params.watchOverflow&&e.isLocked||e.params.cssMode||(e["container"===e.params.touchEventsTarget?"el":"wrapperEl"].style.cursor="")}},events:{attachEvents:function(){var e=this,t=T(),{params:i,support:n}=e;e.onTouchStart=function(e){var n=this,s=T(),a=A(),r=n.touchEventsData,{params:o,touches:l,enabled:c}=n;if(c&&(!n.animating||!o.preventInteractionOnTransition)){!n.animating&&o.cssMode&&o.loop&&n.loopFix();let t=e,i=L((t=t.originalEvent?t.originalEvent:t).target);if(("wrapper"!==o.touchEventsTarget||i.closest(n.wrapperEl).length)&&(r.isTouchEvent="touchstart"===t.type,r.isTouchEvent||!("which"in t)||3!==t.which)&&!(!r.isTouchEvent&&"button"in t&&0<t.button||r.isTouched&&r.isMoved)){var c=!!o.noSwipingClass&&""!==o.noSwipingClass,d=e.composedPath?e.composedPath():e.path,c=(c&&t.target&&t.target.shadowRoot&&d&&(i=L(d[0])),o.noSwipingSelector||"."+o.noSwipingClass),d=!(!t.target||!t.target.shadowRoot);if(o.noSwiping&&(d?function(n,e){return function e(t){var i;return t&&t!==T()&&t!==A()&&((i=(t=t.assignedSlot?t.assignedSlot:t).closest(n))||t.getRootNode)?i||e(t.getRootNode().host):null}(e=void 0===e?this:e)}(c,i[0]):i.closest(c)[0]))n.allowClick=!0;else if(!o.swipeHandler||i.closest(o.swipeHandler)[0]){l.currentX=("touchstart"===t.type?t.targetTouches[0]:t).pageX,l.currentY=("touchstart"===t.type?t.targetTouches[0]:t).pageY;var d=l.currentX,c=l.currentY,u=o.edgeSwipeDetection||o.iOSEdgeSwipeDetection,p=o.edgeSwipeThreshold||o.iOSEdgeSwipeThreshold;if(u&&(d<=p||d>=a.innerWidth-p)){if("prevent"!==u)return;e.preventDefault()}if(Object.assign(r,{isTouched:!0,isMoved:!1,allowTouchCallbacks:!0,isScrolling:void 0,startMoving:void 0}),l.startX=d,l.startY=c,r.touchStartTime=b(),n.allowClick=!0,n.updateSize(),n.swipeDirection=void 0,0<o.threshold&&(r.allowThresholdMove=!1),"touchstart"!==t.type){let e=!0;i.is(r.focusableElements)&&(e=!1,"SELECT"===i[0].nodeName)&&(r.isTouched=!1),s.activeElement&&L(s.activeElement).is(r.focusableElements)&&s.activeElement!==i[0]&&s.activeElement.blur();const T=e&&n.allowTouchMove&&o.touchStartPreventDefault;!o.touchStartForcePreventDefault&&!T||i[0].isContentEditable||t.preventDefault()}n.params.freeMode&&n.params.freeMode.enabled&&n.freeMode&&n.animating&&!o.cssMode&&n.freeMode.onTouchStart(),n.emit("touchStart",t)}}}}.bind(e),e.onTouchMove=function(e){var s=T(),a=this,r=a.touchEventsData,{params:o,touches:l,rtlTranslate:c,enabled:t}=a;if(t){let n=e;if(n.originalEvent&&(n=n.originalEvent),r.isTouched){if(!r.isTouchEvent||"touchmove"===n.type){t="touchmove"===n.type&&n.targetTouches&&(n.targetTouches[0]||n.changedTouches[0]),e=("touchmove"===n.type?t:n).pageX,t=("touchmove"===n.type?t:n).pageY;if(n.preventedByNestedSwiper)l.startX=e,l.startY=t;else if(a.allowTouchMove){if(r.isTouchEvent&&o.touchReleaseOnEdges&&!o.loop)if(a.isVertical()){if(t<l.startY&&a.translate<=a.maxTranslate()||t>l.startY&&a.translate>=a.minTranslate())return r.isTouched=!1,void(r.isMoved=!1)}else if(e<l.startX&&a.translate<=a.maxTranslate()||e>l.startX&&a.translate>=a.minTranslate())return;if(r.isTouchEvent&&s.activeElement&&n.target===s.activeElement&&L(n.target).is(r.focusableElements))r.isMoved=!0,a.allowClick=!1;else if(r.allowTouchCallbacks&&a.emit("touchMove",n),!(n.targetTouches&&1<n.targetTouches.length)){l.currentX=e,l.currentY=t;var i,s=l.currentX-l.startX,d=l.currentY-l.startY;if(!(a.params.threshold&&Math.sqrt(s**2+d**2)<a.params.threshold))if(void 0===r.isScrolling&&(a.isHorizontal()&&l.currentY===l.startY||a.isVertical()&&l.currentX===l.startX?r.isScrolling=!1:25<=s*s+d*d&&(i=180*Math.atan2(Math.abs(d),Math.abs(s))/Math.PI,r.isScrolling=a.isHorizontal()?i>o.touchAngle:90-i>o.touchAngle)),r.isScrolling&&a.emit("touchMoveOpposite",n),void 0!==r.startMoving||l.currentX===l.startX&&l.currentY===l.startY||(r.startMoving=!0),r.isScrolling)r.isTouched=!1;else if(r.startMoving){a.allowClick=!1,!o.cssMode&&n.cancelable&&n.preventDefault(),o.touchMoveStopPropagation&&!o.nested&&n.stopPropagation(),r.isMoved||(o.loop&&!o.cssMode&&a.loopFix(),r.startTranslate=a.getTranslate(),a.setTransition(0),a.animating&&a.$wrapperEl.trigger("webkitTransitionEnd transitionend"),r.allowMomentumBounce=!1,!o.grabCursor||!0!==a.allowSlideNext&&!0!==a.allowSlidePrev||a.setGrabCursor(!0),a.emit("sliderFirstMove",n)),a.emit("sliderMove",n),r.isMoved=!0;let e=a.isHorizontal()?s:d,t=(l.diff=e,e*=o.touchRatio,c&&(e=-e),a.swipeDirection=0<e?"prev":"next",r.currentTranslate=e+r.startTranslate,!0),i=o.resistanceRatio;if(o.touchReleaseOnEdges&&(i=0),0<e&&r.currentTranslate>a.minTranslate()?(t=!1,o.resistance&&(r.currentTranslate=a.minTranslate()-1+(-a.minTranslate()+r.startTranslate+e)**i)):e<0&&r.currentTranslate<a.maxTranslate()&&(t=!1,o.resistance)&&(r.currentTranslate=a.maxTranslate()+1-(a.maxTranslate()-r.startTranslate-e)**i),t&&(n.preventedByNestedSwiper=!0),!a.allowSlideNext&&"next"===a.swipeDirection&&r.currentTranslate<r.startTranslate&&(r.currentTranslate=r.startTranslate),!a.allowSlidePrev&&"prev"===a.swipeDirection&&r.currentTranslate>r.startTranslate&&(r.currentTranslate=r.startTranslate),a.allowSlidePrev||a.allowSlideNext||(r.currentTranslate=r.startTranslate),0<o.threshold){if(!(Math.abs(e)>o.threshold||r.allowThresholdMove))return void(r.currentTranslate=r.startTranslate);if(!r.allowThresholdMove)return r.allowThresholdMove=!0,l.startX=l.currentX,l.startY=l.currentY,r.currentTranslate=r.startTranslate,void(l.diff=a.isHorizontal()?l.currentX-l.startX:l.currentY-l.startY)}o.followFinger&&!o.cssMode&&((o.freeMode&&o.freeMode.enabled&&a.freeMode||o.watchSlidesProgress)&&(a.updateActiveIndex(),a.updateSlidesClasses()),a.params.freeMode&&o.freeMode.enabled&&a.freeMode&&a.freeMode.onTouchMove(),a.updateProgress(r.currentTranslate),a.setTranslate(r.currentTranslate))}}}else L(n.target).is(r.focusableElements)||(a.allowClick=!1),r.isTouched&&(Object.assign(l,{startX:e,startY:t,currentX:e,currentY:t}),r.touchStartTime=b())}}else r.startMoving&&r.isScrolling&&a.emit("touchMoveOpposite",n)}}.bind(e),e.onTouchEnd=function(a){const r=this,e=r.touchEventsData,{params:o,touches:t,rtlTranslate:i,slidesGrid:l,enabled:n}=r;if(n){let s=a;if(s.originalEvent&&(s=s.originalEvent),e.allowTouchCallbacks&&r.emit("touchEnd",s),e.allowTouchCallbacks=!1,e.isTouched){o.grabCursor&&e.isMoved&&e.isTouched&&(!0===r.allowSlideNext||!0===r.allowSlidePrev)&&r.setGrabCursor(!1);var c,d=b(),u=d-e.touchStartTime;if(r.allowClick){const a=s.path||s.composedPath&&s.composedPath();r.updateClickedSlide(a&&a[0]||s.target),r.emit("tap click",s),u<300&&d-e.lastClickTime<300&&r.emit("doubleTap doubleClick",s)}if(e.lastClickTime=b(),C(()=>{r.destroyed||(r.allowClick=!0)}),e.isTouched&&e.isMoved&&r.swipeDirection&&0!==t.diff&&e.currentTranslate!==e.startTranslate){if(e.isTouched=!1,e.isMoved=!1,e.startMoving=!1,c=o.followFinger?i?r.translate:-r.translate:-e.currentTranslate,!o.cssMode)if(r.params.freeMode&&o.freeMode.enabled)r.freeMode.onTouchEnd({currentPos:c});else{let t=0,i=r.slidesSizesGrid[0];for(let e=0;e<l.length;e+=e<o.slidesPerGroupSkip?1:o.slidesPerGroup){const r=e<o.slidesPerGroupSkip-1?1:o.slidesPerGroup;void 0!==l[e+r]?c>=l[e]&&c<l[e+r]&&(t=e,i=l[e+r]-l[e]):c>=l[e]&&(t=e,i=l[l.length-1]-l[l.length-2])}let e=null,n=null;o.rewind&&(r.isBeginning?n=r.params.virtual&&r.params.virtual.enabled&&r.virtual?r.virtual.slides.length-1:r.slides.length-1:r.isEnd&&(e=0));a=(c-l[t])/i,d=t<o.slidesPerGroupSkip-1?1:o.slidesPerGroup;u>o.longSwipesMs?o.longSwipes?("next"===r.swipeDirection&&(a>=o.longSwipesRatio?r.slideTo(o.rewind&&r.isEnd?e:t+d):r.slideTo(t)),"prev"===r.swipeDirection&&(a>1-o.longSwipesRatio?r.slideTo(t+d):null!==n&&a<0&&Math.abs(a)>o.longSwipesRatio?r.slideTo(n):r.slideTo(t))):r.slideTo(r.activeIndex):o.shortSwipes?!r.navigation||s.target!==r.navigation.nextEl&&s.target!==r.navigation.prevEl?("next"===r.swipeDirection&&r.slideTo(null!==e?e:t+d),"prev"===r.swipeDirection&&r.slideTo(null!==n?n:t)):s.target===r.navigation.nextEl?r.slideTo(t+d):r.slideTo(t):r.slideTo(r.activeIndex)}}else e.isTouched=!1,e.isMoved=!1,e.startMoving=!1}else e.isMoved&&o.grabCursor&&r.setGrabCursor(!1),e.isMoved=!1,e.startMoving=!1}}.bind(e),i.cssMode&&(e.onScroll=function(){var e=this,{wrapperEl:t,rtlTranslate:i,enabled:n}=e;n&&(e.previousTranslate=e.translate,e.isHorizontal()?e.translate=-t.scrollLeft:e.translate=-t.scrollTop,0===e.translate&&(e.translate=0),e.updateActiveIndex(),e.updateSlidesClasses(),(0==(n=e.maxTranslate()-e.minTranslate())?0:(e.translate-e.minTranslate())/n)!==e.progress&&e.updateProgress(i?-e.translate:e.translate),e.emit("setTranslate",e.translate,!1))}.bind(e)),e.onClick=function(e){var t=this;t.enabled&&!t.allowClick&&(t.params.preventClicks&&e.preventDefault(),t.params.preventClicksPropagation)&&t.animating&&(e.stopPropagation(),e.stopImmediatePropagation())}.bind(e),n.touch&&!g&&(t.addEventListener("touchstart",R),g=!0),f(e,"on")},detachEvents:function(){f(this,"off")}},breakpoints:{setBreakpoint:function(){const n=this,{activeIndex:e,initialized:t,loopedSlides:i=0,params:s,$el:a}=n,r=s.breakpoints;if(r&&0!==Object.keys(r).length){var o=n.getBreakpoint(r,n.params.breakpointsBase,n.el);if(o&&n.currentBreakpoint!==o){const d=(o in r?r[o]:void 0)||n.originalParams,u=y(n,s),p=y(n,d),h=s.enabled;u&&!p?(a.removeClass(`${s.containerModifierClass}grid ${s.containerModifierClass}grid-column`),n.emitContainerClasses()):!u&&p&&(a.addClass(s.containerModifierClass+"grid"),(d.grid.fill&&"column"===d.grid.fill||!d.grid.fill&&"column"===s.grid.fill)&&a.addClass(s.containerModifierClass+"grid-column"),n.emitContainerClasses()),["navigation","pagination","scrollbar"].forEach(e=>{var t=s[e]&&s[e].enabled,i=d[e]&&d[e].enabled;t&&!i&&n[e].disable(),!t&&i&&n[e].enable()});var l=d.direction&&d.direction!==s.direction,c=s.loop&&(d.slidesPerView!==s.slidesPerView||l),l=(l&&t&&n.changeDirection(),m(n.params,d),n.params.enabled);Object.assign(n,{allowTouchMove:n.params.allowTouchMove,allowSlideNext:n.params.allowSlideNext,allowSlidePrev:n.params.allowSlidePrev}),h&&!l?n.disable():!h&&l&&n.enable(),n.currentBreakpoint=o,n.emit("_beforeBreakpoint",d),c&&t&&(n.loopDestroy(),n.loopCreate(),n.updateSlides(),n.slideTo(e-i+n.loopedSlides,0,!1)),n.emit("breakpoint",d)}}},getBreakpoint:function(e,i,n){if(void 0===i&&(i="window"),e&&("container"!==i||n)){let t=!1;const s=A(),a="window"===i?s.innerHeight:n.clientHeight,r=Object.keys(e).map(e=>{var t;return"string"==typeof e&&0===e.indexOf("@")?(t=parseFloat(e.substr(1)),{value:a*t,point:e}):{value:e,point:e}});r.sort((e,t)=>parseInt(e.value,10)-parseInt(t.value,10));for(let e=0;e<r.length;e+=1){const{point:A,value:a}=r[e];"window"===i?s.matchMedia(`(min-width: ${a}px)`).matches&&(t=A):a<=n.clientWidth&&(t=A)}return t||"max"}}},checkOverflow:{checkOverflow:function(){const e=this,{isLocked:t,params:i}=e,n=i["slidesOffsetBefore"];if(n){const t=e.slides.length-1,i=e.slidesGrid[t]+e.slidesSizesGrid[t]+2*n;e.isLocked=e.size>i}else e.isLocked=1===e.snapGrid.length;!0===i.allowSlideNext&&(e.allowSlideNext=!e.isLocked),!0===i.allowSlidePrev&&(e.allowSlidePrev=!e.isLocked),t&&t!==e.isLocked&&(e.isEnd=!1),t!==e.isLocked&&e.emit(e.isLocked?"lock":"unlock")}},classes:{addClasses:function(){var{classNames:e,params:t,rtl:i,$el:n,device:s,support:a}=this,a=function(e,i){const n=[];return e.forEach(t=>{"object"==typeof t?Object.keys(t).forEach(e=>{t[e]&&n.push(i+e)}):"string"==typeof t&&n.push(i+t)}),n}(["initialized",t.direction,{"pointer-events":!a.touch},{"free-mode":this.params.freeMode&&t.freeMode.enabled},{autoheight:t.autoHeight},{rtl:i},{grid:t.grid&&1<t.grid.rows},{"grid-column":t.grid&&1<t.grid.rows&&"column"===t.grid.fill},{android:s.android},{ios:s.ios},{"css-mode":t.cssMode},{centered:t.cssMode&&t.centeredSlides},{"watch-progress":t.watchSlidesProgress}],t.containerModifierClass);e.push(...a),n.addClass([...e].join(" ")),this.emitContainerClasses()},removeClasses:function(){var{$el:e,classNames:t}=this;e.removeClass(t.join(" ")),this.emitContainerClasses()}},images:{loadImage:function(e,t,i,n,s,a){var r=A();function o(){a&&a()}!(L(e).parent("picture")[0]||e.complete&&s)&&t?((e=new r.Image).onload=o,e.onerror=o,n&&(e.sizes=n),i&&(e.srcset=i),t&&(e.src=t)):o()},preloadImages:function(){const t=this;function i(){null!=t&&t&&!t.destroyed&&(void 0!==t.imagesLoaded&&(t.imagesLoaded+=1),t.imagesLoaded===t.imagesToLoad.length)&&(t.params.updateOnImagesReady&&t.update(),t.emit("imagesReady"))}t.imagesToLoad=t.$el.find("img");for(let e=0;e<t.imagesToLoad.length;e+=1){var n=t.imagesToLoad[e];t.loadImage(n,n.currentSrc||n.getAttribute("src"),n.srcset||n.getAttribute("srcset"),n.sizes||n.getAttribute("sizes"),!0,i)}}}},E={};class x{constructor(){let t,i;for(var u,e=arguments.length,n=new Array(e),s=0;s<e;s++)n[s]=arguments[s];if(1===n.length&&n[0].constructor&&"Object"===Object.prototype.toString.call(n[0]).slice(8,-1)?i=n[0]:[t,i]=n,i=m({},i=i||{}),t&&!i.el&&(i.el=t),i.el&&1<L(i.el).length){const t=[];return L(i.el).each(e=>{e=m({},i,{el:e});t.push(new x(e))}),t}const a=this,r=(a.__swiper__=!0,a.support=p(),a.device=(void 0===(u={userAgent:i.userAgent})&&(u={}),d=d||function(){var e=(void 0===u?{}:u)["userAgent"],t=p(),i=A(),n=i.navigator.platform,e=e||i.navigator.userAgent,s={ios:!1,android:!1},a=i.screen.width,i=i.screen.height,r=e.match(/(Android);?[\s\/]+([\d.]+)?/);let o=e.match(/(iPad).*OS\s([\d_]+)/);var l=e.match(/(iPod)(.*OS\s([\d_]+))?/),c=!o&&e.match(/(iPhone\sOS|iOS)\s([\d_]+)/),d="Win32"===n,n="MacIntel"===n;return!o&&n&&t.touch&&0<=["1024x1366","1366x1024","834x1194","1194x834","834x1112","1112x834","768x1024","1024x768","820x1180","1180x820","810x1080","1080x810"].indexOf(a+"x"+i)&&(o=(o=e.match(/(Version)\/([\d.]+)/))||[0,1,"13_0_0"]),r&&!d&&(s.os="android",s.android=!0),(o||c||l)&&(s.os="ios",s.ios=!0),s}()),a.browser=z(),a.eventsListeners={},a.eventsAnyListeners=[],a.modules=[...a.__modules__],i.modules&&Array.isArray(i.modules)&&a.modules.push(...i.modules),{});a.modules.forEach(e=>{var n,s;e({swiper:a,extendParams:(n=i,s=r,function(e){void 0===e&&(e={});var t=Object.keys(e)[0],i=e[t];"object"==typeof i&&null!==i&&(0<=["navigation","pagination","scrollbar"].indexOf(t)&&!0===n[t]&&(n[t]={auto:!0}),t in n)&&"enabled"in i&&(!0===n[t]&&(n[t]={enabled:!0}),"object"!=typeof n[t]||"enabled"in n[t]||(n[t].enabled=!0),n[t]||(n[t]={enabled:!1})),m(s,e)}),on:a.on.bind(a),once:a.once.bind(a),off:a.off.bind(a),emit:a.emit.bind(a)})});var o,l=m({},w,r);return a.params=m({},l,E,i),a.originalParams=m({},a.params),a.passedParams=m({},i),a.params&&a.params.on&&Object.keys(a.params.on).forEach(e=>{a.on(e,a.params.on[e])}),a.params&&a.params.onAny&&a.onAny(a.params.onAny),a.$=L,Object.assign(a,{enabled:a.params.enabled,el:t,classNames:[],slides:L(),slidesGrid:[],snapGrid:[],slidesSizesGrid:[],isHorizontal:()=>"horizontal"===a.params.direction,isVertical:()=>"vertical"===a.params.direction,activeIndex:0,realIndex:0,isBeginning:!0,isEnd:!1,translate:0,previousTranslate:0,progress:0,velocity:0,animating:!1,allowSlideNext:a.params.allowSlideNext,allowSlidePrev:a.params.allowSlidePrev,touchEvents:(l=["touchstart","touchmove","touchend","touchcancel"],o=["pointerdown","pointermove","pointerup"],a.touchEventsTouch={start:l[0],move:l[1],end:l[2],cancel:l[3]},a.touchEventsDesktop={start:o[0],move:o[1],end:o[2]},a.support.touch||!a.params.simulateTouch?a.touchEventsTouch:a.touchEventsDesktop),touchEventsData:{isTouched:void 0,isMoved:void 0,allowTouchCallbacks:void 0,touchStartTime:void 0,isScrolling:void 0,currentTranslate:void 0,startTranslate:void 0,allowThresholdMove:void 0,focusableElements:a.params.focusableElements,lastClickTime:b(),clickTimeout:void 0,velocities:[],allowMomentumBounce:void 0,isTouchEvent:void 0,startMoving:void 0},allowClick:!0,allowTouchMove:a.params.allowTouchMove,touches:{startX:0,startY:0,currentX:0,currentY:0,diff:0},imagesToLoad:[],imagesLoaded:0}),a.emit("_swiper"),a.params.init&&a.init(),a}enable(){var e=this;e.enabled||(e.enabled=!0,e.params.grabCursor&&e.setGrabCursor(),e.emit("enable"))}disable(){var e=this;e.enabled&&(e.enabled=!1,e.params.grabCursor&&e.unsetGrabCursor(),e.emit("disable"))}setProgress(e,t){var i=this,n=(e=Math.min(Math.max(e,0),1),i.minTranslate()),e=(i.maxTranslate()-n)*e+n;i.translateTo(e,void 0===t?0:t),i.updateActiveIndex(),i.updateSlidesClasses()}emitContainerClasses(){const t=this;var e;t.params._emitClasses&&t.el&&(e=t.el.className.split(" ").filter(e=>0===e.indexOf("swiper")||0===e.indexOf(t.params.containerModifierClass)),t.emit("_containerClasses",e.join(" ")))}getSlideClasses(e){const t=this;return t.destroyed?"":e.className.split(" ").filter(e=>0===e.indexOf("swiper-slide")||0===e.indexOf(t.params.slideClass)).join(" ")}emitSlidesClasses(){const i=this;if(i.params._emitClasses&&i.el){const n=[];i.slides.each(e=>{var t=i.getSlideClasses(e);n.push({slideEl:e,classNames:t}),i.emit("_slideClass",e,t)}),i.emit("_slideClasses",n)}}slidesPerViewDynamic(e,t){void 0===e&&(e="current"),void 0===t&&(t=!1);var{params:i,slides:n,slidesGrid:s,slidesSizesGrid:a,size:r,activeIndex:o}=this;let l=1;if(i.centeredSlides){let t,i=n[o].swiperSlideSize;for(let e=o+1;e<n.length;e+=1)n[e]&&!t&&(i+=n[e].swiperSlideSize,l+=1,i>r)&&(t=!0);for(let e=o-1;0<=e;--e)n[e]&&!t&&(i+=n[e].swiperSlideSize,l+=1,i>r)&&(t=!0)}else if("current"===e)for(let e=o+1;e<n.length;e+=1)(t?s[e]+a[e]-s[o]<r:s[e]-s[o]<r)&&(l+=1);else for(let e=o-1;0<=e;--e)s[o]-s[e]<r&&(l+=1);return l}update(){const t=this;var e,i;function n(){var e=t.rtlTranslate?-1*t.translate:t.translate,e=Math.min(Math.max(e,t.maxTranslate()),t.minTranslate());t.setTranslate(e),t.updateActiveIndex(),t.updateSlidesClasses()}t&&!t.destroyed&&({snapGrid:e,params:i}=t,i.breakpoints&&t.setBreakpoint(),t.updateSize(),t.updateSlides(),t.updateProgress(),t.updateSlidesClasses(),t.params.freeMode&&t.params.freeMode.enabled?(n(),t.params.autoHeight&&t.updateAutoHeight()):(("auto"===t.params.slidesPerView||1<t.params.slidesPerView)&&t.isEnd&&!t.params.centeredSlides?t.slideTo(t.slides.length-1,0,!1,!0):t.slideTo(t.activeIndex,0,!1,!0))||n(),i.watchOverflow&&e!==t.snapGrid&&t.checkOverflow(),t.emit("update"))}changeDirection(t,e){void 0===e&&(e=!0);var i=this,n=i.params.direction;return(t=t||("horizontal"===n?"vertical":"horizontal"))===n||"horizontal"!==t&&"vertical"!==t||(i.$el.removeClass(""+i.params.containerModifierClass+n).addClass(""+i.params.containerModifierClass+t),i.emitContainerClasses(),i.params.direction=t,i.slides.each(e=>{"vertical"===t?e.style.width="":e.style.height=""}),i.emit("changeDirection"),e&&i.update()),i}changeLanguageDirection(e){var t=this;t.rtl&&"rtl"===e||!t.rtl&&"ltr"===e||(t.rtl="rtl"===e,t.rtlTranslate="horizontal"===t.params.direction&&t.rtl,t.rtl?(t.$el.addClass(t.params.containerModifierClass+"rtl"),t.el.dir="rtl"):(t.$el.removeClass(t.params.containerModifierClass+"rtl"),t.el.dir="ltr"),t.update())}mount(e){const i=this;if(!i.mounted){const s=L(e||i.params.el);if(!(e=s[0]))return!1;e.swiper=i;const a=()=>"."+(i.params.wrapperClass||"").trim().split(" ").join(".");let t=e&&e.shadowRoot&&e.shadowRoot.querySelector?((n=L(e.shadowRoot.querySelector(a()))).children=e=>s.children(e),n):(s.children?s:L(s)).children(a());var n;if(0===t.length&&i.params.createElements){const e=T().createElement("div");t=L(e),e.className=i.params.wrapperClass,s.append(e),s.children("."+i.params.slideClass).each(e=>{t.append(e)})}Object.assign(i,{$el:s,el:e,$wrapperEl:t,wrapperEl:t[0],mounted:!0,rtl:"rtl"===e.dir.toLowerCase()||"rtl"===s.css("direction"),rtlTranslate:"horizontal"===i.params.direction&&("rtl"===e.dir.toLowerCase()||"rtl"===s.css("direction")),wrongRTL:"-webkit-box"===t.css("display")})}return!0}init(e){var t=this;return t.initialized||!1!==t.mount(e)&&(t.emit("beforeInit"),t.params.breakpoints&&t.setBreakpoint(),t.addClasses(),t.params.loop&&t.loopCreate(),t.updateSize(),t.updateSlides(),t.params.watchOverflow&&t.checkOverflow(),t.params.grabCursor&&t.enabled&&t.setGrabCursor(),t.params.preloadImages&&t.preloadImages(),t.params.loop?t.slideTo(t.params.initialSlide+t.loopedSlides,0,t.params.runCallbacksOnInit,!1,!0):t.slideTo(t.params.initialSlide,0,t.params.runCallbacksOnInit,!1,!0),t.attachEvents(),t.initialized=!0,t.emit("init"),t.emit("afterInit")),t}destroy(e,t){void 0===e&&(e=!0),void 0===t&&(t=!0);const i=this,{params:n,$el:s,$wrapperEl:a,slides:r}=i;if(void 0!==i.params&&!i.destroyed){if(i.emit("beforeDestroy"),i.initialized=!1,i.detachEvents(),n.loop&&i.loopDestroy(),t&&(i.removeClasses(),s.removeAttr("style"),a.removeAttr("style"),r)&&r.length&&r.removeClass([n.slideVisibleClass,n.slideActiveClass,n.slideNextClass,n.slidePrevClass].join(" ")).removeAttr("style").removeAttr("data-swiper-slide-index"),i.emit("destroy"),Object.keys(i.eventsListeners).forEach(e=>{i.off(e)}),!1!==e){i.$el[0].swiper=null;{const o=i;Object.keys(o).forEach(e=>{try{o[e]=null}catch(e){}try{delete o[e]}catch(e){}})}}i.destroyed=!0}return null}static extendDefaults(e){m(E,e)}static get extendedDefaults(){return E}static get defaults(){return w}static installModule(e){x.prototype.__modules__||(x.prototype.__modules__=[]);var t=x.prototype.__modules__;"function"==typeof e&&t.indexOf(e)<0&&t.push(e)}static use(e){return Array.isArray(e)?e.forEach(e=>x.installModule(e)):x.installModule(e),x}}function k(i,n,s,a){const r=T();return i.params.createElements&&Object.keys(a).forEach(t=>{if(!s[t]&&!0===s.auto){let e=i.$el.children("."+a[t])[0];e||((e=r.createElement("div")).className=a[t],i.$el.append(e)),s[t]=e,n[t]=e}}),s}function M(e){return"."+(e=void 0===e?"":e).trim().replace(/([\.:!\/])/g,"\\$1").replace(/ /g,".")}function N(e){const{effect:i,swiper:n,on:t,setTranslate:s,setTransition:a,overwriteParams:r,perspective:o,recreateShadows:l,getEffectParams:c}=e;let d;t("beforeInit",()=>{var e;n.params.effect===i&&(n.classNames.push(""+n.params.containerModifierClass+i),o&&o()&&n.classNames.push(n.params.containerModifierClass+"3d"),e=r?r():{},Object.assign(n.params,e),Object.assign(n.originalParams,e))}),t("setTranslate",()=>{n.params.effect===i&&s()}),t("setTransition",(e,t)=>{n.params.effect===i&&a(t)}),t("transitionEnd",()=>{n.params.effect===i&&l&&c&&c().slideShadows&&(n.slides.each(e=>{n.$(e).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").remove()}),l())}),t("virtualUpdate",()=>{n.params.effect===i&&(n.slides.length||(d=!0),requestAnimationFrame(()=>{d&&n.slides&&n.slides.length&&(s(),d=!1)}))})}function O(e,t){return e.transformEl?t.find(e.transformEl).css({"backface-visibility":"hidden","-webkit-backface-visibility":"hidden"}):t}function D(e){let{swiper:i,duration:t,transformEl:n,allSlides:s}=e;const{slides:a,activeIndex:r,$wrapperEl:o}=i;if(i.params.virtualTranslate&&0!==t){let e=!1;(s?n?a.find(n):a:n?a.eq(r).find(n):a.eq(r)).transitionEnd(()=>{if(!e&&i&&!i.destroyed){e=!0,i.animating=!1;var t=["webkitTransitionEnd","transitionend"];for(let e=0;e<t.length;e+=1)o.trigger(t[e])}})}}function $(e,t,i){var n="swiper-slide-shadow"+(i?"-"+i:""),e=e.transformEl?t.find(e.transformEl):t;let s=e.children("."+n);return s.length||(s=L(`<div class="swiper-slide-shadow${i?"-"+i:""}"></div>`),e.append(s)),s}return Object.keys(_).forEach(t=>{Object.keys(_[t]).forEach(e=>{x.prototype[e]=_[t][e]})}),x.use([function(e){let{swiper:a,on:t,emit:i}=e;const n=A();let s=null,r=null;const o=()=>{a&&!a.destroyed&&a.initialized&&(i("beforeResize"),i("resize"))},l=()=>{a&&!a.destroyed&&a.initialized&&i("orientationchange")};t("init",()=>{a.params.resizeObserver&&void 0!==n.ResizeObserver?a&&!a.destroyed&&a.initialized&&(s=new ResizeObserver(i=>{r=n.requestAnimationFrame(()=>{var{width:e,height:t}=a;let n=e,s=t;i.forEach(e=>{var{contentBoxSize:e,contentRect:t,target:i}=e;i&&i!==a.el||(n=t?t.width:(e[0]||e).inlineSize,s=t?t.height:(e[0]||e).blockSize)}),n===e&&s===t||o()})})).observe(a.el):(n.addEventListener("resize",o),n.addEventListener("orientationchange",l))}),t("destroy",()=>{r&&n.cancelAnimationFrame(r),s&&s.unobserve&&a.el&&(s.unobserve(a.el),s=null),n.removeEventListener("resize",o),n.removeEventListener("orientationchange",l)})},function(e){let{swiper:i,extendParams:t,on:n,emit:s}=e;function a(e,t){void 0===t&&(t={});var i=new(o.MutationObserver||o.WebkitMutationObserver)(e=>{var t;1===e.length?s("observerUpdate",e[0]):(t=function(){s("observerUpdate",e[0])},o.requestAnimationFrame?o.requestAnimationFrame(t):o.setTimeout(t,0))});i.observe(e,{attributes:void 0===t.attributes||t.attributes,childList:void 0===t.childList||t.childList,characterData:void 0===t.characterData||t.characterData}),r.push(i)}const r=[],o=A();t({observer:!1,observeParents:!1,observeSlideChildren:!1}),n("init",()=>{if(i.params.observer){if(i.params.observeParents){var t=i.$el.parents();for(let e=0;e<t.length;e+=1)a(t[e])}a(i.$el[0],{childList:i.params.observeSlideChildren}),a(i.$wrapperEl[0],{attributes:!1})}}),n("destroy",()=>{r.forEach(e=>{e.disconnect()}),r.splice(0,r.length)})}]),x.use([function(e){let t,{swiper:_,extendParams:i,on:n,emit:E}=e;function x(e,t){var i=_.params.virtual;return i.cache&&_.virtual.cache[t]?_.virtual.cache[t]:((e=i.renderSlide?L(i.renderSlide.call(_,e,t)):L(`<div class="${_.params.slideClass}" data-swiper-slide-index="${t}">${e}</div>`)).attr("data-swiper-slide-index")||e.attr("data-swiper-slide-index",t),i.cache&&(_.virtual.cache[t]=e),e)}function r(t){const{slidesPerView:e,slidesPerGroup:i,centeredSlides:n}=_.params,{addSlidesBefore:s,addSlidesAfter:a}=_.params.virtual,{from:r,to:o,slides:l,slidesGrid:c,offset:d}=_.virtual;_.params.cssMode||_.updateActiveIndex();var u=_.activeIndex||0;let p,h,m;p=_.rtlTranslate?"right":_.isHorizontal()?"left":"top",m=n?(h=Math.floor(e/2)+i+a,Math.floor(e/2)+i+s):(h=e+(i-1)+a,i+s);const g=Math.max((u||0)-m,0),f=Math.min((u||0)+h,l.length-1),b=(_.slidesGrid[g]||0)-(_.slidesGrid[0]||0);function v(){_.updateSlides(),_.updateProgress(),_.updateSlidesClasses(),_.lazy&&_.params.lazy.enabled&&_.lazy.load(),E("virtualUpdate")}if(Object.assign(_.virtual,{from:g,to:f,offset:b,slidesGrid:_.slidesGrid}),r!==g||o!==f||t)if(_.params.virtual.renderExternal)_.params.virtual.renderExternal.call(_,{offset:b,from:g,to:f,slides:function(){var t=[];for(let e=g;e<=f;e+=1)t.push(l[e]);return t}()}),_.params.virtual.renderExternalUpdate?v():E("virtualUpdate");else{var y=[],w=[];if(t)_.$wrapperEl.find("."+_.params.slideClass).remove();else for(let e=r;e<=o;e+=1)(e<g||e>f)&&_.$wrapperEl.find(`.${_.params.slideClass}[data-swiper-slide-index="${e}"]`).remove();for(let e=0;e<l.length;e+=1)e>=g&&e<=f&&(void 0===o||t?w.push(e):(e>o&&w.push(e),e<r&&y.push(e)));w.forEach(e=>{_.$wrapperEl.append(x(l[e],e))}),y.sort((e,t)=>t-e).forEach(e=>{_.$wrapperEl.prepend(x(l[e],e))}),_.$wrapperEl.children(".swiper-slide").css(p,b+"px"),v()}else _.slidesGrid!==c&&b!==d&&_.slides.css(p,b+"px"),_.updateProgress(),E("virtualUpdate")}i({virtual:{enabled:!1,slides:[],cache:!0,renderSlide:null,renderExternal:null,renderExternalUpdate:!0,addSlidesBefore:0,addSlidesAfter:0}}),_.virtual={cache:{},from:void 0,to:void 0,slides:[],offset:0,slidesGrid:[]},n("beforeInit",()=>{_.params.virtual.enabled&&(_.virtual.slides=_.params.virtual.slides,_.classNames.push(_.params.containerModifierClass+"virtual"),_.params.watchSlidesProgress=!0,_.originalParams.watchSlidesProgress=!0,_.params.initialSlide||r())}),n("setTranslate",()=>{_.params.virtual.enabled&&(_.params.cssMode&&!_._immediateVirtual?(clearTimeout(t),t=setTimeout(()=>{r()},100)):r())}),n("init update resize",()=>{_.params.virtual.enabled&&_.params.cssMode&&S(_.wrapperEl,"--swiper-virtual-size",_.virtualSize+"px")}),Object.assign(_.virtual,{appendSlide:function(t){if("object"==typeof t&&"length"in t)for(let e=0;e<t.length;e+=1)t[e]&&_.virtual.slides.push(t[e]);else _.virtual.slides.push(t);r(!0)},prependSlide:function(n){const s=_.activeIndex;let e=s+1,a=1;if(Array.isArray(n)){for(let e=0;e<n.length;e+=1)n[e]&&_.virtual.slides.unshift(n[e]);e=s+n.length,a=n.length}else _.virtual.slides.unshift(n);if(_.params.virtual.cache){const n=_.virtual.cache,s={};Object.keys(n).forEach(e=>{var t=n[e],i=t.attr("data-swiper-slide-index");i&&t.attr("data-swiper-slide-index",parseInt(i,10)+a),s[parseInt(e,10)+a]=t}),_.virtual.cache=s}r(!0),_.slideTo(e,0)},removeSlide:function(i){if(null!=i){let t=_.activeIndex;if(Array.isArray(i))for(let e=i.length-1;0<=e;--e)_.virtual.slides.splice(i[e],1),_.params.virtual.cache&&delete _.virtual.cache[i[e]],i[e]<t&&--t,t=Math.max(t,0);else _.virtual.slides.splice(i,1),_.params.virtual.cache&&delete _.virtual.cache[i],i<t&&--t,t=Math.max(t,0);r(!0),_.slideTo(t,0)}},removeAllSlides:function(){_.virtual.slides=[],_.params.virtual.cache&&(_.virtual.cache={}),r(!0),_.slideTo(0,0)},update:r})},function(e){let{swiper:u,extendParams:t,on:i,emit:p}=e;const h=T(),m=A();function n(t){if(u.enabled){const i=u["rtlTranslate"];let e=t;const n=(e=e.originalEvent?e.originalEvent:e).keyCode||e.charCode,s=u.params.keyboard.pageUpDown,a=s&&33===n,r=s&&34===n,o=37===n,l=39===n,c=38===n,d=40===n;if(!u.allowSlideNext&&(u.isHorizontal()&&l||u.isVertical()&&d||r))return!1;if(!u.allowSlidePrev&&(u.isHorizontal()&&o||u.isVertical()&&c||a))return!1;if(!(e.shiftKey||e.altKey||e.ctrlKey||e.metaKey||h.activeElement&&h.activeElement.nodeName&&("input"===h.activeElement.nodeName.toLowerCase()||"textarea"===h.activeElement.nodeName.toLowerCase()))){if(u.params.keyboard.onlyInViewport&&(a||r||o||l||c||d)){let t=!1;if(0<u.$el.parents("."+u.params.slideClass).length&&0===u.$el.parents("."+u.params.slideActiveClass).length)return;const e=u.$el,n=e[0].clientWidth,s=e[0].clientHeight,p=m.innerWidth,h=m.innerHeight,a=u.$el.offset(),r=(i&&(a.left-=u.$el[0].scrollLeft),[[a.left,a.top],[a.left+n,a.top],[a.left,a.top+s],[a.left+n,a.top+s]]);for(let e=0;e<r.length;e+=1){const i=r[e];0<=i[0]&&i[0]<=p&&0<=i[1]&&i[1]<=h&&(0===i[0]&&0===i[1]||(t=!0))}if(!t)return}u.isHorizontal()?((a||r||o||l)&&(e.preventDefault?e.preventDefault():e.returnValue=!1),((r||l)&&!i||(a||o)&&i)&&u.slideNext(),((a||o)&&!i||(r||l)&&i)&&u.slidePrev()):((a||r||c||d)&&(e.preventDefault?e.preventDefault():e.returnValue=!1),(r||d)&&u.slideNext(),(a||c)&&u.slidePrev()),p("keyPress",n)}}}function s(){u.keyboard.enabled||(L(h).on("keydown",n),u.keyboard.enabled=!0)}function a(){u.keyboard.enabled&&(L(h).off("keydown",n),u.keyboard.enabled=!1)}u.keyboard={enabled:!1},t({keyboard:{enabled:!1,onlyInViewport:!0,pageUpDown:!0}}),i("init",()=>{u.params.keyboard.enabled&&s()}),i("destroy",()=>{u.keyboard.enabled&&a()}),Object.assign(u.keyboard,{enable:s,disable:a})},function(e){let{swiper:c,extendParams:t,on:i,emit:d}=e;const n=A();let u;t({mousewheel:{enabled:!1,releaseOnEdges:!1,invert:!1,forceToAxis:!1,sensitivity:1,eventsTarget:"container",thresholdDelta:null,thresholdTime:null}}),c.mousewheel={enabled:!1};let p,s=b();const h=[];function a(){c.enabled&&(c.mouseEntered=!0)}function r(){c.enabled&&(c.mouseEntered=!1)}function m(e){c.params.mousewheel.thresholdDelta&&e.delta<c.params.mousewheel.thresholdDelta||c.params.mousewheel.thresholdTime&&b()-s<c.params.mousewheel.thresholdTime||6<=e.delta&&b()-s<60||(e.direction<0?c.isEnd&&!c.params.loop||c.animating||(c.slideNext(),d("scroll",e.raw)):c.isBeginning&&!c.params.loop||c.animating||(c.slidePrev(),d("scroll",e.raw)),s=(new n.Date).getTime())}function o(n){let s=n,a=!0;if(c.enabled){var r=c.params.mousewheel;c.params.cssMode&&s.preventDefault();let e=c.$el;if("container"!==c.params.mousewheel.eventsTarget&&(e=L(c.params.mousewheel.eventsTarget)),!c.mouseEntered&&!e[0].contains(s.target)&&!r.releaseOnEdges)return!0;s.originalEvent&&(s=s.originalEvent);let t=0;var o=c.rtlTranslate?-1:1,l=function(e){let t=0,i=0,n=0,s=0;return"detail"in e&&(i=e.detail),"wheelDelta"in e&&(i=-e.wheelDelta/120),"wheelDeltaY"in e&&(i=-e.wheelDeltaY/120),"wheelDeltaX"in e&&(t=-e.wheelDeltaX/120),"axis"in e&&e.axis===e.HORIZONTAL_AXIS&&(t=i,i=0),n=10*t,s=10*i,"deltaY"in e&&(s=e.deltaY),"deltaX"in e&&(n=e.deltaX),e.shiftKey&&!n&&(n=s,s=0),(n||s)&&e.deltaMode&&(1===e.deltaMode?(n*=40,s*=40):(n*=800,s*=800)),n&&!t&&(t=n<1?-1:1),s&&!i&&(i=s<1?-1:1),{spinX:t,spinY:i,pixelX:n,pixelY:s}}(s);if(r.forceToAxis)if(c.isHorizontal()){if(!(Math.abs(l.pixelX)>Math.abs(l.pixelY)))return!0;t=-l.pixelX*o}else{if(!(Math.abs(l.pixelY)>Math.abs(l.pixelX)))return!0;t=-l.pixelY}else t=Math.abs(l.pixelX)>Math.abs(l.pixelY)?-l.pixelX*o:-l.pixelY;if(0===t)return!0;r.invert&&(t=-t);let i=c.getTranslate()+t*r.sensitivity;if((i=i>=c.minTranslate()?c.minTranslate():i)<=c.maxTranslate()&&(i=c.maxTranslate()),(a=!!c.params.loop||!(i===c.minTranslate()||i===c.maxTranslate()))&&c.params.nested&&s.stopPropagation(),c.params.freeMode&&c.params.freeMode.enabled){const n={time:b(),delta:Math.abs(t),direction:Math.sign(t)},a=p&&n.time<p.time+500&&n.delta<=p.delta&&n.direction===p.direction;if(!a){p=void 0,c.params.loop&&c.loopFix();let e=c.getTranslate()+t*r.sensitivity;const L=c.isBeginning,b=c.isEnd;if((e=e>=c.minTranslate()?c.minTranslate():e)<=c.maxTranslate()&&(e=c.maxTranslate()),c.setTransition(0),c.setTranslate(e),c.updateProgress(),c.updateActiveIndex(),c.updateSlidesClasses(),(!L&&c.isBeginning||!b&&c.isEnd)&&c.updateSlidesClasses(),c.params.freeMode.sticky){clearTimeout(u),u=void 0,15<=h.length&&h.shift();const s=h.length?h[h.length-1]:void 0,a=h[0];if(h.push(n),s&&(n.delta>s.delta||n.direction!==s.direction))h.splice(0);else if(15<=h.length&&n.time-a.time<500&&1<=a.delta-n.delta&&n.delta<=6){const s=0<t?.8:.2;p=n,h.splice(0),u=C(()=>{c.slideToClosest(c.params.speed,!0,void 0,s)},0)}u=u||C(()=>{p=n,h.splice(0),c.slideToClosest(c.params.speed,!0,void 0,.5)},500)}if(a||d("scroll",s),c.params.autoplay&&c.params.autoplayDisableOnInteraction&&c.autoplay.stop(),e===c.minTranslate()||e===c.maxTranslate())return!0}}else{const s={time:b(),delta:Math.abs(t),direction:Math.sign(t),raw:n},a=(2<=h.length&&h.shift(),h.length?h[h.length-1]:void 0);if(h.push(s),(!a||s.direction!==a.direction||s.delta>a.delta||s.time>a.time+150)&&m(s),function(e){var t=c.params.mousewheel;if(e.direction<0){if(c.isEnd&&!c.params.loop&&t.releaseOnEdges)return 1}else if(c.isBeginning&&!c.params.loop&&t.releaseOnEdges)return 1}(s))return!0}return s.preventDefault?s.preventDefault():s.returnValue=!1,!1}}function l(e){let t=c.$el;(t="container"!==c.params.mousewheel.eventsTarget?L(c.params.mousewheel.eventsTarget):t)[e]("mouseenter",a),t[e]("mouseleave",r),t[e]("wheel",o)}function g(){return c.params.cssMode?(c.wrapperEl.removeEventListener("wheel",o),!0):!c.mousewheel.enabled&&(l("on"),c.mousewheel.enabled=!0)}function f(){return c.params.cssMode?(c.wrapperEl.addEventListener(event,o),!0):!!c.mousewheel.enabled&&(l("off"),!(c.mousewheel.enabled=!1))}i("init",()=>{!c.params.mousewheel.enabled&&c.params.cssMode&&f(),c.params.mousewheel.enabled&&g()}),i("destroy",()=>{c.params.cssMode&&g(),c.mousewheel.enabled&&f()}),Object.assign(c.mousewheel,{enable:g,disable:f})},function(e){let{swiper:s,extendParams:t,on:i,emit:a}=e;function n(e){let t;return t=e&&(t=L(e),s.params.uniqueNavElements)&&"string"==typeof e&&1<t.length&&1===s.$el.find(e).length?s.$el.find(e):t}function r(e,t){var i=s.params.navigation;e&&0<e.length&&(e[t?"addClass":"removeClass"](i.disabledClass),e[0]&&"BUTTON"===e[0].tagName&&(e[0].disabled=t),s.params.watchOverflow)&&s.enabled&&e[s.isLocked?"addClass":"removeClass"](i.lockClass)}function o(){var e,t;s.params.loop||({$nextEl:e,$prevEl:t}=s.navigation,r(t,s.isBeginning&&!s.params.rewind),r(e,s.isEnd&&!s.params.rewind))}function l(e){e.preventDefault(),s.isBeginning&&!s.params.loop&&!s.params.rewind||(s.slidePrev(),a("navigationPrev"))}function c(e){e.preventDefault(),s.isEnd&&!s.params.loop&&!s.params.rewind||(s.slideNext(),a("navigationNext"))}function d(){var e,t,i=s.params.navigation;s.params.navigation=k(s,s.originalParams.navigation,s.params.navigation,{nextEl:"swiper-button-next",prevEl:"swiper-button-prev"}),(i.nextEl||i.prevEl)&&(e=n(i.nextEl),t=n(i.prevEl),e&&0<e.length&&e.on("click",c),t&&0<t.length&&t.on("click",l),Object.assign(s.navigation,{$nextEl:e,nextEl:e&&e[0],$prevEl:t,prevEl:t&&t[0]}),s.enabled||(e&&e.addClass(i.lockClass),t&&t.addClass(i.lockClass)))}function u(){var{$nextEl:e,$prevEl:t}=s.navigation;e&&e.length&&(e.off("click",c),e.removeClass(s.params.navigation.disabledClass)),t&&t.length&&(t.off("click",l),t.removeClass(s.params.navigation.disabledClass))}t({navigation:{nextEl:null,prevEl:null,hideOnClick:!1,disabledClass:"swiper-button-disabled",hiddenClass:"swiper-button-hidden",lockClass:"swiper-button-lock",navigationDisabledClass:"swiper-navigation-disabled"}}),s.navigation={nextEl:null,$nextEl:null,prevEl:null,$prevEl:null},i("init",()=>{(!1===s.params.navigation.enabled?p:(d(),o))()}),i("toEdge fromEdge lock unlock",()=>{o()}),i("destroy",()=>{u()}),i("enable disable",()=>{var{$nextEl:e,$prevEl:t}=s.navigation;e&&e[s.enabled?"removeClass":"addClass"](s.params.navigation.lockClass),t&&t[s.enabled?"removeClass":"addClass"](s.params.navigation.lockClass)}),i("click",(e,t)=>{var{$nextEl:i,$prevEl:n}=s.navigation,t=t.target;if(s.params.navigation.hideOnClick&&!L(t).is(n)&&!L(t).is(i)&&(!(s.pagination&&s.params.pagination&&s.params.pagination.clickable)||s.pagination.el!==t&&!s.pagination.el.contains(t))){let e;i?e=i.hasClass(s.params.navigation.hiddenClass):n&&(e=n.hasClass(s.params.navigation.hiddenClass)),a(!0===e?"navigationShow":"navigationHide"),i&&i.toggleClass(s.params.navigation.hiddenClass),n&&n.toggleClass(s.params.navigation.hiddenClass)}});const p=()=>{s.$el.addClass(s.params.navigation.navigationDisabledClass),u()};Object.assign(s.navigation,{enable:()=>{s.$el.removeClass(s.params.navigation.navigationDisabledClass),d(),o()},disable:p,update:o,init:d,destroy:u})},function(e){let{swiper:l,extendParams:t,on:i,emit:c}=e;e="swiper-pagination";let d,u=(t({pagination:{el:null,bulletElement:"span",clickable:!1,hideOnClick:!1,renderBullet:null,renderProgressbar:null,renderFraction:null,renderCustom:null,progressbarOpposite:!1,type:"bullets",dynamicBullets:!1,dynamicMainBullets:1,formatFractionCurrent:e=>e,formatFractionTotal:e=>e,bulletClass:e+"-bullet",bulletActiveClass:e+"-bullet-active",modifierClass:e+"-",currentClass:e+"-current",totalClass:e+"-total",hiddenClass:e+"-hidden",progressbarFillClass:e+"-progressbar-fill",progressbarOppositeClass:e+"-progressbar-opposite",clickableClass:e+"-clickable",lockClass:e+"-lock",horizontalClass:e+"-horizontal",verticalClass:e+"-vertical",paginationDisabledClass:e+"-disabled"}}),l.pagination={el:null,$el:null,bullets:[]},0);function p(){return!l.params.pagination.el||!l.pagination.el||!l.pagination.$el||0===l.pagination.$el.length}function h(e,t){var i=l.params.pagination["bulletActiveClass"];e[t]().addClass(i+"-"+t)[t]().addClass(i+`-${t}-`+t)}function n(){const t=l.rtl,a=l.params.pagination;if(!p()){const r=(l.virtual&&l.params.virtual.enabled?l.virtual:l).slides.length,o=l.pagination.$el;let s;var i=l.params.loop?Math.ceil((r-2*l.loopedSlides)/l.params.slidesPerGroup):l.snapGrid.length;if(l.params.loop?((s=Math.ceil((l.activeIndex-l.loopedSlides)/l.params.slidesPerGroup))>r-1-2*l.loopedSlides&&(s-=r-2*l.loopedSlides),s>i-1&&(s-=i),s<0&&"bullets"!==l.params.paginationType&&(s=i+s)):s=void 0!==l.snapIndex?l.snapIndex:l.activeIndex||0,"bullets"===a.type&&l.pagination.bullets&&0<l.pagination.bullets.length){const r=l.pagination.bullets;let i,n,e;if(a.dynamicBullets&&(d=r.eq(0)[l.isHorizontal()?"outerWidth":"outerHeight"](!0),o.css(l.isHorizontal()?"width":"height",d*(a.dynamicMainBullets+4)+"px"),1<a.dynamicMainBullets&&void 0!==l.previousIndex&&((u+=s-(l.previousIndex-l.loopedSlides||0))>a.dynamicMainBullets-1?u=a.dynamicMainBullets-1:u<0&&(u=0)),i=Math.max(s-u,0),n=i+(Math.min(r.length,a.dynamicMainBullets)-1),e=(n+i)/2),r.removeClass(["","-next","-next-next","-prev","-prev-prev","-main"].map(e=>""+a.bulletActiveClass+e).join(" ")),1<o.length)r.each(e=>{var e=L(e),t=e.index();t===s&&e.addClass(a.bulletActiveClass),a.dynamicBullets&&(t>=i&&t<=n&&e.addClass(a.bulletActiveClass+"-main"),t===i&&h(e,"prev"),t===n)&&h(e,"next")});else{const t=r.eq(s),o=t.index();if(t.addClass(a.bulletActiveClass),a.dynamicBullets){const t=r.eq(i),d=r.eq(n);for(let e=i;e<=n;e+=1)r.eq(e).addClass(a.bulletActiveClass+"-main");if(l.params.loop)if(o>=r.length){for(let e=a.dynamicMainBullets;0<=e;--e)r.eq(r.length-e).addClass(a.bulletActiveClass+"-main");r.eq(r.length-a.dynamicMainBullets-1).addClass(a.bulletActiveClass+"-prev")}else h(t,"prev"),h(d,"next");else h(t,"prev"),h(d,"next")}}if(a.dynamicBullets){const c=Math.min(r.length,a.dynamicMainBullets+4),o=(d*c-d)/2-e*d,u=t?"right":"left";r.css(l.isHorizontal()?u:"top",o+"px")}}if("fraction"===a.type&&(o.find(M(a.currentClass)).text(a.formatFractionCurrent(s+1)),o.find(M(a.totalClass)).text(a.formatFractionTotal(i))),"progressbar"===a.type){var n=a.progressbarOpposite?l.isHorizontal()?"vertical":"horizontal":l.isHorizontal()?"horizontal":"vertical";const r=(s+1)/i;let e=1,t=1;"horizontal"==n?e=r:t=r,o.find(M(a.progressbarFillClass)).transform(`translate3d(0,0,0) scaleX(${e}) scaleY(${t})`).transition(l.params.speed)}"custom"===a.type&&a.renderCustom?(o.html(a.renderCustom(l,s+1,i)),c("paginationRender",o[0])):c("paginationUpdate",o[0]),l.params.watchOverflow&&l.enabled&&o[l.isLocked?"addClass":"removeClass"](a.lockClass)}}function s(){var n=l.params.pagination;if(!p()){var e=(l.virtual&&l.params.virtual.enabled?l.virtual:l).slides.length,s=l.pagination.$el;let i="";if("bullets"===n.type){let t=l.params.loop?Math.ceil((e-2*l.loopedSlides)/l.params.slidesPerGroup):l.snapGrid.length;l.params.freeMode&&l.params.freeMode.enabled&&!l.params.loop&&t>e&&(t=e);for(let e=0;e<t;e+=1)n.renderBullet?i+=n.renderBullet.call(l,e,n.bulletClass):i+=`<${n.bulletElement} class="${n.bulletClass}"></${n.bulletElement}>`;s.html(i),l.pagination.bullets=s.find(M(n.bulletClass))}"fraction"===n.type&&(i=n.renderFraction?n.renderFraction.call(l,n.currentClass,n.totalClass):`<span class="${n.currentClass}"></span> / <span class="${n.totalClass}"></span>`,s.html(i)),"progressbar"===n.type&&(i=n.renderProgressbar?n.renderProgressbar.call(l,n.progressbarFillClass):`<span class="${n.progressbarFillClass}"></span>`,s.html(i)),"custom"!==n.type&&c("paginationRender",l.pagination.$el[0])}}function a(){l.params.pagination=k(l,l.originalParams.pagination,l.params.pagination,{el:"swiper-pagination"});var t=l.params.pagination;if(t.el){let e=L(t.el);0!==e.length&&(l.params.uniqueNavElements&&"string"==typeof t.el&&1<e.length&&1<(e=l.$el.find(t.el)).length&&(e=e.filter(e=>L(e).parents(".swiper")[0]===l.el)),"bullets"===t.type&&t.clickable&&e.addClass(t.clickableClass),e.addClass(t.modifierClass+t.type),e.addClass(l.isHorizontal()?t.horizontalClass:t.verticalClass),"bullets"===t.type&&t.dynamicBullets&&(e.addClass(""+t.modifierClass+t.type+"-dynamic"),u=0,t.dynamicMainBullets<1)&&(t.dynamicMainBullets=1),"progressbar"===t.type&&t.progressbarOpposite&&e.addClass(t.progressbarOppositeClass),t.clickable&&e.on("click",M(t.bulletClass),function(e){e.preventDefault();let t=L(this).index()*l.params.slidesPerGroup;l.params.loop&&(t+=l.loopedSlides),l.slideTo(t)}),Object.assign(l.pagination,{$el:e,el:e[0]}),l.enabled||e.addClass(t.lockClass))}}function r(){var e,t=l.params.pagination;p()||((e=l.pagination.$el).removeClass(t.hiddenClass),e.removeClass(t.modifierClass+t.type),e.removeClass(l.isHorizontal()?t.horizontalClass:t.verticalClass),l.pagination.bullets&&l.pagination.bullets.removeClass&&l.pagination.bullets.removeClass(t.bulletActiveClass),t.clickable&&e.off("click",M(t.bulletClass)))}i("init",()=>{(!1===l.params.pagination.enabled?o:(a(),s(),n))()}),i("activeIndexChange",()=>{!l.params.loop&&void 0!==l.snapIndex||n()}),i("snapIndexChange",()=>{l.params.loop||n()}),i("slidesLengthChange",()=>{l.params.loop&&(s(),n())}),i("snapGridLengthChange",()=>{l.params.loop||(s(),n())}),i("destroy",()=>{r()}),i("enable disable",()=>{var e=l.pagination["$el"];e&&e[l.enabled?"removeClass":"addClass"](l.params.pagination.lockClass)}),i("lock unlock",()=>{n()}),i("click",(e,t)=>{var t=t.target,i=l.pagination["$el"];if(l.params.pagination.el&&l.params.pagination.hideOnClick&&i&&0<i.length&&!L(t).hasClass(l.params.pagination.bulletClass)&&(!l.navigation||!(l.navigation.nextEl&&t===l.navigation.nextEl||l.navigation.prevEl&&t===l.navigation.prevEl))){const e=i.hasClass(l.params.pagination.hiddenClass);c(!0===e?"paginationShow":"paginationHide"),i.toggleClass(l.params.pagination.hiddenClass)}});const o=()=>{l.$el.addClass(l.params.pagination.paginationDisabledClass),l.pagination.$el&&l.pagination.$el.addClass(l.params.pagination.paginationDisabledClass),r()};Object.assign(l.pagination,{enable:()=>{l.$el.removeClass(l.params.pagination.paginationDisabledClass),l.pagination.$el&&l.pagination.$el.removeClass(l.params.pagination.paginationDisabledClass),a(),s(),n()},disable:o,render:s,update:n,init:a,destroy:r})},function(e){let{swiper:l,extendParams:t,on:i,emit:a}=e;const o=T();let r,c,d,n,u=!1,p=null,h=null;function s(){if(l.params.scrollbar.el&&l.scrollbar.el){const{scrollbar:i,rtlTranslate:n,progress:s}=l,{$dragEl:a,$el:r}=i,o=l.params.scrollbar;let e=c,t=(d-c)*s;n?0<(t=-t)?(e=c-t,t=0):-t+c>d&&(e=d+t):t<0?(e=c+t,t=0):t+c>d&&(e=d-t),l.isHorizontal()?(a.transform(`translate3d(${t}px, 0, 0)`),a[0].style.width=e+"px"):(a.transform(`translate3d(0px, ${t}px, 0)`),a[0].style.height=e+"px"),o.hide&&(clearTimeout(p),r[0].style.opacity=1,p=setTimeout(()=>{r[0].style.opacity=0,r.transition(400)},1e3))}}function m(){var e,t,i;l.params.scrollbar.el&&l.scrollbar.el&&(e=l["scrollbar"],{$dragEl:t,$el:i}=e,t[0].style.width="",t[0].style.height="",d=l.isHorizontal()?i[0].offsetWidth:i[0].offsetHeight,n=l.size/(l.virtualSize+l.params.slidesOffsetBefore-(l.params.centeredSlides?l.snapGrid[0]:0)),c="auto"===l.params.scrollbar.dragSize?d*n:parseInt(l.params.scrollbar.dragSize,10),l.isHorizontal()?t[0].style.width=c+"px":t[0].style.height=c+"px",i[0].style.display=1<=n?"none":"",l.params.scrollbar.hide&&(i[0].style.opacity=0),l.params.watchOverflow)&&l.enabled&&e.$el[l.isLocked?"addClass":"removeClass"](l.params.scrollbar.lockClass)}function g(e){return l.isHorizontal()?("touchstart"===e.type||"touchmove"===e.type?e.targetTouches[0]:e).clientX:("touchstart"===e.type||"touchmove"===e.type?e.targetTouches[0]:e).clientY}function f(e){var{scrollbar:t,rtlTranslate:i}=l,t=t["$el"];let n;n=(g(e)-t.offset()[l.isHorizontal()?"left":"top"]-(null!==r?r:c/2))/(d-c),n=Math.max(Math.min(n,1),0),i&&(n=1-n);e=l.minTranslate()+(l.maxTranslate()-l.minTranslate())*n;l.updateProgress(e),l.setTranslate(e),l.updateActiveIndex(),l.updateSlidesClasses()}function b(e){var t=l.params.scrollbar,{scrollbar:i,$wrapperEl:n}=l,{$el:i,$dragEl:s}=i;u=!0,r=e.target===s[0]||e.target===s?g(e)-e.target.getBoundingClientRect()[l.isHorizontal()?"left":"top"]:null,e.preventDefault(),e.stopPropagation(),n.transition(100),s.transition(100),f(e),clearTimeout(h),i.transition(0),t.hide&&i.css("opacity",1),l.params.cssMode&&l.$wrapperEl.css("scroll-snap-type","none"),a("scrollbarDragStart",e)}function v(e){var{scrollbar:t,$wrapperEl:i}=l,{$el:t,$dragEl:n}=t;u&&(e.preventDefault?e.preventDefault():e.returnValue=!1,f(e),i.transition(0),t.transition(0),n.transition(0),a("scrollbarDragMove",e))}function y(e){const t=l.params.scrollbar,{scrollbar:i,$wrapperEl:n}=l,s=i["$el"];u&&(u=!1,l.params.cssMode&&(l.$wrapperEl.css("scroll-snap-type",""),n.transition("")),t.hide&&(clearTimeout(h),h=C(()=>{s.css("opacity",0),s.transition(400)},1e3)),a("scrollbarDragEnd",e),t.snapOnRelease)&&l.slideToClosest()}function w(e){var t,{scrollbar:i,touchEventsTouch:n,touchEventsDesktop:s,params:a,support:r}=l,i=i.$el;i&&(i=i[0],t=!(!r.passiveListener||!a.passiveListeners)&&{passive:!1,capture:!1},a=!(!r.passiveListener||!a.passiveListeners)&&{passive:!0,capture:!1},i)&&(e="on"===e?"addEventListener":"removeEventListener",r.touch?(i[e](n.start,b,t),i[e](n.move,v,t),i[e](n.end,y,a)):(i[e](s.start,b,t),o[e](s.move,v,t),o[e](s.end,y,a)))}function _(){var{scrollbar:i,$el:n}=l,s=(l.params.scrollbar=k(l,l.originalParams.scrollbar,l.params.scrollbar,{el:"swiper-scrollbar"}),l.params.scrollbar);if(s.el){let e=L(s.el),t=((e=l.params.uniqueNavElements&&"string"==typeof s.el&&1<e.length&&1===n.find(s.el).length?n.find(s.el):e).addClass(l.isHorizontal()?s.horizontalClass:s.verticalClass),e.find("."+l.params.scrollbar.dragClass));0===t.length&&(t=L(`<div class="${l.params.scrollbar.dragClass}"></div>`),e.append(t)),Object.assign(i,{$el:e,el:e[0],$dragEl:t,dragEl:t[0]}),s.draggable&&l.params.scrollbar.el&&l.scrollbar.el&&w("on"),e&&e[l.enabled?"removeClass":"addClass"](l.params.scrollbar.lockClass)}}function E(){var e=l.params.scrollbar,t=l.scrollbar.$el;t&&t.removeClass(l.isHorizontal()?e.horizontalClass:e.verticalClass),l.params.scrollbar.el&&l.scrollbar.el&&w("off")}t({scrollbar:{el:null,dragSize:"auto",hide:!1,draggable:!1,snapOnRelease:!0,lockClass:"swiper-scrollbar-lock",dragClass:"swiper-scrollbar-drag",scrollbarDisabledClass:"swiper-scrollbar-disabled",horizontalClass:"swiper-scrollbar-horizontal",verticalClass:"swiper-scrollbar-vertical"}}),l.scrollbar={el:null,dragEl:null,$el:null,$dragEl:null},i("init",()=>{(!1===l.params.scrollbar.enabled?x:(_(),m(),s))()}),i("update resize observerUpdate lock unlock",()=>{m()}),i("setTranslate",()=>{s()}),i("setTransition",(e,t)=>{t=t,l.params.scrollbar.el&&l.scrollbar.el&&l.scrollbar.$dragEl.transition(t)}),i("enable disable",()=>{var e=l.scrollbar["$el"];e&&e[l.enabled?"removeClass":"addClass"](l.params.scrollbar.lockClass)}),i("destroy",()=>{E()});const x=()=>{l.$el.addClass(l.params.scrollbar.scrollbarDisabledClass),l.scrollbar.$el&&l.scrollbar.$el.addClass(l.params.scrollbar.scrollbarDisabledClass),E()};Object.assign(l.scrollbar,{enable:()=>{l.$el.removeClass(l.params.scrollbar.scrollbarDisabledClass),l.scrollbar.$el&&l.scrollbar.$el.removeClass(l.params.scrollbar.scrollbarDisabledClass),_(),m(),s()},disable:x,updateSize:m,setTranslate:s,init:_,destroy:E})},function(e){let{swiper:l,extendParams:t,on:i}=e;t({parallax:{enabled:!1}});const a=(e,t)=>{var i=l["rtl"],n=L(e),e=i?-1:1,i=n.attr("data-swiper-parallax")||"0";let s=n.attr("data-swiper-parallax-x"),a=n.attr("data-swiper-parallax-y");var r=n.attr("data-swiper-parallax-scale"),o=n.attr("data-swiper-parallax-opacity");if(s||a?(s=s||"0",a=a||"0"):l.isHorizontal()?(s=i,a="0"):(a=i,s="0"),s=0<=s.indexOf("%")?parseInt(s,10)*t*e+"%":s*t*e+"px",a=0<=a.indexOf("%")?parseInt(a,10)*t+"%":a*t+"px",null!=o){const e=o-(o-1)*(1-Math.abs(t));n[0].style.opacity=e}if(null==r)n.transform(`translate3d(${s}, ${a}, 0px)`);else{const e=r-(r-1)*(1-Math.abs(t));n.transform(`translate3d(${s}, ${a}, 0px) scale(${e})`)}},n=()=>{const{$el:e,slides:t,progress:n,snapGrid:s}=l;e.children("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]").each(e=>{a(e,n)}),t.each((e,t)=>{let i=e.progress;1<l.params.slidesPerGroup&&"auto"!==l.params.slidesPerView&&(i+=Math.ceil(t/2)-n*(s.length-1)),i=Math.min(Math.max(i,-1),1),L(e).find("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]").each(e=>{a(e,i)})})};i("beforeInit",()=>{l.params.parallax.enabled&&(l.params.watchSlidesProgress=!0,l.originalParams.watchSlidesProgress=!0)}),i("init",()=>{l.params.parallax.enabled&&n()}),i("setTranslate",()=>{l.params.parallax.enabled&&n()}),i("setTransition",(e,t)=>{var i;l.params.parallax.enabled&&(void 0===(i=t)&&(i=l.params.speed),l.$el.find("[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]").each(e=>{e=L(e);let t=parseInt(e.attr("data-swiper-parallax-duration"),10)||i;0===i&&(t=0),e.transition(t)}))})},function(e){let{swiper:_,extendParams:t,on:i,emit:n}=e;const E=A();t({zoom:{enabled:!1,maxRatio:3,minRatio:1,toggle:!0,containerClass:"swiper-zoom-container",zoomedSlideClass:"swiper-slide-zoomed"}}),_.zoom={enabled:!1};let s,a,r,x=1,o=!1;const T={$slideEl:void 0,slideWidth:void 0,slideHeight:void 0,$imageEl:void 0,$imageWrapEl:void 0,maxRatio:3},C={isTouched:void 0,isMoved:void 0,currentX:void 0,currentY:void 0,minX:void 0,minY:void 0,maxX:void 0,maxY:void 0,width:void 0,height:void 0,startX:void 0,startY:void 0,touchesStart:{},touchesCurrent:{}},l={x:void 0,y:void 0,prevPositionX:void 0,prevPositionY:void 0,prevTime:void 0};let c=1;function d(e){var t,i,n;return e.targetTouches.length<2?1:(t=e.targetTouches[0].pageX,i=e.targetTouches[0].pageY,n=e.targetTouches[1].pageX,e=e.targetTouches[1].pageY,Math.sqrt((n-t)**2+(e-i)**2))}function u(e){var t=_.support,i=_.params.zoom;if(a=!1,r=!1,!t.gestures){if("touchstart"!==e.type||"touchstart"===e.type&&e.targetTouches.length<2)return;a=!0,T.scaleStart=d(e)}T.$slideEl&&T.$slideEl.length||(T.$slideEl=L(e.target).closest("."+_.params.slideClass),0===T.$slideEl.length&&(T.$slideEl=_.slides.eq(_.activeIndex)),T.$imageEl=T.$slideEl.find("."+i.containerClass).eq(0).find("picture, img, svg, canvas, .swiper-zoom-target").eq(0),T.$imageWrapEl=T.$imageEl.parent("."+i.containerClass),T.maxRatio=T.$imageWrapEl.attr("data-swiper-zoom")||i.maxRatio,0!==T.$imageWrapEl.length)?(T.$imageEl&&T.$imageEl.transition(0),o=!0):T.$imageEl=void 0}function p(e){var t=_.support,i=_.params.zoom,n=_.zoom;if(!t.gestures){if("touchmove"!==e.type||"touchmove"===e.type&&e.targetTouches.length<2)return;r=!0,T.scaleMove=d(e)}T.$imageEl&&0!==T.$imageEl.length?(t.gestures?n.scale=e.scale*x:n.scale=T.scaleMove/T.scaleStart*x,n.scale>T.maxRatio&&(n.scale=T.maxRatio-1+(n.scale-T.maxRatio+1)**.5),n.scale<i.minRatio&&(n.scale=i.minRatio+1-(i.minRatio-n.scale+1)**.5),T.$imageEl.transform(`translate3d(0,0,0) scale(${n.scale})`)):"gesturechange"===e.type&&u(e)}function h(e){var t=_.device,i=_.support,n=_.params.zoom,s=_.zoom;if(!i.gestures){if(!a||!r)return;if("touchend"!==e.type||"touchend"===e.type&&e.changedTouches.length<2&&!t.android)return;a=!1,r=!1}T.$imageEl&&0!==T.$imageEl.length&&(s.scale=Math.max(Math.min(s.scale,T.maxRatio),n.minRatio),T.$imageEl.transition(_.params.speed).transform(`translate3d(0,0,0) scale(${s.scale})`),x=s.scale,o=!1,1===s.scale)&&(T.$slideEl=void 0)}function m(e){var t=_.zoom;if(T.$imageEl&&0!==T.$imageEl.length&&(_.allowClick=!1,C.isTouched)&&T.$slideEl){C.isMoved||(C.width=T.$imageEl[0].offsetWidth,C.height=T.$imageEl[0].offsetHeight,C.startX=I(T.$imageWrapEl[0],"x")||0,C.startY=I(T.$imageWrapEl[0],"y")||0,T.slideWidth=T.$slideEl[0].offsetWidth,T.slideHeight=T.$slideEl[0].offsetHeight,T.$imageWrapEl.transition(0));var i=C.width*t.scale,t=C.height*t.scale;if(!(i<T.slideWidth&&t<T.slideHeight)){if(C.minX=Math.min(T.slideWidth/2-i/2,0),C.maxX=-C.minX,C.minY=Math.min(T.slideHeight/2-t/2,0),C.maxY=-C.minY,C.touchesCurrent.x=("touchmove"===e.type?e.targetTouches[0]:e).pageX,C.touchesCurrent.y=("touchmove"===e.type?e.targetTouches[0]:e).pageY,!C.isMoved&&!o){if(_.isHorizontal()&&(Math.floor(C.minX)===Math.floor(C.startX)&&C.touchesCurrent.x<C.touchesStart.x||Math.floor(C.maxX)===Math.floor(C.startX)&&C.touchesCurrent.x>C.touchesStart.x))return void(C.isTouched=!1);if(!_.isHorizontal()&&(Math.floor(C.minY)===Math.floor(C.startY)&&C.touchesCurrent.y<C.touchesStart.y||Math.floor(C.maxY)===Math.floor(C.startY)&&C.touchesCurrent.y>C.touchesStart.y))return void(C.isTouched=!1)}e.cancelable&&e.preventDefault(),e.stopPropagation(),C.isMoved=!0,C.currentX=C.touchesCurrent.x-C.touchesStart.x+C.startX,C.currentY=C.touchesCurrent.y-C.touchesStart.y+C.startY,C.currentX<C.minX&&(C.currentX=C.minX+1-(C.minX-C.currentX+1)**.8),C.currentX>C.maxX&&(C.currentX=C.maxX-1+(C.currentX-C.maxX+1)**.8),C.currentY<C.minY&&(C.currentY=C.minY+1-(C.minY-C.currentY+1)**.8),C.currentY>C.maxY&&(C.currentY=C.maxY-1+(C.currentY-C.maxY+1)**.8),l.prevPositionX||(l.prevPositionX=C.touchesCurrent.x),l.prevPositionY||(l.prevPositionY=C.touchesCurrent.y),l.prevTime||(l.prevTime=Date.now()),l.x=(C.touchesCurrent.x-l.prevPositionX)/(Date.now()-l.prevTime)/2,l.y=(C.touchesCurrent.y-l.prevPositionY)/(Date.now()-l.prevTime)/2,Math.abs(C.touchesCurrent.x-l.prevPositionX)<2&&(l.x=0),Math.abs(C.touchesCurrent.y-l.prevPositionY)<2&&(l.y=0),l.prevPositionX=C.touchesCurrent.x,l.prevPositionY=C.touchesCurrent.y,l.prevTime=Date.now(),T.$imageWrapEl.transform(`translate3d(${C.currentX}px, ${C.currentY}px,0)`)}}}function g(){var e=_.zoom;T.$slideEl&&_.previousIndex!==_.activeIndex&&(T.$imageEl&&T.$imageEl.transform("translate3d(0,0,0) scale(1)"),T.$imageWrapEl&&T.$imageWrapEl.transform("translate3d(0,0,0)"),e.scale=1,x=1,T.$slideEl=void 0,T.$imageEl=void 0,T.$imageWrapEl=void 0)}function f(v){var y=_.zoom,w=_.params.zoom;if(T.$slideEl||(v&&v.target&&(T.$slideEl=L(v.target).closest("."+_.params.slideClass)),T.$slideEl||(_.params.virtual&&_.params.virtual.enabled&&_.virtual?T.$slideEl=_.$wrapperEl.children("."+_.params.slideActiveClass):T.$slideEl=_.slides.eq(_.activeIndex)),T.$imageEl=T.$slideEl.find("."+w.containerClass).eq(0).find("picture, img, svg, canvas, .swiper-zoom-target").eq(0),T.$imageWrapEl=T.$imageEl.parent("."+w.containerClass)),T.$imageEl&&0!==T.$imageEl.length&&T.$imageWrapEl&&0!==T.$imageWrapEl.length){let e,t,i,n,s,a,r,o,l,c,d,u,p,h,m,g,f,b;_.params.cssMode&&(_.wrapperEl.style.overflow="hidden",_.wrapperEl.style.touchAction="none"),T.$slideEl.addClass(""+w.zoomedSlideClass),t=void 0===C.touchesStart.x&&v?(e=("touchend"===v.type?v.changedTouches[0]:v).pageX,("touchend"===v.type?v.changedTouches[0]:v).pageY):(e=C.touchesStart.x,C.touchesStart.y),y.scale=T.$imageWrapEl.attr("data-swiper-zoom")||w.maxRatio,x=T.$imageWrapEl.attr("data-swiper-zoom")||w.maxRatio,v?(f=T.$slideEl[0].offsetWidth,b=T.$slideEl[0].offsetHeight,i=T.$slideEl.offset().left+E.scrollX,n=T.$slideEl.offset().top+E.scrollY,s=i+f/2-e,a=n+b/2-t,l=T.$imageEl[0].offsetWidth,c=T.$imageEl[0].offsetHeight,d=l*y.scale,u=c*y.scale,m=-(p=Math.min(f/2-d/2,0)),g=-(h=Math.min(b/2-u/2,0)),r=s*y.scale,o=a*y.scale,(r=r<p?p:r)>m&&(r=m),(o=o<h?h:o)>g&&(o=g)):(r=0,o=0),T.$imageWrapEl.transition(300).transform(`translate3d(${r}px, ${o}px,0)`),T.$imageEl.transition(300).transform(`translate3d(0,0,0) scale(${y.scale})`)}}function b(){var e=_.zoom,t=_.params.zoom;T.$slideEl||(_.params.virtual&&_.params.virtual.enabled&&_.virtual?T.$slideEl=_.$wrapperEl.children("."+_.params.slideActiveClass):T.$slideEl=_.slides.eq(_.activeIndex),T.$imageEl=T.$slideEl.find("."+t.containerClass).eq(0).find("picture, img, svg, canvas, .swiper-zoom-target").eq(0),T.$imageWrapEl=T.$imageEl.parent("."+t.containerClass)),T.$imageEl&&0!==T.$imageEl.length&&T.$imageWrapEl&&0!==T.$imageWrapEl.length&&(_.params.cssMode&&(_.wrapperEl.style.overflow="",_.wrapperEl.style.touchAction=""),e.scale=1,x=1,T.$imageWrapEl.transition(300).transform("translate3d(0,0,0)"),T.$imageEl.transition(300).transform("translate3d(0,0,0) scale(1)"),T.$slideEl.removeClass(""+t.zoomedSlideClass),T.$slideEl=void 0)}function v(e){var t=_.zoom;t.scale&&1!==t.scale?b():f(e)}function y(){var e=_.support;return{passiveListener:!("touchstart"!==_.touchEvents.start||!e.passiveListener||!_.params.passiveListeners)&&{passive:!0,capture:!1},activeListenerWithCapture:!e.passiveListener||{passive:!1,capture:!0}}}function w(){return"."+_.params.slideClass}function S(e){var t=y()["passiveListener"],i=w();_.$wrapperEl[e]("gesturestart",i,u,t),_.$wrapperEl[e]("gesturechange",i,p,t),_.$wrapperEl[e]("gestureend",i,h,t)}function k(){s||(s=!0,S("on"))}function M(){s&&(s=!1,S("off"))}function N(){var e,t,i,n=_.zoom;n.enabled||(n.enabled=!0,n=_.support,{passiveListener:e,activeListenerWithCapture:t}=y(),i=w(),n.gestures?(_.$wrapperEl.on(_.touchEvents.start,k,e),_.$wrapperEl.on(_.touchEvents.end,M,e)):"touchstart"===_.touchEvents.start&&(_.$wrapperEl.on(_.touchEvents.start,i,u,e),_.$wrapperEl.on(_.touchEvents.move,i,p,t),_.$wrapperEl.on(_.touchEvents.end,i,h,e),_.touchEvents.cancel)&&_.$wrapperEl.on(_.touchEvents.cancel,i,h,e),_.$wrapperEl.on(_.touchEvents.move,"."+_.params.zoom.containerClass,m,t))}function O(){var e,t,i,n=_.zoom;n.enabled&&(e=_.support,{passiveListener:n,activeListenerWithCapture:t}=(n.enabled=!1,y()),i=w(),e.gestures?(_.$wrapperEl.off(_.touchEvents.start,k,n),_.$wrapperEl.off(_.touchEvents.end,M,n)):"touchstart"===_.touchEvents.start&&(_.$wrapperEl.off(_.touchEvents.start,i,u,n),_.$wrapperEl.off(_.touchEvents.move,i,p,t),_.$wrapperEl.off(_.touchEvents.end,i,h,n),_.touchEvents.cancel)&&_.$wrapperEl.off(_.touchEvents.cancel,i,h,n),_.$wrapperEl.off(_.touchEvents.move,"."+_.params.zoom.containerClass,m,t))}Object.defineProperty(_.zoom,"scale",{get:()=>c,set(e){var t,i;c!==e&&(t=T.$imageEl?T.$imageEl[0]:void 0,i=T.$slideEl?T.$slideEl[0]:void 0,n("zoomChange",e,t,i)),c=e}}),i("init",()=>{_.params.zoom.enabled&&N()}),i("destroy",()=>{O()}),i("touchStart",(e,t)=>{var i;_.zoom.enabled&&(t=t,i=_.device,T.$imageEl)&&0!==T.$imageEl.length&&!C.isTouched&&(i.android&&t.cancelable&&t.preventDefault(),C.isTouched=!0,C.touchesStart.x=("touchstart"===t.type?t.targetTouches[0]:t).pageX,C.touchesStart.y=("touchstart"===t.type?t.targetTouches[0]:t).pageY)}),i("touchEnd",(e,t)=>{if(_.zoom.enabled){var i=_.zoom;if(T.$imageEl&&0!==T.$imageEl.length){if(!C.isTouched||!C.isMoved)return void(C.isTouched=!1,C.isMoved=!1);C.isTouched=!1,C.isMoved=!1;let e=300,t=300;var n=l.x*e,n=C.currentX+n,s=l.y*t,s=C.currentY+s,a=(0!==l.x&&(e=Math.abs((n-C.currentX)/l.x)),0!==l.y&&(t=Math.abs((s-C.currentY)/l.y)),Math.max(e,t)),n=(C.currentX=n,C.currentY=s,C.width*i.scale),s=C.height*i.scale;C.minX=Math.min(T.slideWidth/2-n/2,0),C.maxX=-C.minX,C.minY=Math.min(T.slideHeight/2-s/2,0),C.maxY=-C.minY,C.currentX=Math.max(Math.min(C.currentX,C.maxX),C.minX),C.currentY=Math.max(Math.min(C.currentY,C.maxY),C.minY),T.$imageWrapEl.transition(a).transform(`translate3d(${C.currentX}px, ${C.currentY}px,0)`)}}}),i("doubleTap",(e,t)=>{!_.animating&&_.params.zoom.enabled&&_.zoom.enabled&&_.params.zoom.toggle&&v(t)}),i("transitionEnd",()=>{_.zoom.enabled&&_.params.zoom.enabled&&g()}),i("slideChange",()=>{_.zoom.enabled&&_.params.zoom.enabled&&_.params.cssMode&&g()}),Object.assign(_.zoom,{enable:N,disable:O,in:f,out:b,toggle:v})},function(e){let{swiper:d,extendParams:t,on:i,emit:u}=e,o=(t({lazy:{checkInView:!1,enabled:!1,loadPrevNext:!1,loadPrevNextAmount:1,loadOnTransitionStart:!1,scrollingElement:"",elementClass:"swiper-lazy",loadingClass:"swiper-lazy-loading",loadedClass:"swiper-lazy-loaded",preloaderClass:"swiper-lazy-preloader"}}),!(d.lazy={})),c=!1;function p(e,o){void 0===o&&(o=!0);const l=d.params.lazy;if(void 0!==e&&0!==d.slides.length){const c=d.virtual&&d.params.virtual.enabled?d.$wrapperEl.children(`.${d.params.slideClass}[data-swiper-slide-index="${e}"]`):d.slides.eq(e),t=c.find(`.${l.elementClass}:not(.${l.loadedClass}):not(.${l.loadingClass})`);!c.hasClass(l.elementClass)||c.hasClass(l.loadedClass)||c.hasClass(l.loadingClass)||t.push(c[0]),0!==t.length&&t.each(e=>{const t=L(e),i=(t.addClass(l.loadingClass),t.attr("data-background")),n=t.attr("data-src"),s=t.attr("data-srcset"),a=t.attr("data-sizes"),r=t.parent("picture");d.loadImage(t[0],n||i,s,a,!1,()=>{var e;null==d||!d||d&&!d.params||d.destroyed||(i?(t.css("background-image",`url("${i}")`),t.removeAttr("data-background")):(s&&(t.attr("srcset",s),t.removeAttr("data-srcset")),a&&(t.attr("sizes",a),t.removeAttr("data-sizes")),r.length&&r.children("source").each(e=>{e=L(e);e.attr("data-srcset")&&(e.attr("srcset",e.attr("data-srcset")),e.removeAttr("data-srcset"))}),n&&(t.attr("src",n),t.removeAttr("data-src"))),t.addClass(l.loadedClass).removeClass(l.loadingClass),c.find("."+l.preloaderClass).remove(),d.params.loop&&o&&(e=c.attr("data-swiper-slide-index"),c.hasClass(d.params.slideDuplicateClass)?p(d.$wrapperEl.children(`[data-swiper-slide-index="${e}"]:not(.${d.params.slideDuplicateClass})`).index(),!1):p(d.$wrapperEl.children(`.${d.params.slideDuplicateClass}[data-swiper-slide-index="${e}"]`).index(),!1)),u("lazyImageReady",c[0],t[0]),d.params.autoHeight&&d.updateAutoHeight())}),u("lazyImageLoad",c[0],t[0])})}}function l(){const{$wrapperEl:t,params:i,slides:n,activeIndex:s}=d,a=d.virtual&&i.virtual.enabled,e=i.lazy;let r=i.slidesPerView;function o(e){if(a){if(t.children(`.${i.slideClass}[data-swiper-slide-index="${e}"]`).length)return 1}else if(n[e])return 1}function l(e){return a?L(e).attr("data-swiper-slide-index"):L(e).index()}if("auto"===r&&(r=0),c=c||!0,d.params.watchSlidesProgress)t.children("."+i.slideVisibleClass).each(e=>{p(a?L(e).attr("data-swiper-slide-index"):L(e).index())});else if(1<r)for(let e=s;e<s+r;e+=1)o(e)&&p(e);else p(s);if(e.loadPrevNext)if(1<r||e.loadPrevNextAmount&&1<e.loadPrevNextAmount){const t=e.loadPrevNextAmount,d=Math.ceil(r),i=Math.min(s+d+Math.max(t,d),n.length),a=Math.max(s-Math.max(d,t),0);for(let e=s+d;e<i;e+=1)o(e)&&p(e);for(let e=a;e<s;e+=1)o(e)&&p(e)}else{const d=t.children("."+i.slideNextClass),n=(0<d.length&&p(l(d)),t.children("."+i.slidePrevClass));0<n.length&&p(l(n))}}function h(){var e=A();if(d&&!d.destroyed){var i=d.params.lazy.scrollingElement?L(d.params.lazy.scrollingElement):L(e),n=i[0]===e,s=n?e.innerWidth:i[0].offsetWidth,a=n?e.innerHeight:i[0].offsetHeight,n=d.$el.offset(),e=d["rtlTranslate"];let t=!1;e&&(n.left-=d.$el[0].scrollLeft);var r=[[n.left,n.top],[n.left+d.width,n.top],[n.left,n.top+d.height],[n.left+d.width,n.top+d.height]];for(let e=0;e<r.length;e+=1){const d=r[e];0<=d[0]&&d[0]<=s&&0<=d[1]&&d[1]<=a&&(0===d[0]&&0===d[1]||(t=!0))}e=!("touchstart"!==d.touchEvents.start||!d.support.passiveListener||!d.params.passiveListeners)&&{passive:!0,capture:!1};t?(l(),i.off("scroll",h,e)):o||(o=!0,i.on("scroll",h,e))}}i("beforeInit",()=>{d.params.lazy.enabled&&d.params.preloadImages&&(d.params.preloadImages=!1)}),i("init",()=>{d.params.lazy.enabled&&(d.params.lazy.checkInView?h:l)()}),i("scroll",()=>{d.params.freeMode&&d.params.freeMode.enabled&&!d.params.freeMode.sticky&&l()}),i("scrollbarDragMove resize _freeModeNoMomentumRelease",()=>{d.params.lazy.enabled&&(d.params.lazy.checkInView?h:l)()}),i("transitionStart",()=>{d.params.lazy.enabled&&(d.params.lazy.loadOnTransitionStart||!d.params.lazy.loadOnTransitionStart&&!c)&&(d.params.lazy.checkInView?h:l)()}),i("transitionEnd",()=>{d.params.lazy.enabled&&!d.params.lazy.loadOnTransitionStart&&(d.params.lazy.checkInView?h:l)()}),i("slideChange",()=>{var{lazy:e,cssMode:t,watchSlidesProgress:i,touchReleaseOnEdges:n,resistanceRatio:s}=d.params;e.enabled&&(t||i&&(n||0===s))&&l()}),i("destroy",()=>{d.$el&&d.$el.find("."+d.params.lazy.loadingClass).removeClass(d.params.lazy.loadingClass)}),Object.assign(d.lazy,{load:l,loadInSlide:p})},function(e){let{swiper:o,extendParams:t,on:i}=e;function l(e,t){const i=function(){let i,n,s;return(e,t)=>{for(n=-1,i=e.length;1<i-n;)e[s=i+n>>1]<=t?n=s:i=s;return i}}();let n,s;return this.x=e,this.y=t,this.lastIndex=e.length-1,this.interpolate=function(e){return e?(s=i(this.x,e),n=s-1,(e-this.x[n])*(this.y[s]-this.y[n])/(this.x[s]-this.x[n])+this.y[n]):0},this}function n(){o.controller.control&&o.controller.spline&&(o.controller.spline=void 0,delete o.controller.spline)}t({controller:{control:void 0,inverse:!1,by:"slide"}}),o.controller={control:void 0},i("beforeInit",()=>{o.controller.control=o.params.controller.control}),i("update",()=>{n()}),i("resize",()=>{n()}),i("observerUpdate",()=>{n()}),i("setTranslate",(e,t,i)=>{o.controller.control&&o.controller.setTranslate(t,i)}),i("setTransition",(e,t,i)=>{o.controller.control&&o.controller.setTransition(t,i)}),Object.assign(o.controller,{setTranslate:function(e,t){var i=o.controller.control;let n,s;var a=o.constructor;function r(e){var t,i=o.rtlTranslate?-o.translate:o.translate;"slide"===o.params.controller.by&&(t=e,o.controller.spline||(o.controller.spline=o.params.loop?new l(o.slidesGrid,t.slidesGrid):new l(o.snapGrid,t.snapGrid)),s=-o.controller.spline.interpolate(-i)),s&&"container"!==o.params.controller.by||(n=(e.maxTranslate()-e.minTranslate())/(o.maxTranslate()-o.minTranslate()),s=(i-o.minTranslate())*n+e.minTranslate()),o.params.controller.inverse&&(s=e.maxTranslate()-s),e.updateProgress(s),e.setTranslate(s,o),e.updateActiveIndex(),e.updateSlidesClasses()}if(Array.isArray(i))for(let e=0;e<i.length;e+=1)i[e]!==t&&i[e]instanceof a&&r(i[e]);else i instanceof a&&t!==i&&r(i)},setTransition:function(t,e){const i=o.constructor,n=o.controller.control;let s;function a(e){e.setTransition(t,o),0!==t&&(e.transitionStart(),e.params.autoHeight&&C(()=>{e.updateAutoHeight()}),e.$wrapperEl.transitionEnd(()=>{n&&(e.params.loop&&"slide"===o.params.controller.by&&e.loopFix(),e.transitionEnd())}))}if(Array.isArray(n))for(s=0;s<n.length;s+=1)n[s]!==e&&n[s]instanceof i&&a(n[s]);else n instanceof i&&e!==n&&a(n)}})},function(e){let{swiper:r,extendParams:t,on:i}=e,o=(t({a11y:{enabled:!0,notificationClass:"swiper-notification",prevSlideMessage:"Previous slide",nextSlideMessage:"Next slide",firstSlideMessage:"This is the first slide",lastSlideMessage:"This is the last slide",paginationBulletMessage:"Go to slide {{index}}",slideLabelMessage:"{{index}} / {{slidesLength}}",containerMessage:null,containerRoleDescriptionMessage:null,itemRoleDescriptionMessage:null,slideRole:"group",id:null}}),r.a11y={clicked:!1},null);function n(e){var t=o;0!==t.length&&(t.html(""),t.html(e))}function s(e){e.attr("tabIndex","0")}function a(e){e.attr("tabIndex","-1")}function l(e,t){e.attr("role",t)}function c(e,t){e.attr("aria-roledescription",t)}function d(e,t){e.attr("aria-label",t)}function u(e){e.attr("aria-disabled",!0)}function p(e){e.attr("aria-disabled",!1)}function h(e){var t;13!==e.keyCode&&32!==e.keyCode||(t=r.params.a11y,e=L(e.target),r.navigation&&r.navigation.$nextEl&&e.is(r.navigation.$nextEl)&&(r.isEnd&&!r.params.loop||r.slideNext(),r.isEnd?n(t.lastSlideMessage):n(t.nextSlideMessage)),r.navigation&&r.navigation.$prevEl&&e.is(r.navigation.$prevEl)&&(r.isBeginning&&!r.params.loop||r.slidePrev(),r.isBeginning?n(t.firstSlideMessage):n(t.prevSlideMessage)),r.pagination&&e.is(M(r.params.pagination.bulletClass))&&e[0].click())}function m(){return r.pagination&&r.pagination.bullets&&r.pagination.bullets.length}function g(){return m()&&r.params.pagination.clickable}const f=(e,t,i)=>{s(e),"BUTTON"!==e[0].tagName&&(l(e,"button"),e.on("keydown",h)),d(e,i),e.attr("aria-controls",t)},b=()=>{r.a11y.clicked=!0},v=()=>{requestAnimationFrame(()=>{requestAnimationFrame(()=>{r.a11y.clicked=!1})})},y=e=>{var t,i;r.a11y.clicked||(e=e.target.closest("."+r.params.slideClass))&&r.slides.includes(e)&&(t=r.slides.indexOf(e)===r.activeIndex,i=r.params.watchSlidesProgress&&r.visibleSlides&&r.visibleSlides.includes(e),t||i||(r.isHorizontal()?r.el.scrollLeft=0:r.el.scrollTop=0,r.slideTo(r.slides.indexOf(e),0)))},w=()=>{const i=r.params.a11y,n=(i.itemRoleDescriptionMessage&&c(L(r.slides),i.itemRoleDescriptionMessage),i.slideRole&&l(L(r.slides),i.slideRole),(r.params.loop?r.slides.filter(e=>!e.classList.contains(r.params.slideDuplicateClass)):r.slides).length);i.slideLabelMessage&&r.slides.each((e,t)=>{e=L(e),t=r.params.loop?parseInt(e.attr("data-swiper-slide-index"),10):t;d(e,i.slideLabelMessage.replace(/\{\{index\}\}/,t+1).replace(/\{\{slidesLength\}\}/,n))})};i("beforeInit",()=>{o=L(`<span class="${r.params.a11y.notificationClass}" aria-live="assertive" aria-atomic="true"></span>`)}),i("afterInit",()=>{if(r.params.a11y.enabled){var i=r.params.a11y,n=(r.$el.append(o),r.$el),n=(i.containerRoleDescriptionMessage&&c(n,i.containerRoleDescriptionMessage),i.containerMessage&&d(n,i.containerMessage),r.$wrapperEl),s=i.id||n.attr("id")||"swiper-wrapper-"+"x".repeat(s=void 0===(s=16)?16:s).replace(/x/g,()=>Math.round(16*Math.random()).toString(16)),a=r.params.autoplay&&r.params.autoplay.enabled?"off":"polite";let e,t;n.attr("id",s),n.attr("aria-live",a),w(),r.navigation&&r.navigation.$nextEl&&(e=r.navigation.$nextEl),r.navigation&&r.navigation.$prevEl&&(t=r.navigation.$prevEl),e&&e.length&&f(e,s,i.nextSlideMessage),t&&t.length&&f(t,s,i.prevSlideMessage),g()&&r.pagination.$el.on("keydown",M(r.params.pagination.bulletClass),h),r.$el.on("focus",y,!0),r.$el.on("pointerdown",b,!0),r.$el.on("pointerup",v,!0)}}),i("slidesLengthChange snapGridLengthChange slidesGridLengthChange",()=>{r.params.a11y.enabled&&w()}),i("fromEdge toEdge afterInit lock unlock",()=>{var e,t;r.params.a11y.enabled&&!r.params.loop&&!r.params.rewind&&r.navigation&&({$nextEl:e,$prevEl:t}=r.navigation,t&&0<t.length&&(r.isBeginning?(u(t),a):(p(t),s))(t),e&&0<e.length)&&(r.isEnd?(u(e),a):(p(e),s))(e)}),i("paginationUpdate",()=>{if(r.params.a11y.enabled){const t=r.params.a11y;m()&&r.pagination.bullets.each(e=>{e=L(e);r.params.pagination.clickable&&(s(e),r.params.pagination.renderBullet||(l(e,"button"),d(e,t.paginationBulletMessage.replace(/\{\{index\}\}/,e.index()+1)))),e.is("."+r.params.pagination.bulletActiveClass)?e.attr("aria-current","true"):e.removeAttr("aria-current")})}}),i("destroy",()=>{if(r.params.a11y.enabled){let e,t;o&&0<o.length&&o.remove(),r.navigation&&r.navigation.$nextEl&&(e=r.navigation.$nextEl),r.navigation&&r.navigation.$prevEl&&(t=r.navigation.$prevEl),e&&e.off("keydown",h),t&&t.off("keydown",h),g()&&r.pagination.$el.off("keydown",M(r.params.pagination.bulletClass),h),r.$el.off("focus",y,!0),r.$el.off("pointerdown",b,!0),r.$el.off("pointerup",v,!0)}})},function(e){let{swiper:r,extendParams:t,on:i}=e,a=(t({history:{enabled:!1,root:"",replaceState:!1,key:"slides",keepQuery:!1}}),!1),n={};const o=e=>e.toString().replace(/\s+/g,"-").replace(/[^\w-]+/g,"").replace(/--+/g,"-").replace(/^-+/,"").replace(/-+$/,""),s=e=>{var t=A(),e=(e?new URL(e):t.location).pathname.slice(1).split("/").filter(e=>""!==e),t=e.length;return{key:e[t-2],value:e[t-1]}},l=(i,e)=>{var n=A();if(a&&r.params.history.enabled){var s=r.params.url?new URL(r.params.url):n.location,e=r.slides.eq(e);let t=o(e.attr("data-history"));if(0<r.params.history.root.length){let e=r.params.history.root;"/"===e[e.length-1]&&(e=e.slice(0,e.length-1)),t=e+`/${i}/`+t}else s.pathname.includes(i)||(t=i+"/"+t);r.params.history.keepQuery&&(t+=s.search);e=n.history.state;e&&e.value===t||(r.params.history.replaceState?n.history.replaceState({value:t},null,t):n.history.pushState({value:t},null,t))}},c=(i,n,s)=>{if(n)for(let e=0,t=r.slides.length;e<t;e+=1){var a=r.slides.eq(e);if(o(a.attr("data-history"))===n&&!a.hasClass(r.params.slideDuplicateClass)){const n=a.index();r.slideTo(n,i,s)}}else r.slideTo(0,i,s)},d=()=>{n=s(r.params.url),c(r.params.speed,n.value,!1)};i("init",()=>{var e;r.params.history.enabled&&(e=A(),r.params.history)&&(e.history&&e.history.pushState?(a=!0,((n=s(r.params.url)).key||n.value)&&(c(0,n.value,r.params.runCallbacksOnInit),r.params.history.replaceState||e.addEventListener("popstate",d))):(r.params.history.enabled=!1,r.params.hashNavigation.enabled=!0))}),i("destroy",()=>{var e;r.params.history.enabled&&(e=A(),r.params.history.replaceState||e.removeEventListener("popstate",d))}),i("transitionEnd _freeModeNoMomentumRelease",()=>{a&&l(r.params.history.key,r.activeIndex)}),i("slideChange",()=>{a&&r.params.cssMode&&l(r.params.history.key,r.activeIndex)})},function(e){let{swiper:s,extendParams:t,emit:i,on:n}=e,a=!1;const r=T(),o=A(),l=(t({hashNavigation:{enabled:!1,replaceState:!1,watchState:!1}}),()=>{i("hashChange");var e=r.location.hash.replace("#","");e!==s.slides.eq(s.activeIndex).attr("data-hash")&&void 0!==(e=s.$wrapperEl.children(`.${s.params.slideClass}[data-hash="${e}"]`).index())&&s.slideTo(e)}),c=()=>{var e;a&&s.params.hashNavigation.enabled&&(s.params.hashNavigation.replaceState&&o.history&&o.history.replaceState?o.history.replaceState(null,null,"#"+s.slides.eq(s.activeIndex).attr("data-hash")||""):(e=(e=s.slides.eq(s.activeIndex)).attr("data-hash")||e.attr("data-history"),r.location.hash=e||""),i("hashSet"))};n("init",()=>{if(s.params.hashNavigation.enabled&&!(!s.params.hashNavigation.enabled||s.params.history&&s.params.history.enabled)){a=!0;const n=r.location.hash.replace("#","");if(n)for(let e=0,t=s.slides.length;e<t;e+=1){var i=s.slides.eq(e);if((i.attr("data-hash")||i.attr("data-history"))===n&&!i.hasClass(s.params.slideDuplicateClass)){const n=i.index();s.slideTo(n,0,s.params.runCallbacksOnInit,!0)}}s.params.hashNavigation.watchState&&L(o).on("hashchange",l)}}),n("destroy",()=>{s.params.hashNavigation.enabled&&s.params.hashNavigation.watchState&&L(o).off("hashchange",l)}),n("transitionEnd _freeModeNoMomentumRelease",()=>{a&&c()}),n("slideChange",()=>{a&&s.params.cssMode&&c()})},function(e){let i,{swiper:n,extendParams:t,on:s,emit:a}=e;function r(){if(n.size){var t=n.slides.eq(n.activeIndex);let e=n.params.autoplay.delay;t.attr("data-swiper-autoplay")&&(e=t.attr("data-swiper-autoplay")||n.params.autoplay.delay),clearTimeout(i),i=C(()=>{let e;n.params.autoplay.reverseDirection?n.params.loop?(n.loopFix(),e=n.slidePrev(n.params.speed,!0,!0),a("autoplay")):n.isBeginning?n.params.autoplay.stopOnLastSlide?l():(e=n.slideTo(n.slides.length-1,n.params.speed,!0,!0),a("autoplay")):(e=n.slidePrev(n.params.speed,!0,!0),a("autoplay")):n.params.loop?(n.loopFix(),e=n.slideNext(n.params.speed,!0,!0),a("autoplay")):n.isEnd?n.params.autoplay.stopOnLastSlide?l():(e=n.slideTo(0,n.params.speed,!0,!0),a("autoplay")):(e=n.slideNext(n.params.speed,!0,!0),a("autoplay")),(n.params.cssMode&&n.autoplay.running||!1===e)&&r()},e)}else n.autoplay.running=!1,n.autoplay.paused=!1}function o(){return void 0===i&&!n.autoplay.running&&(n.autoplay.running=!0,a("autoplayStart"),r(),!0)}function l(){return!!n.autoplay.running&&void 0!==i&&(i&&(clearTimeout(i),i=void 0),n.autoplay.running=!1,a("autoplayStop"),!0)}function c(e){!n.autoplay.running||n.autoplay.paused||(i&&clearTimeout(i),n.autoplay.paused=!0,0!==e&&n.params.autoplay.waitForTransition?["transitionend","webkitTransitionEnd"].forEach(e=>{n.$wrapperEl[0].addEventListener(e,u)}):(n.autoplay.paused=!1,r()))}function d(){var e=T();"hidden"===e.visibilityState&&n.autoplay.running&&c(),"visible"===e.visibilityState&&n.autoplay.paused&&(r(),n.autoplay.paused=!1)}function u(e){n&&!n.destroyed&&n.$wrapperEl&&e.target===n.$wrapperEl[0]&&(["transitionend","webkitTransitionEnd"].forEach(e=>{n.$wrapperEl[0].removeEventListener(e,u)}),n.autoplay.paused=!1,(n.autoplay.running?r:l)())}function p(){(n.params.autoplay.disableOnInteraction?l:(a("autoplayPause"),c))(),["transitionend","webkitTransitionEnd"].forEach(e=>{n.$wrapperEl[0].removeEventListener(e,u)})}function h(){n.params.autoplay.disableOnInteraction||(n.autoplay.paused=!1,a("autoplayResume"),r())}n.autoplay={running:!1,paused:!1},t({autoplay:{enabled:!1,delay:3e3,waitForTransition:!0,disableOnInteraction:!0,stopOnLastSlide:!1,reverseDirection:!1,pauseOnMouseEnter:!1}}),s("init",()=>{n.params.autoplay.enabled&&(o(),T().addEventListener("visibilitychange",d),n.params.autoplay.pauseOnMouseEnter)&&(n.$el.on("mouseenter",p),n.$el.on("mouseleave",h))}),s("beforeTransitionStart",(e,t,i)=>{n.autoplay.running&&(i||!n.params.autoplay.disableOnInteraction?n.autoplay.pause(t):l())}),s("sliderFirstMove",()=>{n.autoplay.running&&(n.params.autoplay.disableOnInteraction?l:c)()}),s("touchEnd",()=>{n.params.cssMode&&n.autoplay.paused&&!n.params.autoplay.disableOnInteraction&&r()}),s("destroy",()=>{n.$el.off("mouseenter",p),n.$el.off("mouseleave",h),n.autoplay.running&&l(),T().removeEventListener("visibilitychange",d)}),Object.assign(n.autoplay,{pause:c,run:r,start:o,stop:l})},function(e){let{swiper:l,extendParams:t,on:i}=e,n=(t({thumbs:{swiper:null,multipleActiveThumbs:!0,autoScrollOffset:0,slideThumbActiveClass:"swiper-slide-thumb-active",thumbsContainerClass:"swiper-thumbs"}}),!1),s=!1;function a(){var e=l.thumbs.swiper;if(e&&!e.destroyed){const i=e.clickedIndex,n=e.clickedSlide;if(!(n&&L(n).hasClass(l.params.thumbs.slideThumbActiveClass)||null==i)){let t;if(t=e.params.loop?parseInt(L(e.clickedSlide).attr("data-swiper-slide-index"),10):i,l.params.loop){let e=l.activeIndex;l.slides.eq(e).hasClass(l.params.slideDuplicateClass)&&(l.loopFix(),l._clientLeft=l.$wrapperEl[0].clientLeft,e=l.activeIndex);const i=l.slides.eq(e).prevAll(`[data-swiper-slide-index="${t}"]`).eq(0).index(),n=l.slides.eq(e).nextAll(`[data-swiper-slide-index="${t}"]`).eq(0).index();t=void 0===i||void 0!==n&&n-e<e-i?n:i}l.slideTo(t)}}}function r(){var e=l.params["thumbs"];if(n)return!1;n=!0;var t=l.constructor;return e.swiper instanceof t?(l.thumbs.swiper=e.swiper,Object.assign(l.thumbs.swiper.originalParams,{watchSlidesProgress:!0,slideToClickedSlide:!1}),Object.assign(l.thumbs.swiper.params,{watchSlidesProgress:!0,slideToClickedSlide:!1})):c(e.swiper)&&(e=Object.assign({},e.swiper),Object.assign(e,{watchSlidesProgress:!0,slideToClickedSlide:!1}),l.thumbs.swiper=new t(e),s=!0),l.thumbs.swiper.$el.addClass(l.params.thumbs.thumbsContainerClass),l.thumbs.swiper.on("tap",a),!0}function o(n){var s=l.thumbs.swiper;if(s&&!s.destroyed){const o="auto"===s.params.slidesPerView?s.slidesPerViewDynamic():s.params.slidesPerView;let t=1;var i=l.params.thumbs.slideThumbActiveClass;if(1<l.params.slidesPerView&&!l.params.centeredSlides&&(t=l.params.slidesPerView),l.params.thumbs.multipleActiveThumbs||(t=1),t=Math.floor(t),s.slides.removeClass(i),s.params.loop||s.params.virtual&&s.params.virtual.enabled)for(let e=0;e<t;e+=1)s.$wrapperEl.children(`[data-swiper-slide-index="${l.realIndex+e}"]`).addClass(i);else for(let e=0;e<t;e+=1)s.slides.eq(l.realIndex+e).addClass(i);var a=l.params.thumbs.autoScrollOffset,r=a&&!s.params.loop;if(l.realIndex!==s.realIndex||r){let e,t,i=s.activeIndex;if(s.params.loop){s.slides.eq(i).hasClass(s.params.slideDuplicateClass)&&(s.loopFix(),s._clientLeft=s.$wrapperEl[0].clientLeft,i=s.activeIndex);const n=s.slides.eq(i).prevAll(`[data-swiper-slide-index="${l.realIndex}"]`).eq(0).index(),o=s.slides.eq(i).nextAll(`[data-swiper-slide-index="${l.realIndex}"]`).eq(0).index();e=void 0===n?o:void 0===o?n:o-i==i-n?1<s.params.slidesPerGroup?o:i:o-i<i-n?o:n,t=l.activeIndex>l.previousIndex?"next":"prev"}else e=l.realIndex,t=e>l.previousIndex?"next":"prev";r&&(e+="next"===t?a:-1*a),s.visibleSlidesIndexes&&s.visibleSlidesIndexes.indexOf(e)<0&&(s.params.centeredSlides?e=e>i?e-Math.floor(o/2)+1:e+Math.floor(o/2)-1:e>i&&s.params.slidesPerGroup,s.slideTo(e,n?0:void 0))}}}l.thumbs={swiper:null},i("beforeInit",()=>{var e=l.params["thumbs"];e&&e.swiper&&(r(),o(!0))}),i("slideChange update resize observerUpdate",()=>{o()}),i("setTransition",(e,t)=>{var i=l.thumbs.swiper;i&&!i.destroyed&&i.setTransition(t)}),i("beforeDestroy",()=>{var e=l.thumbs.swiper;e&&!e.destroyed&&s&&e.destroy()}),Object.assign(l.thumbs,{init:r,update:o})},function(e){let{swiper:p,extendParams:t,emit:h,once:m}=e;t({freeMode:{enabled:!1,momentum:!0,momentumRatio:1,momentumBounce:!0,momentumBounceRatio:1,momentumVelocityRatio:1,sticky:!1,minimumVelocity:.02}}),Object.assign(p,{freeMode:{onTouchStart:function(){var e=p.getTranslate();p.setTranslate(e),p.setTransition(0),p.touchEventsData.velocities.length=0,p.freeMode.onTouchEnd({currentPos:p.rtl?p.translate:-p.translate})},onTouchMove:function(){var{touchEventsData:e,touches:t}=p;0===e.velocities.length&&e.velocities.push({position:t[p.isHorizontal()?"startX":"startY"],time:e.touchStartTime}),e.velocities.push({position:t[p.isHorizontal()?"currentX":"currentY"],time:b()})},onTouchEnd:function(a){let r=a["currentPos"];const{params:o,$wrapperEl:l,rtlTranslate:c,snapGrid:d,touchEventsData:u}=p,e=b()-u.touchStartTime;if(r<-p.minTranslate())p.slideTo(p.activeIndex);else if(r>-p.maxTranslate())p.slides.length<d.length?p.slideTo(d.length-1):p.slideTo(p.slides.length-1);else{if(o.freeMode.momentum){if(1<u.velocities.length){const a=u.velocities.pop(),r=u.velocities.pop(),h=a.position-r.position,m=a.time-r.time;p.velocity=h/m,p.velocity/=2,Math.abs(p.velocity)<o.freeMode.minimumVelocity&&(p.velocity=0),(150<m||300<b()-a.time)&&(p.velocity=0)}else p.velocity=0;p.velocity*=o.freeMode.momentumVelocityRatio,u.velocities.length=0;let e=1e3*o.freeMode.momentumRatio;const r=p.velocity*e;let i=p.translate+r;c&&(i=-i);let t,n=!1;a=20*Math.abs(p.velocity)*o.freeMode.momentumBounceRatio;let s;if(i<p.maxTranslate())o.freeMode.momentumBounce?(i+p.maxTranslate()<-a&&(i=p.maxTranslate()-a),t=p.maxTranslate(),n=!0,u.allowMomentumBounce=!0):i=p.maxTranslate(),o.loop&&o.centeredSlides&&(s=!0);else if(i>p.minTranslate())o.freeMode.momentumBounce?(i-p.minTranslate()>a&&(i=p.minTranslate()+a),t=p.minTranslate(),n=!0,u.allowMomentumBounce=!0):i=p.minTranslate(),o.loop&&o.centeredSlides&&(s=!0);else if(o.freeMode.sticky){let t;for(let e=0;e<d.length;e+=1)if(d[e]>-i){t=e;break}i=-(i=Math.abs(d[t]-i)<Math.abs(d[t-1]-i)||"next"===p.swipeDirection?d[t]:d[t-1])}if(s&&m("transitionEnd",()=>{p.loopFix()}),0!==p.velocity){if(e=c?Math.abs((-i-p.translate)/p.velocity):Math.abs((i-p.translate)/p.velocity),o.freeMode.sticky){const r=Math.abs((c?-i:i)-p.translate),h=p.slidesSizesGrid[p.activeIndex];e=r<h?o.speed:r<2*h?1.5*o.speed:2.5*o.speed}}else if(o.freeMode.sticky)return void p.slideToClosest();o.freeMode.momentumBounce&&n?(p.updateProgress(t),p.setTransition(e),p.setTranslate(i),p.transitionStart(!0,p.swipeDirection),p.animating=!0,l.transitionEnd(()=>{p&&!p.destroyed&&u.allowMomentumBounce&&(h("momentumBounce"),p.setTransition(o.speed),setTimeout(()=>{p.setTranslate(t),l.transitionEnd(()=>{p&&!p.destroyed&&p.transitionEnd()})},0))})):p.velocity?(h("_freeModeNoMomentumRelease"),p.updateProgress(i),p.setTransition(e),p.setTranslate(i),p.transitionStart(!0,p.swipeDirection),p.animating||(p.animating=!0,l.transitionEnd(()=>{p&&!p.destroyed&&p.transitionEnd()}))):p.updateProgress(i),p.updateActiveIndex(),p.updateSlidesClasses()}else{if(o.freeMode.sticky)return void p.slideToClosest();o.freeMode&&h("_freeModeNoMomentumRelease")}(!o.freeMode.momentum||e>=o.longSwipesMs)&&(p.updateProgress(),p.updateActiveIndex(),p.updateSlidesClasses())}}}})},function(e){let u,p,h,{swiper:m,extendParams:t}=e;t({grid:{rows:1,fill:"column"}}),m.grid={initSlides:e=>{var t=m.params["slidesPerView"],{rows:i,fill:n}=m.params.grid;p=u/i,h=Math.floor(e/i),u=Math.floor(e/i)===e/i?e:Math.ceil(e/i)*i,"auto"!==t&&"row"===n&&(u=Math.max(u,t*i))},updateSlide:(e,t,i,n)=>{var{slidesPerGroup:s,spaceBetween:a}=m.params,{rows:r,fill:o}=m.params.grid;let l,c,d;if("row"===o&&1<s){const p=Math.floor(e/(s*r)),h=e-r*s*p,m=0===p?s:Math.min(Math.ceil((i-p*r*s)/r),s);d=Math.floor(h/m),l=(c=h-d*m+p*s)+d*u/r,t.css({"-webkit-order":l,order:l})}else"column"===o?(c=Math.floor(e/r),d=e-c*r,(c>h||c===h&&d===r-1)&&(d+=1)>=r&&(d=0,c+=1)):(d=Math.floor(e/p),c=e-d*p);t.css(n("margin-top"),0!==d?a&&a+"px":"")},updateWrapperSize:(i,n,e)=>{var{spaceBetween:t,centeredSlides:s,roundLengths:a}=m.params,r=m.params.grid["rows"];if(m.virtualSize=(i+t)*u,m.virtualSize=Math.ceil(m.virtualSize/r)-t,m.$wrapperEl.css({[e("width")]:m.virtualSize+t+"px"}),s){n.splice(0,n.length);const i=[];for(let t=0;t<n.length;t+=1){let e=n[t];a&&(e=Math.floor(e)),n[t]<m.virtualSize+n[0]&&i.push(e)}n.push(...i)}}}},function(e){e=e.swiper;Object.assign(e,{appendSlide:function(t){var{$wrapperEl:i,params:e}=this;if(e.loop&&this.loopDestroy(),"object"==typeof t&&"length"in t)for(let e=0;e<t.length;e+=1)t[e]&&i.append(t[e]);else i.append(t);e.loop&&this.loopCreate(),e.observer||this.update()}.bind(e),prependSlide:function(t){var e=this,{params:i,$wrapperEl:n,activeIndex:s}=e;i.loop&&e.loopDestroy();let a=s+1;if("object"==typeof t&&"length"in t){for(let e=0;e<t.length;e+=1)t[e]&&n.prepend(t[e]);a=s+t.length}else n.prepend(t);i.loop&&e.loopCreate(),i.observer||e.update(),e.slideTo(a,0,!1)}.bind(e),addSlide:function(t,i){var n=this,{$wrapperEl:s,params:a,activeIndex:r}=n;let o=r;if(a.loop&&(o-=n.loopedSlides,n.loopDestroy(),n.slides=s.children("."+a.slideClass)),r=n.slides.length,t<=0)n.prependSlide(i);else if(r<=t)n.appendSlide(i);else{let e=o>t?o+1:o;var l=[];for(let e=r-1;e>=t;--e){const t=n.slides.eq(e);t.remove(),l.unshift(t)}if("object"==typeof i&&"length"in i){for(let e=0;e<i.length;e+=1)i[e]&&s.append(i[e]);e=o>t?o+i.length:o}else s.append(i);for(let e=0;e<l.length;e+=1)s.append(l[e]);a.loop&&n.loopCreate(),a.observer||n.update(),a.loop?n.slideTo(e+n.loopedSlides,0,!1):n.slideTo(e,0,!1)}}.bind(e),removeSlide:function(t){var i=this,{params:e,$wrapperEl:n,activeIndex:s}=i;let a=s;e.loop&&(a-=i.loopedSlides,i.loopDestroy(),i.slides=n.children("."+e.slideClass));let r,o=a;if("object"==typeof t&&"length"in t)for(let e=0;e<t.length;e+=1)r=t[e],i.slides[r]&&i.slides.eq(r).remove(),r<o&&--o;else r=t,i.slides[r]&&i.slides.eq(r).remove(),r<o&&--o;o=Math.max(o,0),e.loop&&i.loopCreate(),e.observer||i.update(),e.loop?i.slideTo(o+i.loopedSlides,0,!1):i.slideTo(o,0,!1)}.bind(e),removeAllSlides:function(){var t=[];for(let e=0;e<this.slides.length;e+=1)t.push(e);this.removeSlide(t)}.bind(e)})},function(e){let{swiper:r,extendParams:t,on:i}=e;t({fadeEffect:{crossFade:!1,transformEl:null}}),N({effect:"fade",swiper:r,on:i,setTranslate:()=>{const n=r["slides"],s=r.params.fadeEffect;for(let i=0;i<n.length;i+=1){const n=r.slides.eq(i);let e=-n[0].swiperSlideOffset,t=(r.params.virtualTranslate||(e-=r.translate),0);r.isHorizontal()||(t=e,e=0);var a=r.params.fadeEffect.crossFade?Math.max(1-Math.abs(n[0].progress),0):1+Math.min(Math.max(n[0].progress,-1),0);O(s,n).css({opacity:a}).transform(`translate3d(${e}px, ${t}px, 0px)`)}},setTransition:e=>{var t=r.params.fadeEffect["transformEl"];(t?r.slides.find(t):r.slides).transition(e),D({swiper:r,duration:e,transformEl:t,allSlides:!0})},overwriteParams:()=>({slidesPerView:1,slidesPerGroup:1,watchSlidesProgress:!0,spaceBetween:0,virtualTranslate:!r.params.cssMode})})},function(e){let{swiper:g,extendParams:t,on:i}=e;t({cubeEffect:{slideShadows:!0,shadow:!0,shadowOffset:20,shadowScale:.94}});const f=(e,t,i)=>{let n=i?e.find(".swiper-slide-shadow-left"):e.find(".swiper-slide-shadow-top"),s=i?e.find(".swiper-slide-shadow-right"):e.find(".swiper-slide-shadow-bottom");0===n.length&&(n=L(`<div class="swiper-slide-shadow-${i?"left":"top"}"></div>`),e.append(n)),0===s.length&&(s=L(`<div class="swiper-slide-shadow-${i?"right":"bottom"}"></div>`),e.append(s)),n.length&&(n[0].style.opacity=Math.max(-t,0)),s.length&&(s[0].style.opacity=Math.max(t,0))};N({effect:"cube",swiper:g,on:i,setTranslate:()=>{const{$el:e,$wrapperEl:t,slides:o,width:i,height:n,rtlTranslate:l,size:c,browser:s}=g,d=g.params.cubeEffect,u=g.isHorizontal(),p=g.virtual&&g.params.virtual.enabled;let a,h=0;d.shadow&&(u?(0===(a=t.find(".swiper-cube-shadow")).length&&(a=L('<div class="swiper-cube-shadow"></div>'),t.append(a)),a.css({height:i+"px"})):0===(a=e.find(".swiper-cube-shadow")).length&&(a=L('<div class="swiper-cube-shadow"></div>'),e.append(a)));for(let r=0;r<o.length;r+=1){const g=o.eq(r);let e=r,t=90*(e=p?parseInt(g.attr("data-swiper-slide-index"),10):e),i=Math.floor(t/360);l&&(t=-t,i=Math.floor(-t/360));const L=Math.max(Math.min(g[0].progress,1),-1);let n=0,s=0,a=0;e%4==0?(n=4*-i*c,a=0):(e-1)%4==0?(n=0,a=4*-i*c):(e-2)%4==0?(n=c+4*i*c,a=c):(e-3)%4==0&&(n=-c,a=3*c+4*c*i),l&&(n=-n),u||(s=n,n=0);var m=`rotateX(${u?0:-t}deg) rotateY(${u?t:0}deg) translate3d(${n}px, ${s}px, ${a}px)`;L<=1&&-1<L&&(h=90*e+90*L,l)&&(h=90*-e-90*L),g.transform(m),d.slideShadows&&f(g,L,u)}if(t.css({"-webkit-transform-origin":`50% 50% -${c/2}px`,"transform-origin":`50% 50% -${c/2}px`}),d.shadow)if(u)a.transform(`translate3d(0px, ${i/2+d.shadowOffset}px, ${-i/2}px) rotateX(90deg) rotateZ(0deg) scale(${d.shadowScale})`);else{const e=Math.abs(h)-90*Math.floor(Math.abs(h)/90),g=1.5-(Math.sin(2*e*Math.PI/360)/2+Math.cos(2*e*Math.PI/360)/2),t=d.shadowScale,o=d.shadowScale/g,f=d.shadowOffset;a.transform(`scale3d(${t}, 1, ${o}) translate3d(0px, ${n/2+f}px, ${-n/2/o}px) rotateX(-90deg)`)}var r=s.isSafari||s.isWebView?-c/2:0;t.transform(`translate3d(0px,0,${r}px) rotateX(${g.isHorizontal()?0:h}deg) rotateY(${g.isHorizontal()?-h:0}deg)`),t[0].style.setProperty("--swiper-cube-translate-z",r+"px")},setTransition:e=>{var{$el:t,slides:i}=g;i.transition(e).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").transition(e),g.params.cubeEffect.shadow&&!g.isHorizontal()&&t.find(".swiper-cube-shadow").transition(e)},recreateShadows:()=>{const i=g.isHorizontal();g.slides.each(e=>{var t=Math.max(Math.min(e.progress,1),-1);f(L(e),t,i)})},getEffectParams:()=>g.params.cubeEffect,perspective:()=>!0,overwriteParams:()=>({slidesPerView:1,slidesPerGroup:1,watchSlidesProgress:!0,resistanceRatio:0,spaceBetween:0,centeredSlides:!1,virtualTranslate:!0})})},function(e){let{swiper:u,extendParams:t,on:i}=e;t({flipEffect:{slideShadows:!0,limitRotation:!0,transformEl:null}});const p=(e,t,i)=>{let n=u.isHorizontal()?e.find(".swiper-slide-shadow-left"):e.find(".swiper-slide-shadow-top"),s=u.isHorizontal()?e.find(".swiper-slide-shadow-right"):e.find(".swiper-slide-shadow-bottom");0===n.length&&(n=$(i,e,u.isHorizontal()?"left":"top")),0===s.length&&(s=$(i,e,u.isHorizontal()?"right":"bottom")),n.length&&(n[0].style.opacity=Math.max(-t,0)),s.length&&(s[0].style.opacity=Math.max(t,0))};N({effect:"flip",swiper:u,on:i,setTranslate:()=>{var{slides:r,rtlTranslate:o}=u,l=u.params.flipEffect;for(let a=0;a<r.length;a+=1){var c=r.eq(a);let e=c[0].progress;u.params.flipEffect.limitRotation&&(e=Math.max(Math.min(c[0].progress,1),-1));var d=c[0].swiperSlideOffset;let t=-180*e,i=0,n=u.params.cssMode?-d-u.translate:-d,s=0;u.isHorizontal()?o&&(t=-t):(s=n,n=0,i=-t,t=0),c[0].style.zIndex=-Math.abs(Math.round(e))+r.length,l.slideShadows&&p(c,e,l);d=`translate3d(${n}px, ${s}px, 0px) rotateX(${i}deg) rotateY(${t}deg)`;O(l,c).transform(d)}},setTransition:e=>{var t=u.params.flipEffect["transformEl"];(t?u.slides.find(t):u.slides).transition(e).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").transition(e),D({swiper:u,duration:e,transformEl:t})},recreateShadows:()=>{const n=u.params.flipEffect;u.slides.each(e=>{var t=L(e);let i=t[0].progress;u.params.flipEffect.limitRotation&&(i=Math.max(Math.min(e.progress,1),-1)),p(t,i,n)})},getEffectParams:()=>u.params.flipEffect,perspective:()=>!0,overwriteParams:()=>({slidesPerView:1,slidesPerGroup:1,watchSlidesProgress:!0,spaceBetween:0,virtualTranslate:!u.params.cssMode})})},function(e){let{swiper:y,extendParams:t,on:i}=e;t({coverflowEffect:{rotate:50,stretch:0,depth:100,scale:1,modifier:1,slideShadows:!0,transformEl:null}}),N({effect:"coverflow",swiper:y,on:i,setTranslate:()=>{const{width:e,height:l,slides:c,slidesSizesGrid:d}=y,u=y.params.coverflowEffect,p=y.isHorizontal(),h=y.translate,m=p?e/2-h:l/2-h,g=p?u.rotate:-u.rotate,f=u.depth;for(let o=0,e=c.length;o<e;o+=1){const y=c.eq(o),l=d[o],h=(m-y[0].swiperSlideOffset-l/2)/l,v="function"==typeof u.modifier?u.modifier(h):h*u.modifier;let e=p?g*v:0,t=p?0:g*v,i=-f*Math.abs(v),n=u.stretch,s=("string"==typeof n&&-1!==n.indexOf("%")&&(n=parseFloat(u.stretch)/100*l),p?0:n*v),a=p?n*v:0,r=1-(1-u.scale)*Math.abs(v);Math.abs(a)<.001&&(a=0),Math.abs(s)<.001&&(s=0),Math.abs(i)<.001&&(i=0),Math.abs(e)<.001&&(e=0),Math.abs(t)<.001&&(t=0),Math.abs(r)<.001&&(r=0);var b=`translate3d(${a}px,${s}px,${i}px)  rotateX(${t}deg) rotateY(${e}deg) scale(${r})`;if(O(u,y).transform(b),y[0].style.zIndex=1-Math.abs(Math.round(v)),u.slideShadows){let e=p?y.find(".swiper-slide-shadow-left"):y.find(".swiper-slide-shadow-top"),t=p?y.find(".swiper-slide-shadow-right"):y.find(".swiper-slide-shadow-bottom");0===e.length&&(e=$(u,y,p?"left":"top")),0===t.length&&(t=$(u,y,p?"right":"bottom")),e.length&&(e[0].style.opacity=0<v?v:0),t.length&&(t[0].style.opacity=0<-v?-v:0)}}},setTransition:e=>{var t=y.params.coverflowEffect["transformEl"];(t?y.slides.find(t):y.slides).transition(e).find(".swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left").transition(e)},perspective:()=>!0,overwriteParams:()=>({watchSlidesProgress:!0})})},function(e){let{swiper:v,extendParams:t,on:i}=e;t({creativeEffect:{transformEl:null,limitProgress:1,shadowPerProgress:!1,progressMultiplier:1,perspective:!0,prev:{translate:[0,0,0],rotate:[0,0,0],opacity:1,scale:1},next:{translate:[0,0,0],rotate:[0,0,0],opacity:1,scale:1}}});N({effect:"creative",swiper:v,on:i,setTranslate:()=>{const{slides:s,$wrapperEl:e,slidesSizesGrid:a}=v,r=v.params.creativeEffect,o=r["progressMultiplier"],l=v.params.centeredSlides;if(l){const s=a[0]/2-v.params.slidesOffsetBefore||0;e.transform(`translateX(calc(50% - ${s}px))`)}for(let n=0;n<s.length;n+=1){const a=s.eq(n),h=a[0].progress,m=Math.min(Math.max(a[0].progress,-r.limitProgress),r.limitProgress);let e=m;l||(e=Math.min(Math.max(a[0].originalProgress,-r.limitProgress),r.limitProgress));const g=a[0].swiperSlideOffset,f=[v.params.cssMode?-g-v.translate:-g,0,0],b=[0,0,0];let t=!1,i=(v.isHorizontal()||(f[1]=f[0],f[0]=0),{translate:[0,0,0],rotate:[0,0,0],scale:1,opacity:1});m<0?(i=r.next,t=!0):0<m&&(i=r.prev,t=!0),f.forEach((e,t)=>{f[t]=`calc(${e}px + (${e=i.translate[t],"string"==typeof e?e:e+"px"} * ${Math.abs(m*o)}))`}),b.forEach((e,t)=>{b[t]=i.rotate[t]*Math.abs(m*o)}),a[0].style.zIndex=-Math.abs(Math.round(h))+s.length;var c=f.join(", "),d=`rotateX(${b[0]}deg) rotateY(${b[1]}deg) rotateZ(${b[2]}deg)`,u=e<0?`scale(${1+(1-i.scale)*e*o})`:`scale(${1-(1-i.scale)*e*o})`,p=e<0?1+(1-i.opacity)*e*o:1-(1-i.opacity)*e*o,c=`translate3d(${c}) ${d} `+u;if(t&&i.shadow||!t){let e=a.children(".swiper-slide-shadow");if((e=0===e.length&&i.shadow?$(r,a):e).length){const v=r.shadowPerProgress?m*(1/r.limitProgress):m;e[0].style.opacity=Math.min(Math.max(Math.abs(v),0),1)}}d=O(r,a);d.transform(c).css({opacity:p}),i.origin&&d.css("transform-origin",i.origin)}},setTransition:e=>{var t=v.params.creativeEffect["transformEl"];(t?v.slides.find(t):v.slides).transition(e).find(".swiper-slide-shadow").transition(e),D({swiper:v,duration:e,transformEl:t,allSlides:!0})},perspective:()=>v.params.creativeEffect.perspective,overwriteParams:()=>({watchSlidesProgress:!0,virtualTranslate:!v.params.cssMode})})},function(e){let{swiper:y,extendParams:t,on:i}=e;t({cardsEffect:{slideShadows:!0,transformEl:null,rotate:!0,perSlideRotate:2,perSlideOffset:8}}),N({effect:"cards",swiper:y,on:i,setTranslate:()=>{const{slides:o,activeIndex:l}=y,c=y.params.cardsEffect,{startTranslate:d,isTouched:u}=y.touchEventsData,p=y.translate;for(let r=0;r<o.length;r+=1){var h=o.eq(r),m=h[0].progress,g=Math.min(Math.max(m,-4),4);let e=h[0].swiperSlideOffset,t=(y.params.centeredSlides&&!y.params.cssMode&&y.$wrapperEl.transform(`translateX(${y.minTranslate()}px)`),y.params.centeredSlides&&y.params.cssMode&&(e-=o[0].swiperSlideOffset),y.params.cssMode?-e-y.translate:-e),i=0;var f=-100*Math.abs(g);let n=1,s=-c.perSlideRotate*g,a=c.perSlideOffset-.75*Math.abs(g);var b=y.virtual&&y.params.virtual.enabled?y.virtual.from+r:r,v=(b===l||b===l-1)&&0<g&&g<1&&(u||y.params.cssMode)&&p<d,b=(b===l||b===l+1)&&g<0&&-1<g&&(u||y.params.cssMode)&&d<p;if(v||b){const o=(1-Math.abs((Math.abs(g)-.5)/.5))**.5;s+=-28*g*o,n+=-.5*o,a+=96*o,i=-25*o*Math.abs(g)+"%"}if(t=g<0?`calc(${t}px + (${a*Math.abs(g)}%))`:0<g?`calc(${t}px + (-${a*Math.abs(g)}%))`:t+"px",!y.isHorizontal()){const o=i;i=t,t=o}v=g<0?""+(1+(1-n)*g):""+(1-(1-n)*g),b=`
        translate3d(${t}, ${i}, ${f}px)
        rotateZ(${c.rotate?s:0}deg)
        scale(${v})
      `;if(c.slideShadows){let e=h.find(".swiper-slide-shadow");(e=0===e.length?$(c,h):e).length&&(e[0].style.opacity=Math.min(Math.max((Math.abs(g)-.5)/.5,0),1))}h[0].style.zIndex=-Math.abs(Math.round(m))+o.length,O(c,h).transform(b)}},setTransition:e=>{var t=y.params.cardsEffect["transformEl"];(t?y.slides.find(t):y.slides).transition(e).find(".swiper-slide-shadow").transition(e),D({swiper:y,duration:e,transformEl:t})},perspective:()=>!0,overwriteParams:()=>({watchSlidesProgress:!0,virtualTranslate:!y.params.cssMode})})}]),x}),
//# sourceMappingURL=swiper-bundle.min.js.map
/*!
 * Toastify js 1.12.0
 * https://github.com/apvarun/toastify-js
 * @license MIT licensed
 *
 * Copyright (C) 2018 Varun A P
 */
function(e,t){"object"==typeof module&&module.exports?module.exports=t():e.Toastify=t()}(this,function(e){function i(e){
// Returning a new init object
return new i.lib.init(e)}
// Helper function to get offset.
function a(e,t){return t.offset[e]?isNaN(t.offset[e])?t.offset[e]:t.offset[e]+"px":"0px"}function o(e,t){return!(!e||"string"!=typeof t||!(e.className&&-1<e.className.trim().split(/\s+/gi).indexOf(t)))}
// Setting up the prototype for the init object
// Returning the Toastify function to be assigned to the window object/module
// Set the default global options
return i.defaults={oldestFirst:!0,text:"Toastify is awesome!",node:void 0,duration:3e3,selector:void 0,callback:function(){},destination:void 0,newWindow:!1,close:!1,gravity:"toastify-top",positionLeft:!1,position:"",backgroundColor:"",avatar:"",className:"",stopOnFocus:!0,onClick:function(){},offset:{x:0,y:0},escapeMarkup:!0,ariaLive:"polite",style:{background:""}},
// Defining the prototype of the object
i.lib=i.prototype={toastify:"1.12.0",constructor:i,
// Initializing the object with required parameters
init:function(e){
// Returning the current object for chaining functions
// Verifying and validating the input object
return e=e||{},
// Creating the options object
this.options={},this.toastElement=null,
// Validating the options
this.options.text=e.text||i.defaults.text,// Display message
this.options.node=e.node||i.defaults.node,// Display content as node
this.options.duration=0===e.duration?0:e.duration||i.defaults.duration,// Display duration
this.options.selector=e.selector||i.defaults.selector,// Parent selector
this.options.callback=e.callback||i.defaults.callback,// Callback after display
this.options.destination=e.destination||i.defaults.destination,// On-click destination
this.options.newWindow=e.newWindow||i.defaults.newWindow,// Open destination in new window
this.options.close=e.close||i.defaults.close,// Show toast close icon
this.options.gravity="bottom"===e.gravity?"toastify-bottom":i.defaults.gravity,// toast position - top or bottom
this.options.positionLeft=e.positionLeft||i.defaults.positionLeft,// toast position - left or right
this.options.position=e.position||i.defaults.position,// toast position - left or right
this.options.backgroundColor=e.backgroundColor||i.defaults.backgroundColor,// toast background color
this.options.avatar=e.avatar||i.defaults.avatar,// img element src - url or a path
this.options.className=e.className||i.defaults.className,// additional class names for the toast
this.options.stopOnFocus=(void 0===e.stopOnFocus?i.defaults:e).stopOnFocus,// stop timeout on focus
this.options.onClick=e.onClick||i.defaults.onClick,// Callback after click
this.options.offset=e.offset||i.defaults.offset,// toast offset
this.options.escapeMarkup=(void 0!==e.escapeMarkup?e:i.defaults).escapeMarkup,this.options.ariaLive=e.ariaLive||i.defaults.ariaLive,this.options.style=e.style||i.defaults.style,e.backgroundColor&&(this.options.style.background=e.backgroundColor),this},
// Building the DOM element
buildToast:function(){
// Validating if the options are defined
if(!this.options)throw"Toastify is not initialized";
// Creating the DOM object
var e,t,i,n,s=document.createElement("div");
// Loop through our style object and apply styles to divElement
for(e in s.className="toastify on "+this.options.className,
// Positioning toast to left or right or center
this.options.position?s.className+=" toastify-"+this.options.position:
// To be depreciated in further versions
!0===this.options.positionLeft?(s.className+=" toastify-left",console.warn("Property `positionLeft` will be depreciated in further versions. Please use `position` instead.")):
// Default position
s.className+=" toastify-right",
// Assigning gravity of element
s.className+=" "+this.options.gravity,this.options.backgroundColor&&
// This is being deprecated in favor of using the style HTML DOM property
console.warn('DEPRECATION NOTICE: "backgroundColor" is being deprecated. Please use the "style.background" property.'),this.options.style)s.style[e]=this.options.style[e];
// Announce the toast to screen readers
// Returning the generated element
return this.options.ariaLive&&s.setAttribute("aria-live",this.options.ariaLive),
// Adding the toast message/node
this.options.node&&this.options.node.nodeType===Node.ELEMENT_NODE?
// If we have a valid node, we insert it
s.appendChild(this.options.node):(this.options.escapeMarkup?s.innerText=this.options.text:s.innerHTML=this.options.text,""!==this.options.avatar&&((n=document.createElement("img")).src=this.options.avatar,n.className="toastify-avatar","left"==this.options.position||!0===this.options.positionLeft?
// Adding close icon on the left of content
s.appendChild(n):
// Adding close icon on the right of content
s.insertAdjacentElement("afterbegin",n))),
// Adding a close icon to the toast
!0===this.options.close&&((n=document.createElement("button")).type="button",n.setAttribute("aria-label","Close"),n.className="toast-close",n.innerHTML="&#10006;",
// Triggering the removal of toast from DOM on close click
n.addEventListener("click",function(e){e.stopPropagation(),this.removeElement(this.toastElement),window.clearTimeout(this.toastElement.timeOutValue)}.bind(this)),i=0<window.innerWidth?window.innerWidth:screen.width,
// Adding the close icon to the toast element
// Display on the right if screen width is less than or equal to 360px
("left"==this.options.position||!0===this.options.positionLeft)&&360<i?
// Adding close icon on the left of content
s.insertAdjacentElement("afterbegin",n):
// Adding close icon on the right of content
s.appendChild(n)),
// Clear timeout while toast is focused
this.options.stopOnFocus&&0<this.options.duration&&(t=this,
// stop countdown
s.addEventListener("mouseover",function(e){window.clearTimeout(s.timeOutValue)}),
// add back the timeout
s.addEventListener("mouseleave",function(){s.timeOutValue=window.setTimeout(function(){
// Remove the toast from DOM
t.removeElement(s)},t.options.duration)})),
// Adding an on-click destination path
void 0!==this.options.destination&&s.addEventListener("click",function(e){e.stopPropagation(),!0===this.options.newWindow?window.open(this.options.destination,"_blank"):window.location=this.options.destination}.bind(this)),"function"==typeof this.options.onClick&&void 0===this.options.destination&&s.addEventListener("click",function(e){e.stopPropagation(),this.options.onClick()}.bind(this)),
// Adding offset
"object"==typeof this.options.offset&&(i=a("x",this.options),n=a("y",this.options),i="left"==this.options.position?i:"-"+i,n="toastify-top"==this.options.gravity?n:"-"+n,s.style.transform="translate("+i+","+n+")"),s},
// Displaying the toast
showToast:function(){
// Getting the root element to with the toast needs to be added
var e,t;
// Validating if root element is present in DOM
if(
// Creating the DOM object for the toast
this.toastElement=this.buildToast(),e="string"==typeof this.options.selector?document.getElementById(this.options.selector):this.options.selector instanceof HTMLElement||"undefined"!=typeof ShadowRoot&&this.options.selector instanceof ShadowRoot?this.options.selector:document.body)
// Supporting function chaining
return t=i.defaults.oldestFirst?e.firstChild:e.lastChild,e.insertBefore(this.toastElement,t),
// Repositioning the toasts in case multiple toasts are present
i.reposition(),0<this.options.duration&&(this.toastElement.timeOutValue=window.setTimeout(function(){
// Remove the toast from DOM
this.removeElement(this.toastElement)}.bind(this),this.options.duration)),this;
// Adding the DOM element
throw"Root element is not defined"},hideToast:function(){this.toastElement.timeOutValue&&clearTimeout(this.toastElement.timeOutValue),this.removeElement(this.toastElement)},
// Removing the element from the DOM
removeElement:function(e){
// Hiding the element
// toastElement.classList.remove("on");
e.className=e.className.replace(" on",""),
// Removing the element from DOM after transition end
window.setTimeout(function(){
// remove options node if any
this.options.node&&this.options.node.parentNode&&this.options.node.parentNode.removeChild(this.options.node),
// Remove the element from the DOM, only when the parent node was not removed before.
e.parentNode&&e.parentNode.removeChild(e),
// Calling the callback function
this.options.callback.call(e),
// Repositioning the toasts again
i.reposition()}.bind(this),400)}},
// Positioning the toasts on the DOM
i.reposition=function(){
// Modifying the position of each toast element
for(
// Top margins with gravity
var e={top:15,bottom:15},t={top:15,bottom:15},i={top:15,bottom:15},n=document.getElementsByClassName("toastify"),s=0;s<n.length;s++){var
// Getting the applied gravity
a=!0===o(n[s],"toastify-top")?"toastify-top":"toastify-bottom",r=n[s].offsetHeight;a=a.substr(9,a.length-1);
// Show toast in center if screen with less than or equal to 360px
(0<window.innerWidth?window.innerWidth:screen.width)<=360?(
// Setting the position
n[s].style[a]=i[a]+"px",i[a]+=r+15):!0===o(n[s],"toastify-left")?(
// Setting the position
n[s].style[a]=e[a]+"px",e[a]+=r+15):(
// Setting the position
n[s].style[a]=t[a]+"px",t[a]+=r+15)}
// Supporting function chaining
return this},i.lib.init.prototype=i.lib,i}),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).Viewer=t()}(this,function(){"use strict";function a(t,e){var i,n=Object.keys(t);return Object.getOwnPropertySymbols&&(i=Object.getOwnPropertySymbols(t),e&&(i=i.filter(function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable})),n.push.apply(n,i)),n}function j(n){for(var e=1;e<arguments.length;e++){var s=null!=arguments[e]?arguments[e]:{};e%2?a(Object(s),!0).forEach(function(e){var t,i=n;e=s[t=e],t in i?Object.defineProperty(i,t,{value:e,enumerable:!0,configurable:!0,writable:!0}):i[t]=e}):Object.getOwnPropertyDescriptors?Object.defineProperties(n,Object.getOwnPropertyDescriptors(s)):a(Object(s)).forEach(function(e){Object.defineProperty(n,e,Object.getOwnPropertyDescriptor(s,e))})}return n}function n(e){return(n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function o(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l={backdrop:!0,button:!0,navbar:!0,title:!0,toolbar:!0,className:"",container:"body",filter:null,fullscreen:!0,inheritedAttributes:["crossOrigin","decoding","isMap","loading","referrerPolicy","sizes","srcset","useMap"],initialViewIndex:0,inline:!1,interval:5e3,keyboard:!0,focus:!0,loading:!0,loop:!0,minWidth:200,minHeight:100,movable:!0,rotatable:!0,scalable:!0,zoomable:!0,zoomOnTouch:!0,zoomOnWheel:!0,slideOnTouch:!0,toggleOnDblclick:!0,tooltip:!0,transition:!0,zIndex:2015,zIndexInline:0,zoomRatio:.1,minZoomRatio:.01,maxZoomRatio:100,url:"src",ready:null,show:null,shown:null,hide:null,hidden:null,view:null,viewed:null,move:null,moved:null,rotate:null,rotated:null,scale:null,scaled:null,zoom:null,zoomed:null,play:null,stop:null},e=(i="undefined"!=typeof window&&void 0!==window.document)?window:{},r=!(!i||!e.document.documentElement)&&"ontouchstart"in e.document.documentElement,t=i&&"PointerEvent"in e,m="viewer",c="move",d="zoom",h="".concat(m,"-active"),F="".concat(m,"-close"),g="".concat(m,"-fade"),H="".concat(m,"-fixed"),q="".concat(m,"-fullscreen"),W="".concat(m,"-fullscreen-exit"),f="".concat(m,"-hide"),U="".concat(m,"-hide-md-down"),G="".concat(m,"-hide-sm-down"),X="".concat(m,"-hide-xs-down"),u="".concat(m,"-in"),b="".concat(m,"-invisible"),v="".concat(m,"-loading"),Y="".concat(m,"-move"),K="".concat(m,"-open"),p="".concat(m,"-show"),y="".concat(m,"-transition"),w="click",V="dblclick",_="load",Z=t?"pointerdown":r?"touchstart":"mousedown",Q=t?"pointermove":r?"touchmove":"mousemove",J=t?"pointerup pointercancel":r?"touchend touchcancel":"mouseup",E="transitionend",x="viewed",ee="".concat(m,"Action"),te=/\s\s*/,ie=["zoom-in","zoom-out","one-to-one","reset","prev","play","next","rotate-left","rotate-right","flip-horizontal","flip-vertical"];function T(e){return"string"==typeof e}var ne=Number.isNaN||e.isNaN;function C(e){return"number"==typeof e&&!ne(e)}function S(e){return void 0===e}function s(e){return"object"===n(e)&&null!==e}var se=Object.prototype.hasOwnProperty;function k(e){if(!s(e))return!1;try{var t=e.constructor,i=t.prototype;return t&&i&&se.call(i,"isPrototypeOf")}catch(e){return!1}}function M(e){return"function"==typeof e}function N(t,i){if(t&&M(i))if(Array.isArray(t)||C(t.length))for(var e=t.length,n=0;n<e&&!1!==i.call(t,t[n],n,t);n+=1);else s(t)&&Object.keys(t).forEach(function(e){i.call(t,t[e],e,t)})}var O=Object.assign||function(i){for(var e=arguments.length,t=new Array(1<e?e-1:0),n=1;n<e;n++)t[n-1]=arguments[n];return s(i)&&0<t.length&&t.forEach(function(t){s(t)&&Object.keys(t).forEach(function(e){i[e]=t[e]})}),i},ae=/^(?:width|height|left|top|marginLeft|marginTop)$/;function A(e,t){var i=e.style;N(t,function(e,t){ae.test(t)&&C(e)&&(e+="px"),i[t]=e})}function L(e,t){return e&&t&&(e.classList?e.classList.contains(t):-1<e.className.indexOf(t))}function I(e,t){var i;e&&t&&(C(e.length)?N(e,function(e){I(e,t)}):e.classList?e.classList.add(t):(i=e.className.trim())?i.indexOf(t)<0&&(e.className="".concat(i," ").concat(t)):e.className=t)}function D(e,t){e&&t&&(C(e.length)?N(e,function(e){D(e,t)}):e.classList?e.classList.remove(t):0<=e.className.indexOf(t)&&(e.className=e.className.replace(t,"")))}function $(e,t,i){t&&(C(e.length)?N(e,function(e){$(e,t,i)}):(i?I:D)(e,t))}var re=/([a-z\d])([A-Z])/g;function oe(e){return e.replace(re,"$1-$2").toLowerCase()}function P(e,t){return s(e[t])?e[t]:e.dataset?e.dataset[t]:e.getAttribute("data-".concat(oe(t)))}function le(e,t,i){s(i)?e[t]=i:e.dataset?e.dataset[t]=i:e.setAttribute("data-".concat(oe(t)),i)}de=!1,i&&(ce=!1,_e=function(){},Ee=Object.defineProperty({},"once",{get:function(){return de=!0,ce},set:function(e){ce=e}}),e.addEventListener("test",_e,Ee),e.removeEventListener("test",_e,Ee));var ce,de,ue=de;function z(i,e,n,t){var s=3<arguments.length&&void 0!==t?t:{},a=n;e.trim().split(te).forEach(function(e){var t;ue||(t=i.listeners)&&t[e]&&t[e][n]&&(a=t[e][n],delete t[e][n],0===Object.keys(t[e]).length&&delete t[e],0===Object.keys(t).length)&&delete i.listeners,i.removeEventListener(e,a,s)})}function R(a,e,r,t){var o=3<arguments.length&&void 0!==t?t:{},l=r;e.trim().split(te).forEach(function(n){var e,s;o.once&&!ue&&(e=a.listeners,l=function(){delete s[n][r],a.removeEventListener(n,l,o);for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];r.apply(a,t)},(s=void 0===e?{}:e)[n]||(s[n]={}),s[n][r]&&a.removeEventListener(n,s[n][r],o),s[n][r]=l,a.listeners=s),a.addEventListener(n,l,o)})}function B(e,t,i,n){var s;return M(Event)&&M(CustomEvent)?s=new CustomEvent(t,j({bubbles:!0,cancelable:!0,detail:i},n)):(s=document.createEvent("CustomEvent")).initCustomEvent(t,!0,!0,i),e.dispatchEvent(s)}function pe(e){var t=e.rotate,i=e.scaleX,n=e.scaleY,s=e.translateX,a=e.translateY,e=[];return C(s)&&0!==s&&e.push("translateX(".concat(s,"px)")),C(a)&&0!==a&&e.push("translateY(".concat(a,"px)")),C(t)&&0!==t&&e.push("rotate(".concat(t,"deg)")),C(i)&&1!==i&&e.push("scaleX(".concat(i,")")),C(n)&&1!==n&&e.push("scaleY(".concat(n,")")),{WebkitTransform:e=e.length?e.join(" "):"none",msTransform:e,transform:e}}var he=e.navigator&&/(Macintosh|iPhone|iPod|iPad).*AppleWebKit/i.test(e.navigator.userAgent);function me(i,e,t){var n,s=document.createElement("img");return i.naturalWidth&&!he?t(i.naturalWidth,i.naturalHeight):(n=document.body||document.documentElement,s.onload=function(){t(s.width,s.height),he||n.removeChild(s)},N(e.inheritedAttributes,function(e){var t=i.getAttribute(e);null!==t&&s.setAttribute(e,t)}),s.src=i.src,he||(s.style.cssText="left:0;max-height:none!important;max-width:none!important;min-height:0!important;min-width:0!important;opacity:0;position:absolute;top:0;z-index:-1;",n.appendChild(s))),s}function ge(e){switch(e){case 2:return X;case 3:return G;case 4:return U;default:return""}}function fe(e,t){var i=e.pageX,n=e.pageY,e={endX:i,endY:n};return t?e:j({timeStamp:Date.now(),startX:i,startY:n},e)}var be,ve,ye,we={render:function(){this.initContainer(),this.initViewer(),this.initList(),this.renderViewer()},initBody:function(){var e=this.element.ownerDocument,t=e.body||e.documentElement;this.body=t,this.scrollbarWidth=window.innerWidth-e.documentElement.clientWidth,this.initialBodyPaddingRight=t.style.paddingRight,this.initialBodyComputedPaddingRight=window.getComputedStyle(t).paddingRight},initContainer:function(){this.containerData={width:window.innerWidth,height:window.innerHeight}},initViewer:function(){var e,t=this.options,i=this.parent;t.inline&&(e={width:Math.max(i.offsetWidth,t.minWidth),height:Math.max(i.offsetHeight,t.minHeight)},this.parentData=e),!this.fulled&&e||(e=this.containerData),this.viewerData=O({},e)},renderViewer:function(){this.options.inline&&!this.fulled&&A(this.viewer,this.viewerData)},initList:function(){var o=this,e=this.element,l=this.options,c=this.list,d=[];c.innerHTML="",N(this.images,function(i,e){var t,n,s=i.src,a=i.alt||(T(t=s)?decodeURIComponent(t.replace(/^.*\//,"").replace(/[?&#].*$/,"")):""),r=o.getImageURL(i);(s||r)&&(t=document.createElement("li"),n=document.createElement("img"),N(l.inheritedAttributes,function(e){var t=i.getAttribute(e);null!==t&&n.setAttribute(e,t)}),n.src=s||r,n.alt=a,n.setAttribute("data-original-url",r||s),t.setAttribute("data-index",e),t.setAttribute("data-viewer-action","view"),t.setAttribute("role","button"),l.keyboard&&t.setAttribute("tabindex",0),t.appendChild(n),c.appendChild(t),d.push(t))}),N(this.items=d,function(t){var e=t.firstElementChild;le(e,"filled",!0),l.loading&&I(t,v),R(e,_,function(e){l.loading&&D(t,v),o.loadImage(e)},{once:!0})}),l.transition&&R(e,x,function(){I(c,y)},{once:!0})},renderList:function(){var e=this.index,t=this.items[e],i=t.nextElementSibling,n=parseInt(window.getComputedStyle(i||t).marginLeft,10),i=t.offsetWidth;A(this.list,O({width:(t=i+n)*this.length-n},pe({translateX:(this.viewerData.width-i)/2-t*e})))},resetList:function(){var e=this.list;e.innerHTML="",D(e,y),A(e,pe({translateX:0}))},initImage:function(o){var e,l=this,c=this.options,t=this.image,i=this.viewerData,n=this.footer.offsetHeight,d=i.width,u=Math.max(i.height-n,n),p=this.imageData||{};this.imageInitializing={abort:function(){e.onload=null}},e=me(t,c,function(e,t){var i=e/t,n=d,s=u,n=(l.imageInitializing=!1,d<u*i?s=d/i:n=u*i,Math.min(.9*n,e)),s=Math.min(.9*s,t),a=(d-n)/2,r=(u-s)/2,t=O({},e={left:a,top:r,x:a,y:r,width:n,height:s,oldRatio:1,ratio:n/e,aspectRatio:i,naturalWidth:e,naturalHeight:t});c.rotatable&&(e.rotate=p.rotate||0,t.rotate=0),c.scalable&&(e.scaleX=p.scaleX||1,e.scaleY=p.scaleY||1,t.scaleX=1,t.scaleY=1),l.imageData=e,l.initialImageData=t,o&&o()})},renderImage:function(e){var t,i=this,n=this.image,s=this.imageData;A(n,O({width:s.width,height:s.height,marginLeft:s.x,marginTop:s.y},pe(s))),e&&((this.viewing||this.moving||this.rotating||this.scaling||this.zooming)&&this.options.transition&&L(n,y)?(t=function(){i.imageRendering=!1,e()},this.imageRendering={abort:function(){z(n,E,t)}},R(n,E,t,{once:!0})):e())},resetImage:function(){var e;(this.viewing||this.viewed)&&(e=this.image,this.viewing&&this.viewing.abort(),e.parentNode.removeChild(e),this.image=null)}},t={bind:function(){var e=this.options,t=this.viewer,i=this.canvas,n=this.element.ownerDocument;R(t,w,this.onClick=this.click.bind(this)),R(t,"dragstart",this.onDragStart=this.dragstart.bind(this)),R(i,Z,this.onPointerDown=this.pointerdown.bind(this)),R(n,Q,this.onPointerMove=this.pointermove.bind(this)),R(n,J,this.onPointerUp=this.pointerup.bind(this)),R(n,"keydown",this.onKeyDown=this.keydown.bind(this)),R(window,"resize",this.onResize=this.resize.bind(this)),e.zoomable&&e.zoomOnWheel&&R(t,"wheel",this.onWheel=this.wheel.bind(this),{passive:!1,capture:!0}),e.toggleOnDblclick&&R(i,V,this.onDblclick=this.dblclick.bind(this))},unbind:function(){var e=this.options,t=this.viewer,i=this.canvas,n=this.element.ownerDocument;z(t,w,this.onClick),z(t,"dragstart",this.onDragStart),z(i,Z,this.onPointerDown),z(n,Q,this.onPointerMove),z(n,J,this.onPointerUp),z(n,"keydown",this.onKeyDown),z(window,"resize",this.onResize),e.zoomable&&e.zoomOnWheel&&z(t,"wheel",this.onWheel,{passive:!1,capture:!0}),e.toggleOnDblclick&&z(i,V,this.onDblclick)}},i={click:function(e){var t=this.options,i=this.imageData,n=e.target,s=P(n,ee);switch(s||"img"!==n.localName||"li"!==n.parentElement.localName||(s=P(n=n.parentElement,ee)),r&&e.isTrusted&&n===this.canvas&&clearTimeout(this.clickCanvasTimeout),s){case"mix":this.played?this.stop():t.inline?this.fulled?this.exit():this.full():this.hide();break;case"hide":this.hide();break;case"view":this.view(P(n,"index"));break;case"zoom-in":this.zoom(.1,!0);break;case"zoom-out":this.zoom(-.1,!0);break;case"one-to-one":this.toggle();break;case"reset":this.reset();break;case"prev":this.prev(t.loop);break;case"play":this.play(t.fullscreen);break;case"next":this.next(t.loop);break;case"rotate-left":this.rotate(-90);break;case"rotate-right":this.rotate(90);break;case"flip-horizontal":this.scaleX(-i.scaleX||-1);break;case"flip-vertical":this.scaleY(-i.scaleY||-1);break;default:this.played&&this.stop()}},dblclick:function(e){e.preventDefault(),this.viewed&&e.target===this.image&&(r&&e.isTrusted&&clearTimeout(this.doubleClickImageTimeout),this.toggle(e))},load:function(){var e=this,t=(this.timeout&&(clearTimeout(this.timeout),this.timeout=!1),this.element),i=this.options,n=this.image,s=this.index,a=this.viewerData;D(n,b),i.loading&&D(this.canvas,v),n.style.cssText="height:0;"+"margin-left:".concat(a.width/2,"px;")+"margin-top:".concat(a.height/2,"px;")+"max-width:none!important;position:relative;width:0;",this.initImage(function(){$(n,Y,i.movable),$(n,y,i.transition),e.renderImage(function(){e.viewed=!0,e.viewing=!1,M(i.viewed)&&R(t,x,i.viewed,{once:!0}),B(t,x,{originalImage:e.images[s],index:s,image:n},{cancelable:!1})})})},loadImage:function(e){var n=e.target,s=(e=n.parentNode).offsetWidth||30,a=e.offsetHeight||50,r=!!P(n,"filled");me(n,this.options,function(e,t){var i=e/t,e=s,t=a;s<a*i?r?e=a*i:t=s/i:r?t=s/i:e=a*i,A(n,O({width:e,height:t},pe({translateX:(s-e)/2,translateY:(a-t)/2})))})},keydown:function(e){var t=this.options;if(t.keyboard){var i=e.keyCode||e.which||e.charCode;if(13===i&&this.viewer.contains(e.target)&&this.click(e),this.fulled)switch(i){case 27:this.played?this.stop():t.inline?this.fulled&&this.exit():this.hide();break;case 32:this.played&&this.stop();break;case 37:this.prev(t.loop);break;case 38:e.preventDefault(),this.zoom(t.zoomRatio,!0);break;case 39:this.next(t.loop);break;case 40:e.preventDefault(),this.zoom(-t.zoomRatio,!0);break;case 48:case 49:e.ctrlKey&&(e.preventDefault(),this.toggle())}}},dragstart:function(e){"img"===e.target.localName&&e.preventDefault()},pointerdown:function(e){var t=this.options,i=this.pointers,n=e.buttons,s=e.button;!this.viewed||this.showing||this.viewing||this.hiding||("mousedown"===e.type||"pointerdown"===e.type&&"mouse"===e.pointerType)&&(C(n)&&1!==n||C(s)&&0!==s||e.ctrlKey)||(e.preventDefault(),e.changedTouches?N(e.changedTouches,function(e){i[e.identifier]=fe(e)}):i[e.pointerId||0]=fe(e),s=!!t.movable&&c,t.zoomOnTouch&&t.zoomable&&1<Object.keys(i).length?s=d:t.slideOnTouch&&("touch"===e.pointerType||"touchstart"===e.type)&&this.isSwitchable()&&(s="switch"),!t.transition||s!==c&&s!==d||D(this.image,y),this.action=s)},pointermove:function(e){var t=this.pointers,i=this.action;this.viewed&&i&&(e.preventDefault(),e.changedTouches?N(e.changedTouches,function(e){O(t[e.identifier]||{},fe(e,!0))}):O(t[e.pointerId||0]||{},fe(e,!0)),this.change(e))},pointerup:function(e){var t,i=this,n=this.options,s=this.action,a=this.pointers;e.changedTouches?N(e.changedTouches,function(e){t=a[e.identifier],delete a[e.identifier]}):(t=a[e.pointerId||0],delete a[e.pointerId||0]),s&&(e.preventDefault(),!n.transition||s!==c&&s!==d||I(this.image,y),this.action=!1,r)&&s!==d&&t&&Date.now()-t.timeStamp<500&&(clearTimeout(this.clickCanvasTimeout),clearTimeout(this.doubleClickImageTimeout),n.toggleOnDblclick&&this.viewed&&e.target===this.image?this.imageClicked?(this.imageClicked=!1,this.doubleClickImageTimeout=setTimeout(function(){B(i.image,V)},50)):(this.imageClicked=!0,this.doubleClickImageTimeout=setTimeout(function(){i.imageClicked=!1},500)):(this.imageClicked=!1,n.backdrop&&"static"!==n.backdrop&&e.target===this.canvas&&(this.clickCanvasTimeout=setTimeout(function(){B(i.canvas,w)},50))))},resize:function(){var t=this;this.isShown&&!this.hiding&&(this.fulled&&(this.close(),this.initBody(),this.open()),this.initContainer(),this.initViewer(),this.renderViewer(),this.renderList(),this.viewed&&this.initImage(function(){t.renderImage()}),this.played)&&(!this.options.fullscreen||!this.fulled||document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.msFullscreenElement?N(this.player.getElementsByTagName("img"),function(e){R(e,_,t.loadImage.bind(t),{once:!0}),B(e,_)}):this.stop())},wheel:function(e){var t,i,n=this;this.viewed&&(e.preventDefault(),this.wheeling||(this.wheeling=!0,setTimeout(function(){n.wheeling=!1},50),t=Number(this.options.zoomRatio)||.1,i=1,e.deltaY?i=0<e.deltaY?1:-1:e.wheelDelta?i=-e.wheelDelta/120:e.detail&&(i=0<e.detail?1:-1),this.zoom(-i*t,!0,e)))}},_e={show:function(){var e,t,i=0<arguments.length&&void 0!==arguments[0]&&arguments[0],n=this.element,s=this.options;return s.inline||this.showing||this.isShown||this.showing||(this.ready?(M(s.show)&&R(n,"show",s.show,{once:!0}),!1!==B(n,"show")&&this.ready&&(this.hiding&&this.transitioning.abort(),this.showing=!0,this.open(),D(t=this.viewer,f),t.setAttribute("role","dialog"),t.setAttribute("aria-labelledby",this.title.id),t.setAttribute("aria-modal",!0),t.removeAttribute("aria-hidden"),s.transition&&!i?(e=this.shown.bind(this),this.transitioning={abort:function(){z(t,E,e),D(t,u)}},I(t,y),t.initialOffsetWidth=t.offsetWidth,R(t,E,e,{once:!0}),I(t,u)):(I(t,u),this.shown()))):(this.build(),this.ready&&this.show(i))),this},hide:function(){var e,t,i,n,s,a=this,r=0<arguments.length&&void 0!==arguments[0]&&arguments[0],o=this.element,l=this.options;return l.inline||this.hiding||!this.isShown&&!this.showing||(M(l.hide)&&R(o,"hide",l.hide,{once:!0}),!1!==B(o,"hide")&&(this.showing&&this.transitioning.abort(),this.hiding=!0,this.played?this.stop():this.viewing&&this.viewing.abort(),i=this.viewer,n=this.image,s=function(){D(i,u),a.hidden()},l.transition&&!r?(e=function e(t){t&&t.target===i&&(z(i,E,e),a.hidden())},t=function(){L(i,y)?(R(i,E,e),D(i,u)):s()},this.transitioning={abort:function(){a.viewed&&L(n,y)?z(n,E,t):L(i,y)&&z(i,E,e)}},this.viewed&&L(n,y)?(R(n,E,t,{once:!0}),this.zoomTo(0,!1,null,!0)):t()):s())),this},view:function(){var i=this,e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:this.options.initialViewIndex,e=Number(e)||0;if(!(this.hiding||this.played||e<0||e>=this.length||this.viewed&&e===this.index)){if(!this.isShown)return this.index=e,this.show();this.viewing&&this.viewing.abort();var t,n=this.element,s=this.options,a=this.title,r=this.canvas,o=this.items[e],l=o.querySelector("img"),c=P(l,"originalUrl"),d=l.getAttribute("alt"),u=document.createElement("img");N(s.inheritedAttributes,function(e){var t=l.getAttribute(e);null!==t&&u.setAttribute(e,t)}),u.src=c,u.alt=d,M(s.view)&&R(n,"view",s.view,{once:!0}),!1===B(n,"view",{originalImage:this.images[e],index:e,image:u})||!this.isShown||this.hiding||this.played||((c=this.items[this.index])&&(D(c,h),c.removeAttribute("aria-selected")),I(o,h),o.setAttribute("aria-selected",!0),s.focus&&o.focus(),this.image=u,this.viewed=!1,this.index=e,this.imageData={},I(u,b),s.loading&&I(r,v),r.innerHTML="",r.appendChild(u),this.renderList(),a.innerHTML="",R(n,x,p,{once:!0}),this.viewing={abort:function(){z(n,x,p),u.complete?i.imageRendering?i.imageRendering.abort():i.imageInitializing&&i.imageInitializing.abort():(u.src="",z(u,_,t),i.timeout&&clearTimeout(i.timeout))}},u.complete?this.load():(R(u,_,t=this.load.bind(this),{once:!0}),this.timeout&&clearTimeout(this.timeout),this.timeout=setTimeout(function(){D(u,b),i.timeout=!1},1e3)))}return this;function p(){var e=i.imageData,t=Array.isArray(s.title)?s.title[1]:s.title;a.innerHTML=T(e=M(t)?t.call(i,u,e):"".concat(d," (").concat(e.naturalWidth," × ").concat(e.naturalHeight,")"))?e.replace(/&(?!amp;|quot;|#39;|lt;|gt;)/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#39;").replace(/</g,"&lt;").replace(/>/g,"&gt;"):e}},prev:function(){var e=this.index-1;return e<0&&(e=0<arguments.length&&void 0!==arguments[0]&&arguments[0]?this.length-1:0),this.view(e),this},next:function(){var e=this.length-1,t=this.index+1;return this.view(e<t?0<arguments.length&&void 0!==arguments[0]&&arguments[0]?0:e:t),this},move:function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:e,i=this.imageData;return this.moveTo(S(e)?e:i.x+Number(e),S(t)?t:i.y+Number(t)),this},moveTo:function(e){var t=this,i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:e,n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null,s=this.element,a=this.options,r=this.imageData;if(e=Number(e),i=Number(i),this.viewed&&!this.played&&a.movable){var o=r.x,l=r.y,c=!1;if(C(e)?c=!0:e=o,C(i)?c=!0:i=l,c){if(M(a.move)&&R(s,"move",a.move,{once:!0}),!1===B(s,"move",{x:e,y:i,oldX:o,oldY:l,originalEvent:n}))return this;r.x=e,r.y=i,r.left=e,r.top=i,this.moving=!0,this.renderImage(function(){t.moving=!1,M(a.moved)&&R(s,"moved",a.moved,{once:!0}),B(s,"moved",{x:e,y:i,oldX:o,oldY:l,originalEvent:n},{cancelable:!1})})}}return this},rotate:function(e){return this.rotateTo((this.imageData.rotate||0)+Number(e)),this},rotateTo:function(e){var t=this,i=this.element,n=this.options,s=this.imageData;if(C(e=Number(e))&&this.viewed&&!this.played&&n.rotatable){var a=s.rotate;if(M(n.rotate)&&R(i,"rotate",n.rotate,{once:!0}),!1===B(i,"rotate",{degree:e,oldDegree:a}))return this;s.rotate=e,this.rotating=!0,this.renderImage(function(){t.rotating=!1,M(n.rotated)&&R(i,"rotated",n.rotated,{once:!0}),B(i,"rotated",{degree:e,oldDegree:a},{cancelable:!1})})}return this},scaleX:function(e){return this.scale(e,this.imageData.scaleY),this},scaleY:function(e){return this.scale(this.imageData.scaleX,e),this},scale:function(e){var t=this,i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:e,n=this.element,s=this.options,a=this.imageData;if(e=Number(e),i=Number(i),this.viewed&&!this.played&&s.scalable){var r=a.scaleX,o=a.scaleY,l=!1;if(C(e)?l=!0:e=r,C(i)?l=!0:i=o,l){if(M(s.scale)&&R(n,"scale",s.scale,{once:!0}),!1===B(n,"scale",{scaleX:e,scaleY:i,oldScaleX:r,oldScaleY:o}))return this;a.scaleX=e,a.scaleY=i,this.scaling=!0,this.renderImage(function(){t.scaling=!1,M(s.scaled)&&R(n,"scaled",s.scaled,{once:!0}),B(n,"scaled",{scaleX:e,scaleY:i,oldScaleX:r,oldScaleY:o},{cancelable:!1})})}}return this},zoom:function(e){var t=1<arguments.length&&void 0!==arguments[1]&&arguments[1],i=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null,n=this.imageData;return e=Number(e),this.zoomTo(n.width*(e=e<0?1/(1-e):1+e)/n.naturalWidth,t,i),this},zoomTo:function(e){var i,n,s,t=this,a=1<arguments.length&&void 0!==arguments[1]&&arguments[1],r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null,o=3<arguments.length&&void 0!==arguments[3]&&arguments[3],l=this.element,c=this.options,d=this.pointers,u=this.imageData,p=u.x,h=u.y,m=u.width,g=u.height,f=u.naturalWidth,b=u.naturalHeight;if(C(e=Math.max(0,e))&&this.viewed&&!this.played&&(o||c.zoomable)){o||(v=Math.max(.01,c.minZoomRatio),y=Math.min(100,c.maxZoomRatio),e=Math.min(Math.max(e,v),y));var o=f*(e=r&&.055<=c.zoomRatio&&.95<e&&e<1.05?1:e),v=b*e,y=o-m,f=v-g,w=u.ratio;if(M(c.zoom)&&R(l,"zoom",c.zoom,{once:!0}),!1===B(l,"zoom",{ratio:e,oldRatio:w,originalEvent:r}))return this;this.zooming=!0,r?(b={left:(b=(b=this.viewer).getBoundingClientRect()).left+(window.pageXOffset-document.documentElement.clientLeft),top:b.top+(window.pageYOffset-document.documentElement.clientTop)},d=d&&Object.keys(d).length?(s=n=i=0,N(d,function(e){var t=e.startX,e=e.startY;i+=t,n+=e,s+=1}),{pageX:i/=s,pageY:n/=s}):{pageX:r.pageX,pageY:r.pageY},u.x-=(d.pageX-b.left-p)/m*y,u.y-=(d.pageY-b.top-h)/g*f):(u.x-=y/2,u.y-=f/2),u.left=u.x,u.top=u.y,u.width=o,u.height=v,u.oldRatio=w,u.ratio=e,this.renderImage(function(){t.zooming=!1,M(c.zoomed)&&R(l,"zoomed",c.zoomed,{once:!0}),B(l,"zoomed",{ratio:e,oldRatio:w,originalEvent:r},{cancelable:!1})}),a&&this.tooltip()}return this},play:function(){var e,s,a,r,o,l,c,t=this,i=0<arguments.length&&void 0!==arguments[0]&&arguments[0];return this.isShown&&!this.played&&(e=this.element,M((s=this.options).play)&&R(e,"play",s.play,{once:!0}),!1!==B(e,"play")&&(a=this.player,r=this.loadImage.bind(this),o=[],c=l=0,this.played=!0,this.onLoadWhenPlay=r,i&&this.requestFullscreen(i),I(a,p),N(this.items,function(e,t){var i=e.querySelector("img"),n=document.createElement("img");n.src=P(i,"originalUrl"),n.alt=i.getAttribute("alt"),n.referrerPolicy=i.referrerPolicy,l+=1,I(n,g),$(n,y,s.transition),L(e,h)&&(I(n,u),c=t),o.push(n),R(n,_,r,{once:!0}),a.appendChild(n)}),C(s.interval))&&0<s.interval&&1<l)&&function e(){t.playing=setTimeout(function(){D(o[c],u),I(o[c=(c+=1)<l?c:0],u),e()},s.interval)}(),this},stop:function(){var e,t,i=this;return this.played&&(e=this.element,M((t=this.options).stop)&&R(e,"stop",t.stop,{once:!0}),!1!==B(e,"stop"))&&(e=this.player,this.played=!1,clearTimeout(this.playing),N(e.getElementsByTagName("img"),function(e){z(e,_,i.onLoadWhenPlay)}),D(e,p),e.innerHTML="",this.exitFullscreen()),this},full:function(){var e=this,t=this.options,i=this.viewer,n=this.image,s=this.list;return this.isShown&&!this.played&&!this.fulled&&t.inline&&(this.fulled=!0,this.open(),I(this.button,W),t.transition&&(D(s,y),this.viewed)&&D(n,y),I(i,H),i.setAttribute("role","dialog"),i.setAttribute("aria-labelledby",this.title.id),i.setAttribute("aria-modal",!0),i.removeAttribute("style"),A(i,{zIndex:t.zIndex}),t.focus&&this.enforceFocus(),this.initContainer(),this.viewerData=O({},this.containerData),this.renderList(),this.viewed)&&this.initImage(function(){e.renderImage(function(){t.transition&&setTimeout(function(){I(n,y),I(s,y)},0)})}),this},exit:function(){var e=this,t=this.options,i=this.viewer,n=this.image,s=this.list;return this.isShown&&!this.played&&this.fulled&&t.inline&&(this.fulled=!1,this.close(),D(this.button,W),t.transition&&(D(s,y),this.viewed)&&D(n,y),t.focus&&this.clearEnforceFocus(),i.removeAttribute("role"),i.removeAttribute("aria-labelledby"),i.removeAttribute("aria-modal"),D(i,H),A(i,{zIndex:t.zIndexInline}),this.viewerData=O({},this.parentData),this.renderViewer(),this.renderList(),this.viewed)&&this.initImage(function(){e.renderImage(function(){t.transition&&setTimeout(function(){I(n,y),I(s,y)},0)})}),this},tooltip:function(){var e=this,t=this.options,i=this.tooltipBox,n=this.imageData;return this.viewed&&!this.played&&t.tooltip&&(i.textContent="".concat(Math.round(100*n.ratio),"%"),this.tooltipping?clearTimeout(this.tooltipping):t.transition?(this.fading&&B(i,E),I(i,p),I(i,g),I(i,y),i.removeAttribute("aria-hidden"),i.initialOffsetWidth=i.offsetWidth,I(i,u)):(I(i,p),i.removeAttribute("aria-hidden")),this.tooltipping=setTimeout(function(){t.transition?(R(i,E,function(){D(i,p),D(i,g),D(i,y),i.setAttribute("aria-hidden",!0),e.fading=!1},{once:!0}),D(i,u),e.fading=!0):(D(i,p),i.setAttribute("aria-hidden",!0)),e.tooltipping=!1},1e3)),this},toggle:function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null;return 1===this.imageData.ratio?this.zoomTo(this.imageData.oldRatio,!0,e):this.zoomTo(1,!0,e),this},reset:function(){return this.viewed&&!this.played&&(this.imageData=O({},this.initialImageData),this.renderImage()),this},update:function(){var n,s,t=this,e=this.element,i=this.options,a=this.isImg;return a&&!e.parentNode?this.destroy():(s=[],N(a?[e]:e.querySelectorAll("img"),function(e){M(i.filter)?i.filter.call(t,e)&&s.push(e):t.getImageURL(e)&&s.push(e)}),s.length&&(this.images=s,this.length=s.length,this.ready?(n=[],N(this.items,function(e,t){var i=e.querySelector("img");(e=s[t])&&i&&e.src===i.src&&e.alt===i.alt||n.push(t)}),A(this.list,{width:"auto"}),this.initList(),this.isShown&&(this.length?this.viewed&&(0<=(e=n.indexOf(this.index))?(this.viewed=!1,this.view(Math.max(Math.min(this.index-e,this.length-1),0))):(I(e=this.items[this.index],h),e.setAttribute("aria-selected",!0))):(this.image=null,this.viewed=!1,this.index=0,this.imageData={},this.canvas.innerHTML="",this.title.innerHTML=""))):this.build()),this)},destroy:function(){var e=this.element,t=this.options;return e[m]&&(this.destroyed=!0,this.ready?(this.played&&this.stop(),t.inline?(this.fulled&&this.exit(),this.unbind()):this.isShown?(this.viewing&&(this.imageRendering?this.imageRendering.abort():this.imageInitializing&&this.imageInitializing.abort()),this.hiding&&this.transitioning.abort(),this.hidden()):this.showing&&(this.transitioning.abort(),this.hidden()),this.ready=!1,this.viewer.parentNode.removeChild(this.viewer)):t.inline&&(this.delaying?this.delaying.abort():this.initializing&&this.initializing.abort()),t.inline||z(e,w,this.onStart),e[m]=void 0),this}},Ee={getImageURL:function(e){var t=this.options.url;return T(t)?e.getAttribute(t):M(t)?t.call(this,e):""},enforceFocus:function(){var i=this;this.clearEnforceFocus(),R(document,"focusin",this.onFocusin=function(e){var t=i.viewer;(e=e.target)===document||e===t||t.contains(e)||null!==e.getAttribute("tabindex")&&"true"===e.getAttribute("aria-modal")||t.focus()})},clearEnforceFocus:function(){this.onFocusin&&(z(document,"focusin",this.onFocusin),this.onFocusin=null)},open:function(){var e=this.body;I(e,K),e.style.paddingRight="".concat(this.scrollbarWidth+(parseFloat(this.initialBodyComputedPaddingRight)||0),"px")},close:function(){var e=this.body;D(e,K),e.style.paddingRight=this.initialBodyPaddingRight},shown:function(){var e=this.element,t=this.options,i=this.viewer;this.fulled=!0,this.isShown=!0,this.render(),this.bind(),this.showing=!1,t.focus&&(i.focus(),this.enforceFocus()),M(t.shown)&&R(e,"shown",t.shown,{once:!0}),!1!==B(e,"shown")&&this.ready&&this.isShown&&!this.hiding&&this.view(this.index)},hidden:function(){var e=this.element,t=this.options,i=this.viewer;t.fucus&&this.clearEnforceFocus(),this.fulled=!1,this.viewed=!1,this.isShown=!1,this.close(),this.unbind(),I(i,f),i.removeAttribute("role"),i.removeAttribute("aria-labelledby"),i.removeAttribute("aria-modal"),i.setAttribute("aria-hidden",!0),this.resetList(),this.resetImage(),this.hiding=!1,this.destroyed||(M(t.hidden)&&R(e,"hidden",t.hidden,{once:!0}),B(e,"hidden",null,{cancelable:!1}))},requestFullscreen:function(e){var t=this.element.ownerDocument;this.fulled&&!(t.fullscreenElement||t.webkitFullscreenElement||t.mozFullScreenElement||t.msFullscreenElement)&&((t=t.documentElement).requestFullscreen?k(e)?t.requestFullscreen(e):t.requestFullscreen():t.webkitRequestFullscreen?t.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT):t.mozRequestFullScreen?t.mozRequestFullScreen():t.msRequestFullscreen&&t.msRequestFullscreen())},exitFullscreen:function(){var e=this.element.ownerDocument;this.fulled&&(e.fullscreenElement||e.webkitFullscreenElement||e.mozFullScreenElement||e.msFullscreenElement)&&(e.exitFullscreen?e.exitFullscreen():e.webkitExitFullscreen?e.webkitExitFullscreen():e.mozCancelFullScreen?e.mozCancelFullScreen():e.msExitFullscreen&&e.msExitFullscreen())},change:function(e){var t=this.options,i=this.pointers,n=i[Object.keys(i)[0]];if(n){var a,r,s=n.endX-n.startX,o=n.endY-n.startY;switch(this.action){case c:this.move(s,o,e);break;case d:this.zoom((a=j({},l=i),r=[],N(l,function(s,e){delete a[e],N(a,function(e){var t=Math.abs(s.startX-e.startX),i=Math.abs(s.startY-e.startY),n=Math.abs(s.endX-e.endX),e=Math.abs(s.endY-e.endY),i=Math.sqrt(t*t+i*i),e=Math.sqrt(n*n+e*e);r.push((e-i)/i)})}),r.sort(function(e,t){return Math.abs(e)<Math.abs(t)}),r[0]),!1,e);break;case"switch":this.action="switched";var l=Math.abs(s);1<l&&l>Math.abs(o)&&(this.pointers={},1<s?this.prev(t.loop):s<-1&&this.next(t.loop))}N(i,function(e){e.startX=e.endX,e.startY=e.endY})}},isSwitchable:function(){var e=this.imageData,t=this.viewerData;return 1<this.length&&0<=e.x&&0<=e.y&&e.width<=t.width&&e.height<=t.height}},xe=e.Viewer;be=-1;function Te(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},i=this;if(!(i instanceof Te))throw new TypeError("Cannot call a class as a function");if(!e||1!==e.nodeType)throw new Error("The first argument is required and must be an element.");this.element=e,this.options=O({},l,k(t)&&t),this.action=!1,this.fading=!1,this.fulled=!1,this.hiding=!1,this.imageClicked=!1,this.imageData={},this.index=this.options.initialViewIndex,this.isImg=!1,this.isShown=!1,this.length=0,this.moving=!1,this.played=!1,this.playing=!1,this.pointers={},this.ready=!1,this.rotating=!1,this.scaling=!1,this.showing=!1,this.timeout=!1,this.tooltipping=!1,this.viewed=!1,this.viewing=!1,this.wheeling=!1,this.zooming=!1,this.id=be+=1,this.init()}return ye=[{key:"noConflict",value:function(){return window.Viewer=xe,Te}},{key:"setDefaults",value:function(e){O(l,k(e)&&e)}}],o((ve=Te).prototype,[{key:"init",value:function(){var e,t,i,n,s=this,a=this.element,r=this.options;a[m]||(a[m]=this,r.focus&&!r.keyboard&&(r.focus=!1),e="img"===a.localName,t=[],N(e?[a]:a.querySelectorAll("img"),function(e){M(r.filter)?r.filter.call(s,e)&&t.push(e):s.getImageURL(e)&&t.push(e)}),this.isImg=e,this.length=t.length,this.images=t,this.initBody(),S(document.createElement(m).style.transition)&&(r.transition=!1),r.inline?(i=0,n=function(){var e;(i+=1)===s.length&&(s.initializing=!1,s.delaying={abort:function(){clearTimeout(e)}},e=setTimeout(function(){s.delaying=!1,s.build()},0))},this.initializing={abort:function(){N(t,function(e){e.complete||z(e,_,n)})}},N(t,function(e){e.complete?n():R(e,_,n,{once:!0})})):R(a,w,this.onStart=function(e){"img"!==(e=e.target).localName||M(r.filter)&&!r.filter.call(s,e)||s.view(s.images.indexOf(e))}))}},{key:"build",value:function(){var e,a,t,i,n,s,r,o,l,c,d,u,p,h;this.ready||(e=this.element,a=this.options,t=e.parentNode,(p=document.createElement("div")).innerHTML='<div class="viewer-container" tabindex="-1" touch-action="none"><div class="viewer-canvas"></div><div class="viewer-footer"><div class="viewer-title"></div><div class="viewer-toolbar"></div><div class="viewer-navbar"><ul class="viewer-list" role="navigation"></ul></div></div><div class="viewer-tooltip" role="alert" aria-hidden="true"></div><div class="viewer-button" data-viewer-action="mix" role="button"></div><div class="viewer-player"></div></div>',n=(i=p.querySelector(".".concat(m,"-container"))).querySelector(".".concat(m,"-title")),s=i.querySelector(".".concat(m,"-toolbar")),r=i.querySelector(".".concat(m,"-navbar")),h=i.querySelector(".".concat(m,"-button")),p=i.querySelector(".".concat(m,"-canvas")),this.parent=t,this.viewer=i,this.title=n,this.toolbar=s,this.navbar=r,this.button=h,this.canvas=p,this.footer=i.querySelector(".".concat(m,"-footer")),this.tooltipBox=i.querySelector(".".concat(m,"-tooltip")),this.player=i.querySelector(".".concat(m,"-player")),this.list=i.querySelector(".".concat(m,"-list")),i.id="".concat(m).concat(this.id),n.id="".concat(m,"Title").concat(this.id),I(n,a.title?ge(Array.isArray(a.title)?a.title[0]:a.title):f),I(r,a.navbar?ge(a.navbar):f),$(h,f,!a.button),a.keyboard&&h.setAttribute("tabindex",0),a.backdrop&&(I(i,"".concat(m,"-backdrop")),a.inline||"static"===a.backdrop||le(p,ee,"hide")),T(a.className)&&a.className&&a.className.split(te).forEach(function(e){I(i,e)}),a.toolbar?(o=document.createElement("ul"),l=k(a.toolbar),c=ie.slice(0,3),d=ie.slice(7,9),u=ie.slice(9),l||I(s,ge(a.toolbar)),N(l?a.toolbar:ie,function(e,t){var i=l&&k(e),n=l?oe(t):e,s=i&&!S(e.show)?e.show:e;!s||!a.zoomable&&-1!==c.indexOf(n)||!a.rotatable&&-1!==d.indexOf(n)||!a.scalable&&-1!==u.indexOf(n)||(t=i&&!S(e.size)?e.size:e,i=i&&!S(e.click)?e.click:e,e=document.createElement("li"),a.keyboard&&e.setAttribute("tabindex",0),e.setAttribute("role","button"),I(e,"".concat(m,"-").concat(n)),M(i)||le(e,ee,n),C(s)&&I(e,ge(s)),-1!==["small","large"].indexOf(t)?I(e,"".concat(m,"-").concat(t)):"play"===n&&I(e,"".concat(m,"-large")),M(i)&&R(e,w,i),o.appendChild(e))}),s.appendChild(o)):I(s,f),a.rotatable||(I(p=s.querySelectorAll('li[class*="rotate"]'),b),N(p,function(e){s.appendChild(e)})),a.inline?(I(h,q),A(i,{zIndex:a.zIndexInline}),"static"===window.getComputedStyle(t).position&&A(t,{position:"relative"}),t.insertBefore(i,e.nextSibling)):(I(h,F),I(i,H),I(i,g),I(i,f),A(i,{zIndex:a.zIndex}),(h=(h=T(h=a.container)?e.ownerDocument.querySelector(h):h)||this.body).appendChild(i)),a.inline&&(this.render(),this.bind(),this.isShown=!0),this.ready=!0,M(a.ready)&&R(e,"ready",a.ready,{once:!0}),!1!==B(e,"ready")?this.ready&&a.inline&&this.view(this.index):this.ready=!1)}}]),o(ve,ye),O((e=Te).prototype,we,t,i,_e,Ee),e}),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(require("jquery"),require("viewerjs")):"function"==typeof define&&define.amd?define(["jquery","viewerjs"],t):t((e=e||self).jQuery,e.Viewer)}(this,function(c,d){"use strict";var e,u;c=c&&c.hasOwnProperty("default")?c.default:c,d=d&&d.hasOwnProperty("default")?d.default:d,c&&c.fn&&d&&(e=c.fn.viewer,u="viewer",c.fn.viewer=function(r){for(var o,e=arguments.length,l=new Array(1<e?e-1:0),t=1;t<e;t++)l[t-1]=arguments[t];return this.each(function(e,t){var i=c(t),n="destroy"===r;if(!(a=i.data(u))){if(n)return;var s=c.extend({},i.data(),c.isPlainObject(r)&&r),a=new d(t,s);i.data(u,a)}"string"==typeof r&&(t=a[r],c.isFunction(t))&&((o=t.apply(a,l))===a&&(o=void 0),n)&&i.removeData(u)}),void 0!==o?o:this},c.fn.viewer.Constructor=d,c.fn.viewer.setDefaults=d.setDefaults,c.fn.viewer.noConflict=function(){return c.fn.viewer=e,this})});